/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(ee){for(var e=[],d=0,R=ee.length;d<R;d++)e[d]=we[ee[d]];return e};define(we[41],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=d}),define(we[52],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function R(n){const C=[];for(let l in n)d.call(n,l)&&C.push(n[l]);return C}e.values=R;function D(n,C){for(let l in n)if(d.call(n,l)&&C({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=D;function S(n,C){const l=Object.create(null);for(const h of n){const u=C(h);let g=l[u];g||(g=l[u]=[]),g.push(h)}return l}e.groupBy=S;function k(n){const C=Object.create(null);return n&&n.forEach((l,h)=>{C[h]=l}),C}e.fromMap=k;function E(n,C){const l=[],h=[];for(let u of n)C.has(u)||l.push(u);for(let u of C)n.has(u)||h.push(u);return{removed:l,added:h}}e.diffSets=E;function y(n,C){const l=[],h=[];for(let[u,g]of n)C.has(u)||l.push(g);for(let[u,g]of C)n.has(u)||h.push(g);return{removed:l,added:h}}e.diffMaps=y;class T{constructor(){this.map=new Map}add(C,l){let h=this.map.get(C);h||(h=new Set,this.map.set(C,h)),h.add(l)}delete(C,l){const h=this.map.get(C);!h||(h.delete(l),h.size===0&&this.map.delete(C))}forEach(C,l){const h=this.map.get(C);!h||h.forEach(l)}}e.SetMap=T}),define(we[53],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(k){return(E,y,T)=>{let n=null,C=null;if(typeof T.value=="function"?(n="value",C=T.value):typeof T.get=="function"&&(n="get",C=T.get),!C)throw new Error("not supported");T[n]=k(C,y)}}e.createDecorator=d;function R(k,E,y){let T=null,n=null;if(typeof y.value=="function"?(T="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",n=y.get),!n)throw new Error("not supported");const C=`$memoize$${E}`;y[T]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[C]}}e.memoize=R;function D(k,E,y){return d((T,n)=>{const C=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...h){this[l]||(this[l]=y?y():void 0),clearTimeout(this[C]),E&&(this[l]=E(this[l],...h),h=[this[l]]),this[C]=setTimeout(()=>{T.apply(this,h),this[l]=y?y():void 0},k)}})}e.debounce=D;function S(k,E,y){return d((T,n)=>{const C=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...g){if(this[l]||(this[l]=y?y():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),E&&(this[l]=E(this[l],...g)),this[u])return;const b=this[h]+k;b<=Date.now()?(this[h]=Date.now(),T.apply(this,[this[l]]),this[l]=y?y():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[h]=Date.now(),T.apply(this,[this[l]]),this[l]=y?y():void 0},b-Date.now()))}})}e.throttle=S}),define(we[12],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class d{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(a=>{a(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=d,e.errorHandler=new d;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function D(v){y(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=D;function S(v){y(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=S;function k(v){if(v instanceof Error){let{name:t,message:a}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:a,stack:s}}return v}e.transformErrorForSerialization=k;const E="Canceled";function y(v){return v instanceof Error&&v.name===E&&v.message===E}e.isPromiseCanceledError=y;class T extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=T;function n(){const v=new Error(E);return v.name=v.message,v}e.canceled=n;function C(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=C;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function h(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class A extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=A;function o(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=o;function p(v,t=Object.create(null)){const a=new Error(v);return t.actions&&(a.actions=t.actions),a}e.createErrorWithActions=p}),define(we[17],be([0,1,12]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,ne=0){return W[W.length-(1+ne)]}e.tail=R;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function S(W,ne,ge=(_e,Me)=>_e===Me){if(W===ne)return!0;if(!W||!ne||W.length!==ne.length)return!1;for(let _e=0,Me=W.length;_e<Me;_e++)if(!ge(W[_e],ne[_e]))return!1;return!0}e.equals=S;function k(W,ne,ge){let _e=0,Me=W.length-1;for(;_e<=Me;){const Fe=(_e+Me)/2|0,xe=ge(W[Fe],ne);if(xe<0)_e=Fe+1;else if(xe>0)Me=Fe-1;else return Fe}return-(_e+1)}e.binarySearch=k;function E(W,ne){let ge=0,_e=W.length;if(_e===0)return 0;for(;ge<_e;){const Me=Math.floor((ge+_e)/2);ne(W[Me])?_e=Me:ge=Me+1}return ge}e.findFirstInSorted=E;function y(W,ne,ge){if(W=W|0,W>=ne.length)throw new TypeError("invalid index");let _e=ne[Math.floor(ne.length*Math.random())],Me=[],Fe=[],xe=[];for(let Ye of ne){const Ve=ge(Ye,_e);Ve<0?Me.push(Ye):Ve>0?Fe.push(Ye):xe.push(Ye)}return W<Me.length?y(W,Me,ge):W<Me.length+xe.length?xe[0]:y(W-(Me.length+xe.length),Fe,ge)}e.quickSelect=y;function T(W,ne){const ge=[];let _e;for(const Me of W.slice(0).sort(ne))!_e||ne(_e[0],Me)!==0?(_e=[Me],ge.push(_e)):_e.push(Me);return ge}e.groupBy=T;function n(W,ne,ge){const _e=[];function Me(Ye,Ve,qe){if(Ve===0&&qe.length===0)return;const x=_e[_e.length-1];x&&x.start+x.deleteCount===Ye?(x.deleteCount+=Ve,x.toInsert.push(...qe)):_e.push({start:Ye,deleteCount:Ve,toInsert:qe})}let Fe=0,xe=0;for(;;){if(Fe===W.length){Me(Fe,0,ne.slice(xe));break}if(xe===ne.length){Me(Fe,W.length-Fe,[]);break}const Ye=W[Fe],Ve=ne[xe],qe=ge(Ye,Ve);qe===0?(Fe+=1,xe+=1):qe<0?(Me(Fe,1,[]),Fe+=1):qe>0&&(Me(Fe,0,[Ve]),xe+=1)}return _e}e.sortedDiff=n;function C(W,ne,ge){const _e=n(W,ne,ge),Me=[],Fe=[];for(const xe of _e)Me.push(...W.slice(xe.start,xe.start+xe.deleteCount)),Fe.push(...xe.toInsert);return{removed:Me,added:Fe}}e.delta=C;function l(W,ne,ge){if(ge===0)return[];const _e=W.slice(0,ge).sort(ne);return u(W,ne,_e,ge,W.length),_e}e.top=l;function h(W,ne,ge,_e,Me){return ge===0?Promise.resolve([]):new Promise((Fe,xe)=>{(async()=>{const Ye=W.length,Ve=W.slice(0,ge).sort(ne);for(let qe=ge,x=Math.min(ge+_e,Ye);qe<Ye;qe=x,x=Math.min(x+_e,Ye)){if(qe>ge&&await new Promise(Q=>setTimeout(Q)),Me&&Me.isCancellationRequested)throw(0,d.canceled)();u(W,ne,Ve,qe,x)}return Ve})().then(Fe,xe)})}e.topAsync=h;function u(W,ne,ge,_e,Me){for(const Fe=ge.length;_e<Me;_e++){const xe=W[_e];if(ne(xe,ge[Fe-1])<0){ge.pop();const Ye=E(ge,Ve=>ne(xe,Ve)<0);ge.splice(Ye,0,xe)}}}function g(W){return W.filter(ne=>!!ne)}e.coalesce=g;function b(W){let ne=0;for(let ge=0;ge<W.length;ge++)W[ge]&&(W[ne]=W[ge],ne+=1);W.length=ne}e.coalesceInPlace=b;function w(W,ne,ge){W.splice(ge,0,W.splice(ne,1)[0])}e.move=w;function A(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=A;function o(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=o;function p(W,ne){if(!ne)return W.filter((_e,Me)=>W.indexOf(_e)===Me);const ge=Object.create(null);return W.filter(_e=>{const Me=ne(_e);return ge[Me]?!1:(ge[Me]=!0,!0)})}e.distinct=p;function v(W){const ne=new Set;return W.filter(ge=>ne.has(ge)?!1:(ne.add(ge),!0))}e.distinctES6=v;function t(W){const ne=Object.create(null);return ge=>{const _e=W(ge);return ne[_e]?!1:(ne[_e]=!0,!0)}}e.uniqueFilter=t;function a(W,ne){for(let ge=W.length-1;ge>=0;ge--){const _e=W[ge];if(ne(_e))return ge}return-1}e.lastIndex=a;function s(W,ne){return W.length>0?W[0]:ne}e.firstOrDefault=s;function i(W,ne,ge=(_e,Me)=>_e===Me){let _e=0;for(let Me=0,Fe=Math.min(W.length,ne.length);Me<Fe&&ge(W[Me],ne[Me]);Me++)_e++;return _e}e.commonPrefixLength=i;function c(W){return[].concat(...W)}e.flatten=c;function f(W,ne){let ge=typeof ne=="number"?W:0;typeof ne=="number"?ge=W:(ge=0,ne=W);const _e=[];if(ge<=ne)for(let Me=ge;Me<ne;Me++)_e.push(Me);else for(let Me=ge;Me>ne;Me--)_e.push(Me);return _e}e.range=f;function m(W,ne,ge){return W.reduce((_e,Me)=>(_e[ne(Me)]=ge?ge(Me):Me,_e),Object.create(null))}e.index=m;function _(W,ne){return W.push(ne),()=>I(W,ne)}e.insert=_;function I(W,ne){const ge=W.indexOf(ne);if(ge>-1)return W.splice(ge,1),ne}e.remove=I;function r(W,ne,ge){const _e=W.slice(0,ne),Me=W.slice(ne);return _e.concat(ge,Me)}e.arrayInsert=r;function P(W,ne){let ge;if(typeof ne=="number"){let _e=ne;ge=()=>{const Me=Math.sin(_e++)*179426549;return Me-Math.floor(Me)}}else ge=Math.random;for(let _e=W.length-1;_e>0;_e-=1){const Me=Math.floor(ge()*(_e+1)),Fe=W[_e];W[_e]=W[Me],W[Me]=Fe}}e.shuffle=P;function F(W,ne){const ge=W.indexOf(ne);ge>-1&&(W.splice(ge,1),W.unshift(ne))}e.pushToStart=F;function B(W,ne){const ge=W.indexOf(ne);ge>-1&&(W.splice(ge,1),W.push(ne))}e.pushToEnd=B;function j(W,ne){return Array.isArray(W)?W.map(ne):ne(W)}e.mapArrayOrNot=j;function ae(W){return Array.isArray(W)?W:[W]}e.asArray=ae;function oe(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=oe;function V(W,ne){for(const ge of W){const _e=ne(ge);if(_e!==void 0)return _e}}e.mapFind=V;function H(W,ne,ge){const _e=K(W,ne),Me=W.length,Fe=ge.length;W.length=Me+Fe;for(let xe=Me-1;xe>=_e;xe--)W[xe+Fe]=W[xe];for(let xe=0;xe<Fe;xe++)W[xe+_e]=ge[xe]}e.insertInto=H;function M(W,ne,ge,_e){const Me=K(W,ne),Fe=W.splice(Me,ge);return H(W,Me,_e),Fe}e.splice=M;function K(W,ne){return ne<0?Math.max(ne+W.length,0):Math.min(ne,W.length)}function N(W,ne){let ge=Number.MAX_SAFE_INTEGER,_e=0;return W.forEach((Me,Fe)=>{const xe=ne(Me);xe<ge&&(ge=xe,_e=Fe)}),_e}e.minIndex=N;function G(W,ne){let ge=Number.MIN_SAFE_INTEGER,_e=0;return W.forEach((Me,Fe)=>{const xe=ne(Me);xe>ge&&(ge=xe,_e=Fe)}),_e}e.maxIndex=G;class me{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let ge=this.firstIdx;for(;ge<this.items.length&&ne(this.items[ge]);)ge++;const _e=ge===this.firstIdx?null:this.items.slice(this.firstIdx,ge);return this.firstIdx=ge,_e}takeFromEndWhile(ne){let ge=this.lastIdx;for(;ge>=0&&ne(this.items[ge]);)ge--;const _e=ge===this.lastIdx?null:this.items.slice(ge+1,this.lastIdx+1);return this.lastIdx=ge,_e}}e.ArrayQueue=me}),define(we[54],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function d(R){const D=this;let S=!1,k;return function(){return S||(S=!0,k=R.apply(D,arguments)),k}}e.once=d}),define(we[55],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(we[56],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(R){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=D;const S=Object.freeze([]);function k(){return S}R.empty=k;function*E(v){yield v}R.single=E;function y(v){return v||S}R.from=y;function T(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=T;function n(v){return v[Symbol.iterator]().next().value}R.first=n;function C(v,t){for(const a of v)if(t(a))return!0;return!1}R.some=C;function l(v,t){for(const a of v)if(t(a))return a}R.find=l;function*h(v,t){for(const a of v)t(a)&&(yield a)}R.filter=h;function*u(v,t){let a=0;for(const s of v)yield t(s,a++)}R.map=u;function*g(...v){for(const t of v)for(const a of t)yield a}R.concat=g;function*b(v){for(const t of v)for(const a of t)yield a}R.concatNested=b;function w(v,t,a){let s=a;for(const i of v)s=t(s,i);return s}R.reduce=w;function*A(v,t,a=v.length){for(t<0&&(t+=v.length),a<0?a+=v.length:a>v.length&&(a=v.length);t<a;t++)yield v[t]}R.slice=A;function o(v,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,v];const s=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=s.next();if(c.done)return[a,R.empty()];a.push(c.value)}return[a,{[Symbol.iterator](){return s}}]}R.consume=o;function p(v,t,a=(s,i)=>s===i){const s=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=s.next(),f=i.next();if(c.done!==f.done)return!1;if(c.done)return!0;if(!a(c.value,f.value))return!1}}R.equals=p})(d=e.Iterable||(e.Iterable={}))}),define(we[111],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function k(t,a=!1){let s=0,i=t.length,c="",f=0,m=16,_=0;function I(oe){let V=0,H=0;for(;V<oe;){const M=t.charCodeAt(s);if(M>=48&&M<=57)H=H*16+M-48;else if(M>=65&&M<=70)H=H*16+M-65+10;else if(M>=97&&M<=102)H=H*16+M-97+10;else break;s++,V++}return V<oe&&(H=-1),H}function r(oe){s=oe,c="",f=0,m=16,_=0}function P(){const oe=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&T(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&T(t.charCodeAt(s)))for(s++;s<t.length&&T(t.charCodeAt(s));)s++;else return _=3,t.substring(oe,s);let V=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&T(t.charCodeAt(s))){for(s++;s<t.length&&T(t.charCodeAt(s));)s++;V=s}else _=3;return t.substring(oe,V)}function F(){let oe="",V=s;for(;;){if(s>=i){oe+=t.substring(V,s),_=2;break}const H=t.charCodeAt(s);if(H===34){oe+=t.substring(V,s),s++;break}if(H===92){if(oe+=t.substring(V,s),s++,s>=i){_=2;break}switch(t.charCodeAt(s++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:const K=I(4);K>=0?oe+=String.fromCharCode(K):_=4;break;default:_=5}V=s;continue}if(H>=0&&H<=31)if(y(H)){oe+=t.substring(V,s),_=2;break}else _=6;s++}return oe}function B(){if(c="",_=0,f=s,s>=i)return f=i,m=17;let oe=t.charCodeAt(s);if(E(oe)){do s++,c+=String.fromCharCode(oe),oe=t.charCodeAt(s);while(E(oe));return m=15}if(y(oe))return s++,c+=String.fromCharCode(oe),oe===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),m=14;switch(oe){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,c=F(),m=10;case 47:const V=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!y(t.charCodeAt(s));)s++;return c=t.substring(V,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const H=i-1;let M=!1;for(;s<H;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,_=1),c=t.substring(V,s),m=13}return c+=String.fromCharCode(oe),s++,m=16;case 45:if(c+=String.fromCharCode(oe),s++,s===i||!T(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),m=11;default:for(;s<i&&j(oe);)s++,oe=t.charCodeAt(s);if(f!==s){switch(c=t.substring(f,s),c){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return c+=String.fromCharCode(oe),s++,m=16}}function j(oe){if(E(oe)||y(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let oe;do oe=B();while(oe>=12&&oe<=15);return oe}return{setPosition:r,getPosition:()=>s,scan:a?ae:B,getToken:()=>m,getTokenValue:()=>c,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>_}}e.createScanner=k;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function C(t,a){const s=[],i=new Object;let c;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function _(I,r,P,F){f.value=I,f.offset=r,f.length=P,f.type=F,f.colonOffset=void 0,c=f}try{o(t,{onObjectBegin:(I,r)=>{if(a<=I)throw i;c=void 0,m=a>I,s.push("")},onObjectProperty:(I,r,P)=>{if(a<r||(_(I,r,P,"property"),s[s.length-1]=I,a<=r+P))throw i},onObjectEnd:(I,r)=>{if(a<=I)throw i;c=void 0,s.pop()},onArrayBegin:(I,r)=>{if(a<=I)throw i;c=void 0,s.push(0)},onArrayEnd:(I,r)=>{if(a<=I)throw i;c=void 0,s.pop()},onLiteralValue:(I,r,P)=>{if(a<r||(_(I,r,P,v(I)),a<=r+P))throw i},onSeparator:(I,r,P)=>{if(a<=r)throw i;if(I===":"&&c&&c.type==="property")c.colonOffset=r,m=!1,c=void 0;else if(I===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(m=!0,s[s.length-1]=""),c=void 0}}})}catch(I){if(I!==i)throw I}return{path:s,previousNode:c,isAtPropertyKey:m,matches:I=>{let r=0;for(let P=0;r<I.length&&P<s.length;P++)if(I[r]===s[P]||I[r]==="*")r++;else if(I[r]!=="**")return!1;return r===I.length}}}e.getLocation=C;function l(t,a=[],s=S.DEFAULT){let i=null,c=[];const f=[];function m(I){Array.isArray(c)?c.push(I):i!==null&&(c[i]=I)}return o(t,{onObjectBegin:()=>{const I={};m(I),f.push(c),c=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{const I=[];m(I),f.push(c),c=I,i=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:m,onError:(I,r,P)=>{a.push({error:I,offset:r,length:P})}},s),c[0]}e.parse=l;function h(t,a=[],s=S.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function f(I){return i.children.push(I),I}o(t,{onObjectBegin:I=>{i=f({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,r,P)=>{i=f({type:"property",offset:r,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:r,length:P,parent:i})},onObjectEnd:(I,r)=>{i.length=I+r-i.offset,i=i.parent,c(I+r)},onArrayBegin:(I,r)=>{i=f({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,r)=>{i.length=I+r-i.offset,i=i.parent,c(I+r)},onLiteralValue:(I,r,P)=>{f({type:v(I),offset:r,length:P,parent:i,value:I}),c(r+P)},onSeparator:(I,r,P)=>{i.type==="property"&&(I===":"?i.colonOffset=r:I===","&&c(r))},onError:(I,r,P)=>{a.push({error:I,offset:r,length:P})}},s);const _=i.children[0];return _&&delete _.parent,_}e.parseTree=h;function u(t,a){if(!t)return;let s=t;for(let i of a)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===i){s=f.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=u;function g(t){if(!t.parent||!t.parent.children)return[];const a=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;a.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&a.push(s)}return a}e.getNodePath=g;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const a=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(a[s.children[0].value]=b(i))}return a;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,a,s=!1){return a>=t.offset&&a<t.offset+t.length||s&&a===t.offset+t.length}e.contains=w;function A(t,a,s=!1){if(w(t,a,s)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=a;c++){const f=A(i[c],a,s);if(f)return f}return t}}e.findNodeAtOffset=A;function o(t,a,s=S.DEFAULT){const i=k(t,!1);function c(ge){return ge?()=>ge(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(ge){return ge?_e=>ge(_e,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=c(a.onObjectBegin),_=f(a.onObjectProperty),I=c(a.onObjectEnd),r=c(a.onArrayBegin),P=c(a.onArrayEnd),F=f(a.onLiteralValue),B=f(a.onSeparator),j=c(a.onComment),ae=f(a.onError),oe=s&&s.disallowComments,V=s&&s.allowTrailingComma;function H(){for(;;){const ge=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:oe||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(ge){case 12:case 13:oe?M(10):j();break;case 16:M(1);break;case 15:case 14:break;default:return ge}}}function M(ge,_e=[],Me=[]){if(ae(ge),_e.length+Me.length>0){let Fe=i.getToken();for(;Fe!==17;){if(_e.indexOf(Fe)!==-1){H();break}else if(Me.indexOf(Fe)!==-1)break;Fe=H()}}}function K(ge){const _e=i.getTokenValue();return ge?F(_e):_(_e),H(),!0}function N(){switch(i.getToken()){case 11:let ge=0;try{ge=JSON.parse(i.getTokenValue()),typeof ge!="number"&&(M(2),ge=0)}catch(_e){M(2)}F(ge);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return H(),!0}function G(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(B(":"),H(),ne()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function me(){m(),H();let ge=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ge||M(4,[],[]),B(","),H(),i.getToken()===2&&V)break}else ge&&M(6,[],[]);G()||M(4,[],[2,5]),ge=!0}return I(),i.getToken()!==2?M(7,[2],[]):H(),!0}function W(){r(),H();let ge=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ge||M(4,[],[]),B(","),H(),i.getToken()===4&&V)break}else ge&&M(6,[],[]);ne()||M(4,[],[4,5]),ge=!0}return P(),i.getToken()!==4?M(8,[4],[]):H(),!0}function ne(){switch(i.getToken()){case 3:return W();case 1:return me();case 10:return K(!0);default:return N()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):ne()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=o;function p(t,a){let s=k(t),i=[],c,f=0,m;do switch(m=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:f!==m&&i.push(t.substring(f,m)),a!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,a)),f=s.getPosition();break}while(c!==17);return i.join("")}e.stripComments=p;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(we[112],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new d(()=>D(this.getValue()))}}e.Lazy=d}),define(we[6],be([0,1,54,56]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function k(s){S=s}if(e.setDisposableTracker=k,D){const s="__is_disposable_tracked__";k(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==A.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==A.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function E(s){return S?.trackDisposable(s),s}function y(s){S?.markAsDisposed(s)}function T(s,i){S?.setParent(s,i)}function n(s,i){if(!!S)for(const c of s)S.setParent(c,i)}function C(s){return S?.markAsSingleton(s),s}e.markAsSingleton=C;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=h;function u(s){if(R.Iterable.is(s)){let i=[];for(const c of s)if(c)try{c.dispose()}catch(f){i.push(f)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=u;function g(...s){const i=b(()=>u(s));return n(s,i),i}e.combinedDisposable=g;function b(s){const i=E({dispose:(0,d.once)(()=>{y(i),s()})});return i}e.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class A{constructor(){this._store=new w,E(this),T(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=A,A.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=o;class p{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class v{constructor(){this.references=new Map}acquire(i,...c){let f=this.references.get(i);f||(f={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,f));const{object:m}=f,_=(0,d.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(i,f.object),this.references.delete(i))});return f.counter++,{object:m,dispose:_}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const f=this.referenceCollection.acquire(i,...c);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(m){throw f.dispose(),m}}}e.AsyncReferenceCollection=t;class a{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=a}),define(we[79],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class d{constructor(S){this.element=S,this.next=d.Undefined,this.prev=d.Undefined}}d.Undefined=new d(void 0);class R{constructor(){this._first=d.Undefined,this._last=d.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===d.Undefined}clear(){let S=this._first;for(;S!==d.Undefined;){const k=S.next;S.prev=d.Undefined,S.next=d.Undefined,S=k}this._first=d.Undefined,this._last=d.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,k){const E=new d(S);if(this._first===d.Undefined)this._first=E,this._last=E;else if(k){const T=this._last;this._last=E,E.prev=T,T.next=E}else{const T=this._first;this._first=E,E.next=T,T.prev=E}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(E))}}shift(){if(this._first!==d.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==d.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==d.Undefined&&S.next!==d.Undefined){const k=S.prev;k.next=S.next,S.next.prev=k}else S.prev===d.Undefined&&S.next===d.Undefined?(this._first=d.Undefined,this._last=d.Undefined):S.next===d.Undefined?(this._last=this._last.prev,this._last.next=d.Undefined):S.prev===d.Undefined&&(this._first=this._first.next,this._first.prev=d.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==d.Undefined;)yield S.element,S=S.next}}e.LinkedList=R}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(De,ye){for(var Ce=0;Ce<ye.length;Ce++){var se=ye[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(De,se.key,se)}}function e(De,ye,Ce){return ye&&ee(De.prototype,ye),Ce&&ee(De,Ce),De}function d(De,ye){if(!!De){if(typeof De=="string")return R(De,ye);var Ce=Object.prototype.toString.call(De).slice(8,-1);if(Ce==="Object"&&De.constructor&&(Ce=De.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(De);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return R(De,ye)}}function R(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Ce=0,se=new Array(ye);Ce<ye;Ce++)se[Ce]=De[Ce];return se}function D(De,ye){var Ce;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Ce=d(De))||ye&&De&&typeof De.length=="number"){Ce&&(De=Ce);var se=0;return function(){return se>=De.length?{done:!0}:{done:!1,value:De[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=De[Symbol.iterator](),Ce.next.bind(Ce)}function S(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var k=S(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(se){De.exports.defaults=se}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:Ce}}),E=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(ye){return C[ye]};function h(De,ye){if(ye){if(E.test(De))return De.replace(y,l)}else if(T.test(De))return De.replace(n,l);return De}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(De){return De.replace(u,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var b=/(^|[^\[])\^/g;function w(De,ye){De=De.source||De,ye=ye||"";var Ce={replace:function(ue,O){return O=O.source||O,O=O.replace(b,"$1"),De=De.replace(ue,O),Ce},getRegex:function(){return new RegExp(De,ye)}};return Ce}var A=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(De,ye,Ce){if(De){var se;try{se=decodeURIComponent(g(Ce)).replace(A,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ye&&!o.test(Ce)&&(Ce=i(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ue){return null}return Ce}var v={},t=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,ye){v[" "+De]||(t.test(De)?v[" "+De]=De+"/":v[" "+De]=_(De,"/",!0)),De=v[" "+De];var Ce=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:De.replace(a,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:De.replace(s,"$1")+ye:De+ye}var c={exec:function(){}};function f(De){for(var ye=1,Ce,se;ye<arguments.length;ye++){Ce=arguments[ye];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(De[se]=Ce[se])}return De}function m(De,ye){var Ce=De.replace(/\|/g,function(O,Y,le){for(var Ae=!1,Pe=Y;--Pe>=0&&le[Pe]==="\\";)Ae=!Ae;return Ae?"|":" |"}),se=Ce.split(/ \|/),ue=0;if(se.length>ye)se.splice(ye);else for(;se.length<ye;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function _(De,ye,Ce){var se=De.length;if(se===0)return"";for(var ue=0;ue<se;){var O=De.charAt(se-ue-1);if(O===ye&&!Ce)ue++;else if(O!==ye&&Ce)ue++;else break}return De.substr(0,se-ue)}function I(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Ce=De.length,se=0,ue=0;ue<Ce;ue++)if(De[ue]==="\\")ue++;else if(De[ue]===ye[0])se++;else if(De[ue]===ye[1]&&(se--,se<0))return ue;return-1}function r(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(De,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=De),ye>>=1,De+=De;return Ce+De}var F={escape:h,unescape:g,edit:w,cleanUrl:p,resolveUrl:i,noopTest:c,merge:f,splitCells:m,rtrim:_,findClosingBracket:I,checkSanitizeDeprecation:r,repeatString:P},B=k.defaults,j=F.rtrim,ae=F.splitCells,oe=F.escape,V=F.findClosingBracket;function H(De,ye,Ce){var se=ye.href,ue=ye.title?oe(ye.title):null,O=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:se,title:ue,text:O}:{type:"image",raw:Ce,href:se,title:ue,text:oe(O)}}function M(De,ye){var Ce=De.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var se=Ce[1];return ye.split(`
`).map(function(ue){var O=ue.match(/^\s+/);if(O===null)return ue;var Y=O[0];return Y.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var K=function(){function De(Ce){this.options=Ce||B}var ye=De.prototype;return ye.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var O=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?O:j(O,`
`)}}},ye.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var O=ue[0],Y=M(O,ue[3]||"");return{type:"code",raw:O,lang:ue[2]?ue[2].trim():ue[2],text:Y}}},ye.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var O=ue[2].trim();if(/#$/.test(O)){var Y=j(O,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(O=Y.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:O}}},ye.nptable=function(se){var ue=this.rules.block.nptable.exec(se);if(ue){var O={type:"table",header:ae(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(O.header.length===O.align.length){var Y=O.align.length,le;for(le=0;le<Y;le++)/^ *-+: *$/.test(O.align[le])?O.align[le]="right":/^ *:-+: *$/.test(O.align[le])?O.align[le]="center":/^ *:-+ *$/.test(O.align[le])?O.align[le]="left":O.align[le]=null;for(Y=O.cells.length,le=0;le<Y;le++)O.cells[le]=ae(O.cells[le],O.header.length);return O}}},ye.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var O=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:O}}},ye.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var O=ue[0],Y=ue[2],le=Y.length>1,Ae={type:"list",raw:O,ordered:le,start:le?+Y.slice(0,-1):"",loose:!1,items:[]},Pe=ue[0].match(this.rules.block.item),$e=!1,je,et,it,Je,Qe,mt,vt,Et,ot=Pe.length;it=this.rules.block.listItemStart.exec(Pe[0]);for(var at=0;at<ot;at++){if(je=Pe[at],O=je,at!==ot-1){if(Je=this.rules.block.listItemStart.exec(Pe[at+1]),this.options.pedantic?Je[1].length>it[1].length:Je[1].length>it[0].length||Je[1].length>3){Pe.splice(at,2,Pe[at]+`
`+Pe[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Je[2][Je[2].length-1]!==Y[Y.length-1]:le===(Je[2].length===1))&&(Qe=Pe.slice(at+1).join(`
`),Ae.raw=Ae.raw.substring(0,Ae.raw.length-Qe.length),at=ot-1);it=Je}et=je.length,je=je.replace(/^ *([*+-]|\d+[.)]) ?/,""),~je.indexOf(`
 `)&&(et-=je.length,je=this.options.pedantic?je.replace(/^ {1,4}/gm,""):je.replace(new RegExp("^ {1,"+et+"}","gm"),"")),mt=$e||/\n\n(?!\s*$)/.test(je),at!==ot-1&&($e=je.charAt(je.length-1)===`
`,mt||(mt=$e)),mt&&(Ae.loose=!0),this.options.gfm&&(vt=/^\[[ xX]\] /.test(je),Et=void 0,vt&&(Et=je[1]!==" ",je=je.replace(/^\[[ xX]\] +/,""))),Ae.items.push({type:"list_item",raw:O,task:vt,checked:Et,loose:mt,text:je})}return Ae}},ye.html=function(se){var ue=this.rules.block.html.exec(se);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):oe(ue[0]):ue[0]}},ye.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var O=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var O={type:"table",header:ae(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=ue[0];var Y=O.align.length,le;for(le=0;le<Y;le++)/^ *-+: *$/.test(O.align[le])?O.align[le]="right":/^ *:-+: *$/.test(O.align[le])?O.align[le]="center":/^ *:-+ *$/.test(O.align[le])?O.align[le]="left":O.align[le]=null;for(Y=O.cells.length,le=0;le<Y;le++)O.cells[le]=ae(O.cells[le].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},ye.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(se){var ue=this.rules.block.text.exec(se);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:oe(ue[1])}},ye.tag=function(se,ue,O){var Y=this.rules.inline.tag.exec(se);if(Y)return!ue&&/^<a /i.test(Y[0])?ue=!0:ue&&/^<\/a>/i.test(Y[0])&&(ue=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:ue,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):oe(Y[0]):Y[0]}},ye.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var O=ue[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var Y=j(O.slice(0,-1),"\\");if((O.length-Y.length)%2==0)return}else{var le=V(ue[2],"()");if(le>-1){var Ae=ue[0].indexOf("!")===0?5:4,Pe=Ae+ue[1].length+le;ue[2]=ue[2].substring(0,le),ue[0]=ue[0].substring(0,Pe).trim(),ue[3]=""}}var $e=ue[2],je="";if(this.options.pedantic){var et=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec($e);et&&($e=et[1],je=et[3])}else je=ue[3]?ue[3].slice(1,-1):"";return $e=$e.trim(),/^</.test($e)&&(this.options.pedantic&&!/>$/.test(O)?$e=$e.slice(1):$e=$e.slice(1,-1)),H(ue,{href:$e&&$e.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(se,ue){var O;if((O=this.rules.inline.reflink.exec(se))||(O=this.rules.inline.nolink.exec(se))){var Y=(O[2]||O[1]).replace(/\s+/g," ");if(Y=ue[Y.toLowerCase()],!Y||!Y.href){var le=O[0].charAt(0);return{type:"text",raw:le,text:le}}return H(O,Y,O[0])}},ye.emStrong=function(se,ue,O){O===void 0&&(O="");var Y=this.rules.inline.emStrong.lDelim.exec(se);if(!!Y&&!(Y[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=Y[1]||Y[2]||"";if(!le||le&&(O===""||this.rules.inline.punctuation.exec(O))){var Ae=Y[0].length-1,Pe,$e,je=Ae,et=0,it=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(it.lastIndex=0,ue=ue.slice(-1*se.length+Ae);(Y=it.exec(ue))!=null;)if(Pe=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!Pe){if($e=Pe.length,Y[3]||Y[4]){je+=$e;continue}else if((Y[5]||Y[6])&&Ae%3&&!((Ae+$e)%3)){et+=$e;continue}if(je-=$e,!(je>0)){if(je+et-$e<=0&&!ue.slice(it.lastIndex).match(it)&&($e=Math.min($e,$e+je+et)),Math.min(Ae,$e)%2)return{type:"em",raw:se.slice(0,Ae+Y.index+$e+1),text:se.slice(1,Ae+Y.index+$e)};if(Math.min(Ae,$e)%2==0)return{type:"strong",raw:se.slice(0,Ae+Y.index+$e+1),text:se.slice(2,Ae+Y.index+$e-1)}}}}}},ye.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var O=ue[2].replace(/\n/g," "),Y=/[^ ]/.test(O),le=/^ /.test(O)&&/ $/.test(O);return Y&&le&&(O=O.substring(1,O.length-1)),O=oe(O,!0),{type:"codespan",raw:ue[0],text:O}}},ye.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(se,ue){var O=this.rules.inline.autolink.exec(se);if(O){var Y,le;return O[2]==="@"?(Y=oe(this.options.mangle?ue(O[1]):O[1]),le="mailto:"+Y):(Y=oe(O[1]),le=Y),{type:"link",raw:O[0],text:Y,href:le,tokens:[{type:"text",raw:Y,text:Y}]}}},ye.url=function(se,ue){var O;if(O=this.rules.inline.url.exec(se)){var Y,le;if(O[2]==="@")Y=oe(this.options.mangle?ue(O[0]):O[0]),le="mailto:"+Y;else{var Ae;do Ae=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(Ae!==O[0]);Y=oe(O[0]),O[1]==="www."?le="http://"+Y:le=Y}return{type:"link",raw:O[0],text:Y,href:le,tokens:[{type:"text",raw:Y,text:Y}]}}},ye.inlineText=function(se,ue,O){var Y=this.rules.inline.text.exec(se);if(Y){var le;return ue?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):oe(Y[0]):Y[0]:le=oe(this.options.smartypants?O(Y[0]):Y[0]),{type:"text",raw:Y[0],text:le}}},De}(),N=F.noopTest,G=F.edit,me=F.merge,W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=G(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,W.item=G(W.item,"gm").replace(/bull/g,W.bullet).getRegex(),W.listItemStart=G(/^( *)(bull)/).replace("bull",W.bullet).getRegex(),W.list=G(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=G(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=G(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.blockquote=G(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=me({},W),W.gfm=me({},W.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.nptable=G(W.gfm.nptable).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.gfm.table=G(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.pedantic=me({},W.normal,{html:G(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:G(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=G(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=G(W._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=G(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=G(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=G(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=G(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=G(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=G(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=G(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=G(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=me({},ne),ne.pedantic=me({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:G(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:G(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=me({},ne.normal,{escape:G(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=G(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=me({},ne.gfm,{br:G(ne.br).replace("{2,}","*").getRegex(),text:G(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ge={block:W,inline:ne},_e=k.defaults,Me=ge.block,Fe=ge.inline,xe=F.repeatString;function Ye(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ve(De){var ye="",Ce,se,ue=De.length;for(Ce=0;Ce<ue;Ce++)se=De.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),ye+="&#"+se+";";return ye}var qe=function(){function De(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||_e,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Me.normal,inline:Fe.normal};this.options.pedantic?(se.block=Me.pedantic,se.inline=Fe.pedantic):this.options.gfm&&(se.block=Me.gfm,this.options.breaks?se.inline=Fe.breaks:se.inline=Fe.gfm),this.tokenizer.rules=se}De.lex=function(se,ue){var O=new De(ue);return O.lex(se)},De.lexInline=function(se,ue){var O=new De(ue);return O.inlineTokens(se)};var ye=De.prototype;return ye.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(se,ue,O){ue===void 0&&(ue=[]),O===void 0&&(O=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var Y,le,Ae,Pe;se;){if(Y=this.tokenizer.space(se)){se=se.substring(Y.raw.length),Y.type&&ue.push(Y);continue}if(Y=this.tokenizer.code(se)){se=se.substring(Y.raw.length),Pe=ue[ue.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+Y.raw,Pe.text+=`
`+Y.text):ue.push(Y);continue}if(Y=this.tokenizer.fences(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.heading(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.nptable(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.hr(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.blockquote(se)){se=se.substring(Y.raw.length),Y.tokens=this.blockTokens(Y.text,[],O),ue.push(Y);continue}if(Y=this.tokenizer.list(se)){for(se=se.substring(Y.raw.length),Ae=Y.items.length,le=0;le<Ae;le++)Y.items[le].tokens=this.blockTokens(Y.items[le].text,[],!1);ue.push(Y);continue}if(Y=this.tokenizer.html(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(O&&(Y=this.tokenizer.def(se))){se=se.substring(Y.raw.length),this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.lheading(se)){se=se.substring(Y.raw.length),ue.push(Y);continue}if(O&&(Y=this.tokenizer.paragraph(se))){se=se.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.text(se)){se=se.substring(Y.raw.length),Pe=ue[ue.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+Y.raw,Pe.text+=`
`+Y.text):ue.push(Y);continue}if(se){var $e="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return ue},ye.inline=function(se){var ue,O,Y,le,Ae,Pe,$e=se.length;for(ue=0;ue<$e;ue++)switch(Pe=se[ue],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},le=Pe.header.length,O=0;O<le;O++)Pe.tokens.header[O]=[],this.inlineTokens(Pe.header[O],Pe.tokens.header[O]);for(le=Pe.cells.length,O=0;O<le;O++)for(Ae=Pe.cells[O],Pe.tokens.cells[O]=[],Y=0;Y<Ae.length;Y++)Pe.tokens.cells[O][Y]=[],this.inlineTokens(Ae[Y],Pe.tokens.cells[O][Y]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(le=Pe.items.length,O=0;O<le;O++)this.inline(Pe.items[O].tokens);break}}return se},ye.inlineTokens=function(se,ue,O,Y){ue===void 0&&(ue=[]),O===void 0&&(O=!1),Y===void 0&&(Y=!1);var le,Ae,Pe=se,$e,je,et;if(this.tokens.links){var it=Object.keys(this.tokens.links);if(it.length>0)for(;($e=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)it.includes($e[0].slice($e[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,$e.index)+"["+xe("a",$e[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;($e=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,$e.index)+"["+xe("a",$e[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;($e=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,$e.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(je||(et=""),je=!1,le=this.tokenizer.escape(se)){se=se.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.tag(se,O,Y)){se=se.substring(le.raw.length),O=le.inLink,Y=le.inRawBlock;var Je=ue[ue.length-1];Je&&le.type==="text"&&Je.type==="text"?(Je.raw+=le.raw,Je.text+=le.text):ue.push(le);continue}if(le=this.tokenizer.link(se)){se=se.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,Y)),ue.push(le);continue}if(le=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(le.raw.length);var Qe=ue[ue.length-1];le.type==="link"?(le.tokens=this.inlineTokens(le.text,[],!0,Y),ue.push(le)):Qe&&le.type==="text"&&Qe.type==="text"?(Qe.raw+=le.raw,Qe.text+=le.text):ue.push(le);continue}if(le=this.tokenizer.emStrong(se,Pe,et)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],O,Y),ue.push(le);continue}if(le=this.tokenizer.codespan(se)){se=se.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.br(se)){se=se.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.del(se)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],O,Y),ue.push(le);continue}if(le=this.tokenizer.autolink(se,Ve)){se=se.substring(le.raw.length),ue.push(le);continue}if(!O&&(le=this.tokenizer.url(se,Ve))){se=se.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.inlineText(se,Y,Ye)){se=se.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(et=le.raw.slice(-1)),je=!0,Ae=ue[ue.length-1],Ae&&Ae.type==="text"?(Ae.raw+=le.raw,Ae.text+=le.text):ue.push(le);continue}if(se){var mt="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return ue},e(De,null,[{key:"rules",get:function(){return{block:Me,inline:Fe}}}]),De}(),x=k.defaults,Q=F.cleanUrl,X=F.escape,re=function(){function De(Ce){this.options=Ce||x}var ye=De.prototype;return ye.code=function(se,ue,O){var Y=(ue||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(se,Y);le!=null&&le!==se&&(O=!0,se=le)}return se=se.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+X(Y,!0)+'">'+(O?se:X(se,!0))+`</code></pre>
`:"<pre><code>"+(O?se:X(se,!0))+`</code></pre>
`},ye.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ye.html=function(se){return se},ye.heading=function(se,ue,O,Y){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+Y.slug(O)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(se,ue,O){var Y=ue?"ol":"ul",le=ue&&O!==1?' start="'+O+'"':"";return"<"+Y+le+`>
`+se+"</"+Y+`>
`},ye.listitem=function(se){return"<li>"+se+`</li>
`},ye.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(se){return"<p>"+se+`</p>
`},ye.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},ye.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ye.tablecell=function(se,ue){var O=ue.header?"th":"td",Y=ue.align?"<"+O+' align="'+ue.align+'">':"<"+O+">";return Y+se+"</"+O+`>
`},ye.strong=function(se){return"<strong>"+se+"</strong>"},ye.em=function(se){return"<em>"+se+"</em>"},ye.codespan=function(se){return"<code>"+se+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(se){return"<del>"+se+"</del>"},ye.link=function(se,ue,O){if(se=Q(this.options.sanitize,this.options.baseUrl,se),se===null)return O;var Y='<a href="'+X(se)+'"';return ue&&(Y+=' title="'+ue+'"'),Y+=">"+O+"</a>",Y},ye.image=function(se,ue,O){if(se=Q(this.options.sanitize,this.options.baseUrl,se),se===null)return O;var Y='<img src="'+se+'" alt="'+O+'"';return ue&&(Y+=' title="'+ue+'"'),Y+=this.options.xhtml?"/>":">",Y},ye.text=function(se){return se},De}(),q=function(){function De(){}var ye=De.prototype;return ye.strong=function(se){return se},ye.em=function(se){return se},ye.codespan=function(se){return se},ye.del=function(se){return se},ye.html=function(se){return se},ye.text=function(se){return se},ye.link=function(se,ue,O){return""+O},ye.image=function(se,ue,O){return""+O},ye.br=function(){return""},De}(),ie=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(se,ue){var O=se,Y=0;if(this.seen.hasOwnProperty(O)){Y=this.seen[se];do Y++,O=se+"-"+Y;while(this.seen.hasOwnProperty(O))}return ue||(this.seen[se]=Y,this.seen[O]=0),O},ye.slug=function(se,ue){ue===void 0&&(ue={});var O=this.serialize(se);return this.getNextSafeSlug(O,ue.dryrun)},De}(),pe=k.defaults,Te=F.unescape,Be=function(){function De(Ce){this.options=Ce||pe,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ie}De.parse=function(se,ue){var O=new De(ue);return O.parse(se)},De.parseInline=function(se,ue){var O=new De(ue);return O.parseInline(se)};var ye=De.prototype;return ye.parse=function(se,ue){ue===void 0&&(ue=!0);var O="",Y,le,Ae,Pe,$e,je,et,it,Je,Qe,mt,vt,Et,ot,at,Dt,Ee,he,ce=se.length;for(Y=0;Y<ce;Y++)switch(Qe=se[Y],Qe.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,Te(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(it="",et="",Pe=Qe.header.length,le=0;le<Pe;le++)et+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[le]),{header:!0,align:Qe.align[le]});for(it+=this.renderer.tablerow(et),Je="",Pe=Qe.cells.length,le=0;le<Pe;le++){for(je=Qe.tokens.cells[le],et="",$e=je.length,Ae=0;Ae<$e;Ae++)et+=this.renderer.tablecell(this.parseInline(je[Ae]),{header:!1,align:Qe.align[Ae]});Je+=this.renderer.tablerow(et)}O+=this.renderer.table(it,Je);continue}case"blockquote":{Je=this.parse(Qe.tokens),O+=this.renderer.blockquote(Je);continue}case"list":{for(mt=Qe.ordered,vt=Qe.start,Et=Qe.loose,Pe=Qe.items.length,Je="",le=0;le<Pe;le++)at=Qe.items[le],Dt=at.checked,Ee=at.task,ot="",at.task&&(he=this.renderer.checkbox(Dt),Et?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=he+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=he+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:he}):ot+=he),ot+=this.parse(at.tokens,Et),Je+=this.renderer.listitem(ot,Ee,Dt);O+=this.renderer.list(Je,mt,vt);continue}case"html":{O+=this.renderer.html(Qe.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(Je=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Y+1<ce&&se[Y+1].type==="text";)Qe=se[++Y],Je+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);O+=ue?this.renderer.paragraph(Je):Je;continue}default:{var $='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}return O},ye.parseInline=function(se,ue){ue=ue||this.renderer;var O="",Y,le,Ae=se.length;for(Y=0;Y<Ae;Y++)switch(le=se[Y],le.type){case"escape":{O+=ue.text(le.text);break}case"html":{O+=ue.html(le.text);break}case"link":{O+=ue.link(le.href,le.title,this.parseInline(le.tokens,ue));break}case"image":{O+=ue.image(le.href,le.title,le.text);break}case"strong":{O+=ue.strong(this.parseInline(le.tokens,ue));break}case"em":{O+=ue.em(this.parseInline(le.tokens,ue));break}case"codespan":{O+=ue.codespan(le.text);break}case"br":{O+=ue.br();break}case"del":{O+=ue.del(this.parseInline(le.tokens,ue));break}case"text":{O+=ue.text(le.text);break}default:{var Pe='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return O},De}(),ve=F.merge,Ke=F.checkSanitizeDeprecation,z=F.escape,Z=k.getDefaults,fe=k.changeDefaults,Oe=k.defaults;function Ne(De,ye,Ce){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=ve({},Ne.defaults,ye||{}),Ke(ye),Ce){var se=ye.highlight,ue;try{ue=qe.lex(De,ye)}catch(Ae){return Ce(Ae)}var O=function(Pe){var $e;if(!Pe)try{$e=Be.parse(ue,ye)}catch(je){Pe=je}return ye.highlight=se,Pe?Ce(Pe):Ce(null,$e)};if(!se||se.length<3||(delete ye.highlight,!ue.length))return O();var Y=0;Ne.walkTokens(ue,function(Ae){Ae.type==="code"&&(Y++,setTimeout(function(){se(Ae.text,Ae.lang,function(Pe,$e){if(Pe)return O(Pe);$e!=null&&$e!==Ae.text&&(Ae.text=$e,Ae.escaped=!0),Y--,Y===0&&O()})},0))}),Y===0&&O();return}try{var le=qe.lex(De,ye);return ye.walkTokens&&Ne.walkTokens(le,ye.walkTokens),Be.parse(le,ye)}catch(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+z(Ae.message+"",!0)+"</pre>";throw Ae}}Ne.options=Ne.setOptions=function(De){return ve(Ne.defaults,De),fe(Ne.defaults),Ne},Ne.getDefaults=Z,Ne.defaults=Oe,Ne.use=function(De){var ye=ve({},De);if(De.renderer&&function(){var se=Ne.defaults.renderer||new re,ue=function(le){var Ae=se[le];se[le]=function(){for(var Pe=arguments.length,$e=new Array(Pe),je=0;je<Pe;je++)$e[je]=arguments[je];var et=De.renderer[le].apply(se,$e);return et===!1&&(et=Ae.apply(se,$e)),et}};for(var O in De.renderer)ue(O);ye.renderer=se}(),De.tokenizer&&function(){var se=Ne.defaults.tokenizer||new K,ue=function(le){var Ae=se[le];se[le]=function(){for(var Pe=arguments.length,$e=new Array(Pe),je=0;je<Pe;je++)$e[je]=arguments[je];var et=De.tokenizer[le].apply(se,$e);return et===!1&&(et=Ae.apply(se,$e)),et}};for(var O in De.tokenizer)ue(O);ye.tokenizer=se}(),De.walkTokens){var Ce=Ne.defaults.walkTokens;ye.walkTokens=function(se){De.walkTokens(se),Ce&&Ce(se)}}Ne.setOptions(ye)},Ne.walkTokens=function(De,ye){for(var Ce=D(De),se;!(se=Ce()).done;){var ue=se.value;switch(ye(ue),ue.type){case"table":{for(var O=D(ue.tokens.header),Y;!(Y=O()).done;){var le=Y.value;Ne.walkTokens(le,ye)}for(var Ae=D(ue.tokens.cells),Pe;!(Pe=Ae()).done;)for(var $e=Pe.value,je=D($e),et;!(et=je()).done;){var it=et.value;Ne.walkTokens(it,ye)}break}case"list":{Ne.walkTokens(ue.items,ye);break}default:ue.tokens&&Ne.walkTokens(ue.tokens,ye)}}},Ne.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=ve({},Ne.defaults,ye||{}),Ke(ye);try{var Ce=qe.lexInline(De,ye);return ye.walkTokens&&Ne.walkTokens(Ce,ye.walkTokens),Be.parseInline(Ce,ye)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+z(se.message+"",!0)+"</pre>";throw se}},Ne.Parser=Be,Ne.parser=Be.parse,Ne.Renderer=re,Ne.TextRenderer=q,Ne.Lexer=qe,Ne.lexer=qe.lex,Ne.Tokenizer=K,Ne.Slugger=ie,Ne.parse=Ne;var Xe=Ne;return Xe}),define(we[80],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(k,E,y){return Math.min(Math.max(k,E),y)}e.clamp=d;function R(k,E){return(E+k%E)%E}e.rot=R;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class S{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function ee(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function k(y){S.push(y,Date.now())}function E(){const y=[];for(let T=0;T<S.length;T+=2)y.push({name:S[T],startTime:S[T+1]});return y}return{mark:k,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))S.push({name:k.name,startTime:Math.round(D+k.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function d(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=d(R))}(),define(we[22],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const d="en";let R=!1,D=!1,S=!1,k=!1,E=!1,y=!1,T=!1,n,C=d,l,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const g=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=g&&u?.sandboxed,typeof navigator=="object"&&!g)h=navigator.userAgent,R=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,T=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=h.indexOf("Linux")>=0,y=!0,n=navigator.language,C=n;else if(typeof u=="object"){R=u.platform==="win32",D=u.platform==="darwin",S=u.platform==="linux",k=S&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=d,C=d;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),c=i.availableLanguages["*"];n=i.locale,C=c||d,l=i._translationsConfigFile}catch(i){}E=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let A=0;D?A=1:R?A=3:S&&(A=2),e.isWindows=R,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=k,e.isNative=E,e.isWeb=y,e.isIOS=T,e.platform=A,e.userAgent=h,e.language=C;var o;(function(s){function i(){return e.language}s.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function f(){return e.language==="en"}s.isDefault=f})(o=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let _=0,I=c.length;_<I;_++){const r=c[_];if(r.id===m.data.vscodeSetImmediateId){c.splice(_,1),r.callback();return}}});let f=0;return m=>{const _=++f;c.push({id:_,callback:m}),e.globals.postMessage({vscodeSetImmediateId:_},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var p;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(p=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||T?2:R?1:3;let v=!0,t=!1;function a(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=a}),define(we[42],be([0,1,22]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof d.globals.vscode!="undefined"&&typeof d.globals.vscode.process!="undefined"){const D=d.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,d.setImmediate)(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return d.isWindows?"win32":d.isMacintosh?"darwin":"linux"},nextTick(D){return(0,d.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(we[14],be([0,1,42]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,S=90,k=122,E=46,y=47,T=92,n=58,C=63;class l extends Error{constructor(p,v,t){let a;typeof v=="string"&&v.indexOf("not ")===0?(a="must not be",v=v.replace(/^not /,"")):a="must be";const s=p.indexOf(".")!==-1?"property":"argument";let i=`The "${p}" ${s} ${a} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(o,p){if(typeof o!="string")throw new l(p,"string",o)}function u(o){return o===y||o===T}function g(o){return o===y}function b(o){return o>=R&&o<=S||o>=D&&o<=k}function w(o,p,v,t){let a="",s=0,i=-1,c=0,f=0;for(let m=0;m<=o.length;++m){if(m<o.length)f=o.charCodeAt(m);else{if(t(f))break;f=y}if(t(f)){if(!(i===m-1||c===1))if(c===2){if(a.length<2||s!==2||a.charCodeAt(a.length-1)!==E||a.charCodeAt(a.length-2)!==E){if(a.length>2){const _=a.lastIndexOf(v);_===-1?(a="",s=0):(a=a.slice(0,_),s=a.length-1-a.lastIndexOf(v)),i=m,c=0;continue}else if(a.length!==0){a="",s=0,i=m,c=0;continue}}p&&(a+=a.length>0?`${v}..`:"..",s=2)}else a.length>0?a+=`${v}${o.slice(i+1,m)}`:a=o.slice(i+1,m),s=m-i-1;i=m,c=0}else f===E&&c!==-1?++c:c=-1}return a}function A(o,p){if(p===null||typeof p!="object")throw new l("pathObject","Object",p);const v=p.dir||p.root,t=p.base||`${p.name||""}${p.ext||""}`;return v?v===p.root?`${v}${t}`:`${v}${o}${t}`:t}e.win32={resolve(...o){let p="",v="",t=!1;for(let a=o.length-1;a>=-1;a--){let s;if(a>=0){if(s=o[a],h(s,"path"),s.length===0)continue}else p.length===0?s=d.cwd():(s=d.env[`=${p}`]||d.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==p.toLowerCase()&&s.charCodeAt(2)===T)&&(s=`${p}\\`));const i=s.length;let c=0,f="",m=!1;const _=s.charCodeAt(0);if(i===1)u(_)&&(c=1,m=!0);else if(u(_))if(m=!0,u(s.charCodeAt(1))){let I=2,r=I;for(;I<i&&!u(s.charCodeAt(I));)I++;if(I<i&&I!==r){const P=s.slice(r,I);for(r=I;I<i&&u(s.charCodeAt(I));)I++;if(I<i&&I!==r){for(r=I;I<i&&!u(s.charCodeAt(I));)I++;(I===i||I!==r)&&(f=`\\\\${P}\\${s.slice(r,I)}`,c=I)}}}else c=1;else b(_)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),c=2,i>2&&u(s.charCodeAt(2))&&(m=!0,c=3));if(f.length>0)if(p.length>0){if(f.toLowerCase()!==p.toLowerCase())continue}else p=f;if(t){if(p.length>0)break}else if(v=`${s.slice(c)}\\${v}`,t=m,m&&p.length>0)break}return v=w(v,!t,"\\",u),t?`${p}\\${v}`:`${p}${v}`||"."},normalize(o){h(o,"path");const p=o.length;if(p===0)return".";let v=0,t,a=!1;const s=o.charCodeAt(0);if(p===1)return g(s)?"\\":o;if(u(s))if(a=!0,u(o.charCodeAt(1))){let c=2,f=c;for(;c<p&&!u(o.charCodeAt(c));)c++;if(c<p&&c!==f){const m=o.slice(f,c);for(f=c;c<p&&u(o.charCodeAt(c));)c++;if(c<p&&c!==f){for(f=c;c<p&&!u(o.charCodeAt(c));)c++;if(c===p)return`\\\\${m}\\${o.slice(f)}\\`;c!==f&&(t=`\\\\${m}\\${o.slice(f,c)}`,v=c)}}}else v=1;else b(s)&&o.charCodeAt(1)===n&&(t=o.slice(0,2),v=2,p>2&&u(o.charCodeAt(2))&&(a=!0,v=3));let i=v<p?w(o.slice(v),!a,"\\",u):"";return i.length===0&&!a&&(i="."),i.length>0&&u(o.charCodeAt(p-1))&&(i+="\\"),t===void 0?a?`\\${i}`:i:a?`${t}\\${i}`:`${t}${i}`},isAbsolute(o){h(o,"path");const p=o.length;if(p===0)return!1;const v=o.charCodeAt(0);return u(v)||p>2&&b(v)&&o.charCodeAt(1)===n&&u(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let p,v;for(let s=0;s<o.length;++s){const i=o[s];h(i,"path"),i.length>0&&(p===void 0?p=v=i:p+=`\\${i}`)}if(p===void 0)return".";let t=!0,a=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++a;const s=v.length;s>1&&u(v.charCodeAt(1))&&(++a,s>2&&(u(v.charCodeAt(2))?++a:t=!1))}if(t){for(;a<p.length&&u(p.charCodeAt(a));)a++;a>=2&&(p=`\\${p.slice(a)}`)}return e.win32.normalize(p)},relative(o,p){if(h(o,"from"),h(p,"to"),o===p)return"";const v=e.win32.resolve(o),t=e.win32.resolve(p);if(v===t||(o=v.toLowerCase(),p=t.toLowerCase(),o===p))return"";let a=0;for(;a<o.length&&o.charCodeAt(a)===T;)a++;let s=o.length;for(;s-1>a&&o.charCodeAt(s-1)===T;)s--;const i=s-a;let c=0;for(;c<p.length&&p.charCodeAt(c)===T;)c++;let f=p.length;for(;f-1>c&&p.charCodeAt(f-1)===T;)f--;const m=f-c,_=i<m?i:m;let I=-1,r=0;for(;r<_;r++){const F=o.charCodeAt(a+r);if(F!==p.charCodeAt(c+r))break;F===T&&(I=r)}if(r!==_){if(I===-1)return t}else{if(m>_){if(p.charCodeAt(c+r)===T)return t.slice(c+r+1);if(r===2)return t.slice(c+r)}i>_&&(o.charCodeAt(a+r)===T?I=r:r===2&&(I=3)),I===-1&&(I=0)}let P="";for(r=a+I+1;r<=s;++r)(r===s||o.charCodeAt(r)===T)&&(P+=P.length===0?"..":"\\..");return c+=I,P.length>0?`${P}${t.slice(c,f)}`:(t.charCodeAt(c)===T&&++c,t.slice(c,f))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const p=e.win32.resolve(o);if(p.length<=2)return o;if(p.charCodeAt(0)===T){if(p.charCodeAt(1)===T){const v=p.charCodeAt(2);if(v!==C&&v!==E)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(b(p.charCodeAt(0))&&p.charCodeAt(1)===n&&p.charCodeAt(2)===T)return`\\\\?\\${p}`;return o},dirname(o){h(o,"path");const p=o.length;if(p===0)return".";let v=-1,t=0;const a=o.charCodeAt(0);if(p===1)return u(a)?o:".";if(u(a)){if(v=t=1,u(o.charCodeAt(1))){let c=2,f=c;for(;c<p&&!u(o.charCodeAt(c));)c++;if(c<p&&c!==f){for(f=c;c<p&&u(o.charCodeAt(c));)c++;if(c<p&&c!==f){for(f=c;c<p&&!u(o.charCodeAt(c));)c++;if(c===p)return o;c!==f&&(v=t=c+1)}}}}else b(a)&&o.charCodeAt(1)===n&&(v=p>2&&u(o.charCodeAt(2))?3:2,t=v);let s=-1,i=!0;for(let c=p-1;c>=t;--c)if(u(o.charCodeAt(c))){if(!i){s=c;break}}else i=!1;if(s===-1){if(v===-1)return".";s=v}return o.slice(0,s)},basename(o,p){p!==void 0&&h(p,"ext"),h(o,"path");let v=0,t=-1,a=!0,s;if(o.length>=2&&b(o.charCodeAt(0))&&o.charCodeAt(1)===n&&(v=2),p!==void 0&&p.length>0&&p.length<=o.length){if(p===o)return"";let i=p.length-1,c=-1;for(s=o.length-1;s>=v;--s){const f=o.charCodeAt(s);if(u(f)){if(!a){v=s+1;break}}else c===-1&&(a=!1,c=s+1),i>=0&&(f===p.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=o.length),o.slice(v,t)}for(s=o.length-1;s>=v;--s)if(u(o.charCodeAt(s))){if(!a){v=s+1;break}}else t===-1&&(a=!1,t=s+1);return t===-1?"":o.slice(v,t)},extname(o){h(o,"path");let p=0,v=-1,t=0,a=-1,s=!0,i=0;o.length>=2&&o.charCodeAt(1)===n&&b(o.charCodeAt(0))&&(p=t=2);for(let c=o.length-1;c>=p;--c){const f=o.charCodeAt(c);if(u(f)){if(!s){t=c+1;break}continue}a===-1&&(s=!1,a=c+1),f===E?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||a===-1||i===0||i===1&&v===a-1&&v===t+1?"":o.slice(v,a)},format:A.bind(null,"\\"),parse(o){h(o,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return p;const v=o.length;let t=0,a=o.charCodeAt(0);if(v===1)return u(a)?(p.root=p.dir=o,p):(p.base=p.name=o,p);if(u(a)){if(t=1,u(o.charCodeAt(1))){let I=2,r=I;for(;I<v&&!u(o.charCodeAt(I));)I++;if(I<v&&I!==r){for(r=I;I<v&&u(o.charCodeAt(I));)I++;if(I<v&&I!==r){for(r=I;I<v&&!u(o.charCodeAt(I));)I++;I===v?t=I:I!==r&&(t=I+1)}}}}else if(b(a)&&o.charCodeAt(1)===n){if(v<=2)return p.root=p.dir=o,p;if(t=2,u(o.charCodeAt(2))){if(v===3)return p.root=p.dir=o,p;t=3}}t>0&&(p.root=o.slice(0,t));let s=-1,i=t,c=-1,f=!0,m=o.length-1,_=0;for(;m>=t;--m){if(a=o.charCodeAt(m),u(a)){if(!f){i=m+1;break}continue}c===-1&&(f=!1,c=m+1),a===E?s===-1?s=m:_!==1&&(_=1):s!==-1&&(_=-1)}return c!==-1&&(s===-1||_===0||_===1&&s===c-1&&s===i+1?p.base=p.name=o.slice(i,c):(p.name=o.slice(i,s),p.base=o.slice(i,c),p.ext=o.slice(s,c))),i>0&&i!==t?p.dir=o.slice(0,i-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let p="",v=!1;for(let t=o.length-1;t>=-1&&!v;t--){const a=t>=0?o[t]:d.cwd();h(a,"path"),a.length!==0&&(p=`${a}/${p}`,v=a.charCodeAt(0)===y)}return p=w(p,!v,"/",g),v?`/${p}`:p.length>0?p:"."},normalize(o){if(h(o,"path"),o.length===0)return".";const p=o.charCodeAt(0)===y,v=o.charCodeAt(o.length-1)===y;return o=w(o,!p,"/",g),o.length===0?p?"/":v?"./":".":(v&&(o+="/"),p?`/${o}`:o)},isAbsolute(o){return h(o,"path"),o.length>0&&o.charCodeAt(0)===y},join(...o){if(o.length===0)return".";let p;for(let v=0;v<o.length;++v){const t=o[v];h(t,"path"),t.length>0&&(p===void 0?p=t:p+=`/${t}`)}return p===void 0?".":e.posix.normalize(p)},relative(o,p){if(h(o,"from"),h(p,"to"),o===p||(o=e.posix.resolve(o),p=e.posix.resolve(p),o===p))return"";const v=1,t=o.length,a=t-v,s=1,i=p.length-s,c=a<i?a:i;let f=-1,m=0;for(;m<c;m++){const I=o.charCodeAt(v+m);if(I!==p.charCodeAt(s+m))break;I===y&&(f=m)}if(m===c)if(i>c){if(p.charCodeAt(s+m)===y)return p.slice(s+m+1);if(m===0)return p.slice(s+m)}else a>c&&(o.charCodeAt(v+m)===y?f=m:m===0&&(f=0));let _="";for(m=v+f+1;m<=t;++m)(m===t||o.charCodeAt(m)===y)&&(_+=_.length===0?"..":"/..");return`${_}${p.slice(s+f)}`},toNamespacedPath(o){return o},dirname(o){if(h(o,"path"),o.length===0)return".";const p=o.charCodeAt(0)===y;let v=-1,t=!0;for(let a=o.length-1;a>=1;--a)if(o.charCodeAt(a)===y){if(!t){v=a;break}}else t=!1;return v===-1?p?"/":".":p&&v===1?"//":o.slice(0,v)},basename(o,p){p!==void 0&&h(p,"ext"),h(o,"path");let v=0,t=-1,a=!0,s;if(p!==void 0&&p.length>0&&p.length<=o.length){if(p===o)return"";let i=p.length-1,c=-1;for(s=o.length-1;s>=0;--s){const f=o.charCodeAt(s);if(f===y){if(!a){v=s+1;break}}else c===-1&&(a=!1,c=s+1),i>=0&&(f===p.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=o.length),o.slice(v,t)}for(s=o.length-1;s>=0;--s)if(o.charCodeAt(s)===y){if(!a){v=s+1;break}}else t===-1&&(a=!1,t=s+1);return t===-1?"":o.slice(v,t)},extname(o){h(o,"path");let p=-1,v=0,t=-1,a=!0,s=0;for(let i=o.length-1;i>=0;--i){const c=o.charCodeAt(i);if(c===y){if(!a){v=i+1;break}continue}t===-1&&(a=!1,t=i+1),c===E?p===-1?p=i:s!==1&&(s=1):p!==-1&&(s=-1)}return p===-1||t===-1||s===0||s===1&&p===t-1&&p===v+1?"":o.slice(p,t)},format:A.bind(null,"/"),parse(o){h(o,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return p;const v=o.charCodeAt(0)===y;let t;v?(p.root="/",t=1):t=0;let a=-1,s=0,i=-1,c=!0,f=o.length-1,m=0;for(;f>=t;--f){const _=o.charCodeAt(f);if(_===y){if(!c){s=f+1;break}continue}i===-1&&(c=!1,i=f+1),_===E?a===-1?a=f:m!==1&&(m=1):a!==-1&&(m=-1)}if(i!==-1){const _=s===0&&v?1:s;a===-1||m===0||m===1&&a===i-1&&a===s+1?p.base=p.name=o.slice(_,i):(p.name=o.slice(_,a),p.base=o.slice(_,i),p.ext=o.slice(a,i))}return s>0?p.dir=o.slice(0,s-1):v&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=d.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d.platform==="win32"?e.win32.join:e.posix.join,e.resolve=d.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=d.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=d.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=d.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=d.platform==="win32"?e.win32.extname:e.posix.extname,e.format=d.platform==="win32"?e.win32.format:e.posix.format,e.parse=d.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=d.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=d.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[57],be([0,1,22]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=d.globals.performance&&typeof d.globals.performance.now=="function";class D{constructor(k){this._highResolution=R&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?d.globals.performance.now():Date.now()}}e.StopWatch=D}),define(we[3],be([0,1,12,54,6,79,57]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(o){o.None=()=>D.Disposable.None;function p(oe){return(V,H=null,M)=>{let K=!1,N;return N=oe(G=>{if(!K)return N?N.dispose():K=!0,V.call(H,G)},null,M),K&&N.dispose(),N}}o.once=p;function v(oe,V){return f((H,M=null,K)=>oe(N=>H.call(M,V(N)),null,K))}o.map=v;function t(oe,V){return f((H,M=null,K)=>oe(N=>{V(N),H.call(M,N)},null,K))}o.forEach=t;function a(oe,V){return f((H,M=null,K)=>oe(N=>V(N)&&H.call(M,N),null,K))}o.filter=a;function s(oe){return oe}o.signal=s;function i(...oe){return(V,H=null,M)=>(0,D.combinedDisposable)(...oe.map(K=>K(N=>V.call(H,N),null,M)))}o.any=i;function c(oe,V,H){let M=H;return v(oe,K=>(M=V(M,K),M))}o.reduce=c;function f(oe){let V;const H=new l({onFirstListenerAdd(){V=oe(H.fire,H)},onLastListenerRemove(){V.dispose()}});return H.event}function m(oe,V,H=100,M=!1,K){let N,G,me,W=0;const ne=new l({leakWarningThreshold:K,onFirstListenerAdd(){N=oe(ge=>{W++,G=V(G,ge),M&&!me&&(ne.fire(G),G=void 0),clearTimeout(me),me=setTimeout(()=>{const _e=G;G=void 0,me=void 0,(!M||W>1)&&ne.fire(_e),W=0},H)})},onLastListenerRemove(){N.dispose()}});return ne.event}o.debounce=m;function _(oe,V=(H,M)=>H===M){let H=!0,M;return a(oe,K=>{const N=H||!V(K,M);return H=!1,M=K,N})}o.latch=_;function I(oe,V){return[o.filter(oe,V),o.filter(oe,H=>!V(H))]}o.split=I;function r(oe,V=!1,H=[]){let M=H.slice(),K=oe(me=>{M?M.push(me):G.fire(me)});const N=()=>{M&&M.forEach(me=>G.fire(me)),M=null},G=new l({onFirstListenerAdd(){K||(K=oe(me=>G.fire(me)))},onFirstListenerDidAdd(){M&&(V?setTimeout(N):N())},onLastListenerRemove(){K&&K.dispose(),K=null}});return G.event}o.buffer=r;class P{constructor(V){this.event=V}map(V){return new P(v(this.event,V))}forEach(V){return new P(t(this.event,V))}filter(V){return new P(a(this.event,V))}reduce(V,H){return new P(c(this.event,V,H))}latch(){return new P(_(this.event))}debounce(V,H=100,M=!1,K){return new P(m(this.event,V,H,M,K))}on(V,H,M){return this.event(V,H,M)}once(V,H,M){return p(this.event)(V,H,M)}}function F(oe){return new P(oe)}o.chain=F;function B(oe,V,H=M=>M){const M=(...me)=>G.fire(H(...me)),K=()=>oe.on(V,M),N=()=>oe.removeListener(V,M),G=new l({onFirstListenerAdd:K,onLastListenerRemove:N});return G.event}o.fromNodeEventEmitter=B;function j(oe,V,H=M=>M){const M=(...me)=>G.fire(H(...me)),K=()=>oe.addEventListener(V,M),N=()=>oe.removeEventListener(V,M),G=new l({onFirstListenerAdd:K,onLastListenerRemove:N});return G.event}o.fromDOMEventEmitter=j;function ae(oe){return new Promise(V=>p(oe)(V))}o.toPromise=ae})(E=e.Event||(e.Event={}));class y{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${y._idPool++}`}start(p){this._stopWatch=new k.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let T=-1;function n(o){const p=T;return T=o,{dispose(){T=p}}}e.setGlobalLeakWarningThreshold=n;class C{constructor(p,v=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let v=T;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||p<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(t)||0;if(this._stacks.set(t,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let s,i=0;for(const[c,f]of this._stacks)(!s||i<f)&&(s=c,i=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class l{constructor(p){this._disposed=!1,this._options=p,this._leakageMon=T>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(p,v,t)=>{this._listeners||(this._listeners=new S.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(v?[p,v]:p);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,D.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(p){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,p]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(a){(0,d.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class h extends l{async fireAsync(p,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,p]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[a,s]=this._asyncDeliveryQueue.shift(),i=[],c={...s,waitUntil:f=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof a=="function"?a:a[0])),i.push(f)}};try{typeof a=="function"?a.call(void 0,c):a[0].call(a[1],c)}catch(f){(0,d.onUnexpectedError)(f);continue}Object.freeze(i),await Promise.allSettled(i).then(f=>{for(const m of f)m.status==="rejected"&&(0,d.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=h;class u extends l{constructor(p){super(p);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=u;class g extends u{constructor(p){super(p);this._delay=p.delay??100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}e.DebounceEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const v={event:p,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const a=this.events.indexOf(v);this.events.splice(a,1)};return(0,D.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(v=>this.emitter.fire(v))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class w{constructor(){this.buffers=[]}wrapEvent(p){return(v,t,a)=>p(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,s)):v.call(t,s)},void 0,a)}bufferEvents(p){const v=[];this.buffers.push(v);const t=p();return this.buffers.pop(),v.forEach(a=>a()),t}}e.EventBufferer=w;class A{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=D.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=A}),define(we[20],be([0,1,3]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(E,y){const T=setTimeout(E.bind(y),0);return{dispose(){clearTimeout(T)}}});var D;(function(E){function y(T){return T===E.None||T===E.Cancelled||T instanceof S?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}E.isCancellationToken=y,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new d.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(we[35],be([0,1,3]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(C){const l=this._icons.get(C.id);l?C.description?l.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function S(n,C){return new E(n,C)}e.registerCodicon=S;function k(n){return n?n.replace(/\$\((.*?)\)/g,(C,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=k;class E{constructor(C,l,h){this.id=C,this.definition=l,this.description=h,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function y(n,C){const l=["codicon","codicon-"+n];return C&&l.push("codicon-modifier-"+C),l}e.getClassNamesArray=y;var T;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(g){if(g instanceof E)return["codicon","codicon-"+g.id];const b=C.exec(g.id);if(!b)return l(E.error);let[,w,A]=b;const o=["codicon","codicon-"+w];return A&&o.push("codicon-modifier-"+A.substr(1)),o}n.asClassNameArray=l;function h(g){return l(g).join(" ")}n.asClassName=h;function u(g){return"."+l(g).join(".")}n.asCSSSelector=u})(T=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(we[113],be([0,1,12,6]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(o){const p=o;return p?[p.on,p.pause,p.resume,p.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=D;function S(o){const p=o;return p?D(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=S;function k(o,p){return new E(o,p)}e.newWriteableStream=k;class E{constructor(p,v){this.reducer=p,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(v=>v(p))}emitError(p){this.listeners.error.length===0?(0,d.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(v=>v(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,v){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(p,v){if(this.state.destroyed)return;let t;switch(p){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const a=t.indexOf(v);a>=0&&t.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(o,p){const v=[];let t;for(;(t=o.read())!==null;)v.push(t);return p(v)}e.consumeReadable=y;function T(o,p,v){const t=[];let a;for(;(a=o.read())!==null&&t.length<v;)t.push(a);return a===null&&t.length>0?p(t):{read:()=>{if(t.length>0)return t.shift();if(typeof a!="undefined"){const s=a;return a=void 0,s}return o.read()}}}e.peekReadable=T;function n(o,p){return new Promise((v,t)=>{const a=[];C(o,{onData:s=>{p&&a.push(s)},onError:s=>{p?t(s):v(void 0)},onEnd:()=>{v(p?p(a):void 0)}})})}e.consumeStream=n;function C(o,p){o.on("error",v=>p.onError(v)),o.on("end",()=>p.onEnd()),o.on("data",v=>p.onData(v))}e.listenStream=C;function l(o,p){return new Promise((v,t)=>{const a=new R.DisposableStore,s=[],i=m=>{if(s.push(m),s.length>p)return a.dispose(),o.pause(),v({stream:o,buffer:s,ended:!1})},c=m=>t(m),f=()=>v({stream:o,buffer:s,ended:!0});a.add((0,R.toDisposable)(()=>o.removeListener("error",c))),o.on("error",c),a.add((0,R.toDisposable)(()=>o.removeListener("end",f))),o.on("end",f),a.add((0,R.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=l;function h(o,p){const v=k(p);return v.end(o),v}e.toStream=h;function u(){const o=k(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=u;function g(o){let p=!1;return{read:()=>p?null:(p=!0,o)}}e.toReadable=g;function b(o,p,v){const t=k(v);return C(o,{onData:a=>t.write(p.data(a)),onError:a=>t.error(p.error?p.error(a):a),onEnd:()=>t.end()}),t}e.transform=b;function w(o,p,v){let t=!1;return{read:()=>{const a=p.read();return t?a:(t=!0,a!==null?v([o,a]):o)}}}e.prefixedReadable=w;function A(o,p,v){let t=!1;const a=k(v);return C(p,{onData:s=>t?a.write(s):(t=!0,a.write(v([o,s]))),onError:s=>a.error(s),onEnd:()=>{t||(t=!0,a.write(o)),a.end()}}),a}e.prefixedStream=A}),define(we[24],be([0,1,113]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined";let D,S;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return R?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return R&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,c){return!(c?.dontUseNodeBuffer||!1)&&R?new k(Buffer.from(i)):(D||(D=new TextEncoder),new k(D.encode(i)))}static concat(i,c){if(typeof c=="undefined"){c=0;for(let _=0,I=i.length;_<I;_++)c+=i[_].byteLength}const f=k.alloc(c);let m=0;for(let _=0,I=i.length;_<I;_++){const r=i[_];f.set(r,m),m+=r.byteLength}return f}toString(){return R?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(i,c){return new k(this.buffer.subarray(i,c))}set(i,c){i instanceof k?this.buffer.set(i.buffer,c):this.buffer.set(i,c)}readUInt32BE(i){return T(this.buffer,i)}writeUInt32BE(i,c){n(this.buffer,i,c)}readUInt32LE(i){return C(this.buffer,i)}writeUInt32LE(i,c){l(this.buffer,i,c)}readUInt8(i){return h(this.buffer,i)}writeUInt8(i,c){u(this.buffer,i,c)}}e.VSBuffer=k;function E(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0}e.readUInt16LE=E;function y(s,i,c){s[c+0]=i&255,i=i>>>8,s[c+1]=i&255}e.writeUInt16LE=y;function T(s,i){return s[i]*2**24+s[i+1]*2**16+s[i+2]*2**8+s[i+3]}e.readUInt32BE=T;function n(s,i,c){s[c+3]=i,i=i>>>8,s[c+2]=i,i=i>>>8,s[c+1]=i,i=i>>>8,s[c]=i}e.writeUInt32BE=n;function C(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0|s[i+2]<<16>>>0|s[i+3]<<24>>>0}e.readUInt32LE=C;function l(s,i,c){s[c+0]=i&255,i=i>>>8,s[c+1]=i&255,i=i>>>8,s[c+2]=i&255,i=i>>>8,s[c+3]=i&255}e.writeUInt32LE=l;function h(s,i){return s[i]}e.readUInt8=h;function u(s,i,c){s[c]=i}e.writeUInt8=u;function g(s){return d.consumeReadable(s,i=>k.concat(i))}e.readableToBuffer=g;function b(s){return d.toReadable(s)}e.bufferToReadable=b;function w(s){return d.consumeStream(s,i=>k.concat(i))}e.streamToBuffer=w;async function A(s){return s.ended?k.concat(s.buffer):k.concat([...s.buffer,await w(s.stream)])}e.bufferedStreamToBuffer=A;function o(s){return d.toStream(s,i=>k.concat(i))}e.bufferToStream=o;function p(s){return d.transform(s,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=p;function v(s){return d.newWriteableStream(i=>k.concat(i),s)}e.newWriteableBufferStream=v;function t(s,i){return d.prefixedReadable(s,i,c=>k.concat(c))}e.prefixedBufferReadable=t;function a(s,i){return d.prefixedStream(s,i,c=>k.concat(c))}e.prefixedBufferStream=a}),define(we[8],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function d(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=d;const R=/{(\d+)}/g;function D(O,...Y){return Y.length===0?O:O.replace(R,function(le,Ae){const Pe=parseInt(Ae,10);return isNaN(Pe)||Pe<0||Pe>=Y.length?le:Y[Pe]})}e.format=D;const S=/{([^}]+)}/g;function k(O,Y){return O.replace(S,(le,Ae)=>Y[Ae]??le)}e.format2=k;function E(O){return O.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=E;function y(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function T(O,Y){let le=0;const Ae=Y.charCodeAt(0);for(let Pe=O.length-1;Pe>=0;Pe--)O.charCodeAt(Pe)===Ae&&le++;return le}e.count=T;function n(O,Y,le="\u2026"){return O.length<=Y?O:`${O.substr(0,Y)}${le}`}e.truncate=n;function C(O,Y=" "){const le=l(O,Y);return h(le,Y)}e.trim=C;function l(O,Y){if(!O||!Y)return O;const le=Y.length;if(le===0||O.length===0)return O;let Ae=0;for(;O.indexOf(Y,Ae)===Ae;)Ae=Ae+le;return O.substring(Ae)}e.ltrim=l;function h(O,Y){if(!O||!Y)return O;const le=Y.length,Ae=O.length;if(le===0||Ae===0)return O;let Pe=Ae,$e=-1;for(;$e=O.lastIndexOf(Y,Pe-1),!($e===-1||$e+le!==Pe);){if($e===0)return"";Pe=$e}return O.substring(0,Pe)}e.rtrim=h;function u(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(O){return O.replace(/\*/g,"")}e.stripWildcards=g;function b(O,Y,le={}){if(!O)throw new Error("Cannot create regex from empty string");Y||(O=y(O)),le.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let Ae="";return le.global&&(Ae+="g"),le.matchCase||(Ae+="i"),le.multiline&&(Ae+="m"),le.unicode&&(Ae+="u"),new RegExp(O,Ae)}e.createRegExp=b;function w(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function A(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=A;function o(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=o;function p(O){return O.split(/\r\n|\r|\n/)}e.splitLines=p;function v(O){for(let Y=0,le=O.length;Y<le;Y++){const Ae=O.charCodeAt(Y);if(Ae!==32&&Ae!==9)return Y}return-1}e.firstNonWhitespaceIndex=v;function t(O,Y=0,le=O.length){for(let Ae=Y;Ae<le;Ae++){const Pe=O.charCodeAt(Ae);if(Pe!==32&&Pe!==9)return O.substring(Y,Ae)}return O.substring(Y,le)}e.getLeadingWhitespace=t;function a(O,Y=O.length-1){for(let le=Y;le>=0;le--){const Ae=O.charCodeAt(le);if(Ae!==32&&Ae!==9)return le}return-1}e.lastNonWhitespaceIndex=a;function s(O,Y){return O<Y?-1:O>Y?1:0}e.compare=s;function i(O,Y,le=0,Ae=O.length,Pe=0,$e=Y.length){for(;le<Ae&&Pe<$e;le++,Pe++){let it=O.charCodeAt(le),Je=Y.charCodeAt(Pe);if(it<Je)return-1;if(it>Je)return 1}const je=Ae-le,et=$e-Pe;return je<et?-1:je>et?1:0}e.compareSubstring=i;function c(O,Y){return f(O,Y,0,O.length,0,Y.length)}e.compareIgnoreCase=c;function f(O,Y,le=0,Ae=O.length,Pe=0,$e=Y.length){for(;le<Ae&&Pe<$e;le++,Pe++){let it=O.charCodeAt(le),Je=Y.charCodeAt(Pe);if(it===Je)continue;const Qe=it-Je;if(!(Qe===32&&_(Je))&&!(Qe===-32&&_(it)))return m(it)&&m(Je)?Qe:i(O.toLowerCase(),Y.toLowerCase(),le,Ae,Pe,$e)}const je=Ae-le,et=$e-Pe;return je<et?-1:je>et?1:0}e.compareSubstringIgnoreCase=f;function m(O){return O>=97&&O<=122}e.isLowerAsciiLetter=m;function _(O){return O>=65&&O<=90}e.isUpperAsciiLetter=_;function I(O){return m(O)||_(O)}function r(O,Y){return O.length===Y.length&&P(O,Y)}e.equalsIgnoreCase=r;function P(O,Y,le=O.length){for(let Ae=0;Ae<le;Ae++){const Pe=O.charCodeAt(Ae),$e=Y.charCodeAt(Ae);if(Pe!==$e){if(I(Pe)&&I($e)){const je=Math.abs(Pe-$e);if(je!==0&&je!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode($e).toLowerCase())return!1}}return!0}function F(O,Y){const le=Y.length;return Y.length>O.length?!1:P(O,Y,le)}e.startsWithIgnoreCase=F;function B(O,Y){let le,Ae=Math.min(O.length,Y.length);for(le=0;le<Ae;le++)if(O.charCodeAt(le)!==Y.charCodeAt(le))return le;return Ae}e.commonPrefixLength=B;function j(O,Y){let le,Ae=Math.min(O.length,Y.length);const Pe=O.length-1,$e=Y.length-1;for(le=0;le<Ae;le++)if(O.charCodeAt(Pe-le)!==Y.charCodeAt($e-le))return le;return Ae}e.commonSuffixLength=j;function ae(O){return 55296<=O&&O<=56319}e.isHighSurrogate=ae;function oe(O){return 56320<=O&&O<=57343}e.isLowSurrogate=oe;function V(O,Y){return(O-55296<<10)+(Y-56320)+65536}e.computeCodePoint=V;function H(O,Y,le){const Ae=O.charCodeAt(le);if(ae(Ae)&&le+1<Y){const Pe=O.charCodeAt(le+1);if(oe(Pe))return V(Ae,Pe)}return Ae}e.getNextCodePoint=H;function M(O,Y){const le=O.charCodeAt(Y-1);if(oe(le)&&Y>1){const Ae=O.charCodeAt(Y-2);if(ae(Ae))return V(Ae,le)}return le}function K(O,Y){const le=Ne.getInstance(),Ae=Y,Pe=O.length,$e=H(O,Pe,Y);Y+=$e>=65536?2:1;let je=le.getGraphemeBreakType($e);for(;Y<Pe;){const et=H(O,Pe,Y),it=le.getGraphemeBreakType(et);if(fe(je,it))break;Y+=et>=65536?2:1,je=it}return Y-Ae}e.nextCharLength=K;function N(O,Y){const le=Ne.getInstance(),Ae=Y,Pe=M(O,Y);Y-=Pe>=65536?2:1;let $e=le.getGraphemeBreakType(Pe);for(;Y>0;){const je=M(O,Y),et=le.getGraphemeBreakType(je);if(fe(et,$e))break;Y-=je>=65536?2:1,$e=et}return Ae-Y}e.prevCharLength=N;function G(O,Y){const le=Ne.getInstance(),Ae=O.length,Pe=Y,$e=H(O,Ae,Y),je=le.getGraphemeBreakType($e);Y+=$e>=65536?2:1;let et=je;for(;Y<Ae;){const Je=H(O,Ae,Y),Qe=le.getGraphemeBreakType(Je);if(fe(et,Qe))break;Y+=Je>=65536?2:1,et=Qe}const it=Y;for(Y=Pe,et=je;Y>0;){const Je=M(O,Y),Qe=le.getGraphemeBreakType(Je);if(fe(Qe,et))break;Y-=Je>=65536?2:1,et=Qe}return[Y,it]}function me(O,Y){return Y>0&&oe(O.charCodeAt(Y))?G(O,Y-1):G(O,Y)}e.getCharContainingOffset=me;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ne(O){return W.test(O)}e.containsRTL=ne;const ge=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function _e(O){return ge.test(O)}e.containsEmoji=_e;const Me=/^[\t\n\r\x20-\x7E]*$/;function Fe(O){return Me.test(O)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function xe(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=xe;function Ye(O){for(let Y=0,le=O.length;Y<le;Y++)if(Ve(O.charCodeAt(Y)))return!0;return!1}e.containsFullWidthCharacter=Ye;function Ve(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=Ve;function qe(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=qe;function x(O,Y){if(O.length<Y)return O;const le=/\b/g;let Ae=0;for(;le.test(O)&&!(O.length-le.lastIndex<Y);)Ae=le.lastIndex,le.lastIndex+=1;return O.substring(Ae).replace(/^\s/,"")}e.lcut=x;const Q=/\x1B\x5B[12]?K/g,X=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function q(O){return O&&(O=O.replace(Q,""),O=O.replace(X,""),O=O.replace(re,"")),O}e.removeAnsiEscapeCodes=q,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ie(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ie;function pe(O){return ie(O)?O.substr(1):O}e.stripUTF8BOM=pe;function Te(O,Y){if(!O||!Y||O.length<Y.length)return!1;const le=Y.length,Ae=O.toLowerCase();let Pe=0,$e=-1;for(;Pe<le;){const je=Ae.indexOf(Y[Pe],$e+1);if(je<0)return!1;$e=je,Pe++}return!0}e.fuzzyContains=Te;function Be(O,Y=!1){return O?(Y&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=Be;function ve(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=ve;function Ke(O,Y=1){if(Y===0)return"";let le=-1;do le=O.indexOf(`
`,le+1),Y--;while(Y>0&&le>=0);return le===-1?O:(O[le-1]==="\r"&&le--,O.substr(0,le))}e.getNLines=Ke;function z(O){const Y=90-65+1;return O=O%(2*Y),O<Y?String.fromCharCode(97+O):String.fromCharCode(65+O-Y)}e.singleLetterHash=z;function Z(O){return Ne.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=Z;function fe(O,Y){return O===0?Y!==5&&Y!==7:O===2&&Y===3?!1:O===4||O===2||O===3||Y===4||Y===2||Y===3?!0:!(O===8&&(Y===8||Y===9||Y===11||Y===12)||(O===11||O===9)&&(Y===9||Y===10)||(O===12||O===10)&&Y===10||Y===5||Y===13||Y===7||O===1||O===13&&Y===14||O===6&&Y===6)}e.breakBetweenGraphemeBreakType=fe;var Oe;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Xe()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const le=this._data,Ae=le.length/3;let Pe=1;for(;Pe<=Ae;)if(Y<le[3*Pe])Pe=2*Pe;else if(Y>le[3*Pe+1])Pe=2*Pe+1;else return le[3*Pe+2];return 0}}Ne._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(O,Y){if(O===0)return 0;const le=ye(O,Y);if(le!==void 0)return le;const Ae=M(Y,O);return O-=Ce(Ae),O}e.getLeftDeleteOffset=De;function ye(O,Y){let le=M(Y,O);for(O-=Ce(le);se(le)||le===65039||le===8419;){if(O===0)return;le=M(Y,O),O-=Ce(le)}if(!!qe(le)){if(O>=0){const Ae=M(Y,O);Ae===8205&&(O-=Ce(Ae))}return O}}function Ce(O){return O>=65536?2:1}function se(O){return 127995<=O&&O<=127999}var ue;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(we[43],be([0,1,8]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return D(w,0)}e.hash=R;function D(w,A){switch(typeof w){case"object":return w===null?S(349,A):Array.isArray(w)?y(w,A):T(w,A);case"string":return E(w,A);case"boolean":return k(w,A);case"number":return S(w,A);case"undefined":return S(937,A);default:return S(617,A)}}e.doHash=D;function S(w,A){return(A<<5)-A+w|0}function k(w,A){return S(w?433:863,A)}function E(w,A){A=S(149417,A);for(let o=0,p=w.length;o<p;o++)A=S(w.charCodeAt(o),A);return A}e.stringHash=E;function y(w,A){return A=S(104579,A),w.reduce((o,p)=>D(p,o),A)}function T(w,A){return A=S(181387,A),Object.keys(w).sort().reduce((o,p)=>(o=E(p,o),D(w[p],o)),A)}class n{constructor(){this._value=0}get value(){return this._value}hash(A){return this._value=D(A,this._value),this._value}}e.Hasher=n;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function l(w,A,o=32){const p=o-A,v=~((1<<p)-1);return(w<<A|(v&w)>>>p)>>>0}function h(w,A=0,o=w.byteLength,p=0){for(let v=0;v<o;v++)w[A+v]=p}function u(w,A,o="0"){for(;w.length<A;)w=o+w;return w}function g(w,A=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(o=>o.toString(16).padStart(2,"0")).join(""):u((w>>>0).toString(16),A/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(A){const o=A.length;if(o===0)return;const p=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,a,s;for(t!==0?(a=t,s=-1,t=0):(a=A.charCodeAt(0),s=0);;){let i=a;if(d.isHighSurrogate(a))if(s+1<o){const c=A.charCodeAt(s+1);d.isLowSurrogate(c)?(s++,i=d.computeCodePoint(a,c)):i=65533}else{t=a;break}else d.isLowSurrogate(a)&&(i=65533);if(v=this._push(p,v,i),s++,s<o)a=A.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(A,o,p){return p<128?A[o++]=p:p<2048?(A[o++]=192|(p&1984)>>>6,A[o++]=128|(p&63)>>>0):p<65536?(A[o++]=224|(p&61440)>>>12,A[o++]=128|(p&4032)>>>6,A[o++]=128|(p&63)>>>0):(A[o++]=240|(p&1835008)>>>18,A[o++]=128|(p&258048)>>>12,A[o++]=128|(p&4032)>>>6,A[o++]=128|(p&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,A[0]=A[64+0],A[1]=A[64+1],A[2]=A[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const A=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(A/4294967296),!1),this._buffDV.setUint32(60,A%4294967296,!1),this._step()}_step(){const A=b._bigBlock32,o=this._buffDV;for(let m=0;m<64;m+=4)A.setUint32(m,o.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)A.setUint32(m,l(A.getUint32(m-12,!1)^A.getUint32(m-32,!1)^A.getUint32(m-56,!1)^A.getUint32(m-64,!1),1),!1);let p=this._h0,v=this._h1,t=this._h2,a=this._h3,s=this._h4,i,c,f;for(let m=0;m<80;m++)m<20?(i=v&t|~v&a,c=1518500249):m<40?(i=v^t^a,c=1859775393):m<60?(i=v&t|v&a|t&a,c=2400959708):(i=v^t^a,c=3395469782),f=l(p,5)+i+s+c+A.getUint32(m*4,!1)&4294967295,s=a,a=t,t=l(v,30),v=p,p=f;this._h0=this._h0+p&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[36],be([0,1,8]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const S="error",k="warning",E="warn",y="info",T="ignore";function n(l){return l?d.equalsIgnoreCase(S,l)?D.Error:d.equalsIgnoreCase(k,l)||d.equalsIgnoreCase(E,l)?D.Warning:d.equalsIgnoreCase(y,l)?D.Info:D.Ignore:D.Ignore}D.fromValue=n;function C(l){switch(l){case D.Error:return S;case D.Warning:return k;case D.Info:return y;default:return T}}D.toString=C}(R||(R={})),e.default=R}),define(we[10],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function d(m){return Array.isArray(m)}e.isArray=d;function R(m){return typeof m=="string"}e.isString=R;function D(m){return Array.isArray(m)&&m.every(_=>R(_))}e.isStringArray=D;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function k(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=k;function E(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=E;function y(m){return m===!0||m===!1}e.isBoolean=y;function T(m){return typeof m=="undefined"}e.isUndefined=T;function n(m){return!C(m)}e.isDefined=n;function C(m){return T(m)||m===null}e.isUndefinedOrNull=C;function l(m,_){if(!m)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=l;function h(m){if(C(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=h;function u(...m){const _=[];for(let I=0;I<m.length;I++){const r=m[I];if(C(r))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);_.push(r)}return _}e.assertAllDefined=u;const g=Object.prototype.hasOwnProperty;function b(m){if(!S(m))return!1;for(let _ in m)if(g.call(m,_))return!1;return!0}e.isEmptyObject=b;function w(m){return typeof m=="function"}e.isFunction=w;function A(...m){return m.length>0&&m.every(w)}e.areFunctions=A;function o(m,_){const I=Math.min(m.length,_.length);for(let r=0;r<I;r++)p(m[r],_[r])}e.validateConstraints=o;function p(m,_){if(R(_)){if(typeof m!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(m instanceof _)return}catch{}if(!C(m)&&m.constructor===_||_.length===1&&_.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function v(m){let _=[],I=Object.getPrototypeOf(m);for(;Object.prototype!==I;)_=_.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return _}e.getAllPropertyNames=v;function t(m){const _=[];for(const I of v(m))typeof m[I]=="function"&&_.push(I);return _}e.getAllMethodNames=t;function a(m,_){const I=P=>function(){const F=Array.prototype.slice.call(arguments,0);return _(P,F)};let r={};for(const P of m)r[P]=I(P);return r}e.createProxyObject=a;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function i(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=i;function c(m){return class{constructor(){return new Proxy({},{get(_,I){if(_[I])return _[I];throw new Error(`Not Implemented: ${m}->${String(I)}`)}})}}}e.NotImplementedProxy=c;function f(m,_="Unreachable"){throw new Error(_)}e.assertNever=f}),define(we[44],be([0,1,14,22,8,10]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function E(s){return s.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=E;function y(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function T(s,i=d.posix.sep){if(!s)return"";const c=s.length,f=s.charCodeAt(0);if(k(f)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let _=3;const I=_;for(;_<c&&!k(s.charCodeAt(_));_++);if(I!==_&&!k(s.charCodeAt(_+1))){for(_+=1;_<c;_++)if(k(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,i)}}return i}else if(w(f)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(k(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=T;function n(s){if(!R.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let c=2;const f=c;for(;c<s.length&&(i=s.charCodeAt(c),i!==92);c++);return!(f===c||(i=s.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(s,i=R.isWindows){const c=i?C:l;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||i&&h.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=u;function g(s,i,c){const f=s===i;return!c||f?f:!s||!i?!1:(0,D.equalsIgnoreCase)(s,i)}e.isEqual=g;function b(s,i,c,f=d.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let _=i.length;return i.charAt(i.length-1)===f&&_--,s.charAt(_)===f}return i.charAt(i.length-1)!==f&&(i+=f),s.indexOf(i)===0}e.isEqualOrParent=b;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function A(s,i){return R.isWindows&&s.endsWith(":")&&(s+=d.sep),(0,d.isAbsolute)(s)||(s=(0,d.join)(i,s)),s=(0,d.normalize)(s),R.isWindows?(s=(0,D.rtrim)(s,d.sep),s.endsWith(":")&&(s+=d.sep)):(s=(0,D.rtrim)(s,d.sep),s||(s=d.sep)),s}e.sanitizeFilePath=A;function o(s){const i=(0,d.normalize)(s);return R.isWindows?s.length>3?!1:p(i)&&(s.length===2||i.charCodeAt(2)===92):i===d.posix.sep}e.isRootOrDriveLetter=o;function p(s){return R.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function v(s){return p(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,c){return i.length>s.length?-1:s===i?0:(c&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function a(s){const i=s.split(":");let c,f,m;if(i.forEach(_=>{const I=Number(_);(0,S.isNumber)(I)?f===void 0?f=I:m===void 0&&(m=I):c=c?[c,_].join(":"):_}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(we[23],be([0,1,10]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(w=>{g[w]&&typeof g[w]=="object"?b[w]=R(g[w]):b[w]=g[w]}),b}e.deepClone=R;function D(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const A in w)if(S.call(w,A)){const o=w[A];typeof o=="object"&&!Object.isFrozen(o)&&b.push(o)}}return g}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function k(g,b){return E(g,b,new Set)}e.cloneAndChange=k;function E(g,b,w){if((0,d.isUndefinedOrNull)(g))return g;const A=b(g);if(typeof A!="undefined")return A;if((0,d.isArray)(g)){const o=[];for(const p of g)o.push(E(p,b,w));return o}if((0,d.isObject)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const o={};for(let p in g)S.call(g,p)&&(o[p]=E(g[p],b,w));return w.delete(g),o}return g}function y(g,b,w=!0){return(0,d.isObject)(g)?((0,d.isObject)(b)&&Object.keys(b).forEach(A=>{A in g?w&&((0,d.isObject)(g[A])&&(0,d.isObject)(b[A])?y(g[A],b[A],w):g[A]=b[A]):g[A]=b[A]}),g):b}e.mixin=y;function T(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let w,A;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(w=0;w<g.length;w++)if(!T(g[w],b[w]))return!1}else{const o=[];for(A in g)o.push(A);o.sort();const p=[];for(A in b)p.push(A);if(p.sort(),!T(o,p))return!1;for(w=0;w<o.length;w++)if(!T(g[o[w]],b[o[w]]))return!1}return!0}e.equals=T;function n(g){const b=new Set;return JSON.stringify(g,(w,A)=>{if((0,d.isObject)(A)||Array.isArray(A)){if(b.has(A))return"[Circular]";b.add(A)}return A})}e.safeStringify=n;function C(g,b,w){const A=b(g);return typeof A=="undefined"?w:A}e.getOrDefault=C;function l(g,b){const w=Object.create(null);return!g||!b||Object.keys(b).forEach(o=>{const p=g[o],v=b[o];T(p,v)||(w[o]=v)}),w}e.distinct=l;function h(g,b){const w=b.toLowerCase(),A=Object.keys(g).find(o=>o.toLowerCase()===w);return A?g[A]:g[b]}e.getCaseInsensitive=h;function u(g,b){const w=Object.create(null);for(const A of Object.keys(g))b(A,g[A])&&(w[A]=g[A]);return w}e.filter=u}),define(we[81],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var d;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d=e.Constants||(e.Constants={}));function R(S){return S<0?0:S>255?255:S|0}e.toUint8=R;function D(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=D}),define(we[2],be([0,1,14,22]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,k=/^\/\//;function E(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,i){return!s&&!i?"file":s}function T(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const n="",C="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,c,f,m,_,I=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,I),this.authority=c||n,this.path=T(this.scheme,f||n),this.query=m||n,this.fragment=_||n,E(this,I))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return o(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:f,path:m,query:_,fragment:I}=i;return c===void 0?c=this.scheme:c===null&&(c=n),f===void 0?f=this.authority:f===null&&(f=n),m===void 0?m=this.path:m===null&&(m=n),_===void 0?_=this.query:_===null&&(_=n),I===void 0?I=this.fragment:I===null&&(I=n),c===this.scheme&&f===this.authority&&m===this.path&&_===this.query&&I===this.fragment?this:new g(c,f,m,_,I)}static parse(i,c=!1){const f=l.exec(i);return f?new g(f[2]||n,a(f[4]||n),a(f[5]||n),a(f[7]||n),a(f[9]||n),c):new g(n,n,n,n,n)}static file(i){let c=n;if(R.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const f=i.indexOf(C,2);f===-1?(c=i.substring(2),i=C):(c=i.substring(2,f),i=i.substring(f)||C)}return new g("file",c,i,n,n)}static from(i){const c=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return E(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return R.isWindows&&i.scheme==="file"?f=h.file(d.win32.join(o(i,!0),...c)).path:f=d.posix.join(i.path,...c),i.with({path:f})}toString(i=!1){return p(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const c=new g(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=h;const u=R.isWindows?1:void 0;class g extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(i=!1){return i?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let c,f=-1;for(let m=0;m<s.length;m++){const _=s.charCodeAt(m);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||i&&_===47)f!==-1&&(c+=encodeURIComponent(s.substring(f,m)),f=-1),c!==void 0&&(c+=s.charAt(m));else{c===void 0&&(c=s.substr(0,m));const I=b[_];I!==void 0?(f!==-1&&(c+=encodeURIComponent(s.substring(f,m)),f=-1),c+=I):f===-1&&(f=m)}}return f!==-1&&(c+=encodeURIComponent(s.substring(f))),c!==void 0?c:s}function A(s){let i;for(let c=0;c<s.length;c++){const f=s.charCodeAt(c);f===35||f===63?(i===void 0&&(i=s.substr(0,c)),i+=b[f]):i!==void 0&&(i+=s[c])}return i!==void 0?i:s}function o(s,i){let c;return s.authority&&s.path.length>1&&s.scheme==="file"?c=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?c=s.path.substr(1):c=s.path[1].toLowerCase()+s.path.substr(2):c=s.path,R.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=o;function p(s,i){const c=i?A:w;let f="",{scheme:m,authority:_,path:I,query:r,fragment:P}=s;if(m&&(f+=m,f+=":"),(_||m==="file")&&(f+=C,f+=C),_){let F=_.indexOf("@");if(F!==-1){const B=_.substr(0,F);_=_.substr(F+1),F=B.indexOf(":"),F===-1?f+=c(B,!1):(f+=c(B.substr(0,F),!1),f+=":",f+=c(B.substr(F+1),!1)),f+="@"}_=_.toLowerCase(),F=_.indexOf(":"),F===-1?f+=c(_,!1):(f+=c(_.substr(0,F),!1),f+=_.substr(F))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const F=I.charCodeAt(1);F>=65&&F<=90&&(I=`/${String.fromCharCode(F+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const F=I.charCodeAt(0);F>=65&&F<=90&&(I=`${String.fromCharCode(F+32)}:${I.substr(2)}`)}f+=c(I,!0)}return r&&(f+="?",f+=c(r,!1)),P&&(f+="#",f+=i?P:w(P,!1)),f}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(s){return s.match(t)?s.replace(t,i=>v(i)):s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[21],be([0,1,8,2]),function(ee,e,d,R){"use strict";var D,S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(t,a,s){let i=t.get(a);return i===void 0&&(i=s,t.set(a,i)),i}e.getOrSet=E;function y(t){const a=[];return t.forEach((s,i)=>{a.push(`${i} => ${s}`)}),`Map(${t.size}) {${a.join(", ")}}`}e.mapToString=y;function T(t){const a=[];return t.forEach(s=>{a.push(s)}),`Set(${t.size}) {${a.join(", ")}}`}e.setToString=T;class n{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const s=a.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class C{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,d.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,d.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class l{constructor(a=!0,s=!0){this._splitOnBackslash=a,this._caseSensitive=s}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,d.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,d.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class u{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,d.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,d.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,d.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,d.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(a){this._iter=a}static forUris(a=()=>!1){return new b(new u(a))}static forPaths(){return new b(new l)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new C)}clear(){this._root=void 0}set(a,s){const i=this._iter.reset(a);let c;for(this._root||(this._root=new g,this._root.segment=i.value()),c=this._root;;){const m=i.cmp(c.segment);if(m>0)c.left||(c.left=new g,c.left.segment=i.value()),c=c.left;else if(m<0)c.right||(c.right=new g,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new g,c.mid.segment=i.value()),c=c.mid;else break}const f=c.value;return c.value=s,c.key=a,f}get(a){return this._getNode(a)?.value}_getNode(a){const s=this._iter.reset(a);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(a){const s=this._getNode(a);return!(s?.value===void 0&&s?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,s){const i=this._iter.reset(a),c=[];let f=this._root;for(;f;){const m=i.cmp(f.segment);if(m>0)c.push([1,f]),f=f.left;else if(m<0)c.push([-1,f]),f=f.right;else if(i.hasNext())i.next(),c.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;c.length>0&&f.isEmpty();){let[_,I]=c.pop();switch(_){case 1:I.left=void 0;break;case 0:I.mid=void 0;break;case-1:I.right=void 0;break}f=I}break}}}findSubstr(a){const s=this._iter.reset(a);let i=this._root,c;for(;i;){const f=s.cmp(i.segment);if(f>0)i=i.left;else if(f<0)i=i.right;else if(s.hasNext())s.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(a){const s=this._iter.reset(a);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(a){for(const[s,i]of this)a(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){if(!a)return;const s=[a];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=b;class w{constructor(a,s){this[D]="ResourceMap",a instanceof w?(this.map=new Map(a.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=a??w.defaultToKey)}set(a,s){return this.map.set(this.toKey(a),s),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,s){typeof s!="undefined"&&(a=a.bind(s));for(let[i,c]of this.map)a(c,R.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield R.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[R.URI.parse(a[0]),a[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let a of this.map)yield[R.URI.parse(a[0]),a[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var A;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(A=e.Touch||(e.Touch={}));class o{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,s=0){const i=this._map.get(a);if(!!i)return s!==0&&this.touch(i,s),i.value}set(a,s,i=0){let c=this._map.get(a);if(c)c.value=s,i!==0&&this.touch(c,i);else{switch(c={key:a,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(a,c),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const s=this._map.get(a);if(!!s)return this._map.delete(a),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,s){const i=this._state;let c=this._head;for(;c;){if(s?a.bind(s)(c.value,c.key,this):a(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const a=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:i.key,done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return c}values(){const a=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:i.value,done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return c}entries(){const a=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(a._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:[i.key,i.value],done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return c}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>a;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const s=a.next,i=a.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}a.next=void 0,a.previous=void 0,this._state++}touch(a,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(a===this._head)return;const i=a.next,c=a.previous;a===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(s===2){if(a===this._tail)return;const i=a.next,c=a.previous;a===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((s,i)=>{a.push([i,s])}),a}fromJSON(a){this.clear();for(const[s,i]of a)this.set(s,i)}}e.LinkedMap=o;class p extends o{constructor(a,s=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,s=2){return super.get(a,s)}peek(a){return super.get(a,0)}set(a,s){return super.set(a,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class v{constructor(a){k.set(this,void 0),nt(this,k,a,"f")}get size(){return Ue(this,k,"f").size}forEach(a,s){Ue(this,k,"f").forEach(a,s)}get(a){return Ue(this,k,"f").get(a)}has(a){return Ue(this,k,"f").has(a)}entries(){return Ue(this,k,"f").entries()}keys(){return Ue(this,k,"f").keys()}values(){return Ue(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ue(this,k,"f").entries()}}e.ReadonlyMapView=v}),define(we[114],be([0,1,21,8]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...q){return function(ie,pe){for(let Te=0,Be=q.length;Te<Be;Te++){const ve=q[Te](ie,pe);if(ve)return ve}return null}}e.or=D,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(q,ie,pe){if(!pe||pe.length<ie.length)return null;let Te;return q?Te=R.startsWithIgnoreCase(pe,ie):Te=pe.indexOf(ie)===0,Te?ie.length>0?[{start:0,end:ie.length}]:[]:null}function k(q,ie){const pe=ie.toLowerCase().indexOf(q.toLowerCase());return pe===-1?null:[{start:pe,end:pe+q.length}]}e.matchesContiguousSubString=k;function E(q,ie){return y(q.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=E;function y(q,ie,pe,Te){if(pe===q.length)return[];if(Te===ie.length)return null;if(q[pe]===ie[Te]){let Be=null;return(Be=y(q,ie,pe+1,Te+1))?w({start:Te,end:Te+1},Be):null}return y(q,ie,pe,Te+1)}function T(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function C(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>h.add(q.charCodeAt(0)));function u(q){return l(q)||h.has(q)}function g(q,ie){return q===ie||u(q)&&u(ie)}function b(q){return T(q)||n(q)||C(q)}function w(q,ie){return ie.length===0?ie=[q]:q.end===ie[0].start?ie[0].start=q.start:ie.unshift(q),ie}function A(q,ie){for(let pe=ie;pe<q.length;pe++){const Te=q.charCodeAt(pe);if(n(Te)||C(Te)||pe>0&&!b(q.charCodeAt(pe-1)))return pe}return q.length}function o(q,ie,pe,Te){if(pe===q.length)return[];if(Te===ie.length)return null;if(q[pe]!==ie[Te].toLowerCase())return null;{let Be=null,ve=Te+1;for(Be=o(q,ie,pe+1,Te+1);!Be&&(ve=A(ie,ve))<ie.length;)Be=o(q,ie,pe+1,ve),ve++;return Be===null?null:w({start:Te,end:Te+1},Be)}}function p(q){let ie=0,pe=0,Te=0,Be=0,ve=0;for(let Oe=0;Oe<q.length;Oe++)ve=q.charCodeAt(Oe),n(ve)&&ie++,T(ve)&&pe++,b(ve)&&Te++,C(ve)&&Be++;const Ke=ie/q.length,z=pe/q.length,Z=Te/q.length,fe=Be/q.length;return{upperPercent:Ke,lowerPercent:z,alphaPercent:Z,numericPercent:fe}}function v(q){const{upperPercent:ie,lowerPercent:pe}=q;return pe===0&&ie>.6}function t(q){const{upperPercent:ie,lowerPercent:pe,alphaPercent:Te,numericPercent:Be}=q;return pe>.2&&ie<.8&&Te>.6&&Be<.2}function a(q){let ie=0,pe=0,Te=0,Be=0;for(let ve=0;ve<q.length;ve++)Te=q.charCodeAt(ve),n(Te)&&ie++,T(Te)&&pe++,l(Te)&&Be++;return(ie===0||pe===0)&&Be===0?q.length<=30:ie<=5}function s(q,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!a(q)||ie.length>60)return null;const pe=p(ie);if(!t(pe)){if(!v(pe))return null;ie=ie.toLowerCase()}let Te=null,Be=0;for(q=q.toLowerCase();Be<ie.length&&(Te=o(q,ie,0,Be))===null;)Be=A(ie,Be+1);return Te}e.matchesCamelCase=s;function i(q,ie,pe=!1){if(!ie||ie.length===0)return null;let Te=null,Be=0;for(q=q.toLowerCase(),ie=ie.toLowerCase();Be<ie.length&&(Te=c(q,ie,0,Be,pe))===null;)Be=f(ie,Be+1);return Te}e.matchesWords=i;function c(q,ie,pe,Te,Be){if(pe===q.length)return[];if(Te===ie.length)return null;if(g(q.charCodeAt(pe),ie.charCodeAt(Te))){let ve=null,Ke=Te+1;if(ve=c(q,ie,pe+1,Te+1,Be),!Be)for(;!ve&&(Ke=f(ie,Ke))<ie.length;)ve=c(q,ie,pe+1,Ke,Be),Ke++;return ve===null?null:w({start:Te,end:Te+1},ve)}else return null}function f(q,ie){for(let pe=ie;pe<q.length;pe++)if(u(q.charCodeAt(pe))||pe>0&&u(q.charCodeAt(pe-1)))return pe;return q.length}const m=D(e.matchesPrefix,s,k),_=D(e.matchesPrefix,s,E),I=new d.LRUCache(1e4);function r(q,ie,pe=!1){if(typeof q!="string"||typeof ie!="string")return null;let Te=I.get(q);Te||(Te=new RegExp(R.convertSimple2RegExpPattern(q),"i"),I.set(q,Te));const Be=Te.exec(ie);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:pe?_(q,ie):m(q,ie)}e.matchesFuzzy=r;function P(q,ie){const pe=Ye(q,q.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=P;function F(q,ie,pe,Te,Be,ve){const Ke=Math.min(13,q.length);for(;pe<Ke;pe++){const z=Ye(q,ie,pe,Te,Be,ve,!1);if(z)return z}return[0,ve]}e.anyScore=F;function B(q){if(typeof q=="undefined")return[];const ie=[],pe=q[1];for(let Te=q.length-1;Te>1;Te--){const Be=q[Te]+pe,ve=ie[ie.length-1];ve&&ve.end===Be?ve.end=Be+1:ie.push({start:Be,end:Be+1})}return ie}e.createMatches=B;const j=128;function ae(){const q=[],ie=[];for(let pe=0;pe<=j;pe++)ie[pe]=0;for(let pe=0;pe<=j;pe++)q.push(ie.slice(0));return q}function oe(q){const ie=[];for(let pe=0;pe<=q;pe++)ie[pe]=0;return ie}const V=oe(2*j),H=oe(2*j),M=ae(),K=ae(),N=ae(),G=!1;function me(q,ie,pe,Te,Be){function ve(z,Z,fe=" "){for(;z.length<Z;)z=fe+z;return z}let Ke=` |   |${Te.split("").map(z=>ve(z,3)).join("|")}
`;for(let z=0;z<=pe;z++)z===0?Ke+=" |":Ke+=`${ie[z-1]}|`,Ke+=q[z].slice(0,Be+1).map(Z=>ve(Z.toString(),3)).join("|")+`
`;return Ke}function W(q,ie,pe,Te){q=q.substr(ie),pe=pe.substr(Te),console.log(me(K,q,q.length,pe,pe.length)),console.log(me(N,q,q.length,pe,pe.length)),console.log(me(M,q,q.length,pe,pe.length))}function ne(q,ie){if(ie<0||ie>=q.length)return!1;const pe=q.codePointAt(ie);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(pe)}}function ge(q,ie){if(ie<0||ie>=q.length)return!1;switch(q.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function _e(q,ie,pe){return ie[q]!==pe[q]}function Me(q,ie,pe,Te,Be,ve,Ke=!1){for(;ie<pe&&Be<ve;)q[ie]===Te[Be]&&(Ke&&(V[ie]=Be),ie+=1),Be+=1;return ie===pe}e.isPatternInWord=Me;var Fe;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var xe;(function(q){q.Default=[-100,0];function ie(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}q.isDefault=ie})(xe=e.FuzzyScore||(e.FuzzyScore={}));function Ye(q,ie,pe,Te,Be,ve,Ke){const z=q.length>j?j:q.length,Z=Te.length>j?j:Te.length;if(pe>=z||ve>=Z||z-pe>Z-ve||!Me(ie,pe,z,Be,ve,Z,!0))return;Ve(z,Z,pe,ve,ie,Be);let fe=1,Oe=1,Ne=pe,Xe=ve;const De=[!1];for(fe=1,Ne=pe;Ne<z;fe++,Ne++){const O=V[Ne],Y=H[Ne],le=Ne+1<z?H[Ne+1]:Z;for(Oe=O-ve+1,Xe=O;Xe<le;Oe++,Xe++){let Ae=Number.MIN_SAFE_INTEGER,Pe=!1;Xe<=Y&&(Ae=qe(q,ie,Ne,pe,Te,Be,Xe,Z,ve,M[fe-1][Oe-1]===0,De));let $e=0;Ae!==Number.MAX_SAFE_INTEGER&&(Pe=!0,$e=Ae+K[fe-1][Oe-1]);const je=Xe>O,et=je?K[fe][Oe-1]+(M[fe][Oe-1]>0?-5:0):0,it=Xe>O+1&&M[fe][Oe-1]>0,Je=it?K[fe][Oe-2]+(M[fe][Oe-2]>0?-5:0):0;if(it&&(!je||Je>=et)&&(!Pe||Je>=$e))K[fe][Oe]=Je,N[fe][Oe]=3,M[fe][Oe]=0;else if(je&&(!Pe||et>=$e))K[fe][Oe]=et,N[fe][Oe]=2,M[fe][Oe]=0;else if(Pe)K[fe][Oe]=$e,N[fe][Oe]=1,M[fe][Oe]=M[fe-1][Oe-1]+1;else throw new Error("not possible")}}if(G&&W(q,pe,Te,ve),!De[0]&&!Ke)return;fe--,Oe--;const ye=[K[fe][Oe],ve];let Ce=0,se=0;for(;fe>=1;){let O=Oe;do{const Y=N[fe][O];if(Y===3)O=O-2;else if(Y===2)O=O-1;else break}while(O>=1);Ce>1&&ie[pe+fe-1]===Be[ve+Oe-1]&&!_e(O+ve-1,Te,Be)&&Ce+1>M[fe][O]&&(O=Oe),O===Oe?Ce++:Ce=1,se||(se=O),fe--,Oe=O-1,ye.push(Oe)}Z===z&&(ye[0]+=2);const ue=se-z;return ye[0]-=ue,ye}e.fuzzyScore=Ye;function Ve(q,ie,pe,Te,Be,ve){let Ke=q-1,z=ie-1;for(;Ke>=pe&&z>=Te;)Be[Ke]===ve[z]&&(H[Ke]=z,Ke--),z--}function qe(q,ie,pe,Te,Be,ve,Ke,z,Z,fe,Oe){if(ie[pe]!==ve[Ke])return Number.MIN_SAFE_INTEGER;let Ne=1,Xe=!1;return Ke===pe-Te?Ne=q[pe]===Be[Ke]?7:5:_e(Ke,Be,ve)&&(Ke===0||!_e(Ke-1,Be,ve))?(Ne=q[pe]===Be[Ke]?7:5,Xe=!0):ne(ve,Ke)&&(Ke===0||!ne(ve,Ke-1))?Ne=5:(ne(ve,Ke-1)||ge(ve,Ke-1))&&(Ne=5,Xe=!0),Ne>1&&pe===Te&&(Oe[0]=!0),Xe||(Xe=_e(Ke,Be,ve)||ne(ve,Ke-1)||ge(ve,Ke-1)),pe===Te?Ke>Z&&(Ne-=Xe?3:5):fe?Ne+=Xe?2:0:Ne+=Xe?0:1,Ke+1===z&&(Ne-=Xe?3:5),Ne}function x(q,ie,pe,Te,Be,ve,Ke){return X(q,ie,pe,Te,Be,ve,!0,Ke)}e.fuzzyScoreGracefulAggressive=x;function Q(q,ie,pe,Te,Be,ve,Ke){return X(q,ie,pe,Te,Be,ve,!1,Ke)}e.fuzzyScoreGraceful=Q;function X(q,ie,pe,Te,Be,ve,Ke,z){let Z=Ye(q,ie,pe,Te,Be,ve,z);if(Z&&!Ke)return Z;if(q.length>=3){const fe=Math.min(7,q.length-1);for(let Oe=pe+1;Oe<fe;Oe++){const Ne=re(q,Oe);if(Ne){const Xe=Ye(Ne,Ne.toLowerCase(),pe,Te,Be,ve,z);Xe&&(Xe[0]-=3,(!Z||Xe[0]>Z[0])&&(Z=Xe))}}}return Z}function re(q,ie){if(ie+1>=q.length)return;const pe=q[ie],Te=q[ie+1];if(pe!==Te)return q.slice(0,ie)+Te+pe+q.slice(ie+2)}}),define(we[115],be([0,1,35,114,8]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${S.source}`,"g");function E(g){return g.replace(k,(b,w)=>w?b:`\\${b}`)}e.escapeIcons=E;const y=new RegExp(`\\\\${S.source}`,"g");function T(g){return g.replace(y,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=T;const n=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function C(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(n,(b,w,A,o)=>A?b:w||o||"")}e.stripIcons=C;function l(g){const b=g.indexOf(e.iconStartMarker);return b===-1?{text:g}:h(g,b)}e.parseLabelWithIcons=l;function h(g,b){const w=[];let A="";function o(f){if(f){A+=f;for(const m of f)w.push(t)}}let p=-1,v="",t=0,a,s,i=b;const c=g.length;for(o(g.substr(0,b));i<c;)a=g[i],s=g[i+1],a===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(p=i,o(v),v=e.iconStartMarker,i++):a===")"&&p!==-1?(t+=i-p+1,p=-1,v=""):p!==-1?/^[a-z0-9\-]$/i.test(a)?v+=a:(o(v),p=-1,v=""):o(a),i++;return o(v),{text:A,iconOffsets:w}}function u(g,b,w=!1){const{text:A,iconOffsets:o}=b;if(!o||o.length===0)return(0,R.matchesFuzzy)(g,A,w);const p=(0,D.ltrim)(A," "),v=A.length-p.length,t=(0,R.matchesFuzzy)(g,p,w);if(t)for(const a of t){const s=o[a.start+v]+v;a.start+=s,a.end+=s}return t}e.matchesFuzzyIconAware=u}),define(we[82],be([0,1,12,115]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",u=!1){if(this.value=h,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(h,u=0){return this.value+=T(this.supportThemeIcons?(0,R.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,u){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=S;function k(l){return E(l)?!l.value:Array.isArray(l)?l.every(k):!0}e.isEmptyMarkdownString=k;function E(l){return l instanceof S?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function y(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=y;function T(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function C(l){const h=[],u=l.split("|").map(b=>b.trim());l=u[0];const g=u[1];if(g){const b=/height=(\d+)/.exec(g),w=/width=(\d+)/.exec(g),A=b?b[1]:"",o=w?w[1]:"",p=isFinite(parseInt(o)),v=isFinite(parseInt(A));p&&h.push(`width="${o}"`),v&&h.push(`height="${A}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=C}),define(we[58],be([0,1,24,8,2]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(n){return JSON.stringify(n,y)}e.stringify=S;function k(n){let C=JSON.parse(n);return C=T(C),C}e.parse=k;var E;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function y(n,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function T(n,C=0){if(!n||C>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof d.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=T(n[l],C+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=T(n[l],C+1))}return n}e.revive=T}),define(we[11],be([0,1,22,2]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,T,n){this._hosts[y]=T,this._ports[y]=n}setConnectionToken(y,T){this._connectionTokens[y]=T}rewrite(y){if(this._delegate)return this._delegate(y);const T=y.authority;let n=this._hosts[T];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const C=this._ports[T],l=this._connectionTokens[T];let h=`path=${encodeURIComponent(y.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),R.URI.from({scheme:d.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${C}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new S;class k{asBrowserUri(y,T){const n=this.toUri(y,T);return n.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===D.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?n.with({scheme:D.vscodeFileResource,authority:n.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,T){const n=this.toUri(y,T);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==k.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,T){return R.URI.isUri(y)?y:R.URI.parse(T.toUrl(y))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(we[25],be([0,1,44,11,14,22,8,2]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(h){return(0,E.uriToFsPath)(h,!0)}e.originalFSPath=y;class T{constructor(u){this._ignorePathCasing=u}compare(u,g,b=!1){return u===g?0:(0,k.compare)(this.getComparisonKey(u,b),this.getComparisonKey(g,b))}isEqual(u,g,b=!1){return u===g?!0:!u||!g?!1:this.getComparisonKey(u,b)===this.getComparisonKey(g,b)}getComparisonKey(u,g=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,g,b=!1){if(u.scheme===g.scheme){if(u.scheme===R.Schemas.file)return d.isEqualOrParent(y(u),y(g),this._ignorePathCasing(u))&&u.query===g.query&&(b||u.fragment===g.fragment);if((0,e.isEqualAuthority)(u.authority,g.authority))return d.isEqualOrParent(u.path,g.path,this._ignorePathCasing(u),"/")&&u.query===g.query&&(b||u.fragment===g.fragment)}return!1}joinPath(u,...g){return E.URI.joinPath(u,...g)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){const g=D.posix.extname(u.path),b=g.indexOf("?");return b!==-1?g.substr(0,b):g}dirname(u){if(u.path.length===0)return u;let g;return u.scheme===R.Schemas.file?g=E.URI.file(D.dirname(y(u))).path:(g=D.posix.dirname(u.path),u.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),g="/")),u.with({path:g})}normalizePath(u){if(!u.path.length)return u;let g;return u.scheme===R.Schemas.file?g=E.URI.file(D.normalize(y(u))).path:g=D.posix.normalize(u.path),u.with({path:g})}relativePath(u,g){if(u.scheme!==g.scheme||!(0,e.isEqualAuthority)(u.authority,g.authority))return;if(u.scheme===R.Schemas.file){const A=D.relative(y(u),y(g));return S.isWindows?d.toSlashes(A):A}let b=u.path||"/",w=g.path||"/";if(this._ignorePathCasing(u)){let A=0;for(const o=Math.min(b.length,w.length);A<o&&!(b.charCodeAt(A)!==w.charCodeAt(A)&&b.charAt(A).toLowerCase()!==w.charAt(A).toLowerCase());A++);b=w.substr(0,A)+b.substr(A)}return D.posix.relative(b,w)}resolvePath(u,g){if(u.scheme===R.Schemas.file){const b=E.URI.file(D.resolve(y(u),g));return u.with({authority:b.authority,path:b.path})}return g=d.toPosixPath(g),u.with({path:D.posix.resolve(u.path,g)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,g){return u===g||(0,k.equalsIgnoreCase)(u,g)}hasTrailingPathSeparator(u,g=D.sep){if(u.scheme===R.Schemas.file){const b=y(u);return b.length>d.getRoot(b).length&&b[b.length-1]===g}else{const b=u.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,g=D.sep){return(0,e.hasTrailingPathSeparator)(u,g)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,g=D.sep){let b=!1;if(u.scheme===R.Schemas.file){const w=y(u);b=w!==void 0&&w.length===d.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=u.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(u,g)?u.with({path:u.path+"/"}):u}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(h=>h.scheme===R.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new T(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,u){const g=[];for(let b=0;b<h.length;b++){const w=u(h[b]);h.some((A,o)=>o===b?!1:(0,e.isEqualOrParent)(w,u(A)))||g.push(h[b])}return g}e.distinctParents=n;var C;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function u(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[p,v]=o.split(":");p&&v&&b.set(p,v)});const A=g.path.substring(0,g.path.indexOf(";"));return A&&b.set(h.META_DATA_MIME,A),b}h.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function l(h,u,g){if(u){let b=h.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),h.with({scheme:g,authority:u,path:b})}return h.with({scheme:g})}e.toLocalResource=l}),define(we[15],be([0,1,20,12,3,6,25]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(H){return!!H&&typeof H.then=="function"}e.isThenable=E;function y(H){const M=new d.CancellationTokenSource,K=H(M.token),N=new Promise((G,me)=>{const W=M.token.onCancellationRequested(()=>{W.dispose(),M.dispose(),me((0,R.canceled)())});Promise.resolve(K).then(ne=>{W.dispose(),M.dispose(),G(ne)},ne=>{W.dispose(),M.dispose(),me(ne)})});return new class{cancel(){M.cancel()}then(G,me){return N.then(G,me)}catch(G){return this.then(void 0,G)}finally(G){return N.finally(G)}}}e.createCancelablePromise=y;function T(H,M,K){return Promise.race([H,new Promise(N=>M.onCancellationRequested(()=>N(K)))])}e.raceCancellation=T;async function n(H){let M=-1;const K=H.map((G,me)=>G.then(W=>(M=me,W))),N=await Promise.race(K);return H.forEach((G,me)=>{me!==M&&G.cancel()}),N}e.raceCancellablePromises=n;function C(H,M,K){let N;const G=setTimeout(()=>{N?.(void 0),K?.()},M);return Promise.race([H.finally(()=>clearTimeout(G)),new Promise(me=>N=me)])}e.raceTimeout=C;function l(H){return new Promise((M,K)=>{const N=H();E(N)?N.then(M,K):M(N)})}e.asPromise=l;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const K=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(K,K).then(N)})}return new Promise((K,N)=>{this.queuedPromise.then(K,N)})}return this.activePromise=M(),new Promise((K,N)=>{this.activePromise.then(G=>{this.activePromise=null,K(G)},G=>{this.activePromise=null,N(G)})})}}e.Throttler=h;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class g{constructor(){this.promiseMap=new Map}queue(M,K){const G=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(M)===G&&this.promiseMap.delete(M)});return this.promiseMap.set(M,G),G}}e.SequencerByKey=g;class b{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,K=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,G)=>{this.doResolve=N,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},K),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(M){this.delayer=new b(M),this.throttler=new h}trigger(M,K){return this.delayer.trigger(()=>this.throttler.queue(M),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class A{constructor(){this._isOpen=!1,this._promise=new Promise((M,K)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=A;class o extends A{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function p(H,M){return M?new Promise((K,N)=>{const G=setTimeout(()=>{me.dispose(),K()},H),me=M.onCancellationRequested(()=>{clearTimeout(G),me.dispose(),N((0,R.canceled)())})}):y(K=>p(H,K))}e.timeout=p;function v(H,M=0){const K=setTimeout(H,M);return(0,S.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=v;function t(H){const M=[];let K=0;const N=H.length;function G(){return K<N?H[K++]():null}function me(W){W!=null&&M.push(W);const ne=G();return ne?ne.then(me):Promise.resolve(M)}return Promise.resolve(null).then(me)}e.sequence=t;function a(H,M=N=>!!N,K=null){let N=0;const G=H.length,me=()=>{if(N>=G)return Promise.resolve(K);const W=H[N++];return Promise.resolve(W()).then(ge=>M(ge)?Promise.resolve(ge):me())};return me()}e.first=a;function s(H,M=N=>!!N,K=null){if(H.length===0)return Promise.resolve(K);let N=H.length;const G=()=>{N=-1;for(const me of H)me.cancel?.()};return new Promise((me,W)=>{for(const ne of H)ne.then(ge=>{--N>=0&&M(ge)?(G(),me(ge)):N===0&&me(K)}).catch(ge=>{--N>=0&&(G(),W(ge))})})}e.firstParallel=s;class i{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((K,N)=>{this.outstandingPromises.push({factory:M,c:K,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const K=M.factory();K.then(M.c,M.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class f{constructor(){this.queues=new Map}queueFor(M,K=k.extUri){const N=K.getComparisonKey(M);let G=this.queues.get(N);return G||(G=new c,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(N)}),this.queues.set(N,G)),G}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(M,K){this._token=-1,typeof M=="function"&&typeof K=="number"&&this.setIfNotSet(M,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},K)}setIfNotSet(M,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},K))}}e.TimeoutTimer=m;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,K){this.cancel(),this._token=setInterval(()=>{M()},K)}}e.IntervalTimer=_;class I{constructor(M,K){this.timeoutToken=-1,this.runner=M,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class r extends I{constructor(M,K){super(M,K);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=r;class P extends S.Disposable{constructor(M,K,N,G){super();this.maxWorkChunkSize=M,this.maxPendingWork=K,this.throttleDelay=N,this.handler=G,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new I(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=P,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const K=setTimeout(()=>M(H));let N=!1;return{dispose(){N||(N=!0,clearTimeout(K))}}}}else e.runWhenIdle=(H,M)=>{const K=requestIdleCallback(H,typeof M=="number"?{timeout:M}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(K))}}}}();class F{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function B(H,M,K){let N;for(let G=0;G<K;G++)try{return await H()}catch(me){N=me,await p(M)}throw N}e.retry=B;class j{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,K,N){return this._pending={taskId:M,cancel:()=>N?.(),promise:K},K.then(()=>this.donePending(M),()=>this.donePending(M)),K}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let K,N;const G=new Promise((me,W)=>{K=me,N=W});this._next={run:M,promise:G,promiseResolve:K,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=j;class ae{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;class oe{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,K)=>{this.completeCallback=M,this.errorCallback=K})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(K=>{this.completeCallback(M),this.resolved=!0,K()})}error(M){return new Promise(K=>{this.errorCallback(M),this.rejected=!0,K()})}cancel(){new Promise(M=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=oe;var V;(function(H){async function M(K){let N;const G=await Promise.all(K.map(me=>me.then(W=>W,W=>{N||(N=W)})));if(typeof N!="undefined")throw N;return G}H.settled=M})(V=e.Promises||(e.Promises={}))}),define(we[116],be([0,1,15,14]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new d.IdleValue(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),S=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function E(I,r,P=!1){const F=I||"",B=r||"",j=D.value.collator.compare(F,B);return D.value.collatorIsNumeric&&j===0&&F!==B?F<B?-1:1:j}e.compareFileNames=E;function y(I,r){const P=S.value.collator;return I=I||"",r=r||"",v(P,I,r)}e.compareFileNamesDefault=y;function T(I,r){const P=S.value.collator;return I=I||"",r=r||"",i(I,r)||v(P,I,r)}e.compareFileNamesUpper=T;function n(I,r){const P=S.value.collator;return I=I||"",r=r||"",s(I,r)||v(P,I,r)}e.compareFileNamesLower=n;function C(I,r){return I=I||"",r=r||"",I===r?0:I<r?-1:1}e.compareFileNamesUnicode=C;function l(I,r,P=!1){P||(I=I&&I.toLowerCase(),r=r&&r.toLowerCase());const[F,B]=o(I),[j,ae]=o(r);return F!==j?F<j?-1:1:B===ae?0:B<ae?-1:1}e.noIntlCompareFileNames=l;function h(I,r){const[P,F]=o(I),[B,j]=o(r);let ae=D.value.collator.compare(F,j);if(ae===0){if(D.value.collatorIsNumeric&&F!==j)return F<j?-1:1;if(ae=D.value.collator.compare(P,B),D.value.collatorIsNumeric&&ae===0&&P!==B)return P<B?-1:1}return ae}e.compareFileExtensions=h;function u(I,r){I=I||"",r=r||"";const P=p(I),F=p(r),B=S.value.collator,j=k.value.collator;return v(j,P,F)||v(B,I,r)}e.compareFileExtensionsDefault=u;function g(I,r){I=I||"",r=r||"";const P=p(I),F=p(r),B=S.value.collator,j=k.value.collator;return v(j,P,F)||i(I,r)||v(B,I,r)}e.compareFileExtensionsUpper=g;function b(I,r){I=I||"",r=r||"";const P=p(I),F=p(r),B=S.value.collator,j=k.value.collator;return v(j,P,F)||s(I,r)||v(B,I,r)}e.compareFileExtensionsLower=b;function w(I,r){I=I||"",r=r||"";const P=p(I).toLowerCase(),F=p(r).toLowerCase();return P!==F?P<F?-1:1:I!==r?I<r?-1:1:0}e.compareFileExtensionsUnicode=w;const A=/^(.*?)(\.([^.]*))?$/;function o(I,r=!1){const P=I?A.exec(I):[];let F=[P&&P[1]||"",P&&P[3]||""];return r&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function p(I){const r=I?A.exec(I):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function v(I,r,P){let F=I.compare(r,P);return F!==0?F:r.length!==P.length?r.length<P.length?-1:1:0}function t(I){const r=I.charAt(0);return r.toLocaleUpperCase()!==r}function a(I){const r=I.charAt(0);return r.toLocaleLowerCase()!==r}function s(I,r){return t(I)&&a(r)?-1:a(I)&&t(r)?1:0}function i(I,r){return a(I)&&t(r)?-1:t(I)&&a(r)?1:0}function c(I,r,P=!1){return P||(I=I&&I.toLowerCase(),r=r&&r.toLowerCase()),I===r?0:I<r?-1:1}function f(I,r,P=!1){const F=I.split(R.sep),B=r.split(R.sep),j=F.length-1,ae=B.length-1;let oe,V;for(let H=0;;H++){if(oe=j===H,V=ae===H,oe&&V)return E(F[H],B[H],P);if(oe)return-1;if(V)return 1;const M=c(F[H],B[H],P);if(M!==0)return M}}e.comparePaths=f;function m(I,r,P){const F=I.toLowerCase(),B=r.toLowerCase(),j=_(I,r,P);if(j)return j;const ae=F.endsWith(P),oe=B.endsWith(P);if(ae!==oe)return ae?-1:1;const V=E(F,B);return V!==0?V:F.localeCompare(B)}e.compareAnything=m;function _(I,r,P){const F=I.toLowerCase(),B=r.toLowerCase(),j=F.startsWith(P),ae=B.startsWith(P);if(j!==ae)return j?-1:1;if(j&&ae){if(F.length<B.length)return-1;if(F.length>B.length)return 1}return 0}e.compareByPrefix=_}),define(we[27],be([0,1,15,44,21,14,8]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E;const y="**",T="/",n="[/\\\\]",C="[^/\\\\]",l=/\//g;function h(G){switch(G){case 0:return"";case 1:return`${C}*?`;default:return`(?:${n}|${C}+${n}|${n}${C}+)*?`}}function u(G,me){if(!G)return[];const W=[];let ne=!1,ge=!1,_e="";for(const Me of G){switch(Me){case me:if(!ne&&!ge){W.push(_e),_e="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}_e+=Me}return _e&&W.push(_e),W}e.splitGlobAware=u;function g(G){if(!G)return"";let me="";const W=u(G,T);if(W.every(ne=>ne===y))me=".*";else{let ne=!1;W.forEach((ge,_e)=>{if(ge===y){ne||(me+=h(2),ne=!0);return}let Me=!1,Fe="",xe=!1,Ye="";for(const Ve of ge){if(Ve!=="}"&&Me){Fe+=Ve;continue}if(xe&&(Ve!=="]"||!Ye)){let qe;Ve==="-"?qe=Ve:(Ve==="^"||Ve==="!")&&!Ye?qe="^":Ve===T?qe="":qe=k.escapeRegExpCharacters(Ve),Ye+=qe;continue}switch(Ve){case"{":Me=!0;continue;case"[":xe=!0;continue;case"}":me+=`(?:${u(Fe,",").map(Q=>g(Q)).join("|")})`,Me=!1,Fe="";break;case"]":me+="["+Ye+"]",xe=!1,Ye="";break;case"?":me+=C;continue;case"*":me+=h(1);continue;default:me+=k.escapeRegExpCharacters(Ve)}}_e<W.length-1&&(W[_e+1]!==y||_e+2<W.length)&&(me+=n),ne=!1})}return me}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),a=function(){return!1},s=function(){return null};function i(G,me){if(!G)return s;let W;typeof G!="string"?W=G.pattern:W=G,W=W.trim();const ne=`${W}_${!!me.trimForExclusions}`;let ge=t.get(ne);if(ge)return c(ge,G);let _e;if(b.test(W)){const Me=W.substr(4);ge=function(Fe,xe){return typeof Fe=="string"&&Fe.endsWith(Me)?W:null}}else(_e=w.exec(f(W,me)))?ge=m(_e[1],W):(me.trimForExclusions?o:A).test(W)?ge=_(W,me):(_e=p.exec(f(W,me)))?ge=I(_e[1].substr(1),W,!0):(_e=v.exec(f(W,me)))?ge=I(_e[1],W,!1):ge=r(W);return t.set(ne,ge),c(ge,G)}function c(G,me){return typeof me=="string"?G:function(W,ne){return R.isEqualOrParent(W,me.base)?G(S.relative(me.base,W),ne):null}}function f(G,me){return me.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function m(G,me){const W=`/${G}`,ne=`\\${G}`,ge=function(Me,Fe){return typeof Me!="string"?null:Fe?Fe===G?me:null:Me===G||Me.endsWith(W)||Me.endsWith(ne)?me:null},_e=[G];return ge.basenames=_e,ge.patterns=[me],ge.allBasenames=_e,ge}function _(G,me){const W=N(G.slice(1,-1).split(",").map(Fe=>i(Fe,me)).filter(Fe=>Fe!==s),G),ne=W.length;if(!ne)return s;if(ne===1)return W[0];const ge=function(Fe,xe){for(let Ye=0,Ve=W.length;Ye<Ve;Ye++)if(W[Ye](Fe,xe))return G;return null},_e=W.find(Fe=>!!Fe.allBasenames);_e&&(ge.allBasenames=_e.allBasenames);const Me=W.reduce((Fe,xe)=>xe.allPaths?Fe.concat(xe.allPaths):Fe,[]);return Me.length&&(ge.allPaths=Me),ge}function I(G,me,W){const ne=S.sep===S.posix.sep,ge=ne?G:G.replace(l,S.sep),_e=S.sep+ge,Me=S.posix.sep+G,Fe=W?function(xe,Ye){return typeof xe=="string"&&(xe===ge||xe.endsWith(_e)||!ne&&(xe===G||xe.endsWith(Me)))?me:null}:function(xe,Ye){return typeof xe=="string"&&(xe===ge||!ne&&xe===G)?me:null};return Fe.allPaths=[(W?"*/":"./")+G],Fe}function r(G){try{const me=new RegExp(`^${g(G)}$`);return function(W){return me.lastIndex=0,typeof W=="string"&&me.test(W)?G:null}}catch(me){return s}}function P(G,me,W){return!G||typeof me!="string"?!1:F(G)(me,void 0,W)}e.match=P;function F(G,me={}){if(!G)return a;if(typeof G=="string"||oe(G)){const W=i(G,me);if(W===s)return a;const ne=function(ge,_e){return!!W(ge,_e)};return W.allBasenames&&(ne.allBasenames=W.allBasenames),W.allPaths&&(ne.allPaths=W.allPaths),ne}return M(G,me)}e.parse=F;function B(G){if(!G)return;let me;return W=>(me||(me=(G()||Promise.resolve([])).then(ne=>ne?ae(ne):{})),me.then(ne=>!!ne[W]))}e.hasSiblingPromiseFn=B;function j(G){if(!G)return;let me;return W=>{if(!me){const ne=G();me=ne?ae(ne):{}}return!!me[W]}}e.hasSiblingFn=j;function ae(G){const me={};for(const W of G)me[W]=!0;return me}function oe(G){const me=G;return me&&typeof me.base=="string"&&typeof me.pattern=="string"}e.isRelativePattern=oe;function V(G){return G.allBasenames||[]}e.getBasenameTerms=V;function H(G){return G.allPaths||[]}e.getPathTerms=H;function M(G,me){const W=N(Object.getOwnPropertyNames(G).map(Fe=>K(Fe,G[Fe],me)).filter(Fe=>Fe!==s)),ne=W.length;if(!ne)return s;if(!W.some(Fe=>!!Fe.requiresSiblings)){if(ne===1)return W[0];const Fe=function(Ve,qe){for(let x=0,Q=W.length;x<Q;x++){const X=W[x](Ve,qe);if(X)return X}return null},xe=W.find(Ve=>!!Ve.allBasenames);xe&&(Fe.allBasenames=xe.allBasenames);const Ye=W.reduce((Ve,qe)=>qe.allPaths?Ve.concat(qe.allPaths):Ve,[]);return Ye.length&&(Fe.allPaths=Ye),Fe}const ge=function(Fe,xe,Ye){let Ve;for(let qe=0,x=W.length;qe<x;qe++){const Q=W[qe];Q.requiresSiblings&&Ye&&(xe||(xe=S.basename(Fe)),Ve||(Ve=xe.substr(0,xe.length-S.extname(Fe).length)));const X=Q(Fe,xe,Ve,Ye);if(X)return X}return null},_e=W.find(Fe=>!!Fe.allBasenames);_e&&(ge.allBasenames=_e.allBasenames);const Me=W.reduce((Fe,xe)=>xe.allPaths?Fe.concat(xe.allPaths):Fe,[]);return Me.length&&(ge.allPaths=Me),ge}function K(G,me,W){if(me===!1)return s;const ne=i(G,W);if(ne===s)return s;if(typeof me=="boolean")return ne;if(me){const ge=me.when;if(typeof ge=="string"){const _e=(Me,Fe,xe,Ye)=>{if(!Ye||!ne(Me,Fe))return null;const Ve=ge.replace("$(basename)",xe),qe=Ye(Ve);return(0,d.isThenable)(qe)?qe.then(x=>x?G:null):qe?G:null};return _e.requiresSiblings=!0,_e}}return ne}function N(G,me){const W=G.filter(Fe=>!!Fe.basenames);if(W.length<2)return G;const ne=W.reduce((Fe,xe)=>{const Ye=xe.basenames;return Ye?Fe.concat(Ye):Fe},[]);let ge;if(me){ge=[];for(let Fe=0,xe=ne.length;Fe<xe;Fe++)ge.push(me)}else ge=W.reduce((Fe,xe)=>{const Ye=xe.patterns;return Ye?Fe.concat(Ye):Fe},[]);const _e=function(Fe,xe){if(typeof Fe!="string")return null;if(!xe){let Ve;for(Ve=Fe.length;Ve>0;Ve--){const qe=Fe.charCodeAt(Ve-1);if(qe===47||qe===92)break}xe=Fe.substr(Ve)}const Ye=ne.indexOf(xe);return Ye!==-1?ge[Ye]:null};_e.basenames=ne,_e.patterns=ge,_e.allBasenames=ne;const Me=G.filter(Fe=>!Fe.basenames);return Me.push(_e),Me}}),define(we[83],be([0,1,44,11,14,22,25,8,2]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,c,f){if(typeof i=="string"&&(i=y.URI.file(i)),f){const _=f.getWorkspaceFolder(i);if(_){const I=f.getWorkspace().folders.length>1;let r;if((0,k.isEqual)(_.uri,i)?r="":r=(0,k.relativePath)(_.uri,i),I){const P=_.name?_.name:(0,k.basename)(_.uri);r=r?P+" \u2022 "+r:P}return r}}if(i.scheme!==R.Schemas.file&&i.scheme!==R.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(i.fsPath))return(0,D.normalize)(C(i.fsPath));let m=(0,D.normalize)(i.fsPath);return!S.isWindows&&c?.userHome&&(m=h(m,c.userHome.fsPath)),m}e.getPathLabel=T;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,k.basename)(i)||(i.scheme===R.Schemas.file?i.fsPath:i.path);return S.isWindows&&(0,d.isRootOrDriveLetter)(c)?C(c):c}e.getBaseLabel=n;function C(i){return(0,d.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let l=Object.create(null);function h(i,c){if(S.isWindows||!i||!c)return i;let f=l.original===c?l.normalized:void 0;return f||(f=`${(0,E.rtrim)(c,D.posix.sep)}${D.posix.sep}`,l={original:c,normalized:f}),(S.isLinux?i.startsWith(f):(0,E.startsWithIgnoreCase)(i,f))&&(i=`~/${i.substr(f.length)}`),i}e.tildify=h;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const g="\u2026",b="\\\\",w="~";function A(i,c=D.sep){const f=new Array(i.length);let m=!1;for(let _=0;_<i.length;_++){let I=i[_];if(I===""){f[_]=`.${c}`;continue}if(!I){f[_]=I;continue}m=!0;let r="";I.indexOf(b)===0?(r=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(c)===0?(r=I.substr(0,I.indexOf(c)+c.length),I=I.substr(I.indexOf(c)+c.length)):I.indexOf(w)===0&&(r=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length));const P=I.split(c);for(let F=1;m&&F<=P.length;F++)for(let B=P.length-F;m&&B>=0;B--){m=!1;let j=P.slice(B,B+F).join(c);for(let ae=0;!m&&ae<i.length;ae++)if(ae!==_&&i[ae]&&i[ae].indexOf(j)>-1){const oe=B+F===P.length,V=B>0&&i[ae].indexOf(c)>-1?c+j:j,H=i[ae].endsWith(V);m=!oe||H}if(!m){let ae="";(P[0].endsWith(":")||r!=="")&&(B===1&&(B=0,F++,j=P[0]+c+j),B>0&&(ae=P[0]+c),ae=r+ae),B>0&&(ae=ae+g+c),ae=ae+j,B+F<P.length&&(ae=ae+c+g),f[_]=ae}}m&&(f[_]=I)}return f}e.shorten=A;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function p(i,c=Object.create(null)){const f=[];let m=!1,_="";for(const I of i)if(I==="$"||m&&I==="{")_&&f.push({value:_,type:o.TEXT}),_="",m=!0;else if(I==="}"&&m){const r=c[_];if(typeof r=="string")r.length&&f.push({value:r,type:o.VARIABLE});else if(r){const P=f[f.length-1];(!P||P.type!==o.SEPARATOR)&&f.push({value:r.label,type:o.SEPARATOR})}_="",m=!1}else _+=I;return _&&!m&&f.push({value:_,type:o.TEXT}),f.filter((I,r)=>{if(I.type===o.SEPARATOR){const P=f[r-1],F=f[r+1];return[P,F].every(B=>B&&(B.type===o.VARIABLE||B.type===o.TEXT)&&B.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=p;function v(i,c){return S.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return S.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):S.isWindows?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function a(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=a;function s(i){const c=i.indexOf("/")!==-1?D.posix:D.win32,f=c.basename(i),m=c.dirname(i);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(we[84],be([0,1,27,11,14,25,8]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var E;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(E=e.Mimes||(e.Mimes={}));let y=[],T=[],n=[];function C(i,c=!1){const f=l(i);y.push(f),f.userConfigured?n.push(f):T.push(f),c&&!f.userConfigured&&y.forEach(m=>{m.mime===f.mime||m.userConfigured||(f.extension&&m.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&m.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&m.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&m.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=C;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(D.posix.sep)>=0:!1}}function h(i){i?(y=y.filter(c=>!c.userConfigured),n=[]):(y=[],T=[],n=[])}e.clearTextMimes=h;function u(i,c){let f;if(i)switch(i.scheme){case R.Schemas.file:f=i.fsPath;break;case R.Schemas.data:f=S.DataUri.parseMetaData(i).get(S.DataUri.META_DATA_LABEL);break;default:f=i.path}if(!f)return[E.unknown];f=f.toLowerCase();const m=(0,D.basename)(f),_=g(f,m,n);if(_)return[_,E.text];const I=g(f,m,T);if(I)return[I,E.text];if(c){const r=b(c);if(r)return[r,E.text]}return[E.unknown]}e.guessMimeTypes=u;function g(i,c,f){let m=null,_=null,I=null;for(let r=f.length-1;r>=0;r--){const P=f[r];if(c===P.filenameLowercase){m=P;break}if(P.filepattern&&(!_||P.filepattern.length>_.filepattern.length)){const F=P.filepatternOnPath?i:c;(0,d.match)(P.filepatternLowercase,F)&&(_=P)}P.extension&&(!I||P.extension.length>I.extension.length)&&c.endsWith(P.extensionLowercase)&&(I=P)}return m?m.mime:_?_.mime:I?I.mime:null}function b(i){if((0,k.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let c=y.length-1;c>=0;c--){const f=y[c];if(!f.firstline)continue;const m=i.match(f.firstline);if(m&&m.length>0)return f.mime}return null}function w(i){return i?typeof i=="string"?i===E.binary||i===E.text||i===E.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(i){const c=(0,D.extname)(i),f=A[c.toLowerCase()];return f!==void 0?f:v(i)}e.getMediaOrTextMime=p;function v(i){const c=(0,D.extname)(i);return o[c.toLowerCase()]}e.getMediaMime=v;function t(i){for(const c in o)if(o[c]===i)return c}e.getExtensionForMimeType=t;const a=/^(.+)\/(.+?)(;.+)?$/;function s(i,c){const f=a.exec(i);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:c?void 0:i}e.normalizeMimeType=s}),define(we[117],be([0,1,2]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class D{constructor(C){this._uriTransformer=C}transformIncoming(C){const l=this._uriTransformer.transformIncoming(C);return l===C?C:R(d.URI.from(l))}transformOutgoing(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:R(d.URI.from(l))}transformOutgoingURI(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:d.URI.from(l)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function S(n,C,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof d.URI)return C.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const u=S(n[h],C,l+1);u!==null&&(n[h]=u)}}return null}function k(n,C){const l=S(n,C,0);return l===null?n:l}e.transformOutgoingURIs=k;function E(n,C,l,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?d.URI.revive(C.transformIncoming(n)):C.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const g=E(n[u],C,l,h+1);g!==null&&(n[u]=g)}}return null}function y(n,C){const l=E(n,C,!1,0);return l===null?n:l}e.transformIncomingURIs=y;function T(n,C){const l=E(n,C,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=T}),define(we[37],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return d.test(y)}e.isUUID=R;const D=new Uint8Array(16),S=[];for(let y=0;y<256;y++)S.push(y.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let T=0;T<y.length;T++)y[T]=Math.floor(Math.random()*256);return y};function E(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,T="";return T+=S[D[y++]],T+=S[D[y++]],T+=S[D[y++]],T+=S[D[y++]],T+="-",T+=S[D[y++]],T+=S[D[y++]],T+="-",T+=S[D[y++]],T+=S[D[y++]],T+="-",T+=S[D[y++]],T+=S[D[y++]],T+="-",T+=S[D[y++]],T+=S[D[y++]],T+=S[D[y++]],T+=S[D[y++]],T+=S[D[y++]],T+=S[D[y++]],T}e.generateUuid=E}),define(we[85],be([0,1,81]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(E){let y=(0,d.toUint8)(E);this._defaultValue=y,this._asciiMap=R._createAsciiMap(y),this._map=new Map}static _createAsciiMap(E){let y=new Uint8Array(256);for(let T=0;T<256;T++)y[T]=E;return y}set(E,y){let T=(0,d.toUint8)(y);E>=0&&E<256?this._asciiMap[E]=T:this._map.set(E,T)}get(E){return E>=0&&E<256?this._asciiMap[E]:this._map.get(E)||this._defaultValue}}e.CharacterClassifier=R;var D;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(D||(D={}));class S{constructor(){this._actual=new R(0)}add(E){this._actual.set(E,1)}has(E){return this._actual.get(E)===1}}e.CharacterSet=S}),define(we[118],be([0,1,85]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends d.CharacterClassifier{constructor(E){super(0);for(let y=0,T=E.length;y<T;y++)this.set(E.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function S(k){let E={};return y=>(E.hasOwnProperty(y)||(E[y]=k(y)),E[y])}e.getMapForWordSeparators=S(k=>new D(k))}),define(we[38],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class d{constructor(D,S){this.lineNumber=D,this.column=S}with(D=this.lineNumber,S=this.column){return D===this.lineNumber&&S===this.column?this:new d(D,S)}delta(D=0,S=0){return this.with(this.lineNumber+D,this.column+S)}equals(D){return d.equals(this,D)}static equals(D,S){return!D&&!S?!0:!!D&&!!S&&D.lineNumber===S.lineNumber&&D.column===S.column}isBefore(D){return d.isBefore(this,D)}static isBefore(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<S.column}isBeforeOrEqual(D){return d.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<=S.column}static compare(D,S){let k=D.lineNumber|0,E=S.lineNumber|0;if(k===E){let y=D.column|0,T=S.column|0;return y-T}return k-E}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new d(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=d}),define(we[31],be([0,1,38]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(S,k,E,y){S>E||S===E&&k>y?(this.startLineNumber=E,this.startColumn=y,this.endLineNumber=S,this.endColumn=k):(this.startLineNumber=S,this.startColumn=k,this.endLineNumber=E,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return R.containsPosition(this,S)}static containsPosition(S,k){return!(k.lineNumber<S.startLineNumber||k.lineNumber>S.endLineNumber||k.lineNumber===S.startLineNumber&&k.column<S.startColumn||k.lineNumber===S.endLineNumber&&k.column>S.endColumn)}containsRange(S){return R.containsRange(this,S)}static containsRange(S,k){return!(k.startLineNumber<S.startLineNumber||k.endLineNumber<S.startLineNumber||k.startLineNumber>S.endLineNumber||k.endLineNumber>S.endLineNumber||k.startLineNumber===S.startLineNumber&&k.startColumn<S.startColumn||k.endLineNumber===S.endLineNumber&&k.endColumn>S.endColumn)}strictContainsRange(S){return R.strictContainsRange(this,S)}static strictContainsRange(S,k){return!(k.startLineNumber<S.startLineNumber||k.endLineNumber<S.startLineNumber||k.startLineNumber>S.endLineNumber||k.endLineNumber>S.endLineNumber||k.startLineNumber===S.startLineNumber&&k.startColumn<=S.startColumn||k.endLineNumber===S.endLineNumber&&k.endColumn>=S.endColumn)}plusRange(S){return R.plusRange(this,S)}static plusRange(S,k){let E,y,T,n;return k.startLineNumber<S.startLineNumber?(E=k.startLineNumber,y=k.startColumn):k.startLineNumber===S.startLineNumber?(E=k.startLineNumber,y=Math.min(k.startColumn,S.startColumn)):(E=S.startLineNumber,y=S.startColumn),k.endLineNumber>S.endLineNumber?(T=k.endLineNumber,n=k.endColumn):k.endLineNumber===S.endLineNumber?(T=k.endLineNumber,n=Math.max(k.endColumn,S.endColumn)):(T=S.endLineNumber,n=S.endColumn),new R(E,y,T,n)}intersectRanges(S){return R.intersectRanges(this,S)}static intersectRanges(S,k){let E=S.startLineNumber,y=S.startColumn,T=S.endLineNumber,n=S.endColumn,C=k.startLineNumber,l=k.startColumn,h=k.endLineNumber,u=k.endColumn;return E<C?(E=C,y=l):E===C&&(y=Math.max(y,l)),T>h?(T=h,n=u):T===h&&(n=Math.min(n,u)),E>T||E===T&&y>n?null:new R(E,y,T,n)}equalsRange(S){return R.equalsRange(this,S)}static equalsRange(S,k){return!!S&&!!k&&S.startLineNumber===k.startLineNumber&&S.startColumn===k.startColumn&&S.endLineNumber===k.endLineNumber&&S.endColumn===k.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(S){return new d.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(S){return new d.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,k){return new R(this.startLineNumber,this.startColumn,S,k)}setStartPosition(S,k){return new R(S,k,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(S){return new R(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,k=S){return new R(S.lineNumber,S.column,k.lineNumber,k.column)}static lift(S){return S?new R(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,k){return!(S.endLineNumber<k.startLineNumber||S.endLineNumber===k.startLineNumber&&S.endColumn<k.startColumn||k.endLineNumber<S.startLineNumber||k.endLineNumber===S.startLineNumber&&k.endColumn<S.startColumn)}static areIntersecting(S,k){return!(S.endLineNumber<k.startLineNumber||S.endLineNumber===k.startLineNumber&&S.endColumn<=k.startColumn||k.endLineNumber<S.startLineNumber||k.endLineNumber===S.startLineNumber&&k.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,k){if(S&&k){const T=S.startLineNumber|0,n=k.startLineNumber|0;if(T===n){const C=S.startColumn|0,l=k.startColumn|0;if(C===l){const h=S.endLineNumber|0,u=k.endLineNumber|0;if(h===u){const g=S.endColumn|0,b=k.endColumn|0;return g-b}return h-u}return C-l}return T-n}return(S?1:0)-(k?1:0)}static compareRangesUsingEnds(S,k){return S.endLineNumber===k.endLineNumber?S.endColumn===k.endColumn?S.startLineNumber===k.startLineNumber?S.startColumn-k.startColumn:S.startLineNumber-k.startLineNumber:S.endColumn-k.endColumn:S.endLineNumber-k.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=R}),define(we[119],be([0,1,38,31]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class S extends R.Range{constructor(E,y,T,n){super(E,y,T,n);this.selectionStartLineNumber=E,this.selectionStartColumn=y,this.positionLineNumber=T,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(E){return S.selectionsEqual(this,E)}static selectionsEqual(E,y){return E.selectionStartLineNumber===y.selectionStartLineNumber&&E.selectionStartColumn===y.selectionStartColumn&&E.positionLineNumber===y.positionLineNumber&&E.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(E,y){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,E,y):new S(E,y,this.startLineNumber,this.startColumn)}getPosition(){return new d.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(E,y){return this.getDirection()===0?new S(E,y,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,E,y)}static fromPositions(E,y=E){return new S(E.lineNumber,E.column,y.lineNumber,y.column)}static liftSelection(E){return new S(E.selectionStartLineNumber,E.selectionStartColumn,E.positionLineNumber,E.positionColumn)}static selectionsArrEqual(E,y){if(E&&!y||!E&&y)return!1;if(!E&&!y)return!0;if(E.length!==y.length)return!1;for(let T=0,n=E.length;T<n;T++)if(!this.selectionsEqual(E[T],y[T]))return!1;return!0}static isISelection(E){return E&&typeof E.selectionStartLineNumber=="number"&&typeof E.selectionStartColumn=="number"&&typeof E.positionLineNumber=="number"&&typeof E.positionColumn=="number"}static createWithDirection(E,y,T,n,C){return C===0?new S(E,y,T,n):new S(T,n,E,y)}}e.Selection=S}),define(we[86],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var d;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(d=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var S;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(S=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class E{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace)}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=E;class y{constructor(g,b){this._findMatchBrand=void 0,this.range=g,this.matches=b}}e.FindMatch=y;var T;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class l{constructor(g,b,w,A,o,p){this.identifier=g,this.range=b,this.text=w,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=o,this._isTracked=p}}e.ValidAnnotatedEditOperation=l;class h{constructor(g,b,w){this.reverseEdits=g,this.changes=b,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(we[120],be([0,1,8,118,38,31,86]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const E=999;class y{constructor(o,p,v,t){this.searchString=o,this.isRegex=p,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let p=null;try{p=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(t){return null}if(!p)return null;let v=!this.isRegex&&!o;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(p,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=y;function T(A){if(!A||A.length===0)return!1;for(let o=0,p=A.length;o<p;o++)if(A.charCodeAt(o)===92){if(o++,o>=p)break;const t=A.charCodeAt(o);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=T;class n{constructor(o,p,v){this.regex=o,this.wordSeparators=p,this.simpleSearch=v}}e.SearchData=n;function C(A,o,p){if(!p)return new k.FindMatch(A,null);let v=[];for(let t=0,a=o.length;t<a;t++)v[t]=o[t];return new k.FindMatch(A,v)}e.createFindMatch=C;class l{constructor(o){let p=[],v=0;for(let t=0,a=o.length;t<a;t++)o.charCodeAt(t)===10&&(p[v++]=t);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(o){const p=this._lineFeedsOffsets;let v=0,t=p.length-1;if(t===-1||o<=p[0])return 0;for(;v<t;){const a=v+((t-v)/2>>0);p[a]>=o?t=a-1:p[a+1]>=o?(v=a,t=a):v=a+1}return v+1}}class h{static findMatches(o,p,v,t,a){const s=p.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(o,v,new w(s.wordSeparators,s.regex),t,a):this._doFindMatchesLineByLine(o,v,s,t,a):[]}static _getMultilineMatchRange(o,p,v,t,a,s){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(a),i=p+a+c):i=p+a;let f;if(t){let r=t.findLineFeedCountBeforeOffset(a+s.length)-c;f=i+s.length+r}else f=i+s.length;const m=o.getPositionAt(i),_=o.getPositionAt(f);return new S.Range(m.lineNumber,m.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(o,p,v,t,a){const s=o.getOffsetAt(p.getStartPosition()),i=o.getValueInRange(p,1),c=o.getEOL()===`\r
`?new l(i):null,f=[];let m=0,_;for(v.reset(0);_=v.next(i);)if(f[m++]=C(this._getMultilineMatchRange(o,s,i,c,_.index,_[0]),_,t),m>=a)return f;return f}static _doFindMatchesLineByLine(o,p,v,t,a){const s=[];let i=0;if(p.startLineNumber===p.endLineNumber){const f=o.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return i=this._findMatchesInLine(v,f,p.startLineNumber,p.startColumn-1,i,s,t,a),s}const c=o.getLineContent(p.startLineNumber).substring(p.startColumn-1);i=this._findMatchesInLine(v,c,p.startLineNumber,p.startColumn-1,i,s,t,a);for(let f=p.startLineNumber+1;f<p.endLineNumber&&i<a;f++)i=this._findMatchesInLine(v,o.getLineContent(f),f,0,i,s,t,a);if(i<a){const f=o.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);i=this._findMatchesInLine(v,f,p.endLineNumber,0,i,s,t,a)}return s}static _findMatchesInLine(o,p,v,t,a,s,i,c){const f=o.wordSeparators;if(!i&&o.simpleSearch){const I=o.simpleSearch,r=I.length,P=p.length;let F=-r;for(;(F=p.indexOf(I,F+r))!==-1;)if((!f||b(f,p,P,F,r))&&(s[a++]=new k.FindMatch(new S.Range(v,F+1+t,v,F+1+r+t),null),a>=c))return a;return a}const m=new w(o.wordSeparators,o.regex);let _;m.reset(0);do if(_=m.next(p),_&&(s[a++]=C(new S.Range(v,_.index+1+t,v,_.index+1+_[0].length+t),_,i),a>=c))return a;while(_);return a}static findNextMatch(o,p,v,t){const a=p.parseSearchRequest();if(!a)return null;const s=new w(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(o,v,s,t):this._doFindNextMatchLineByLine(o,v,s,t)}static _doFindNextMatchMultiline(o,p,v,t){const a=new D.Position(p.lineNumber,1),s=o.getOffsetAt(a),i=o.getLineCount(),c=o.getValueInRange(new S.Range(a.lineNumber,a.column,i,o.getLineMaxColumn(i)),1),f=o.getEOL()===`\r
`?new l(c):null;v.reset(p.column-1);let m=v.next(c);return m?C(this._getMultilineMatchRange(o,s,c,f,m.index,m[0]),m,t):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(o,new D.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(o,p,v,t){const a=o.getLineCount(),s=p.lineNumber,i=o.getLineContent(s),c=this._findFirstMatchInLine(v,i,s,p.column,t);if(c)return c;for(let f=1;f<=a;f++){const m=(s+f-1)%a,_=o.getLineContent(m+1),I=this._findFirstMatchInLine(v,_,m+1,1,t);if(I)return I}return null}static _findFirstMatchInLine(o,p,v,t,a){o.reset(t-1);const s=o.next(p);return s?C(new S.Range(v,s.index+1,v,s.index+1+s[0].length),s,a):null}static findPreviousMatch(o,p,v,t){const a=p.parseSearchRequest();if(!a)return null;const s=new w(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(o,v,s,t):this._doFindPreviousMatchLineByLine(o,v,s,t)}static _doFindPreviousMatchMultiline(o,p,v,t){const a=this._doFindMatchesMultiline(o,new S.Range(1,1,p.lineNumber,p.column),v,t,10*E);if(a.length>0)return a[a.length-1];const s=o.getLineCount();return p.lineNumber!==s||p.column!==o.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(o,new D.Position(s,o.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(o,p,v,t){const a=o.getLineCount(),s=p.lineNumber,i=o.getLineContent(s).substring(0,p.column-1),c=this._findLastMatchInLine(v,i,s,t);if(c)return c;for(let f=1;f<=a;f++){const m=(a+s-f-1)%a,_=o.getLineContent(m+1),I=this._findLastMatchInLine(v,_,m+1,t);if(I)return I}return null}static _findLastMatchInLine(o,p,v,t){let a=null,s;for(o.reset(0);s=o.next(p);)a=C(new S.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return a}}e.TextModelSearch=h;function u(A,o,p,v,t){if(v===0)return!0;const a=o.charCodeAt(v-1);if(A.get(a)!==0||a===13||a===10)return!0;if(t>0){const s=o.charCodeAt(v);if(A.get(s)!==0)return!0}return!1}function g(A,o,p,v,t){if(v+t===p)return!0;const a=o.charCodeAt(v+t);if(A.get(a)!==0||a===13||a===10)return!0;if(t>0){const s=o.charCodeAt(v+t-1);if(A.get(s)!==0)return!0}return!1}function b(A,o,p,v,t){return u(A,o,p,v,t)&&g(A,o,p,v,t)}e.isValidMatch=b;class w{constructor(o,p){this._wordSeparators=o,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const p=o.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(v=this._searchRegex.exec(o),!v))return null;const t=v.index,a=v[0].length;if(t===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){d.getNextCodePoint(o,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=a,!this._wordSeparators||b(this._wordSeparators,o,p,t,a))return v}while(v);return null}}e.Searcher=w}),define(we[87],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function d(E=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)E.indexOf(T)>=0||(y+="\\"+T);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=d();function R(E){let y=e.DEFAULT_WORD_REGEXP;if(E&&E instanceof RegExp)if(E.global)y=E;else{let T="g";E.ignoreCase&&(T+="i"),E.multiline&&(T+="m"),E.unicode&&(T+="u"),y=new RegExp(E.source,T)}return y.lastIndex=0,y}e.ensureValidWordDefinition=R;const D={maxLen:1e3,windowSize:15,timeBudget:150};function S(E,y,T,n,C=D){if(T.length>C.maxLen){let b=E-C.maxLen/2;return b<0?b=0:n+=b,T=T.substring(b,E+C.maxLen/2),S(E,y,T,n,C)}const l=Date.now(),h=E-1-n;let u=-1,g=null;for(let b=1;!(Date.now()-l>=C.timeBudget);b++){const w=h-C.windowSize*b;y.lastIndex=Math.max(0,w);const A=k(y,T,h,u);if(!A&&g||(g=A,w<=0))break;u=w}if(g){let b={word:g[0],startColumn:n+1+g.index,endColumn:n+1+g.index+g[0].length};return y.lastIndex=0,b}return null}e.getWordAtText=S;function k(E,y,T,n){let C;for(;C=E.exec(y);){const l=C.index||0;if(l<=T&&E.lastIndex>=T)return C;if(n>0&&l>n)return null}return null}}),define(we[121],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class R{constructor(E){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=E.open,this.close=E.close,this._standardTokenMask=0,Array.isArray(E.notIn))for(let y=0,T=E.notIn.length;y<T;y++)switch(E.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(E){return(this._standardTokenMask&E)==0}}e.StandardAutoClosingPairConditional=R;class D{constructor(E){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of E)S(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),S(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),S(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),S(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&S(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function S(k,E,y){k.has(E)?k.get(E).push(y):k.set(E,[y])}}),define(we[59],be([0,1,27,14]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(S,k,E,y){if(Array.isArray(S)){let T=0;for(const n of S){const C=D(n,k,E,y);if(C===10)return C;C>T&&(T=C)}return T}else{if(typeof S=="string")return y?S==="*"?5:S===E?10:0:0;if(S){const{language:T,pattern:n,scheme:C,hasAccessToAllModels:l}=S;if(!y&&!l)return 0;let h=0;if(C)if(C===k.scheme)h=10;else if(C==="*")h=5;else return 0;if(T)if(T===E)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,R.normalize)(n.base)},u===k.fsPath||(0,d.match)(u,k.fsPath))h=10;else return 0}return h}else return 0}}e.score=D}),define(we[122],be([0,1,85]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class D{constructor(u,g,b){const w=new Uint8Array(u*g);for(let A=0,o=u*g;A<o;A++)w[A]=b;this._data=w,this.rows=u,this.cols=g}get(u,g){return this._data[u*this.cols+g]}set(u,g,b){this._data[u*this.cols+g]=b}}e.Uint8Matrix=D;class S{constructor(u){let g=0,b=0;for(let A=0,o=u.length;A<o;A++){let[p,v,t]=u[A];v>g&&(g=v),p>b&&(b=p),t>b&&(b=t)}g++,b++;let w=new D(b,g,0);for(let A=0,o=u.length;A<o;A++){let[p,v,t]=u[A];w.set(p,v,t)}this._states=w,this._maxCharCode=g}nextState(u,g){return g<0||g>=this._maxCharCode?0:this._states.get(u,g)}}e.StateMachine=S;let k=null;function E(){return k===null&&(k=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var y;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let T=null;function n(){if(T===null){T=new d.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<h.length;g++)T.set(h.charCodeAt(g),1);const u=".,;";for(let g=0;g<u.length;g++)T.set(u.charCodeAt(g),2)}return T}class C{static _createLink(u,g,b,w,A){let o=A-1;do{const p=g.charCodeAt(o);if(u.get(p)!==2)break;o--}while(o>w);if(w>0){const p=g.charCodeAt(w-1),v=g.charCodeAt(o);(p===40&&v===41||p===91&&v===93||p===123&&v===125)&&o--}return{range:{startLineNumber:b,startColumn:w+1,endLineNumber:b,endColumn:o+2},url:g.substring(w,o+1)}}static computeLinks(u,g=E()){const b=n();let w=[];for(let A=1,o=u.getLineCount();A<=o;A++){const p=u.getLineContent(A),v=p.length;let t=0,a=0,s=0,i=1,c=!1,f=!1,m=!1,_=!1;for(;t<v;){let I=!1;const r=p.charCodeAt(t);if(i===13){let P;switch(r){case 40:c=!0,P=0;break;case 41:P=c?0:1;break;case 91:m=!0,f=!0,P=0;break;case 93:m=!1,P=f?0:1;break;case 123:_=!0,P=0;break;case 125:P=_?0:1;break;case 39:P=s===34||s===96?0:1;break;case 34:P=s===39||s===96?0:1;break;case 96:P=s===39||s===34?0:1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=m?0:1;break;default:P=b.get(r)}P===1&&(w.push(C._createLink(b,p,A,a,t)),I=!0)}else if(i===12){let P;r===91?(f=!0,P=0):P=b.get(r),P===1?I=!0:i=13}else i=g.nextState(i,r),i===0&&(I=!0);I&&(i=1,c=!1,f=!1,_=!1,a=t+1,s=r),t++}i===13&&w.push(C._createLink(b,p,A,a,v))}return w}}e.LinkComputer=C;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:C.computeLinks(h)}e.computeLinks=l}),define(we[123],be([0,1,3,6]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,E){return this._map.set(k,E),this.fire([k]),(0,R.toDisposable)(()=>{this._map.get(k)===E&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,E){let y=null,T=!1;return this._promises.set(k,E.then(n=>{this._promises.delete(k),!(T||!n)&&(y=this.register(k,n))})),(0,R.toDisposable)(()=>{T=!0,y&&y.dispose()})}getPromise(k){const E=this.get(k);if(E)return Promise.resolve(E);const y=this._promises.get(k);return y?y.then(T=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(we[88],be([0,1,24,22]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(D||(D={}));function S(C){for(let l=0,h=C.length;l<h;l+=4){const u=C[l+0],g=C[l+1],b=C[l+2],w=C[l+3];C[l+0]=w,C[l+1]=b,C[l+2]=g,C[l+3]=u}}function k(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return R.isLittleEndian()||S(l),d.VSBuffer.wrap(l)}function E(C){const l=C.buffer;if(R.isLittleEndian()||S(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function y(C){const l=new Uint32Array(T(C));let h=0;if(l[h++]=C.id,C.type==="full")l[h++]=1,l[h++]=C.data.length,l.set(C.data,h),h+=C.data.length;else{l[h++]=2,l[h++]=C.deltas.length;for(const u of C.deltas)l[h++]=u.start,l[h++]=u.deleteCount,u.data?(l[h++]=u.data.length,l.set(u.data,h),h+=u.data.length):l[h++]=0}return k(l)}e.encodeSemanticTokensDto=y;function T(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const h of C.deltas)h.data&&(l+=h.data.length)}return l}function n(C){const l=E(C);let h=0;const u=l[h++];if(l[h++]===1){const A=l[h++],o=l.subarray(h,h+A);return h+=A,{id:u,type:"full",data:o}}const b=l[h++];let w=[];for(let A=0;A<b;A++){const o=l[h++],p=l[h++],v=l[h++];let t;v>0&&(t=l.subarray(h,h+v),h+=v),w[A]={start:o,deleteCount:p,data:t}}return{id:u,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(we[89],be([0,1,81]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(k,E){this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=E}}e.PrefixSumIndexOfResult=R;class D{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,E){k=(0,d.toUint32)(k);const y=this.values,T=this.prefixSum,n=E.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,k),0),this.values.set(y.subarray(k),k+n),this.values.set(E,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,E){return k=(0,d.toUint32)(k),E=(0,d.toUint32)(E),this.values[k]===E?!1:(this.values[k]=E,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,E){k=(0,d.toUint32)(k),E=(0,d.toUint32)(E);const y=this.values,T=this.prefixSum;if(k>=y.length)return!1;let n=y.length-k;return E>=n&&(E=n),E===0?!1:(this.values=new Uint32Array(y.length-E),this.values.set(y.subarray(0,k),0),this.values.set(y.subarray(k+E),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=(0,d.toUint32)(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let E=this.prefixSumValidIndex[0]+1;E===0&&(this.prefixSum[0]=this.values[0],E++),k>=this.values.length&&(k=this.values.length-1);for(let y=E;y<=k;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let E=0,y=this.values.length-1,T=0,n=0,C=0;for(;E<=y;)if(T=E+(y-E)/2|0,n=this.prefixSum[T],C=n-this.values[T],k<C)y=T-1;else if(k>=n)E=T+1;else break;return new R(T,k-C)}}e.PrefixSumComputer=D}),define(we[124],be([0,1,8,38,89]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(E,y,T,n){this._uri=E,this._lines=y,this._eol=T,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(E){E.eol&&E.eol!==this._eol&&(this._eol=E.eol,this._lineStarts=null);const y=E.changes;for(const T of y)this._acceptDeleteRange(T.range),this._acceptInsertText(new R.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=E.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const E=this._eol.length,y=this._lines.length,T=new Uint32Array(y);for(let n=0;n<y;n++)T[n]=this._lines[n].length+E;this._lineStarts=new D.PrefixSumComputer(T)}}_setLineText(E,y){this._lines[E]=y,this._lineStarts&&this._lineStarts.changeValue(E,this._lines[E].length+this._eol.length)}_acceptDeleteRange(E){if(E.startLineNumber===E.endLineNumber){if(E.startColumn===E.endColumn)return;this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.startLineNumber-1].substring(E.endColumn-1));return}this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.endLineNumber-1].substring(E.endColumn-1)),this._lines.splice(E.startLineNumber,E.endLineNumber-E.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(E.startLineNumber,E.endLineNumber-E.startLineNumber)}_acceptInsertText(E,y){if(y.length===0)return;let T=(0,d.splitLines)(y);if(T.length===1){this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+T[0]+this._lines[E.lineNumber-1].substring(E.column-1));return}T[T.length-1]+=this._lines[E.lineNumber-1].substring(E.column-1),this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+T[0]);let n=new Uint32Array(T.length-1);for(let C=1;C<T.length;C++)this._lines.splice(E.lineNumber+C-1,0,T[C]),n[C-1]=T[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(E.lineNumber,n)}}e.MirrorTextModel=S}),define(we[125],be([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(we[60],be([0,1,17,10,125]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(T,n){return n&&(T.stack||T.stacktrace)?D.localize(0,null,E(T),k(T.stack)||k(T.stacktrace)):E(T)}function k(T){return Array.isArray(T)?T.join(`
`):T}function E(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?D.localize(1,null,T.message):T.message||D.localize(2,null)}function y(T=null,n=!1){if(!T)return D.localize(3,null);if(Array.isArray(T)){const C=d.coalesce(T),l=y(C[0],n);return C.length>1?D.localize(4,null,l,C.length):l}if(R.isString(T))return T;if(T.detail){const C=T.detail;if(C.error)return S(C.error,n);if(C.exception)return S(C.exception,n)}return T.stack?S(T,n):T.message?T.message:D.localize(5,null)}e.toErrorMessage=y}),define(we[126],be([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(we[127],be([0,1,126,22,87]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=k;class E{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,fe){this._values[Z]=fe}}e.ValidatedEditorOptions=E;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class T{constructor(Z,fe,Oe,Ne){this.id=Z,this.name=fe,this.defaultValue=Oe,this.schema=Ne}compute(Z,fe,Oe){return Oe}}class n{constructor(Z,fe=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(Z){return this.defaultValue}}class C{constructor(Z,fe,Oe,Ne){this.id=Z,this.name=fe,this.defaultValue=Oe,this.schema=Ne}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,fe,Oe){return Oe}}function l(z,Z){return typeof z=="undefined"?Z:z==="false"?!1:Boolean(z)}e.boolean=l;class h extends C{constructor(Z,fe,Oe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Oe),super(Z,fe,Oe,Ne)}validate(Z){return l(Z,this.defaultValue)}}class u extends C{constructor(Z,fe,Oe,Ne,Xe,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Oe,De.minimum=Ne,De.maximum=Xe),super(Z,fe,Oe,De),this.minimum=Ne,this.maximum=Xe}static clampedInt(Z,fe,Oe,Ne){if(typeof Z=="undefined")return fe;let Xe=parseInt(Z,10);return isNaN(Xe)?fe:(Xe=Math.max(Oe,Xe),Xe=Math.min(Ne,Xe),Xe|0)}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class g extends C{constructor(Z,fe,Oe,Ne,Xe){typeof Xe!="undefined"&&(Xe.type="number",Xe.default=Oe),super(Z,fe,Oe,Xe),this.validationFn=Ne}static clamp(Z,fe,Oe){return Z<fe?fe:Z>Oe?Oe:Z}static float(Z,fe){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return fe;const Oe=parseFloat(Z);return isNaN(Oe)?fe:Oe}validate(Z){return this.validationFn(g.float(Z,this.defaultValue))}}class b extends C{static string(Z,fe){return typeof Z!="string"?fe:Z}constructor(Z,fe,Oe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Oe),super(Z,fe,Oe,Ne)}validate(Z){return b.string(Z,this.defaultValue)}}function w(z,Z,fe){return typeof z!="string"||fe.indexOf(z)===-1?Z:z}e.stringSet=w;class A extends C{constructor(Z,fe,Oe,Ne,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Ne,Xe.default=Oe),super(Z,fe,Oe,Xe),this._allowedValues=Ne}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class o extends T{constructor(Z,fe,Oe,Ne,Xe,De,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=Xe,ye.default=Ne),super(Z,fe,Oe,ye),this._allowedValues=Xe,this._convert=De}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function p(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,fe,Oe){return Oe===0?Z.accessibilitySupport:Oe}}class t extends T{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{insertSpace:l(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(z){switch(z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function f(z){switch(z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class m extends n{constructor(){super(126,[64,31])}compute(Z,fe,Oe){const Ne=["monaco-editor"];return fe.get(31)&&Ne.push(fe.get(31)),Z.extraEditorClassName&&Ne.push(Z.extraEditorClassName),fe.get(64)==="default"?Ne.push("mouse-default"):fe.get(64)==="copy"&&Ne.push("mouse-copy"),fe.get(99)&&Ne.push("showUnused"),fe.get(124)&&Ne.push("showDeprecated"),Ne.join(" ")}}class _ extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Z,fe,Oe){return Oe&&Z.emptySelectionClipboard}}class I extends T{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:d.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:d.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{cursorMoveOnType:l(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":w(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(fe.loop,this.defaultValue.loop)}}}class r extends T{constructor(){super(42,"fontLigatures",r.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?r.OFF:Z==="true"?r.ON:Z:Boolean(Z)?r.ON:r.OFF}}e.EditorFontLigatures=r,r.OFF='"liga" off, "calt" off',r.ON='"liga" on, "calt" on';class P extends n{constructor(){super(41)}compute(Z,fe,Oe){return Z.fontInfo}}class F extends C{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(Z){let fe=g.float(Z,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(fe,6,100)}compute(Z,fe,Oe){return Z.fontInfo.fontSize}}class B extends T{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class j extends T{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Oe,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Oe,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Oe,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Oe,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Oe,description:d.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{multiple:w(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??w(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??w(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??w(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??w(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??w(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends T{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(51,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:d.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{enabled:l(fe.enabled,this.defaultValue.enabled),delay:u.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:l(fe.sticky,this.defaultValue.sticky)}}}var oe;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(oe=e.RenderMinimap||(e.RenderMinimap={}));class V extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(Z,fe,Oe){return V.computeLayout(fe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const fe=Z.height/Z.lineHeight,Oe=Z.scrollBeyondLastLine?fe-1:0,Ne=(Z.viewLineCount+Oe)/(Z.pixelRatio*Z.height),Xe=Math.floor(Z.viewLineCount/Ne);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Oe,desiredRatio:Ne,minimapLineCount:Xe}}static _computeMinimapLayout(Z,fe){const Oe=Z.outerWidth,Ne=Z.outerHeight,Xe=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const De=fe.stableMinimapLayoutInput,ye=De&&Z.outerHeight===De.outerHeight&&Z.lineHeight===De.lineHeight&&Z.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&Z.pixelRatio===De.pixelRatio&&Z.scrollBeyondLastLine===De.scrollBeyondLastLine&&Z.minimap.enabled===De.minimap.enabled&&Z.minimap.side===De.minimap.side&&Z.minimap.size===De.minimap.size&&Z.minimap.showSlider===De.minimap.showSlider&&Z.minimap.renderCharacters===De.minimap.renderCharacters&&Z.minimap.maxColumn===De.minimap.maxColumn&&Z.minimap.scale===De.minimap.scale&&Z.verticalScrollbarWidth===De.verticalScrollbarWidth&&Z.isViewportWrapping===De.isViewportWrapping,Ce=Z.lineHeight,se=Z.typicalHalfwidthCharacterWidth,ue=Z.scrollBeyondLastLine,O=Z.minimap.renderCharacters;let Y=Xe>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const le=Z.minimap.maxColumn,Ae=Z.minimap.size,Pe=Z.minimap.side,$e=Z.verticalScrollbarWidth,je=Z.viewLineCount,et=Z.remainingWidth,it=Z.isViewportWrapping,Je=O?2:3;let Qe=Math.floor(Xe*Ne);const mt=Qe/Xe;let vt=!1,Et=!1,ot=Je*Y,at=Y/Xe,Dt=1;if(Ae==="fill"||Ae==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:ze,desiredRatio:ft,minimapLineCount:bt}=V.computeContainedMinimapLineCount({viewLineCount:je,scrollBeyondLastLine:ue,height:Ne,lineHeight:Ce,pixelRatio:Xe});if(je/bt>1)vt=!0,Et=!0,Y=1,ot=1,at=Y/Xe;else{let dt=!1,ut=Y+1;if(Ae==="fit"){const ht=Math.ceil((je+ze)*ot);it&&ye&&et<=fe.stableFitRemainingWidth?(dt=!0,ut=fe.stableFitMaxMinimapScale):dt=ht>Qe}if(Ae==="fill"||dt){vt=!0;const ht=Y;ot=Math.min(Ce*Xe,Math.max(1,Math.floor(1/ft))),it&&ye&&et<=fe.stableFitRemainingWidth&&(ut=fe.stableFitMaxMinimapScale),Y=Math.min(ut,Math.max(1,Math.floor(ot/Je))),Y>ht&&(Dt=Math.min(2,Y/ht)),at=Y/Xe/Dt,Qe=Math.ceil(Math.max(Ze,je+ze)*ot),it?(fe.stableMinimapLayoutInput=Z,fe.stableFitRemainingWidth=et,fe.stableFitMaxMinimapScale=Y):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Ee=Math.floor(le*at),he=Math.min(Ee,Math.max(0,Math.floor((et-$e-2)*at/(se+at)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(Xe*he);const $=ce/Xe;ce=Math.floor(ce*Dt);const Ie=O?1:2,Le=Pe==="left"?0:Oe-he-$e;return{renderMinimap:Ie,minimapLeft:Le,minimapWidth:he,minimapHeightIsEditorHeight:vt,minimapIsSampling:Et,minimapScale:Y,minimapLineHeight:ot,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:$,minimapCanvasOuterHeight:mt}}static computeLayout(Z,fe){const Oe=fe.outerWidth|0,Ne=fe.outerHeight|0,Xe=fe.lineHeight|0,De=fe.lineNumbersDigitCount|0,ye=fe.typicalHalfwidthCharacterWidth,Ce=fe.maxDigitWidth,se=fe.pixelRatio,ue=fe.viewLineCount,O=Z.get(121),Y=O==="inherit"?Z.get(120):O,le=Y==="inherit"?Z.get(116):Y,Ae=Z.get(119),Pe=Z.get(2),$e=fe.isDominatedByLongLines,je=Z.get(47),et=Z.get(58).renderType!==0,it=Z.get(59),Je=Z.get(93),Qe=Z.get(63),mt=Z.get(91),vt=mt.verticalScrollbarSize,Et=mt.verticalHasArrows,ot=mt.arrowSize,at=mt.horizontalScrollbarSize,Dt=Z.get(56),Ee=Z.get(35);let he;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const It=parseFloat(Dt.substr(0,Dt.length-2));he=u.clampedInt(It*ye,0,0,1e3)}else he=u.clampedInt(Dt,0,0,1e3);Ee&&(he+=16);let ce=0;if(et){const It=Math.max(De,it);ce=Math.round(It*Ce)}let $=0;je&&($=Xe);let Ie=0,Le=Ie+$,Ze=Le+ce,ze=Ze+he;const ft=Oe-$-ce-he;let bt=!1,kt=!1,dt=-1;Pe!==2&&(Y==="inherit"&&$e?(bt=!0,kt=!0):le==="on"||le==="bounded"?kt=!0:le==="wordWrapColumn"&&(dt=Ae));const ut=V._computeMinimapLayout({outerWidth:Oe,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:ye,pixelRatio:se,scrollBeyondLastLine:Je,minimap:Qe,verticalScrollbarWidth:vt,viewLineCount:ue,remainingWidth:ft,isViewportWrapping:kt},fe.memory||new y);ut.renderMinimap!==0&&ut.minimapLeft===0&&(Ie+=ut.minimapWidth,Le+=ut.minimapWidth,Ze+=ut.minimapWidth,ze+=ut.minimapWidth);const ht=ft-ut.minimapWidth,_t=Math.max(1,Math.floor((ht-vt-2)/ye)),Tt=Et?ot:0;return kt&&(dt=Math.max(1,_t),le==="bounded"&&(dt=Math.min(dt,Ae))),{width:Oe,height:Ne,glyphMarginLeft:Ie,glyphMarginWidth:$,lineNumbersLeft:Le,lineNumbersWidth:ce,decorationsLeft:Ze,decorationsWidth:he,contentLeft:ze,contentWidth:ht,minimap:ut,viewportColumn:_t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:dt,verticalScrollbarWidth:vt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:vt,height:Ne-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=V;class H extends T{constructor(){const Z={enabled:!0};super(55,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:d.localize(42,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:l(Z.enabled,this.defaultValue.enabled)}}}class M extends T{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:d.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{enabled:l(fe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class K extends g{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>g.clamp(Z,0,150),{markdownDescription:d.localize(46,null)})}compute(Z,fe,Oe){return Z.fontInfo.lineHeight}}class N extends T{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:Z.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:d.localize(56,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{enabled:l(fe.enabled,this.defaultValue.enabled),size:w(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(fe.side,this.defaultValue.side,["right","left"]),showSlider:w(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(fe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(fe.scale,1,1,3),maxColumn:u.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends T{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{top:u.clampedInt(fe.top,0,0,1e3),bottom:u.clampedInt(fe.bottom,0,0,1e3)}}}class W extends T{constructor(){const Z={enabled:!0,cycle:!1};super(74,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:d.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{enabled:l(fe.enabled,this.defaultValue.enabled),cycle:l(fe.cycle,this.defaultValue.cycle)}}}class ne extends n{constructor(){super(127)}compute(Z,fe,Oe){return Z.pixelRatio}}class ge extends T{constructor(){const Z={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:d.localize(61,null)},comments:{type:"boolean",default:Z.comments,description:d.localize(62,null)},other:{type:"boolean",default:Z.other,description:d.localize(63,null)}}}],default:Z,description:d.localize(64,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const fe=Z,Oe={other:l(fe.other,this.defaultValue.other),comments:l(fe.comments,this.defaultValue.comments),strings:l(fe.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var _e;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends T{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(Z){let fe=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(fe=4,Oe=Z):Z==="interval"?fe=3:Z==="relative"?fe=2:Z==="on"?fe=1:fe=0),{renderType:fe,renderFn:Oe}}}function Fe(z){const Z=z.get(86);return Z==="editable"?z.get(79):Z!=="on"}e.filterValidationDecorations=Fe;class xe extends T{constructor(){const Z=[],fe={type:"number",description:d.localize(70,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:Z,description:d.localize(72,null)})}validate(Z){if(Array.isArray(Z)){let fe=[];for(let Oe of Z)if(typeof Oe=="number")fe.push({column:u.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ne=Oe;fe.push({column:u.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return fe.sort((Oe,Ne)=>Oe.column-Ne.column),fe}return this.defaultValue}}function Ye(z,Z){if(typeof z!="string")return Z;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends T{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:d.localize(83,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z,Oe=u.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=u.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(fe.vertical,this.defaultValue.vertical),horizontal:Ye(fe.horizontal,this.defaultValue.horizontal),useShadows:l(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:u.clampedInt(fe.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:u.clampedInt(fe.verticalSliderSize,Ne,0,1e3),scrollByPage:l(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends T{constructor(){const Z={enabled:!0,mode:"subwordSmart"};super(53,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:d.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null)],default:Z.mode,description:d.localize(88,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{enabled:l(fe.enabled,this.defaultValue.enabled),mode:w(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends T{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(89,null),d.localize(90,null)],default:Z.insertMode,description:d.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:d.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:d.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:d.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:d.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:d.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:d.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:d.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[d.localize(99,null),d.localize(100,null),d.localize(101,null)],default:Z.previewMode,description:d.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:d.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const fe=Z;return{insertMode:w(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(fe.showIcons,this.defaultValue.showIcons),showStatusBar:l(fe.showStatusBar,this.defaultValue.showStatusBar),preview:l(fe.preview,this.defaultValue.preview),previewMode:w(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(fe.showMethods,this.defaultValue.showMethods),showFunctions:l(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:l(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:l(fe.showFields,this.defaultValue.showFields),showVariables:l(fe.showVariables,this.defaultValue.showVariables),showClasses:l(fe.showClasses,this.defaultValue.showClasses),showStructs:l(fe.showStructs,this.defaultValue.showStructs),showInterfaces:l(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:l(fe.showModules,this.defaultValue.showModules),showProperties:l(fe.showProperties,this.defaultValue.showProperties),showEvents:l(fe.showEvents,this.defaultValue.showEvents),showOperators:l(fe.showOperators,this.defaultValue.showOperators),showUnits:l(fe.showUnits,this.defaultValue.showUnits),showValues:l(fe.showValues,this.defaultValue.showValues),showConstants:l(fe.showConstants,this.defaultValue.showConstants),showEnums:l(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:l(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(fe.showKeywords,this.defaultValue.showKeywords),showWords:l(fe.showWords,this.defaultValue.showWords),showColors:l(fe.showColors,this.defaultValue.showColors),showFiles:l(fe.showFiles,this.defaultValue.showFiles),showReferences:l(fe.showReferences,this.defaultValue.showReferences),showFolders:l(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:l(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(fe.showSnippets,this.defaultValue.showSnippets),showUsers:l(fe.showUsers,this.defaultValue.showUsers),showIssues:l(fe.showIssues,this.defaultValue.showIssues)}}}class Q extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(135,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends n{constructor(){super(128,[79])}compute(Z,fe,Oe){return fe.get(79)?!0:Z.tabFocusMode}}var re;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function q(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ie extends n{constructor(){super(130,[129])}compute(Z,fe,Oe){const Ne=fe.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const pe="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Te:R.isLinux?Be:pe,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(z){return e.editorOptionsRegistry[z.id]=z,z}var Ke;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.foldingImportsByDefault=38]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=40]="fontFamily",z[z.fontInfo=41]="fontInfo",z[z.fontLigatures=42]="fontLigatures",z[z.fontSize=43]="fontSize",z[z.fontWeight=44]="fontWeight",z[z.formatOnPaste=45]="formatOnPaste",z[z.formatOnType=46]="formatOnType",z[z.glyphMargin=47]="glyphMargin",z[z.gotoLocation=48]="gotoLocation",z[z.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",z[z.hover=51]="hover",z[z.inDiffEditor=52]="inDiffEditor",z[z.inlineSuggest=53]="inlineSuggest",z[z.letterSpacing=54]="letterSpacing",z[z.lightbulb=55]="lightbulb",z[z.lineDecorationsWidth=56]="lineDecorationsWidth",z[z.lineHeight=57]="lineHeight",z[z.lineNumbers=58]="lineNumbers",z[z.lineNumbersMinChars=59]="lineNumbersMinChars",z[z.linkedEditing=60]="linkedEditing",z[z.links=61]="links",z[z.matchBrackets=62]="matchBrackets",z[z.minimap=63]="minimap",z[z.mouseStyle=64]="mouseStyle",z[z.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=66]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",z[z.multiCursorModifier=68]="multiCursorModifier",z[z.multiCursorPaste=69]="multiCursorPaste",z[z.occurrencesHighlight=70]="occurrencesHighlight",z[z.overviewRulerBorder=71]="overviewRulerBorder",z[z.overviewRulerLanes=72]="overviewRulerLanes",z[z.padding=73]="padding",z[z.parameterHints=74]="parameterHints",z[z.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",z[z.quickSuggestions=77]="quickSuggestions",z[z.quickSuggestionsDelay=78]="quickSuggestionsDelay",z[z.readOnly=79]="readOnly",z[z.renameOnType=80]="renameOnType",z[z.renderControlCharacters=81]="renderControlCharacters",z[z.renderIndentGuides=82]="renderIndentGuides",z[z.renderFinalNewline=83]="renderFinalNewline",z[z.renderLineHighlight=84]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=86]="renderValidationDecorations",z[z.renderWhitespace=87]="renderWhitespace",z[z.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",z[z.roundedSelection=89]="roundedSelection",z[z.rulers=90]="rulers",z[z.scrollbar=91]="scrollbar",z[z.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=93]="scrollBeyondLastLine",z[z.scrollPredominantAxis=94]="scrollPredominantAxis",z[z.selectionClipboard=95]="selectionClipboard",z[z.selectionHighlight=96]="selectionHighlight",z[z.selectOnLineNumbers=97]="selectOnLineNumbers",z[z.showFoldingControls=98]="showFoldingControls",z[z.showUnused=99]="showUnused",z[z.snippetSuggestions=100]="snippetSuggestions",z[z.smartSelect=101]="smartSelect",z[z.smoothScrolling=102]="smoothScrolling",z[z.stickyTabStops=103]="stickyTabStops",z[z.stopRenderingLineAfter=104]="stopRenderingLineAfter",z[z.suggest=105]="suggest",z[z.suggestFontSize=106]="suggestFontSize",z[z.suggestLineHeight=107]="suggestLineHeight",z[z.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",z[z.suggestSelection=109]="suggestSelection",z[z.tabCompletion=110]="tabCompletion",z[z.tabIndex=111]="tabIndex",z[z.unusualLineTerminators=112]="unusualLineTerminators",z[z.useShadowDOM=113]="useShadowDOM",z[z.useTabStops=114]="useTabStops",z[z.wordSeparators=115]="wordSeparators",z[z.wordWrap=116]="wordWrap",z[z.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=119]="wordWrapColumn",z[z.wordWrapOverride1=120]="wordWrapOverride1",z[z.wordWrapOverride2=121]="wordWrapOverride2",z[z.wrappingIndent=122]="wrappingIndent",z[z.wrappingStrategy=123]="wrappingStrategy",z[z.showDeprecated=124]="showDeprecated",z[z.inlayHints=125]="inlayHints",z[z.editorClassName=126]="editorClassName",z[z.pixelRatio=127]="pixelRatio",z[z.tabFocusMode=128]="tabFocusMode",z[z.layoutInfo=129]="layoutInfo",z[z.wrappingInfo=130]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(136,null)})),acceptSuggestionOnEnter:ve(new A(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(137,null),""],markdownDescription:d.localize(138,null)})),accessibilitySupport:ve(new v),accessibilityPageSize:ve(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(139,null)})),ariaLabel:ve(new b(4,"ariaLabel",d.localize(140,null))),autoClosingBrackets:ve(new A(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(141,null),d.localize(142,null),""],description:d.localize(143,null)})),autoClosingDelete:ve(new A(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(144,null),""],description:d.localize(145,null)})),autoClosingOvertype:ve(new A(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(146,null),""],description:d.localize(147,null)})),autoClosingQuotes:ve(new A(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(148,null),d.localize(149,null),""],description:d.localize(150,null)})),autoIndent:ve(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[d.localize(151,null),d.localize(152,null),d.localize(153,null),d.localize(154,null),d.localize(155,null)],description:d.localize(156,null)})),automaticLayout:ve(new h(10,"automaticLayout",!1)),autoSurround:ve(new A(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(157,null),d.localize(158,null),d.localize(159,null),""],description:d.localize(160,null)})),stickyTabStops:ve(new h(103,"stickyTabStops",!1,{description:d.localize(161,null)})),codeLens:ve(new h(12,"codeLens",!0,{description:d.localize(162,null)})),codeLensFontFamily:ve(new b(13,"codeLensFontFamily","",{description:d.localize(163,null)})),codeLensFontSize:ve(new u(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(164,null)})),colorDecorators:ve(new h(15,"colorDecorators",!0,{description:d.localize(165,null)})),columnSelection:ve(new h(16,"columnSelection",!1,{description:d.localize(166,null)})),comments:ve(new t),contextmenu:ve(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new h(19,"copyWithSyntaxHighlighting",!0,{description:d.localize(167,null)})),cursorBlinking:ve(new o(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:d.localize(168,null)})),cursorSmoothCaretAnimation:ve(new h(21,"cursorSmoothCaretAnimation",!1,{description:d.localize(169,null)})),cursorStyle:ve(new o(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:d.localize(170,null)})),cursorSurroundingLines:ve(new u(23,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(171,null)})),cursorSurroundingLinesStyle:ve(new A(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(172,null),d.localize(173,null)],description:d.localize(174,null)})),cursorWidth:ve(new u(25,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(175,null)})),disableLayerHinting:ve(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new h(28,"domReadOnly",!1)),dragAndDrop:ve(new h(29,"dragAndDrop",!0,{description:d.localize(176,null)})),emptySelectionClipboard:ve(new _),extraEditorClassName:ve(new b(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new g(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:d.localize(177,null)})),find:ve(new I),fixedOverflowWidgets:ve(new h(34,"fixedOverflowWidgets",!1)),folding:ve(new h(35,"folding",!0,{description:d.localize(178,null)})),foldingStrategy:ve(new A(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(179,null),d.localize(180,null)],description:d.localize(181,null)})),foldingHighlight:ve(new h(37,"foldingHighlight",!0,{description:d.localize(182,null)})),foldingImportsByDefault:ve(new h(38,"foldingImportsByDefault",!1,{description:d.localize(183,null)})),unfoldOnClickAfterEndOfLine:ve(new h(39,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(184,null)})),fontFamily:ve(new b(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(185,null)})),fontInfo:ve(new P),fontLigatures2:ve(new r),fontSize:ve(new F),fontWeight:ve(new B),formatOnPaste:ve(new h(45,"formatOnPaste",!1,{description:d.localize(186,null)})),formatOnType:ve(new h(46,"formatOnType",!1,{description:d.localize(187,null)})),glyphMargin:ve(new h(47,"glyphMargin",!0,{description:d.localize(188,null)})),gotoLocation:ve(new j),hideCursorInOverviewRuler:ve(new h(49,"hideCursorInOverviewRuler",!1,{description:d.localize(189,null)})),highlightActiveIndentGuide:ve(new h(50,"highlightActiveIndentGuide",!0,{description:d.localize(190,null)})),hover:ve(new ae),inDiffEditor:ve(new h(52,"inDiffEditor",!1)),letterSpacing:ve(new g(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>g.clamp(z,-5,20),{description:d.localize(191,null)})),lightbulb:ve(new H),lineDecorationsWidth:ve(new C(56,"lineDecorationsWidth",10)),lineHeight:ve(new K),lineNumbers:ve(new Me),lineNumbersMinChars:ve(new u(59,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new h(60,"linkedEditing",!1,{description:d.localize(192,null)})),links:ve(new h(61,"links",!0,{description:d.localize(193,null)})),matchBrackets:ve(new A(62,"matchBrackets","always",["always","near","never"],{description:d.localize(194,null)})),minimap:ve(new N),mouseStyle:ve(new A(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new g(65,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:d.localize(195,null)})),mouseWheelZoom:ve(new h(66,"mouseWheelZoom",!1,{markdownDescription:d.localize(196,null)})),multiCursorMergeOverlapping:ve(new h(67,"multiCursorMergeOverlapping",!0,{description:d.localize(197,null)})),multiCursorModifier:ve(new o(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[d.localize(198,null),d.localize(199,null)],markdownDescription:d.localize(200,null)})),multiCursorPaste:ve(new A(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(201,null),d.localize(202,null)],markdownDescription:d.localize(203,null)})),occurrencesHighlight:ve(new h(70,"occurrencesHighlight",!0,{description:d.localize(204,null)})),overviewRulerBorder:ve(new h(71,"overviewRulerBorder",!0,{description:d.localize(205,null)})),overviewRulerLanes:ve(new u(72,"overviewRulerLanes",3,0,3)),padding:ve(new me),parameterHints:ve(new W),peekWidgetDefaultFocus:ve(new A(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(206,null),d.localize(207,null)],description:d.localize(208,null)})),definitionLinkOpensInPeek:ve(new h(76,"definitionLinkOpensInPeek",!1,{description:d.localize(209,null)})),quickSuggestions:ve(new ge),quickSuggestionsDelay:ve(new u(78,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(210,null)})),readOnly:ve(new h(79,"readOnly",!1)),renameOnType:ve(new h(80,"renameOnType",!1,{description:d.localize(211,null),markdownDeprecationMessage:d.localize(212,null)})),renderControlCharacters:ve(new h(81,"renderControlCharacters",!1,{description:d.localize(213,null)})),renderIndentGuides:ve(new h(82,"renderIndentGuides",!0,{description:d.localize(214,null)})),renderFinalNewline:ve(new h(83,"renderFinalNewline",!0,{description:d.localize(215,null)})),renderLineHighlight:ve(new A(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(216,null)],description:d.localize(217,null)})),renderLineHighlightOnlyWhenFocus:ve(new h(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(218,null)})),renderValidationDecorations:ve(new A(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new A(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(219,null),d.localize(220,null),d.localize(221,null),""],description:d.localize(222,null)})),revealHorizontalRightPadding:ve(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new h(89,"roundedSelection",!0,{description:d.localize(223,null)})),rulers:ve(new xe),scrollbar:ve(new Ve),scrollBeyondLastColumn:ve(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(224,null)})),scrollBeyondLastLine:ve(new h(93,"scrollBeyondLastLine",!0,{description:d.localize(225,null)})),scrollPredominantAxis:ve(new h(94,"scrollPredominantAxis",!0,{description:d.localize(226,null)})),selectionClipboard:ve(new h(95,"selectionClipboard",!0,{description:d.localize(227,null),included:R.isLinux})),selectionHighlight:ve(new h(96,"selectionHighlight",!0,{description:d.localize(228,null)})),selectOnLineNumbers:ve(new h(97,"selectOnLineNumbers",!0)),showFoldingControls:ve(new A(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(229,null),d.localize(230,null)],description:d.localize(231,null)})),showUnused:ve(new h(99,"showUnused",!0,{description:d.localize(232,null)})),showDeprecated:ve(new h(124,"showDeprecated",!0,{description:d.localize(233,null)})),inlayHints:ve(new M),snippetSuggestions:ve(new A(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(234,null),d.localize(235,null),d.localize(236,null),d.localize(237,null)],description:d.localize(238,null)})),smartSelect:ve(new Q),smoothScrolling:ve(new h(102,"smoothScrolling",!1,{description:d.localize(239,null)})),stopRenderingLineAfter:ve(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new x),inlineSuggest:ve(new qe),suggestFontSize:ve(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(240,null)})),suggestLineHeight:ve(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(241,null)})),suggestOnTriggerCharacters:ve(new h(108,"suggestOnTriggerCharacters",!0,{description:d.localize(242,null)})),suggestSelection:ve(new A(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(243,null),d.localize(244,null),d.localize(245,null)],description:d.localize(246,null)})),tabCompletion:ve(new A(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(247,null),d.localize(248,null),d.localize(249,null)],description:d.localize(250,null)})),tabIndex:ve(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new A(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(251,null),d.localize(252,null),d.localize(253,null)],description:d.localize(254,null)})),useShadowDOM:ve(new h(113,"useShadowDOM",!0)),useTabStops:ve(new h(114,"useTabStops",!0,{description:d.localize(255,null)})),wordSeparators:ve(new b(115,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:d.localize(256,null)})),wordWrap:ve(new A(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(257,null),d.localize(258,null),d.localize(259,null),d.localize(260,null)],description:d.localize(261,null)})),wordWrapBreakAfterCharacters:ve(new b(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new b(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(262,null)})),wordWrapOverride1:ve(new A(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new A(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[d.localize(263,null),d.localize(264,null),d.localize(265,null),d.localize(266,null)],description:d.localize(267,null)})),wrappingStrategy:ve(new A(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(268,null),d.localize(269,null)],description:d.localize(270,null)})),editorClassName:ve(new m),pixelRatio:ve(new ne),tabFocusMode:ve(new X),layoutInfo:ve(new V),wrappingInfo:ve(new ie)}}),define(we[128],be([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[129],be([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[130],be([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(we[131],be([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(we[132],be([18,19]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(we[133],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[134],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[135],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(we[136],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[137],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[138],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[139],be([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[140],be([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(we[141],be([18,19]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(we[142],be([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[143],be([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[144],be([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[145],be([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[146],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var R;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var D;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[147],be([0,1,129]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(R);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=k;function E(l){if(!l)return null;let h=l.majorBase,u=l.majorMustEqual,g=l.minorBase,b=l.minorMustEqual,w=l.patchBase,A=l.patchMustEqual;l.hasCaret&&(h===0||(b=!1),A=!1);let o=0;if(l.preRelease){const p=D.exec(l.preRelease);if(p){const[,v,t,a]=p;o=Date.UTC(Number(v),Number(t)-1,Number(a))}}return{majorBase:h,majorMustEqual:u,minorBase:g,minorMustEqual:b,patchBase:w,patchMustEqual:A,isMinimum:l.hasGreaterEquals,notBefore:o}}e.normalizeVersion=E;function y(l,h,u){let g;typeof l=="string"?g=E(k(l)):g=l;let b;h instanceof Date?b=h.getTime():typeof h=="string"&&(b=new Date(h).getTime());let w;if(typeof u=="string"?w=E(k(u)):w=u,!g||!w)return!1;let A=g.majorBase,o=g.minorBase,p=g.patchBase,v=w.majorBase,t=w.minorBase,a=w.patchBase,s=w.notBefore,i=w.majorMustEqual,c=w.minorMustEqual,f=w.patchMustEqual;return w.isMinimum?A>v?!0:A<v?!1:o>t?!0:o<t||b&&b<s?!1:p>=a:(A===1&&v===0&&(!i||!c||!f)&&(v=1,t=0,a=0,i=!0,c=!1,f=!1),A<v?!1:A>v?!i:o<t?!1:o>t?!c:p<a?!1:p>a?!f:!(b&&b<s))}e.isValidVersion=y;function T(l,h,u,g){return u.isBuiltin||typeof u.main=="undefined"?!0:C(l,h,u.engines.vscode,g)}e.isValidExtensionVersion=T;function n(l,h,u){return l==="*"||C(h,u,l)}e.isEngineValid=n;function C(l,h,u,g=[]){let b=E(k(u));if(!b)return g.push(d.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(d.localize(1,null,u)),!1}else if(!b.majorMustEqual)return g.push(d.localize(2,null,u)),!1;return y(l,h,b)?!0:(g.push(d.localize(3,null,l,u)),!1)}}),define(we[90],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(D,S=[],k=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=d}),define(we[61],be([0,1,90]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function D(k,E,y){E instanceof d.SyncDescriptor||(E=new d.SyncDescriptor(E,[],y)),R.push([k,E])}e.registerSingleton=D;function S(){return R}e.getSingletonServiceDescriptors=S}),define(we[148],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=d;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let k of this._nodes.values())k.outgoing.size===0&&S.push(k);return S}insertEdge(S,k){const E=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(k);E.outgoing.set(this._hashFn(k),y),y.incoming.set(this._hashFn(S),E)}removeNode(S){const k=this._hashFn(S);this._nodes.delete(k);for(let E of this._nodes.values())E.outgoing.delete(k),E.incoming.delete(k)}lookupOrInsertNode(S){const k=this._hashFn(S);let E=this._nodes.get(k);return E||(E=new d(S),this._nodes.set(k,E)),E}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[k,E]of this._nodes)S.push(`${k}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,k]of this._nodes){const E=new Set([S]),y=this._findCycle(k,E);if(y)return y}}_findCycle(S,k){for(let[E,y]of S.outgoing){if(k.has(E))return[...k,E].join(" -> ");k.add(E);const T=this._findCycle(y,k);if(T)return T;k.delete(E)}}}e.Graph=R}),define(we[4],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function y(T){return T[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=y})(d=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(E,y,T,n){y[d.DI_TARGET]===y?y[d.DI_DEPENDENCIES].push({id:E,index:T,optional:n}):(y[d.DI_DEPENDENCIES]=[{id:E,index:T,optional:n}],y[d.DI_TARGET]=y)}function D(E){if(d.serviceIds.has(E))return d.serviceIds.get(E);const y=function(T,n,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,T,C,!1)};return y.toString=()=>E,d.serviceIds.set(E,y),y}e.createDecorator=D;function S(E){return E}e.refineServiceDecorator=S;function k(E){return function(y,T,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(E,y,n,!0)}}e.optional=k}),define(we[149],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function R(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(we[150],be([0,1,3,43,6,21,80,59,149]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(T):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(h,u){let g={selector:h,provider:u,_score:-1,_time:this._clock++};return this._entries.push(g),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(g){let b=this._entries.indexOf(g);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const u=[];for(let g of this._entries)g._score>0&&u.push(g.provider);return u}ordered(h){const u=[];return this._orderedForEach(h,g=>u.push(g.provider)),u}orderedGroups(h){const u=[];let g,b;return this._orderedForEach(h,w=>{g&&b===w._score?g.push(w.provider):(b=w._score,g=[w.provider],u.push(g))}),u}_orderedForEach(h,u){if(!!h){this._updateScores(h);for(const g of this._entries)g._score>0&&u(g)}}_updateScores(h){let u={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let g of this._entries)if(g._score=(0,E.score)(g.selector,h.uri,h.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(h)),T(g.selector)&&g._score>0){for(let b of this._entries)b._score=0;g._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,u){return h._score<u._score?1:h._score>u._score?-1:h._time<u._time?1:h._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class C{constructor(h,u,g=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=u,this.max=g,this._cache=new S.LRUCache(50,.7)}_key(h){return h.id+(0,R.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const u=this._key(h),g=this._cache.get(u);return this._clamp(g?.value)}update(h,u){const g=this._key(h);let b=this._cache.get(g);return b||(b=new k.MovingAverage,this._cache.set(g,b)),b.update(u),this.get(h)}}e.LanguageFeatureRequestDelays=C}),define(we[62],be([0,1,2,31,150,123,35]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var E;(function(r){r[r.Null=0]="Null",r[r.PlainText=1]="PlainText"})(E=e.LanguageId||(e.LanguageId={}));class y{constructor(P,F){this.language=P,this.id=F}}e.LanguageIdentifier=y;var T;(function(r){r[r.NotSet=-1]="NotSet",r[r.None=0]="None",r[r.Italic=1]="Italic",r[r.Bold=2]="Bold",r[r.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var n;(function(r){r[r.None=0]="None",r[r.DefaultForeground=1]="DefaultForeground",r[r.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var C;(function(r){r[r.Other=0]="Other",r[r.Comment=1]="Comment",r[r.String=2]="String",r[r.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(r){r[r.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",r[r.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",r[r.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",r[r.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",r[r.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",r[r.ITALIC_MASK=2048]="ITALIC_MASK",r[r.BOLD_MASK=4096]="BOLD_MASK",r[r.UNDERLINE_MASK=8192]="UNDERLINE_MASK",r[r.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",r[r.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",r[r.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",r[r.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",r[r.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",r[r.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",r[r.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",r[r.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",r[r.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",r[r.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let F=this.getForeground(P),B="mtk"+F,j=this.getFontStyle(P);return j&1&&(B+=" mtki"),j&2&&(B+=" mtkb"),j&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(P,F){const B=this.getForeground(P),j=this.getFontStyle(P);let ae=`color: ${F[B]};`;return j&1&&(ae+="font-style: italic;"),j&2&&(ae+="font-weight: bold;"),j&4&&(ae+="text-decoration: underline;"),ae}}e.TokenMetadata=h;var u;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let r=Object.create(null);return r[0]="symbol-method",r[1]="symbol-function",r[2]="symbol-constructor",r[3]="symbol-field",r[4]="symbol-variable",r[5]="symbol-class",r[6]="symbol-struct",r[7]="symbol-interface",r[8]="symbol-module",r[9]="symbol-property",r[10]="symbol-event",r[11]="symbol-operator",r[12]="symbol-unit",r[13]="symbol-value",r[14]="symbol-constant",r[15]="symbol-enum",r[16]="symbol-enum-member",r[17]="symbol-keyword",r[27]="symbol-snippet",r[18]="symbol-text",r[19]="symbol-color",r[20]="symbol-file",r[21]="symbol-reference",r[22]="symbol-customcolor",r[23]="symbol-folder",r[24]="symbol-type-parameter",r[25]="account",r[26]="issues",function(P){const F=r[P];let B=F&&k.iconRegistry.get(F);return B||(console.info("No codicon found for CompletionItemKind "+P),B=k.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let r=Object.create(null);return r.method=0,r.function=1,r.constructor=2,r.field=3,r.variable=4,r.class=5,r.struct=6,r.interface=7,r.module=8,r.property=9,r.event=10,r.operator=11,r.unit=12,r.value=13,r.constant=14,r.enum=15,r["enum-member"]=16,r.enumMember=16,r.keyword=17,r.snippet=27,r.text=18,r.color=19,r.file=20,r.reference=21,r.customcolor=22,r.folder=23,r["type-parameter"]=24,r.typeParameter=24,r.account=25,r.issue=26,function(P,F){let B=r[P];return typeof B=="undefined"&&!F&&(B=9),B}}();var g;(function(r){r[r.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var A;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(A=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(r){return r&&d.URI.isUri(r.uri)&&R.Range.isIRange(r.range)&&(R.Range.isIRange(r.originSelectionRange)||R.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=t;var a;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(a=e.SymbolKind||(e.SymbolKind={}));var s;(function(r){r[r.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(r){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function B(oe){return P.get(oe)}r.fromString=B;function j(oe){return F.get(oe)}r.toString=j;function ae(oe,V){const H=F.get(oe);let M=H&&k.iconRegistry.get("symbol-"+H);return M||(console.info("No codicon found for SymbolKind "+oe),M=k.Codicon.symbolProperty),`${V?"inline":"block"} ${M.classNames}`}r.toCssClassName=ae})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(P){this.value=P}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var f;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var _;(function(r){r[r.Other=0]="Other",r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var I;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[45],be([0,1,22,8,4]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=d.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",d.isMacintosh),k.set("isLinux",d.isLinux),k.set("isWindows",d.isWindows),k.set("isWeb",d.isWeb),k.set("isMacNative",d.isMacintosh&&!d.isWeb),k.set("isEdge",S.indexOf("Edg/")>=0),k.set("isFirefox",S.indexOf("Firefox")>=0),k.set("isChrome",S.indexOf("Chrome")>=0),k.set("isSafari",S.indexOf("Safari")>=0);const E=Object.prototype.hasOwnProperty;var y;(function(I){I[I.False=0]="False",I[I.True=1]="True",I[I.Defined=2]="Defined",I[I.Not=3]="Not",I[I.Equals=4]="Equals",I[I.NotEquals=5]="NotEquals",I[I.And=6]="And",I[I.Regex=7]="Regex",I[I.NotRegex=8]="NotRegex",I[I.Or=9]="Or",I[I.In=10]="In",I[I.NotIn=11]="NotIn",I[I.Greater=12]="Greater",I[I.GreaterEquals=13]="GreaterEquals",I[I.Smaller=14]="Smaller",I[I.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return C.INSTANCE}static true(){return l.INSTANCE}static has(r){return h.create(r)}static equals(r,P){return u.create(r,P)}static notEquals(r,P){return w.create(r,P)}static regex(r,P){return a.create(r,P)}static in(r,P){return g.create(r,P)}static not(r){return A.create(r)}static and(...r){return i.create(r)}static or(...r){return c.create(r)}static greater(r,P){return o.create(r,P)}static less(r,P){return v.create(r,P)}static deserialize(r,P=!1){if(!!r)return this._deserializeOrExpression(r,P)}static _deserializeOrExpression(r,P){let F=r.split("||");return c.create(F.map(B=>this._deserializeAndExpression(B,P)))}static _deserializeAndExpression(r,P){let F=r.split("&&");return i.create(F.map(B=>this._deserializeOne(B,P)))}static _deserializeOne(r,P){if(r=r.trim(),r.indexOf("!=")>=0){let F=r.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],P))}if(r.indexOf("==")>=0){let F=r.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],P))}if(r.indexOf("=~")>=0){let F=r.split("=~");return a.create(F[0].trim(),this._deserializeRegexValue(F[1],P))}if(r.indexOf(" in ")>=0){let F=r.split(" in ");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(r)){const F=r.split(">=");return p.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(r)){const F=r.split(">");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(r)){const F=r.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(r)){const F=r.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(r)?A.create(r.substr(1).trim()):h.create(r)}static _deserializeValue(r,P){if(r=r.trim(),r==="true")return!0;if(r==="false")return!1;let F=/^'([^']*)'$/.exec(r);return F?F[1].trim():r}static _deserializeRegexValue(r,P){if((0,R.isFalsyOrWhitespace)(r)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=r.indexOf("/"),B=r.lastIndexOf("/");if(F===B||F<0){if(P)throw new Error(`bad regexp-value '${r}', missing /-enclosure`);return console.warn(`bad regexp-value '${r}', missing /-enclosure`),null}let j=r.slice(F+1,B),ae=r[B+1]==="i"?"i":"";try{return new RegExp(j,ae)}catch(oe){if(P)throw new Error(`bad regexp-value '${r}', parse error: ${oe}`);return console.warn(`bad regexp-value '${r}', parse error: ${oe}`),null}}}e.ContextKeyExpr=T;function n(I,r){return I.cmp(r)}class C{constructor(){this.type=0}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}evaluate(r){return!1}serialize(){return"false"}keys(){return[]}map(r){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class l{constructor(){this.type=1}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}evaluate(r){return!0}serialize(){return"true"}keys(){return[]}map(r){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(r){this.key=r,this.type=2}static create(r){const P=k.get(r);return typeof P=="boolean"?P?l.INSTANCE:C.INSTANCE:new h(r)}cmp(r){return r.type!==this.type?this.type-r.type:m(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}evaluate(r){return!!r.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(r){return r.mapDefined(this.key)}negate(){return A.create(this.key)}}e.ContextKeyDefinedExpr=h;class u{constructor(r,P){this.key=r,this.value=P,this.type=4}static create(r,P){if(typeof P=="boolean")return P?h.create(r):A.create(r);const F=k.get(r);return typeof F=="boolean"?P===(F?"true":"false")?l.INSTANCE:C.INSTANCE:new u(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return r.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(r){return r.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class g{constructor(r,P){this.key=r,this.valueKey=P,this.type=10}static create(r,P){return new g(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.valueKey,r.key,r.valueKey)}equals(r){return r.type===this.type?this.key===r.key&&this.valueKey===r.valueKey:!1}evaluate(r){const P=r.getValue(this.valueKey),F=r.getValue(this.key);return Array.isArray(P)?P.indexOf(F)>=0:typeof F=="string"&&typeof P=="object"&&P!==null?E.call(P,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(r){return r.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=g;class b{constructor(r){this._actual=r,this.type=11}static create(r){return new b(r)}cmp(r){return r.type!==this.type?this.type-r.type:this._actual.cmp(r._actual)}equals(r){return r.type===this.type?this._actual.equals(r._actual):!1}evaluate(r){return!this._actual.evaluate(r)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(r){return new b(this._actual.map(r))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class w{constructor(r,P){this.key=r,this.value=P,this.type=5}static create(r,P){if(typeof P=="boolean")return P?A.create(r):h.create(r);const F=k.get(r);return typeof F=="boolean"?P===(F?"true":"false")?C.INSTANCE:l.INSTANCE:new w(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return r.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(r){return r.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class A{constructor(r){this.key=r,this.type=3}static create(r){const P=k.get(r);return typeof P=="boolean"?P?C.INSTANCE:l.INSTANCE:new A(r)}cmp(r){return r.type!==this.type?this.type-r.type:m(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}evaluate(r){return!r.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(r){return r.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=A;class o{constructor(r,P){this.key=r,this.value=P,this.type=12}static create(r,P){return new o(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(r){return r.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=o;class p{constructor(r,P){this.key=r,this.value=P,this.type=13}static create(r,P){return new p(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(r){return r.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=p;class v{constructor(r,P){this.key=r,this.value=P,this.type=14}static create(r,P){return new v(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(r){return r.mapSmaller(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(r,P){this.key=r,this.value=P,this.type=15}static create(r,P){return new t(r,P)}cmp(r){return r.type!==this.type?this.type-r.type:_(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(r){return r.mapSmallerEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class a{constructor(r,P){this.key=r,this.regexp=P,this.type=7}static create(r,P){return new a(r,P)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.key<r.key)return-1;if(this.key>r.key)return 1;const P=this.regexp?this.regexp.source:"",F=r.regexp?r.regexp.source:"";return P<F?-1:P>F?1:0}equals(r){if(r.type===this.type){const P=this.regexp?this.regexp.source:"",F=r.regexp?r.regexp.source:"";return this.key===r.key&&P===F}return!1}evaluate(r){let P=r.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const r=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${r}`}keys(){return[this.key]}map(r){return r.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=a;class s{constructor(r){this._actual=r,this.type=8}static create(r){return new s(r)}cmp(r){return r.type!==this.type?this.type-r.type:this._actual.cmp(r._actual)}equals(r){return r.type===this.type?this._actual.equals(r._actual):!1}evaluate(r){return!this._actual.evaluate(r)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(r){return new s(this._actual.map(r))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(r){this.expr=r,this.type=6}static create(r){return i._normalizeArr(r)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const B=n(this.expr[P],r.expr[P]);if(B!==0)return B}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(r.expr[P]))return!1;return!0}return!1}evaluate(r){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(r))return!1;return!0}static _normalizeArr(r){const P=[];let F=!1;for(const B of r)if(!!B){if(B.type===1){F=!0;continue}if(B.type===0)return C.INSTANCE;if(B.type===6){P.push(...B.expr);continue}P.push(B)}if(P.length===0&&F)return l.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(n);P.length>1;){const B=P[P.length-1];if(B.type!==9)break;P.pop();const j=P.pop(),ae=c.create(B.expr.map(oe=>i.create([oe,j])));ae&&(P.push(ae),P.sort(n))}return P.length===1?P[0]:new i(P)}}serialize(){return this.expr.map(r=>r.serialize()).join(" && ")}keys(){const r=[];for(let P of this.expr)r.push(...P.keys());return r}map(r){return new i(this.expr.map(P=>P.map(r)))}negate(){let r=[];for(let P of this.expr)r.push(P.negate());return c.create(r)}}e.ContextKeyAndExpr=i;class c{constructor(r){this.expr=r,this.type=9}static create(r){const P=c._normalizeArr(r);if(P.length!==0)return P.length===1?P[0]:new c(P)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const B=n(this.expr[P],r.expr[P]);if(B!==0)return B}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(r.expr[P]))return!1;return!0}return!1}evaluate(r){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(r))return!0;return!1}static _normalizeArr(r){let P=[],F=!1;if(r){for(let B=0,j=r.length;B<j;B++){const ae=r[B];if(!!ae){if(ae.type===0){F=!0;continue}if(ae.type===1)return[l.INSTANCE];if(ae.type===9){P=P.concat(ae.expr);continue}P.push(ae)}}if(P.length===0&&F)return[C.INSTANCE];P.sort(n)}return P}serialize(){return this.expr.map(r=>r.serialize()).join(" || ")}keys(){const r=[];for(let P of this.expr)r.push(...P.keys());return r}map(r){return new c(this.expr.map(P=>P.map(r)))}negate(){let r=[];for(let F of this.expr)r.push(F.negate());const P=F=>F.type===9?F.expr:[F];for(;r.length>1;){const F=r.shift(),B=r.shift(),j=[];for(const ae of P(F))for(const oe of P(B))j.push(T.and(ae,oe));r.unshift(T.or(...j))}return r[0]}}e.ContextKeyOrExpr=c;class f extends h{constructor(r,P,F){super(r);this._defaultValue=P,typeof F=="object"?f._info.push({...F,key:r}):F!==!0&&f._info.push({key:r,description:F,type:P!=null?typeof P:void 0})}static all(){return f._info.values()}bindTo(r){return r.createKey(this.key,this._defaultValue)}getValue(r){return r.getContextKeyValue(this.key)}toNegated(){return T.not(this.key)}isEqualTo(r){return T.equals(this.key,r)}notEqualsTo(r){return T.notEquals(this.key,r)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(I,r){return I<r?-1:I>r?1:0}function _(I,r,P,F){return I<P?-1:I>P?1:r<F?-1:r>F?1:0}}),define(we[151],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(we[26],be([0,1,8,4]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class E{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,l){if(typeof C=="undefined"||C===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof C=="string"||typeof l=="string"){let h=typeof C=="string"?C:C.value,u=typeof l=="string"?l:l.value;return d.equalsIgnoreCase(h,u)}return C._lower===l._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=E;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function T(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[152],be([0,1,8,26]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(u,g){return u.uuid&&g.uuid?u.uuid===g.uuid:u.id===g.id?!0:(0,d.compareIgnoreCase)(u.id,g.id)===0}e.areSameExtensions=D;class S{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof S?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=S;function k(u,g){return`${u}.${g}`}e.getExtensionId=k;function E(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function y(u,g){return E(k(u,g))}e.getGalleryExtensionId=y;function T(u,g){const b=[],w=A=>{for(const o of b)if(o.some(p=>D(g(p),g(A))))return o;return null};for(const A of u){const o=w(A);o?o.push(A):b.push([A])}return b}e.groupByExtension=T;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(u){const g=new Set;for(const b of u)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=l;function h(u,g){const b=[],w=g.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const A=w.shift();if(A&&b.every(o=>!D(o.identifier,{id:A}))){const o=u.filter(p=>D(p.identifier,{id:A}));o.length===1&&(b.push(o[0]),w.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=h}),define(we[63],be([0,1,21,14,8,10,2,130,4]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(V){return V.create===!0}e.isFileOpenForWriteOptions=T;var n;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var C;(function(V){V[V.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var l;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function u(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=u;function g(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=b;var w;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class A extends Error{constructor(H,M){super(H);this.code=M}}e.FileSystemProviderError=A;function o(V,H){const M=new A(V.toString(),H);return v(M,H),M}e.createFileSystemProviderError=o;function p(V){return V||o((0,E.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=p;function v(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=v;function t(V){if(!V)return w.Unknown;if(V instanceof A)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return w.Unknown;switch(H[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function a(V){if(V instanceof _)return V.fileOperationResult;switch(t(V)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(H,M,K){this.resource=H,this.operation=M,this.target=K}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var c;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class f{constructor(H,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const K of H)switch(K.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>M)),this.added.set(K.resource,K);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>M)),this.updated.set(K.resource,K);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>M)),this.deleted.set(K.resource,K);break}}contains(H,...M){return this.doContains(H,{includeChildren:!1},...M)}affects(H,...M){return this.doContains(H,{includeChildren:!0},...M)}doContains(H,M,...K){if(!H)return!1;const N=K.length>0;return!!((!N||K.includes(1))&&(this.added?.get(H)||M.includeChildren&&this.added?.findSuperstr(H))||(!N||K.includes(0))&&(this.updated?.get(H)||M.includeChildren&&this.updated?.findSuperstr(H))||(!N||K.includes(2))&&(this.deleted?.findSubstr(H)||M.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(V,H,M){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),M?(0,D.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=m;class _ extends Error{constructor(H,M,K){super(H);this.fileOperationResult=M,this.options=K}}e.FileOperationError=_;class I extends _{constructor(H,M,K){super(H,2,K);this.stat=M}}e.NotModifiedSinceFileOperationError=I;var r;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(r=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=F;async function B(V,H){if(!H.canHandleResource(k.URI.from({scheme:V.scheme})))return new Promise(M=>{const K=H.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===V.scheme&&N.added&&(K.dispose(),M())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(H){return(0,S.isNumber)(H)||(H=0),H<j.KB?(0,E.localize)(1,null,H.toFixed(0)):H<j.MB?(0,E.localize)(2,null,(H/j.KB).toFixed(2)):H<j.GB?(0,E.localize)(3,null,(H/j.MB).toFixed(2)):H<j.TB?(0,E.localize)(4,null,(H/j.GB).toFixed(2)):(0,E.localize)(5,null,(H/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var ae;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function oe(V){return{maxFileSize:V===0?300*j.MB:16*j.GB,maxHeapSize:V===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=oe}),define(we[64],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...D){this._entries=new Map;for(let[S,k]of D)this.set(S,k)}set(D,S){const k=this._entries.get(D);return this._entries.set(D,S),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=d}),define(we[153],be([0,1,15,12,90,148,4,64]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class T extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new E.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=g,this._parent=b,this._services.set(k.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...g){let b=l.traceInvocation(u),w=!1;try{return u({get:(o,p)=>{if(w)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(o,b);if(!v&&p!==k.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return v}},...g)}finally{w=!0,b.stop()}}createInstance(u,...g){let b,w;return u instanceof D.SyncDescriptor?(b=l.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(g),b)):(b=l.traceCreation(u),w=this._createInstance(u,g,b)),b.stop(),w}_createInstance(u,g=[],b){let w=k._util.getServiceDependencies(u).sort((p,v)=>p.index-v.index),A=[];for(const p of w){let v=this._getOrCreateServiceInstance(p.id,b);if(!v&&this._strict&&!p.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${p.id}.`);A.push(v)}let o=w.length>0?w[0].index:g.length;if(g.length!==o){console.warn(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${g.length} static arguments`);let p=o-g.length;p>0?g=g.concat(new Array(p)):g=g.slice(0,o)}return new u(...[...g,...A])}_setServiceInstance(u,g){if(this._services.get(u)instanceof D.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,g.branch(u,!0)):(g.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,g,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,b){const w=new S.Graph(p=>p.id.toString());let A=0;const o=[{id:u,desc:g,_trace:b}];for(;o.length;){const p=o.pop();if(w.lookupOrInsertNode(p),A++>1e3)throw new T(w);for(let v of k._util.getServiceDependencies(p.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const a={id:v.id,desc:t,_trace:p._trace.branch(v.id,!0)};w.insertEdge(p,a),o.push(a)}}}for(;;){const p=w.roots();if(p.length===0){if(!w.isEmpty())throw new T(w);break}for(const{data:v}of p){if(this._getServiceInstanceOrDescriptor(v.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,a)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,b=[],w,A){if(this._services.get(u)instanceof D.SyncDescriptor)return this._createServiceInstance(g,b,w,A);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,b,w,A);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g=[],b,w){if(b){const A=new d.IdleValue(()=>this._createInstance(u,g,w));return new Proxy(Object.create(null),{get(o,p){if(p in o)return o[p];let v=A.value,t=v[p];return typeof t!="function"||(t=t.bind(v),o[p]=t),t},set(o,p,v){return A.value[p]=v,!0}})}else return this._createInstance(u,g,w)}}e.InstantiationService=n;var C;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(C||(C={}));class l{constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new l(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(u){return y?new l(0,u.name):l._None}branch(u,g){let b=new l(2,u.toString());return this._dep.push([u,g,b]),b}stop(){let u=Date.now()-this._start;l._totals+=u;let g=!1;function b(A,o){let p=[],v=new Array(A+1).join("	");for(const[t,a,s]of o._dep)if(a&&s){g=!0,p.push(`${v}CREATES -> ${t}`);let i=b(A+1,s);i&&p.push(i)}else p.push(`${v}uses -> ${t}`);return p.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(u>2||g)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(we[16],be([0,1,60,3,6,22,4]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function E(){return new Date().toISOString()}var y;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class T extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class n extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...a){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...a]))}debug(t,...a){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...a]))}info(t,...a){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...a]))}warn(t,...a){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...a]))}error(t,...a){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...a]))}critical(t,...a){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...a]))}flush(){}format(t){let a="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}a+=(s>0?" ":"")+i}return a}}e.AbstractMessageLogger=n;class C extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...a){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...a):console.log(`[main ${E()}]`,t,...a))}debug(t,...a){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...a):console.log(`[main ${E()}]`,t,...a))}info(t,...a){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...a):console.log(`[main ${E()}]`,t,...a))}warn(t,...a){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,t,...a):console.warn(`[main ${E()}]`,t,...a))}error(t,...a){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,t,...a):console.error(`[main ${E()}]`,t,...a))}critical(t,...a){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,t,...a):console.error(`[main ${E()}]`,t,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class l extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...a){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...a)}debug(t,...a){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...a)}info(t,...a){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...a)}warn(t,...a){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...a)}error(t,...a){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...a)}critical(t,...a){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...a)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends T{constructor(t,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(a)}trace(t,...a){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...a])}debug(t,...a){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...a])}info(t,...a){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...a])}warn(t,...a){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...a])}error(t,...a){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...a])}critical(t,...a){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...a])}extractMessage(t){return typeof t=="string"?t:(0,d.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class u extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const a of this.logServices)a.setLevel(t);super.setLevel(t)}trace(t,...a){for(const s of this.logServices)s.trace(t,...a)}debug(t,...a){for(const s of this.logServices)s.debug(t,...a)}info(t,...a){for(const s of this.logServices)s.info(t,...a)}warn(t,...a){for(const s of this.logServices)s.warn(t,...a)}error(t,...a){for(const s of this.logServices)s.error(t,...a)}critical(t,...a){for(const s of this.logServices)s.critical(t,...a)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class g extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...a){this.logger.trace(t,...a)}debug(t,...a){this.logger.debug(t,...a)}info(t,...a){this.logger.info(t,...a)}warn(t,...a){this.logger.warn(t,...a)}error(t,...a){this.logger.error(t,...a)}critical(t,...a){this.logger.critical(t,...a)}flush(){this.logger.flush()}}e.LogService=g;class b extends D.Disposable{constructor(t,a){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,a){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,a?.always?y.Trace:this.logLevel,a),this.loggers.set(t.toString(),s),a?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...a){}debug(t,...a){}info(t,...a){}warn(t,...a){}error(t,...a){}critical(t,...a){}dispose(){}flush(){}}e.NullLogService=w;function A(v){if(v.verbose)return y.Trace;if(typeof v.logLevel=="string"){const t=o(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=A;function o(v){switch(v){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=o;function p(v){switch(v){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=p}),define(we[91],be([0,1,36,131,4]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var k;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(u,g){return g-u}y.compare=T;const n=Object.create(null);n[y.Error]=(0,R.localize)(0,null),n[y.Warning]=(0,R.localize)(1,null),n[y.Info]=(0,R.localize)(2,null);function C(u){return n[u]||""}y.toString=C;function l(u){switch(u){case d.default.Error:return y.Error;case d.default.Warning:return y.Warning;case d.default.Info:return y.Info;case d.default.Ignore:return y.Hint}}y.fromSeverity=l;function h(u){switch(u){case y.Error:return d.default.Error;case y.Warning:return d.default.Warning;case y.Info:return d.default.Info;case y.Hint:return d.default.Ignore}}y.toSeverity=h}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(y){const T="";function n(l){return C(l,!0)}y.makeKey=n;function C(l,h){let u=[T];return l.source?u.push(l.source.replace("\xA6","\\\xA6")):u.push(T),l.code?typeof l.code=="string"?u.push(l.code.replace("\xA6","\\\xA6")):u.push(l.code.value.replace("\xA6","\\\xA6")):u.push(T),l.severity!==void 0&&l.severity!==null?u.push(k.toString(l.severity)):u.push(T),l.message&&h?u.push(l.message.replace("\xA6","\\\xA6")):u.push(T),l.startLineNumber!==void 0&&l.startLineNumber!==null?u.push(l.startLineNumber.toString()):u.push(T),l.startColumn!==void 0&&l.startColumn!==null?u.push(l.startColumn.toString()):u.push(T),l.endLineNumber!==void 0&&l.endLineNumber!==null?u.push(l.endLineNumber.toString()):u.push(T),l.endColumn!==void 0&&l.endColumn!==null?u.push(l.endColumn.toString()):u.push(T),u.push(T),u.join("\xA6")}y.makeKeyOptionalMessage=C})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(we[154],be([0,1,3,36,4]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,D.createDecorator)("notificationService");var S;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class E{constructor(){this.progress=new y,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=E;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(we[155],be([0,1,6,8,2,4]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(E){return{resolved:E,dispose(){}}}});function k(E,y){return D.URI.isUri(E)?(0,R.equalsIgnoreCase)(E.scheme,y):(0,R.startsWithIgnoreCase)(E,y+":")}e.matchesScheme=k});var We=this&&this.__decorate||function(ee,e,d,R){var D=arguments.length,S=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,d):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(ee,e,d,R);else for(var E=ee.length-1;E>=0;E--)(k=ee[E])&&(S=(D<3?k(S):D>3?k(e,d,S):k(e,d))||S);return D>3&&S&&Object.defineProperty(e,d,S),S},He=this&&this.__param||function(ee,e){return function(d,R){e(d,R,ee)}};define(we[156],be([0,1,15,20,6,4]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,S.createDecorator)("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=E,E.None=Object.freeze({report(){}});let y=class extends D.Disposable{constructor(C,l){super();this.deferred=new d.DeferredPromise,l.withProgress(C,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=We([He(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends D.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(C){this.stop();const l=++this.currentOperationId,h=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,S.createDecorator)("editorProgressService")}),define(we[28],be([0,1,41,10]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,E){d.ok(R.isString(k)),d.ok(R.isObject(E)),d.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,E)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(we[92],be([0,1,3,28]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class S{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,T){this.schemasById[D(y)]=T,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new S;R.Registry.add(e.Extensions.JSONContribution,k)}),define(we[65],be([0,1,3,10,128,92,28]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=k.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(A,o=!0){this.registerConfigurations([A],o)}registerConfigurations(A,o=!0){const p=[];A.forEach(v=>{p.push(...this.validateAndRegisterProperties(v,o,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(A){const o=[],p=v=>{if(v.properties)for(const t in v.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>p(t))};for(const v of A){p(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(A){const o=[],p=[];for(const v of A)for(const t in v)if(o.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const a={type:"object",default:this.defaultValues[t],description:D.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};p.push(l(t)),this.configurationProperties[t]=a,this.defaultLanguageConfigurationOverridesNode.properties[t]=a}else{this.defaultValues[t]=v[t];const a=this.configurationProperties[t];a&&(this.updatePropertyDefaultValue(t,a),this.updateSchema(t,a))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(A){const o=[];for(const p of A)for(const v in p)if(o.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...A){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(A){for(const o of A)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(A,o=!0,p,v=3){v=R.isUndefinedOrNull(A.scope)?v:A.scope;let t=[],a=A.properties;if(a)for(let i in a){if(o&&g(i)){delete a[i];continue}const c=a[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=R.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=R.isUndefinedOrNull(c.restricted)?!!p?.restrictedConfigurations?.includes(i):c.restricted),a[i].hasOwnProperty("included")&&!a[i].included){this.excludedConfigurationProperties[i]=a[i],delete a[i];continue}else this.configurationProperties[i]=a[i];!a[i].deprecationMessage&&a[i].markdownDeprecationMessage&&(a[i].deprecationMessage=a[i].markdownDeprecationMessage),t.push(i)}let s=A.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,o,p,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(A){const o=p=>{let v=p.properties;if(v)for(const a in v)this.updateSchema(a,v[a]);let t=p.allOf;t&&t.forEach(o)};o(A)}updateSchema(A,o){switch(e.allSettings.properties[A]=o,o.scope){case 1:e.applicationSettings.properties[A]=o;break;case 2:e.machineSettings.properties[A]=o;break;case 6:e.machineOverridableSettings.properties[A]=o;break;case 3:e.windowSettings.properties[A]=o;break;case 4:e.resourceSettings.properties[A]=o;break;case 5:e.resourceSettings.properties[A]=o,this.resourceLanguageSettingsSchema.properties[A]=o;break}}removeFromSchema(A,o){switch(delete e.allSettings.properties[A],o.scope){case 1:delete e.applicationSettings.properties[A];break;case 2:delete e.machineSettings.properties[A];break;case 6:delete e.machineOverridableSettings.properties[A];break;case 3:delete e.windowSettings.properties[A];break;case 4:case 5:delete e.resourceSettings.properties[A];break}}updateOverridePropertyPatternKey(){for(const A of this.overrideIdentifiers.values()){const o=`[${A}]`,p={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,p),e.allSettings.properties[o]=p,e.applicationSettings.properties[o]=p,e.machineSettings.properties[o]=p,e.machineOverridableSettings.properties[o]=p,e.windowSettings.properties[o]=p,e.resourceSettings.properties[o]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(A,o){let p=this.defaultValues[A];R.isUndefined(p)&&(p=o.default),R.isUndefined(p)&&(p=h(o.type)),o.default=p}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new n;k.Registry.add(e.Extensions.Configuration,u);function g(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?D.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?D.localize(6,null,w):null:D.localize(4,null)}e.validateProperty=g;function b(){const w=[],A=u.getConfigurationProperties();for(const o of Object.keys(A))w.push([o,A[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(we[93],be([0,1,23,10,2,65,4,28]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function y(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}e.isConfigurationOverrides=y;var T;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function C(a,s){const i=s?a?s.keys.filter(P=>a.keys.indexOf(P)===-1):[...s.keys]:[],c=a?s?a.keys.filter(P=>s.keys.indexOf(P)===-1):[...a.keys]:[],f=[];if(s&&a){for(const P of a.keys)if(s.keys.indexOf(P)!==-1){const F=w(a.contents,P),B=w(s.contents,P);d.equals(F,B)||f.push(P)}}const m=[],_=P=>{const F={};for(const B of P)for(const j of B.identifiers)F[v(j)]=B;return F},I=s?_(s.overrides):{},r=a?_(a.overrides):{};if(Object.keys(I).length)for(const P of i){const F=I[P];F&&m.push([(0,S.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(r).length)for(const P of c){const F=r[P];F&&m.push([(0,S.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(I).length&&Object.keys(r).length)for(const P of f){const F=r[P],B=I[P];if(F&&B){const j=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});m.push([(0,S.overrideIdentifierFromKey)(P),[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:c,updated:f,overrides:m}}e.compare=C;function l(a,s){const i=[];for(const c of Object.keys(a))if(S.OVERRIDE_PROPERTY_PATTERN.test(c)){const f={};for(const m in a[c])f[m]=a[c][m];i.push({identifiers:[(0,S.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(f),contents:h(f,s)})}return i}e.toOverrides=l;function h(a,s){const i=Object.create(null);for(let c in a)u(i,c,a[c],s);return i}e.toValuesTree=h;function u(a,s,i,c){const f=s.split("."),m=f.pop();let _=a;for(let I=0;I<f.length;I++){let r=f[I],P=_[r];switch(typeof P){case"undefined":P=_[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${s} as ${f.slice(0,I+1).join(".")} is ${JSON.stringify(P)}`);return}_=P}if(typeof _=="object"&&_!==null)try{_[m]=i}catch(I){c(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(_)}`)}else c(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=u;function g(a,s){const i=s.split(".");b(a,i)}e.removeFromValueTree=g;function b(a,s){const i=s.shift();if(s.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const c=a[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,s),Object.keys(c).length===0&&delete a[i])}}function w(a,s,i){function c(_,I){let r=_;for(const P of I){if(typeof r!="object"||r===null)return;r=r[P]}return r}const f=s.split("."),m=c(a,f);return typeof m=="undefined"?i:m}e.getConfigurationValue=w;function A(a,s,i){Object.keys(s).forEach(c=>{c!=="__proto__"&&(c in a?R.isObject(a[c])&&R.isObject(s[c])?A(a[c],s[c],i):i&&(a[c]=s[c]):a[c]=s[c])})}e.merge=A;function o(){const a=E.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=o;function p(){const a=Object.create(null),s=E.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let i in s){let c=s[i].default;u(a,i,c,f=>console.error(`Conflict in default settings: ${f}`))}return a}e.getDefaultValues=p;function v(a){return`[${a}]`}e.keyFromOverrideIdentifier=v;function t(a,s,i){const c=a.inspect(s),f=a.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:c.defaultValue}e.getMigratedSettingValue=t}),define(we[157],be([0,1,17,3,111,6,21,23,10,2,93,65,28]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},a=[],s=[]){this._contents=t,this._keys=a,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,a){const s=this.getContentsForOverrideIdentifer(a);return s?t?(0,n.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.keys;return[]}override(t){const a=this.getContentsForOverrideIdentifer(t);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let s={};for(const i of d.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[i],f=a[i];f&&(typeof c=="object"&&typeof f=="object"?(c=E.deepClone(c),this.mergeContents(c,f)):c=f),s[i]=c}return new h(s,this.keys,this.overrides)}merge(...t){const a=E.deepClone(this.contents),s=E.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(a,c.contents);for(const f of c.overrides){const[m]=s.filter(_=>d.equals(_.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):s.push(E.deepClone(f))}for(const f of c.keys)i.indexOf(f)===-1&&i.push(f)}return new h(a,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,a){for(const s of Object.keys(a)){if(s in t&&y.isObject(t[s])&&y.isObject(a[s])){this.mergeContents(t[s],a[s]);continue}t[s]=E.deepClone(a[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,a){this.addKey(t),(0,n.addToValueTree)(this.contents,t,a,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let a=this.keys.length;for(let s=0;s<a;s++)t.indexOf(this.keys[s])===0&&(a=s);this.keys.splice(a,1,t)}removeKey(t){let a=this.keys.indexOf(t);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=h;class u extends h{constructor(){const t=(0,n.getDefaultValues)(),a=(0,n.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,C.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,a,s)}}e.DefaultConfigurationModel=u;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,a){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,a)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,a){this._raw=t;const{contents:s,keys:i,overrides:c,restricted:f}=this.doParseRaw(t,a);this._configurationModel=new h(s,i,c),this._restrictedConfigurations=f||[]}doParseContent(t){let a={},s=null,i=[],c=[],f=[];function m(I){Array.isArray(i)?i.push(I):s!==null&&(i[s]=I)}let _={onObjectBegin:()=>{let I={};m(I),c.push(i),i=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let I=[];m(I),c.push(i),i=I,s=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:m,onError:(I,r,P)=>{f.push({error:I,offset:r,length:P})}};if(t)try{D.visit(t,_),a=i[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return a}doParseRaw(t,a){const s=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,a);t=i.raw;const c=(0,n.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),f=Object.keys(t),m=(0,n.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:c,keys:f,overrides:m,restricted:i.restricted}}filter(t,a,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},f=[];for(let m in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const _=this.filter(t[m],a,!1,i);c[m]=_.raw,f.push(..._.restricted)}else{const _=a[m],I=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&f.push(m),(I===void 0||i.scopes===void 0||i.scopes.includes(I))&&(i.skipRestricted&&_?.restricted||(c[m]=t[m]))}return{raw:c,restricted:f}}}e.ConfigurationModelParser=g;class b extends S.Disposable{constructor(t,a,s,i){super();this.userSettingsResource=t,this.scopes=a,this.fileService=i,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(t,a,s=new h,i=new h,c=new k.ResourceMap,f=new h,m=new k.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=a,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,a,s){return this.getConsolidateConfigurationModel(a,s).getValue(t)}updateValue(t,a,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new h,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,a===void 0?i.removeValue(t):i.setValue(t,a),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,a,s){const i=this.getConsolidateConfigurationModel(a,s),c=this.getFolderConfigurationModelForResource(a.resource,s),f=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,m=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),I=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),r=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=s?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=c?a.overrideIdentifier?c.freeze().override(a.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,B=a.overrideIdentifier?f.override(a.overrideIdentifier).getValue(t):f.getValue(t),j=i.getValue(t),ae=d.distinct(d.flatten(i.overrides.map(oe=>oe.identifiers))).filter(oe=>i.getOverrideValue(t,oe)!==void 0);return{defaultValue:m,userValue:_,userLocalValue:I,userRemoteValue:r,workspaceValue:P,workspaceFolderValue:F,memoryValue:B,value:j,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userRemote:r!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:c?.freeze().getValue(t),override:a.overrideIdentifier?c?.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:f.getValue(t),override:a.overrideIdentifier?f.getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(t){const a=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,a){this._folderConfigurations.set(t,a),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,a){const s=a.filter(i=>C.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,C.overrideIdentifierFromKey)(i),f=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=t.getKeysForOverrideIdentifier(c),_=[...m.filter(I=>f.indexOf(I)===-1),...f.filter(I=>m.indexOf(I)===-1),...f.filter(I=>!E.equals(this._defaultConfiguration.override(c).getValue(I),t.override(c).getValue(I)))];return[c,_]});return this.updateDefaultConfiguration(t),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:a,updated:s,removed:i,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),f=[...a,...s,...i];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:a,updated:s,removed:i,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...a,...s,...i];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:a,updated:s,removed:i,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...a,...s,...i];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:c}}compareAndUpdateFolderConfiguration(t,a){const s=this.folderConfigurations.get(t),{added:i,updated:c,removed:f,overrides:m}=(0,n.compare)(s,a);let _=[...i,...c,...f];return(_.length||!s)&&this.updateFolderConfiguration(t,a),{keys:_,overrides:m}}compareAndDeleteFolderConfiguration(t){const a=this.folderConfigurations.get(t);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:c,overrides:f}=(0,n.compare)(a,void 0);return{keys:[...s,...i,...c],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,a){let s=this.getConsolidatedConfigurationModelForResource(t,a);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},a){let s=this.getWorkspaceConsolidatedConfiguration();if(a&&t){const i=a.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const c=this._memoryConfigurationByResource.get(t);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let a=this._foldersConsolidatedConfigurations.get(t);if(!a){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(a=s.merge(i),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(t,a)):a=s}return a}getFolderConfigurationModelForResource(t,a){if(a&&t){const s=a.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,a)=>{const{contents:s,overrides:i,keys:c}=this._folderConfigurations.get(a);return t.push([a,{contents:s,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>t.add(a)),this.userConfiguration.freeze().keys.forEach(a=>t.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>t.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>a.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>a.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>a.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>a.add(i))),[...a.values()]}static parse(t){const a=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((f,m)=>(f.set(T.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new k.ResourceMap);return new w(a,s,new h,i,c,new h,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function A(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,a=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,f])=>{const m=(0,k.getOrSet)(a,c,new Set);f.forEach(_=>m.add(_))});const s=[];return a.forEach((i,c)=>s.push([c,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=A;class o{constructor(t,a,s,i){this.change=t,this.previous=a,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(m=>c.add(m)),t.overrides.forEach(([,m])=>m.forEach(_=>c.add(_))),this.affectedKeys=[...c.values()];const f=new h;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(a){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,a,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,a,this.currentWorkspace);return!E.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,a){let s=(0,n.toValuesTree)({[a]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=o;class p extends o{constructor(t,a,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,a);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=p}),define(we[94],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,E=R.Unknown,y){super(k);this._message=k,this._code=E,this._detail=y,this.isHandled=E===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===R.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(we[95],be([0,1,11]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=R;function D(T){if(!T)return;const n=T.indexOf("+");return n<0?T:T.substr(0,n)}e.getRemoteName=D;function S(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=S;function k(T){if(T.folders.length)return T.folders.every(n=>S(n.uri))?T.folders[0].uri:void 0;if(T.configuration&&S(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=k;function E(T){return k(T)?.scheme}e.getVirtualWorkspaceScheme=E;function y(T){return k(T)!==void 0}e.isVirtualWorkspace=y}),define(we[158],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,S,k=5){let E;return E=S(y=>{const T=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(D);if(n){n.data.push(T);return}const C=setTimeout(()=>this.flushBuffer(D),k);n={data:[T],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(D),E.dispose()}},this._terminalBufferMap.set(D,n)}),E}stopBuffering(D){const S=this._terminalBufferMap.get(D);S&&S.dispose()}flushBuffer(D){const S=this._terminalBufferMap.get(D);S&&(this._terminalBufferMap.delete(D),this._callback(D,S.data.join("")))}}e.TerminalDataBufferer=d}),define(we[159],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(we[46],be([0,1,35,3,6,4,28,159]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var y;(function(b){function w(A){return A&&typeof A=="object"&&typeof A.id=="string"}b.isThemeColor=w})(y=e.ThemeColor||(e.ThemeColor={}));function T(b){return{id:b}}e.themeColorFromId=T;var n;(function(b){function w(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||y.isThemeColor(a.color))}b.isThemeIcon=w;const A=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(a){const s=A.exec(a);if(!s)return;let[,i]=s;return{id:i}}b.fromString=o;function p(a,s){let i=a.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),s&&(i=`${i}~${s}`),{id:i}}b.modify=p;function v(a,s){return a.id===s.id&&a.color?.id===s.color?.id}b.isEqual=v;function t(a,s){return{id:a.id,color:s?T(s):void 0}}b.asThemeIcon=t,b.asClassNameArray=d.CSSIcon.asClassNameArray,b.asClassName=d.CSSIcon.asClassName,b.asCSSSelector=d.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function C(b){switch(b){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,D.toDisposable)(()=>{const A=this.themingParticipants.indexOf(w);this.themingParticipants.splice(A,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new l;k.Registry.add(e.Extensions.ThemingContribution,h);function u(b){return h.onColorThemeChange(b)}e.registerThemingParticipant=u;class g extends D.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(A=>this.onThemeChange(A)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,A){let o=this.theme.getColor(w);return o&&A&&(o=A(o,this.theme)),o?o.toString():null}}e.Themable=g}),define(we[160],be([0,1,15,35,3,132,92,28,46]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${R.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,A,o,p){const v=this.iconsById[w];if(v){if(o&&!v.description){v.description=o,this.iconSchema.properties[w].markdownDescription=`${o} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=o),this._onDidChange.fire()}return v}let t={id:w,description:o,defaults:A,deprecationMessage:p};this.iconsById[w]=t;let a={$ref:"#/definitions/icons"};return p&&(a.deprecationMessage=p),o&&(a.markdownDescription=`${o}: $(${w})`),this.iconSchema.properties[w]=a,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const A=this.iconReferenceSchema.enum.indexOf(w);A!==-1&&(this.iconReferenceSchema.enum.splice(A,1),this.iconReferenceSchema.enumDescriptions.splice(A,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,A){const o=this.iconFontsById[w];if(o)return o;let p={id:w,definition:A};return this.iconFontsById[w]=p,this._onDidChange.fire(),p}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),A=v=>{for(;y.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of p.filter(t=>!!t.description).sort(w))o.push(`|<i class="${A(v)}"></i>|${v.id}|${y.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const v of p.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(w))o.push(`|<i class="${A(v)}"></i>|${v.id}|`);return o.join(`
`)}}const n=new T;E.Registry.add(e.Extensions.IconContribution,n);function C(b,w,A,o){return n.registerIcon(b,w,A,o)}e.registerIcon=C;function l(){return n}e.getIconRegistry=l;function h(){for(const b of R.iconRegistry.all)n.registerIcon(b.id,b.definition,b.description);R.iconRegistry.onDidRegister(b=>n.registerIcon(b.id,b.definition,b.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let u=E.Registry.as(k.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const g=new d.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=C("widget-close",R.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",R.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",R.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=y.ThemeIcon.modify(R.Codicon.sync,"spin")}),define(we[47],be([0,1,21,25,2,4]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var k;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function E(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=E;function y(l){const h=l;return!!(h&&typeof h=="object"&&D.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=y;class T{constructor(h,u,g,b){this._id=h,this._configuration=g,this._ignorePathCasing=b,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class n{constructor(h,u){this.raw=u,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,R.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function C(l){return new n({uri:l,index:0,name:(0,R.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=C}),define(we[66],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const S=this._idPool++;return this._data.set(S,D),this.logDebugInfo(),S}get(D,S){return this._data.has(D)?this._data.get(D)[S]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(we[67],be([0,1,2,3,4]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class S{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(E){this._tabs=E.map(y=>({name:y.name,group:y.group,resource:d.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=S}),define(we[48],be([0,1,11,4]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,E){E===null?this._providerInfo.delete(k):this._providerInfo.set(k,E)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(we[161],be([0,1,15]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(k,E,y){this._deferredPromises=new Map,this._id=k,this._shared=E,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of T.values())n.complete()}catch(n){for(const C of T.values())C.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,E){let y=this._value[k];return typeof y=="undefined"&&(y=E),y}update(k,E){this._value[k]=E;let y=this._deferredPromises.get(k);if(y!==void 0)return y.p;const T=new d.DeferredPromise;return this._deferredPromises.set(k,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class D extends R{constructor(k,E){super(k.identifier.value,!0,E);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=D}),define(we[162],be([0,1,3,2,16]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(E,y){this._logService=E,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(E,y,T){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E)).acceptModelChanged(y,T)}$acceptDirtyStateChanged(E,y){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E)).acceptDirty(y)}$acceptModelSaved(E){const y=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(E,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",E.path,y);const T=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(E));T.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};S=We([He(0,D.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(we[13],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class R{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[163],be([0,1,26,3]),function(ee,e,d,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(E,y){D.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(E.identifier),nt(this,D,y,"f"),Ue(this,D,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(E){return Ue(this,D,"f").get(this._id,E)}store(E,y){return Ue(this,D,"f").store(this._id,E,y)}delete(E){return Ue(this,D,"f").delete(this._id,E)}}e.ExtensionSecrets=S,D=new WeakMap}),define(we[96],be([0,1,4,3]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(we[68],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(A){A[A.Upsert=0]="Upsert",A[A.RemoveChild=1]="RemoveChild",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp",A[A.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const R=new WeakMap,D=(A,o)=>{const p={controllerId:o};return R.set(A,p),p};e.createPrivateApiFor=D;const S=A=>R.get(A);e.getPrivateApiFor=S;const k=(A,o,p,v)=>{let t=p;return{enumerable:!0,configurable:!1,get(){return t},set(a){v(t,a)||(t=a,A.listener?.({op:3,key:o,value:a}))}}},E=(A,o)=>A===o,y={range:(A,o)=>A===o?!0:!A||!o?!1:A.isEqual(o),label:E,description:E,busy:E,error:E,canResolveChildren:E,tags:(A,o)=>!(A.length!==o.length||A.some(p=>!o.find(v=>p.id===v.id)))},T=Object.keys(y),n=(A,o)=>({range:k(A,"range",void 0,y.range),label:k(A,"label",o,y.label),description:k(A,"description",void 0,y.description),canResolveChildren:k(A,"canResolveChildren",!1,y.canResolveChildren),busy:k(A,"busy",!1,y.busy),error:k(A,"error",void 0,y.error),tags:k(A,"tags",[],y.tags)}),C=(A,o)=>{const p=new Map;for(const v of T)y[v](A[v],o[v])||p.set(v,o[v]);return p};e.diffTestItems=C;class l extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=l;class h extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class u extends Error{constructor(o,p,v){super(`TestItem with ID "${o}" is from controller "${p}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=u;const g=A=>{const o=(0,e.getPrivateApiFor)(A);let p=new Map;return{get size(){return p.size},forEach(v,t){for(const a of p.values())v.call(t,a,this)},replace(v){const t=new Map,a=new Set(p.keys()),s={op:4,ops:[]};for(const i of v){if(!(i instanceof b))throw new h(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==o.controllerId)throw new u(i.id,c,o.controllerId);if(t.has(i.id))throw new l(i.id);t.set(i.id,i),a.delete(i.id),s.ops.push({op:0,item:i})}for(const i of a.keys())s.ops.push({op:1,id:i});o.listener?.(s),p=t},add(v){if(!(v instanceof b))throw new h(v.id);p.set(v.id,v),o.listener?.({op:0,item:v})},delete(v){p.delete(v)&&o.listener?.({op:1,id:v})},get(v){return p.get(v)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class b{constructor(o,p,v,t){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const a=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof w?void 0:a.parent}},children:{value:g(this),enumerable:!0,writable:!1},...n(a,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=b;class w extends b{constructor(o,p){super(o,o,p,void 0)}}e.TestItemRootImpl=w}),define(we[69],be([0,1,4,3,13]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var S;(function(E){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}E.fromApiTunnel=y;function T(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}E.fromServiceTunnel=T})(S=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let k=class{constructor(y){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,T){return{dispose:()=>{}}}async $providePortAttributes(y,T,n,C,l){return[]}async $forwardPort(y,T){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=We([He(0,D.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[7],be([0,1,17,12,82,21,84,10,2,37,63,94]),function(ee,e,d,R,D,S,k,E,y,T,n,C){"use strict";var l,h,u,g,b,w,A,o,p,v,t,a,s,i,c,f,m,_,I,r;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let F=b=class{constructor(L){l.set(this,void 0),nt(this,l,L,"f")}static from(...L){let te=L;return new b(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}dispose(){typeof Ue(this,l,"f")=="function"&&(Ue(this,l,"f").call(this),nt(this,l,void 0,"f"))}};l=new WeakMap,F=b=We([P],F),e.Disposable=F;let B=w=class{constructor(L,te){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(te<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Se=1;Se<L.length;Se++){const Ge=L[Se];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Se=1;Se<L.length;Se++){const Ge=L[Se];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:te,character:Se}=L;return typeof te=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,R.illegalArgument)();let Se;return typeof L=="undefined"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&te===0?this:new w(this.line+Se,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,R.illegalArgument)();let Se;return typeof L=="undefined"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Se===this.line&&te===this.character?this:new w(Se,te)}toJSON(){return{line:this.line,character:this.character}}};B=w=We([P],B),e.Position=B;let j=A=class{constructor(L,te,Se,Ge){let tt,rt;if(typeof L=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"?(tt=new B(L,te),rt=new B(Se,Ge)):L instanceof B&&te instanceof B&&(tt=L,rt=te),!tt||!rt)throw new Error("Invalid arguments");tt.isBefore(rt)?(this._start=tt,this._end=rt):(this._start=rt,this._end=tt)}static isRange(L){return L instanceof A?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof A?this.contains(L._start)&&this.contains(L._end):L instanceof B?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=B.Max(L.start,this._start),Se=B.Min(L.end,this._end);if(!te.isAfter(Se))return new A(te,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=B.Min(L.start,this._start),Se=B.Max(L.end,this.end);return new A(te,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,R.illegalArgument)();let Se;return L?B.isPosition(L)?Se=L:(Se=L.start||this.start,te=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&te.isEqual(this.end)?this:new A(Se,te)}toJSON(){return[this.start,this.end]}};j=A=We([P],j),e.Range=j;let ae=o=class extends j{constructor(L,te,Se,Ge){let tt,rt;if(typeof L=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"?(tt=new B(L,te),rt=new B(Se,Ge)):L instanceof B&&te instanceof B&&(tt=L,rt=te),!tt||!rt)throw new Error("Invalid arguments");super(tt,rt);this._anchor=tt,this._active=rt}static isSelection(L){return L instanceof o?!0:L?j.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ae=o=We([P],ae),e.Selection=ae;class oe{constructor(L,te,Se){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,R.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,R.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=Se}}e.ResolvedAuthority=oe;class V extends Error{constructor(L,te=C.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L);this._message=L,this._code=te,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,te){return new V(L,C.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new V(L,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var M;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=p=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof p?!0:L?j.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new p(L,te)}static insert(L,te){return p.replace(new j(L,L),te)}static delete(L){return p.replace(L,"")}static setEndOfLine(L){const te=new p(new j(new B(0,0),new B(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!j.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=p=We([P],K),e.TextEdit=K;var N;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(N=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,Se,Ge){this._edits.push({_type:1,from:L,to:te,options:Se,metadata:Ge})}createFile(L,te,Se){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:Se})}deleteFile(L,te,Se){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:Se})}replaceNotebookMetadata(L,te,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,Se,Ge,tt){let rt,lt,St=[],At;if(Bt.isNotebookRange(te)&&Ft.isNotebookCellDataArray(Se)&&!Ft.isNotebookCellDataArray(Ge)?(rt=te.start,lt=te.end,St=Se,At=Ge):typeof te=="number"&&typeof Se=="number"&&Ft.isNotebookCellDataArray(Ge)&&(rt=te,lt=Se,St=Ge,At=tt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||St.length>0)&&this._edits.push({_type:5,uri:L,index:rt,count:lt-rt,cells:St,metadata:At})}replaceNotebookCellMetadata(L,te,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:te,metadata:Se}})}replace(L,te,Se,Ge){this._edits.push({_type:2,uri:L,edit:new K(te,Se),metadata:Ge})}insert(L,te,Se,Ge){this.replace(L,new j(te,te),Se,Ge)}delete(L,te,Se){this.replace(L,te,"",Se)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Se of te)Se&&this._edits.push({_type:2,uri:L,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[Se]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&te.push(Se.edit);return te}entries(){const L=new S.ResourceMap;for(let te of this._edits)if(te._type===2){let Se=L.get(te.uri);Se||(Se=[te.uri,[]],L.set(te.uri,Se)),Se[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=We([P],G),e.WorkspaceEdit=G;let me=v=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=v._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const Se=new v;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=v._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const Se=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Se=new v;Se._tabstop=this._tabstop,te(Se),this._tabstop=Se._tabstop,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};me=v=We([P],me),e.SnippetString=me;var W;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var ne;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ne=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ge=t=class{constructor(L,te){if(this.uri=L,te)if(te instanceof j)this.range=te;else if(te instanceof B)this.range=new j(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof t?!0:L?j.isRange(L.range)&&y.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ge=t=We([P],ge),e.Location=ge;let _e=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&j.isRange(L.location.range)&&y.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};_e=We([P],_e),e.DiagnosticRelatedInformation=_e;let Me=class{constructor(L,te,Se=ne.Error){if(!j.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Se}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,d.equals)(L.tags,te.tags)&&(0,d.equals)(L.relatedInformation,te.relatedInformation,_e.isEqual)}};Me=We([P],Me),e.Diagnostic=Me;let Fe=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Fe=We([P],Fe),e.Hover=Fe;var xe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(xe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(L,te=xe.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:xe[this.kind]}}};Ye=We([P],Ye),e.DocumentHighlight=Ye;var Ve;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var qe;(function(U){U[U.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=a=class{constructor(L,te,Se,Ge,tt){this.name=L,this.kind=te,this.containerName=tt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof ge?this.location=Ge:Se instanceof j&&(this.location=new ge(Ge,Se)),a.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};x=a=We([P],x),e.SymbolInformation=x;let Q=s=class{constructor(L,te,Se,Ge,tt){this.name=L,this.detail=te,this.kind=Se,this.range=Ge,this.selectionRange=tt,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(s.validate)}};Q=s=We([P],Q),e.DocumentSymbol=Q;var X;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(L,te){this.title=L,this.kind=te}};re=We([P],re),e.CodeAction=re;let q=i=class{constructor(L){this.value=L}append(L){return new i(this.value?this.value+i.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=We([P],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ie=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ie=We([P],ie),e.SelectionRange=ie;class pe{constructor(L,te,Se,Ge,tt,rt){this.kind=L,this.name=te,this.detail=Se,this.uri=Ge,this.range=tt,this.selectionRange=rt}}e.CallHierarchyItem=pe;class Te{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Te;class Be{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=Be;var ve;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};Ke=We([P],Ke),e.CodeLens=Ke;let z=c=class{constructor(L,te=!1){h.set(this,void 0),nt(this,h,new D.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof c?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ue(this,h,"f").value}set value(L){Ue(this,h,"f").value=L}get isTrusted(){return Ue(this,h,"f").isTrusted}set isTrusted(L){Ue(this,h,"f").isTrusted=L}get supportThemeIcons(){return Ue(this,h,"f").supportThemeIcons}set supportThemeIcons(L){Ue(this,h,"f").supportThemeIcons=L}appendText(L){return Ue(this,h,"f").appendText(L),this}appendMarkdown(L){return Ue(this,h,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Ue(this,h,"f").appendCodeblock(te??"",L),this}};h=new WeakMap,z=c=We([P],z),e.MarkdownString=z;let Z=class{constructor(L,te){this.label=L,this.documentation=te}};Z=We([P],Z),e.ParameterInformation=Z;let fe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};fe=We([P],fe),e.SignatureInformation=fe;let Oe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Oe=We([P],Oe),e.SignatureHelp=Oe;var Ne;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Xe;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Xe=e.InlayHintKind||(e.InlayHintKind={}));let De=class{constructor(L,te,Se){this.text=L,this.position=te,this.kind=Se}};De=We([P],De),e.InlayHint=De;var ye;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(U){U[U.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let ue=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ue=We([P],ue),e.CompletionItem=ue;let O=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};O=We([P],O),e.CompletionList=O;let Y=class{constructor(L,te,Se){this.text=L,this.range=te,this.command=Se}};Y=We([P],Y),e.InlineSuggestion=Y;let le=class{constructor(L){this.items=L}};le=We([P],le),e.InlineSuggestions=le;var Ae;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ae=e.ViewColumn||(e.ViewColumn={}));var Pe;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Pe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var $e;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})($e=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var je;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(et=e.TextEditorRevealType||(e.TextEditorRevealType={}));var it;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(it=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Je;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Je=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(it=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let mt=class{constructor(L,te){if(te&&!y.URI.isUri(te))throw(0,R.illegalArgument)("target");if(!j.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=te}};mt=We([P],mt),e.DocumentLink=mt;let vt=class{constructor(L,te,Se,Ge){this.red=L,this.green=te,this.blue=Se,this.alpha=Ge}};vt=We([P],vt),e.Color=vt;let Et=class{constructor(L,te){if(te&&!(te instanceof vt))throw(0,R.illegalArgument)("color");if(!j.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=te}};Et=We([P],Et),e.ColorInformation=Et;let ot=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};ot=We([P],ot),e.ColorPresentation=ot;var at;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Dt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ee{constructor(L,te,Se){if(this.startIndex=L,this.length=te,this.tooltip=Se,typeof L!="number"||L<0)throw(0,R.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,R.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Ee;class he{constructor(L){this.options=L,typeof L!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=he;var ce;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var $;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})($=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=f=class{constructor(L,te){if(typeof L!="string"||typeof te!="string")throw(0,R.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ie.Clean=new f("clean","Clean"),Ie.Build=new f("build","Build"),Ie.Rebuild=new f("rebuild","Rebuild"),Ie.Test=new f("test","Test"),Ie=f=We([P],Ie),e.TaskGroup=Ie;function Le(U){let L="";for(let te=0;te<U.length;te++)L+=U[te].replace(/,/g,",,")+",";return L}let Ze=class{constructor(L,te,Se){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Se):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Le(L)}};Ze=We([P],Ze),e.ProcessExecution=Ze;let ze=class{constructor(L,te,Se){if(this._args=[],Array.isArray(te)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=te,this._options=Se}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Le(L)}};ze=We([P],ze),e.ShellExecution=ze;var ft;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ft=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=kt;let dt=m=class{constructor(L,te,Se,Ge,tt,rt){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Se,this.execution=Ge,lt=tt,this.__deprecated=!0):te===bt.Global||te===bt.Workspace?(this.target=te,this._name=this.name=Se,this._source=this.source=Ge,this.execution=tt,lt=rt):(this.target=te,this._name=this.name=Se,this._source=this.source=Ge,this.execution=tt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof ze?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=m=We([P],dt),e.Task=dt;var ut;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(L,te=_t.None){this.collapsibleState=te,y.URI.isUri(L)?this.resourceUri=L:this.label=L}};ht=We([P],ht),e.TreeItem=ht;var _t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(L,te){this.id=L,this.color=te}};Tt=We([P],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor(L){this.id=L}};It=We([P],It),e.ThemeColor=It;var En;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(En=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(L,te){if(typeof L!="string"&&(!L||!y.URI.isUri(L)&&!y.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof te!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=y.URI.file(L),this.base=L):y.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};Vt=We([P],Vt),e.RelativePattern=Vt;let yt=class{constructor(L,te,Se,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};yt=We([P],yt),e.Breakpoint=yt;let Yt=class extends yt{constructor(L,te,Se,Ge,tt){super(te,Se,Ge,tt);if(L===null)throw(0,R.illegalArgument)("location");this.location=L}};Yt=We([P],Yt),e.SourceBreakpoint=Yt;let Jt=class extends yt{constructor(L,te,Se,Ge,tt){super(te,Se,Ge,tt);this.functionName=L}};Jt=We([P],Jt),e.FunctionBreakpoint=Jt;let gt=class extends yt{constructor(L,te,Se,Ge,tt,rt,lt){super(Ge,tt,rt,lt);if(!te)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=Se}};gt=We([P],gt),e.DataBreakpoint=gt;let qt=class{constructor(L,te,Se){this.command=L,this.args=te||[],this.options=Se}};qt=We([P],qt),e.DebugAdapterExecutable=qt;let Wt=class{constructor(L,te){this.port=L,this.host=te}};Wt=We([P],Wt),e.DebugAdapterServer=Wt;let Xt=class{constructor(L){this.path=L}};Xt=We([P],Xt),e.DebugAdapterNamedPipeServer=Xt;let Zt=class{constructor(L){this.implementation=L}};Zt=We([P],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor(L,te){this.range=L,this.expression=te}};Pt=We([P],Pt),e.EvaluatableExpression=Pt;var hn;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(L,te){this.range=L,this.text=te}};en=We([P],en),e.InlineValueText=en;let xt=class{constructor(L,te,Se=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Se}};xt=We([P],xt),e.InlineValueVariableLookup=xt;let ct=class{constructor(L,te){this.range=L,this.expression=te}};ct=We([P],ct),e.InlineValueEvaluatableExpression=ct;let tn=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};tn=We([P],tn),e.InlineValueContext=tn;var Lt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Lt=e.FileChangeType||(e.FileChangeType={}));let Nt=_=class extends Error{constructor(L,te=n.FileSystemProviderErrorCode.Unknown,Se){super(y.URI.isUri(L)?L.toString(!0):L);this.code=Se?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(L){return new _(L,n.FileSystemProviderErrorCode.FileExists,_.FileExists)}static FileNotFound(L){return new _(L,n.FileSystemProviderErrorCode.FileNotFound,_.FileNotFound)}static FileNotADirectory(L){return new _(L,n.FileSystemProviderErrorCode.FileNotADirectory,_.FileNotADirectory)}static FileIsADirectory(L){return new _(L,n.FileSystemProviderErrorCode.FileIsADirectory,_.FileIsADirectory)}static NoPermissions(L){return new _(L,n.FileSystemProviderErrorCode.NoPermissions,_.NoPermissions)}static Unavailable(L){return new _(L,n.FileSystemProviderErrorCode.Unavailable,_.Unavailable)}};Nt=_=We([P],Nt),e.FileSystemError=Nt;let jt=class{constructor(L,te,Se){this.start=L,this.end=te,this.kind=Se}};jt=We([P],jt),e.FoldingRange=jt;var _n;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(_n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yn;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(yn=e.CommentMode||(e.CommentMode={}));class mn{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=mn;function nn(U){return typeof U=="undefined"||(0,E.isStringArray)(U)}class rn{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,Se=L.tokenTypes.length;te<Se;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,Se=L.tokenModifiers.length;te<Se;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,Se,Ge,tt){if(typeof L=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,te,Se,Ge,tt);if(j.isRange(L)&&typeof te=="string"&&nn(Se))return this._push(L,te,Se);throw(0,R.illegalArgument)()}_push(L,te,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,tt=L.start.character,rt=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(te);let St=0;if(Se)for(const At of Se){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);St|=1<<Rt>>>0}this._pushEncoded(Ge,tt,rt,lt,St)}_pushEncoded(L,te,Se,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Rt=0;for(let Mt=0;Mt<St;Mt++){let Ot=this._data[5*Mt],cn=this._data[5*Mt+1];Ot===0?(Ot=At,cn+=Rt):Ot+=At,this._data[5*Mt]=Ot,this._data[5*Mt+1]=cn,At=Ot,Rt=cn}}let rt=L,lt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const Se=L.length/5|0;for(let lt=0;lt<Se;lt++)te[lt]=lt;te.sort((lt,St)=>{const At=L[5*lt],Rt=L[5*St];if(At===Rt){const Mt=L[5*lt+1],Ot=L[5*St+1];return Mt-Ot}return At-Rt});const Ge=new Uint32Array(L.length);let tt=0,rt=0;for(let lt=0;lt<Se;lt++){const St=5*te[lt],At=L[St+0],Rt=L[St+1],Mt=L[St+2],Ot=L[St+3],cn=L[St+4],Un=At-tt,jn=Un===0?Rt-rt:Rt,dn=5*lt;Ge[dn+0]=Un,Ge[dn+1]=jn,Ge[dn+2]=Mt,Ge[dn+3]=Ot,Ge[dn+4]=cn,tt=At,rt=Rt}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(rn._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=rn;class Ht{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=Ht;class sn{constructor(L,te,Se){this.start=L,this.deleteCount=te,this.data=Se}}e.SemanticTokensEdit=sn;class Sn{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=Sn;var Dn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=We([P],Gt),e.QuickInputButtons=Gt;var Cn;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(L,te,Se){this.badge=L,this.tooltip=te,this.color=Se}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let on=class{constructor(L){this.kind=L}};on=We([P],on),e.ColorTheme=on;var an;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(L,te){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(te<0)throw(0,R.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Bt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,Se=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Se=L.end),te===this._start&&Se===this._end?this:new Bt(te,Se)}}e.NotebookRange=Bt;class Ft{constructor(L,te,Se,Ge,tt,rt,lt){this.kind=L,this.value=te,this.languageId=Se,this.mime=Ge,this.outputs=tt??[],this.metadata=rt,this.executionSummary=lt,Ft.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ft.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ft;class Kt{constructor(L){this.cells=L}}e.NotebookData=Kt;class Re{constructor(L,te){this.data=L,this.mime=te;const Se=(0,k.normalizeMimeType)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(L){return L instanceof Re?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Re.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Re.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Re.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Re(L,te)}static text(L,te=k.Mimes.text){const Se=Ue(Re,u,"f",g).encode(String(L));return new Re(Se,te)}static json(L,te="application/json"){const Se=JSON.stringify(L,void 0,"	");return Re.text(Se,te)}}e.NotebookCellOutputItem=Re,u=Re,g={value:new TextEncoder};class $t{constructor(L,te,Se){this.items=$t.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,T.generateUuid)(),this.metadata=te??Se)}static isNotebookCellOutput(L){return L instanceof $t?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,E.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Se=new Set,Ge=new Set;for(let tt=0;tt<L.length;tt++){const rt=L[tt],lt=(0,k.normalizeMimeType)(rt.mime);if(!Se.has(lt)){Se.add(lt);continue}Ge.add(tt),te&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ge.size===0?L:L.filter((tt,rt)=>!Ge.has(rt))}}e.NotebookCellOutput=$t;var gn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(gn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=pn;var vn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(L,te=[]){this.uri=L,this.provides=(0,d.asArray)(te)}}e.NotebookRendererScript=An;let ln=class{constructor(L,te){this.label=L,this.timestamp=te}};ln=We([P],ln),e.TimelineItem=ln;var Tn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var wn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(wn=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Fn;class Mn{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var Ln;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var Nn;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let un=class{constructor(L,te,Se){this.include=L,this.exclude=te,this.profile=Se}};un=We([P],un),e.TestRunRequest=un;let J=I=class{constructor(L){this.message=L}static diff(L,te,Se){const Ge=new I(L);return Ge.expectedOutput=te,Ge.actualOutput=Se,Ge}};J=I=We([P],J),e.TestMessage=J;let de=class{constructor(L,te){this.id=L,this.label=te}};de=We([P],de),e.TestTag=de;let ke=class{constructor(L,te){this.covered=L,this.total=te}};ke=We([P],ke),e.CoveredCount=ke;let st=r=class{constructor(L,te,Se,Ge){this.uri=L,this.statementCoverage=te,this.branchCoverage=Se,this.functionCoverage=Ge}static fromDetails(L,te){const Se=new ke(0,0),Ge=new ke(0,0),tt=new ke(0,0);for(const lt of te)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const St of lt.branches)Ge.total+=1,Ge.covered+=St.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const rt=new r(L,Se,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return rt.detailedCoverage=te,rt}};st=r=We([P],st),e.FileCoverage=st;let wt=class{constructor(L,te,Se=[]){this.executionCount=L,this.location=te,this.branches=Se}};wt=We([P],wt),e.StatementCoverage=wt;let Ct=class{constructor(L,te){this.executionCount=L,this.location=te}};Ct=We([P],Ct),e.BranchCoverage=Ct;let On=class{constructor(L,te){this.executionCount=L,this.location=te}};On=We([P],On),e.FunctionCoverage=On;var Hn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(L,te,Se,Ge,tt,rt){this.kind=L,this.name=te,this.detail=Se,this.uri=Ge,this.range=tt,this.selectionRange=rt}}e.TypeHierarchyItem=qn}),define(we[97],be([0,1,41,11,8,124,87,7,17]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function n(u,g){g?T.set(u,g):T.delete(u)}e.setWordDefinitionFor=n;function C(u){return T.get(u)}e.getWordDefinitionFor=C;class l extends S.MirrorTextModel{constructor(g,b,w,A,o,p,v,t){super(b,w,A,o);this._proxy=g,this._languageId=p,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,y.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===R.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(b){return b?g._getTextInRange(b):g.getText()},get eol(){return g._eol===`
`?E.EndOfLine.LF:E.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(b){return g._lineAt(b)},offsetAt(b){return g._offsetAt(b)},positionAt(b){return g._positionAt(b)},validateRange(b){return g._validateRange(b)},validatePosition(b){return g._validatePosition(b)},getWordRangeAtPosition(b,w){return g._getWordRangeAtPosition(b,w)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,d.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,d.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const b=this._validateRange(g);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const w=this._eol,A=b.start.line,o=b.end.line,p=[];p.push(this._lines[A].substring(b.start.character));for(let v=A+1;v<o;v++)p.push(this._lines[v]);return p.push(this._lines[o].substring(0,b.end.character)),p.join(w)}_lineAt(g){let b;if(g instanceof E.Position?b=g.line:typeof g=="number"&&(b=g),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new h(b,this._lines[b],b===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(g),w=this._lines[b.index].length;return new E.Position(b.index,Math.min(b.remainder,w))}_validateRange(g){if(!(g instanceof E.Range))throw new Error("Invalid argument");const b=this._validatePosition(g.start),w=this._validatePosition(g.end);return b===g.start&&w===g.end?g:new E.Range(b.line,b.character,w.line,w.character)}_validatePosition(g){if(!(g instanceof E.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:b,character:w}=g,A=!1;if(b<0)b=0,w=0,A=!0;else if(b>=this._lines.length)b=this._lines.length-1,w=this._lines[b].length,A=!0;else{const o=this._lines[b].length;w<0?(w=0,A=!0):w>o&&(w=o,A=!0)}return A?new E.Position(b,w):g}_getWordRangeAtPosition(g,b){const w=this._validatePosition(g);if(!b)b=C(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const A=(0,k.getWordAtText)(w.character+1,(0,k.ensureValidWordDefinition)(b),this._lines[w.line],0);if(A)return new E.Range(w.line,A.startColumn-1,w.line,A.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(g,b,w){this._line=g,this._text=b,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new E.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new E.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[164],be([0,1,7,3,89,6,59,21,2,37]),function(ee,e,d,R,D,S,k,E,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,h,u,g){this._notebook=u,this._selector=g,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(w=>{const A=this._cellUris.get(w.document.uri);A!==void 0&&(this._cellLengths.changeValue(A,this._cells[A].document.getText().length+1),this._cellLines.changeValue(A,this._cells[A].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>b(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new E.ResourceMap;const l=[],h=[];for(const u of this._notebook.getCells())u.kind===d.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),l.push(u.document.getText().length+1),h.push(u.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){if(!l){let A="";for(const o of this._cells)A+=o.document.getText()+`
`;return A=A.slice(0,-1),A}if(l.isEmpty)return"";const h=this.locationAt(l.start),u=this.locationAt(l.end),g=this._cellUris.get(h.uri),b=this._cellUris.get(u.uri);if(g===void 0||b===void 0)return"";if(g===b)return this._cells[g].document.getText(new d.Range(h.range.start,u.range.end));const w=[this._cells[g].document.getText(new d.Range(h.range.start,new d.Position(this._cells[g].document.lineCount,0)))];for(let A=g+1;A<b;A++)w.push(this._cells[A].document.getText());return w.push(this._cells[b].document.getText(new d.Range(new d.Position(0,0),u.range.end))),w.join(`
`)}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),u=this._cellLengths.getPrefixSum(h.index-1),g=this._cells[h.index].document.offsetAt(l.with(h.remainder));return u+g}positionAt(l){if(typeof l=="number"){const u=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(g)}const h=this._cellUris.get(l.uri);if(h!==void 0){const u=this._cellLines.getPrefixSum(h-1);return new d.Position(u+l.range.start.line,l.range.start.character)}return new d.Position(0,0)}locationAt(l){d.Range.isRange(l)||(l=new d.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let u=h;l.isEmpty||(u=this._cellLines.getIndexOf(l.end.line));const g=new d.Position(h.remainder,l.start.character),b=new d.Position(u.remainder,l.end.character),w=new d.Range(g,b),A=this._cells[h.index];return new d.Location(A.document.uri,A.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),u=this.validatePosition(l.end);return l.with(h,u)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),u=new d.Position(h.remainder,l.character),g=this._cells[h.index].document.validatePosition(u),b=this._cellLines.getPrefixSum(h.index-1);return new d.Position(b+g.line,g.character)}}e.ExtHostNotebookConcatDocument=n}),define(we[165],be([0,1,7,13,3]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(E){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(E){let y=E==="light"?d.ColorThemeKind.Light:E==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=We([He(0,R.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(we[70],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class R{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=R}),define(we[166],be([0,1,24]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function D(E,y){if(y.serializeBuffersForPostMessage){const T=new R,n=(h,u)=>{if(u instanceof ArrayBuffer){const g=T.add(u);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(u)){const g=S(u);if(g){const b=T.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:g,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},C=JSON.stringify(E,n),l=T.buffers.map(h=>{const u=new Uint8Array(h);return d.VSBuffer.wrap(u)});return{message:C,buffers:l}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeWebviewMessage=D;function S(E){switch(E.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(E,y){const T=y.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),n=y.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const u=h,{index:g}=u,b=T[g];if(u.view)switch(u.view.type){case 1:return new Int8Array(b,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return h}:void 0;return{message:JSON.parse(E,n),arrayBuffers:T}}e.deserializeWebviewMessage=k}),define(we[167],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(R){function D(k){const E={items:new Map};return k.types.forEach((y,T)=>{E.items.set(y,{asString:async()=>k.items[T].asString})}),E}R.toITreeDataTransfer=D;async function S(k){const E={types:[],items:[]},y=Array.from(k.items.entries());for(const T of y)E.types.push(T[0]),E.items.push({asString:await T[1].asString()});return E}R.toTreeDataTransferDTO=S})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[71],be([0,1,11,2]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(E,y){return E.scheme===d.Schemas.http||E.scheme===d.Schemas.https?E:(y&&y.authority&&y.isRemote&&E.scheme===d.Schemas.file&&(E=R.URI.from({scheme:d.Schemas.vscodeRemote,authority:y.authority,path:E.path})),R.URI.from({scheme:d.Schemas.https,authority:`${E.scheme}+${S(E.authority)}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=D;function S(E){return E.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function k(E){return E.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=k}),define(we[168],be([0,1,3,6,71]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(E,y,T){this._proxy=E,this._editors=y,this._initData=T,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const C of this._insets.values())n.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,y,T,n,C){let l;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===E){l=o;break}if(!l)throw new Error("not a visible editor");const h=this,u=this._handlePool++,g=new d.Emitter,b=new d.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,D.asWebviewUri)(o,h._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(o){this._options=o,h._proxy.$setOptions(u,o)}get options(){return this._options}set html(o){this._html=o,h._proxy.$setHtml(u,o)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(o){return h._proxy.$postMessage(u,o)}},A=new class{constructor(){this.editor=E,this.line=y,this.height=T,this.webview=w,this.onDidDispose=b.event}dispose(){h._insets.has(u)&&(h._insets.delete(u),h._proxy.$disposeEditorInset(u),b.fire(),b.dispose(),g.dispose())}};return this._proxy.$createEditorInset(u,l.id,l.value.document.uri,y+1,T,n||{},C.identifier,C.extensionLocation),this._insets.set(u,{editor:E,inset:A,onDidReceiveMessage:g}),A}$onDidDispose(E){const y=this._insets.get(E);y&&y.inset.dispose()}$onDidReceiveMessage(E,y){const T=this._insets.get(E);T&&T.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=S}),define(we[169],be([0,1,140,10,2,6,4,45,28,17,11]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new E.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new E.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new E.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new E.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new E.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorContext=new E.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new E.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new E.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new E.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.EditorGroupEditorsCountContext=new E.RawContextKey("groupEditorsCount",0,(0,d.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new E.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(12,null)),e.ActiveEditorGroupIndexContext=new E.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(13,null)),e.ActiveEditorGroupLastContext=new E.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(14,null)),e.MultipleEditorGroupsContext=new E.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new E.RawContextKey("editorIsOpen",!1,(0,d.localize)(16,null)),e.InEditorZenModeContext=new E.RawContextKey("inZenMode",!1,(0,d.localize)(17,null)),e.IsCenteredLayoutContext=new E.RawContextKey("isCenteredLayout",!1,(0,d.localize)(18,null)),e.SplitEditorsVertically=new E.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(19,null)),e.EditorAreaVisibleContext=new E.RawContextKey("editorAreaVisible",!0,(0,d.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function C(r){return typeof r?.getViewState=="function"}e.isTextEditorPane=C;function l(r){if(o(r))return!1;const P=r;return D.URI.isUri(P?.resource)}e.isResourceEditorInput=l;function h(r){if(o(r))return!1;const P=r;return P?.original!==void 0&&P.modified!==void 0}e.isResourceDiffEditorInput=h;function u(r){if(o(r))return!1;const P=r;return P?P.resource===void 0||P.resource.scheme===n.Schemas.untitled||P.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var g;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var b;(function(r){r[r.EXPLICIT=1]="EXPLICIT",r[r.AUTO=2]="AUTO",r[r.FOCUS_CHANGE=3]="FOCUS_CHANGE",r[r.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var w;(function(r){r[r.None=0]="None",r[r.Readonly=2]="Readonly",r[r.Untitled=4]="Untitled",r[r.Singleton=8]="Singleton",r[r.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class A extends S.Disposable{}e.AbstractEditorInput=A;function o(r){return r instanceof A}e.isEditorInput=o;function p(r){const P=r;return D.URI.isUri(P?.preferredResource)}function v(r){const P=r;return o(P?.primary)&&o(P?.secondary)}e.isSideBySideEditorInput=v;function t(r){return o(r?.editor)}e.isEditorInputWithOptions=t;function a(r){const P=r;return t(r)&&P?.group!==void 0}e.isEditorInputWithOptionsAndGroup=a;function s(r){const P=r;return typeof P?.groupId=="number"&&o(P.editor)}e.isEditorIdentifier=s;var i;(function(r){r[r.PRIMARY=1]="PRIMARY",r[r.SECONDARY=2]="SECONDARY",r[r.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(P,F){if(!P)return;const B=v(P)?P.primary:h(P)?P.modified:void 0,j=v(P)?P.secondary:h(P)?P.original:void 0;if(F?.supportSideBySide&&B&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:F.filterByScheme})};P=F.supportSideBySide===i.PRIMARY?B:j}if(h(P))return;const ae=p(P)?P.preferredResource:P.resource;return!ae||!F||!F.filterByScheme?ae:this.filterUri(ae,F.filterByScheme)}getCanonicalUri(P,F){if(!P)return;const B=v(P)?P.primary:h(P)?P.modified:void 0,j=v(P)?P.secondary:h(P)?P.original:void 0;if(F?.supportSideBySide&&B&&j){if(F?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:F.filterByScheme})};P=F.supportSideBySide===i.PRIMARY?B:j}if(h(P))return;const ae=P.resource;return!ae||!F||!F.filterByScheme?ae:this.filterUri(ae,F.filterByScheme)}filterUri(P,F){if(Array.isArray(F)){if(F.some(B=>P.scheme===B))return P}else if(F===P.scheme)return P}}e.EditorResourceAccessor=new c;var f;(function(r){r[r.LEFT=0]="LEFT",r[r.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(P){const F=this.instantiationService=P.get(k.IInstantiationService);for(const[B,j]of this.editorSerializerConstructors)this.createEditorSerializer(B,j,F);this.editorSerializerConstructors.clear()}createEditorSerializer(P,F,B){const j=B.createInstance(F);this.editorSerializerInstances.set(P,j)}registerFileEditorFactory(P){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=P}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(P,F){if(this.editorSerializerConstructors.has(P)||this.editorSerializerInstances.has(P))throw new Error(`A editor serializer with type ID '${P}' was already registered.`);return this.instantiationService?this.createEditorSerializer(P,F,this.instantiationService):this.editorSerializerConstructors.set(P,F),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(P),this.editorSerializerInstances.delete(P)})}getEditorSerializer(P){return this.editorSerializerInstances.get(typeof P=="string"?P:P.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new m);async function _(r,P){if(!r||!r.length)return[];const F=await Promise.all(r.map(async B=>{const j=D.URI.revive(B.fileUri);if(!j||(await P.activateProvider(j.scheme),!P.canHandleResource(j)))return;const ae=typeof B.exists=="boolean"?B.exists:await P.exists(j);if(!ae&&B.openOnlyIfExists)return;const oe=ae&&!(0,R.isUndefined)(B.selection)?{selection:B.selection,pinned:!0,override:B.editorOverrideId}:{pinned:!0,override:B.editorOverrideId};let V;return ae?V={resource:j,options:oe,forceFile:!0}:V={resource:j,options:oe,forceUntitled:!0},V}));return(0,T.coalesce)(F)}e.pathsToEditors=_;var I;(function(r){r[r.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",r[r.SEQUENTIAL=1]="SEQUENTIAL"})(I=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[170],be([0,1,3,45,141,4,6,21,28,17,52,23,35,160]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",l.Codicon.window,(0,D.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var g;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function w(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=w;class A extends k.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(f,m,_){const I=this.get(f.id);if(I)return I;const r=f;return r.openCommandActionDescriptor=_?.donotRegisterOpenCommand?void 0:r.openCommandActionDescriptor??{id:r.id},(0,E.getOrSet)(this.viewContainers,m,[]).push(r),_?.isDefault&&this.defaultViewContainers.push(r),this._onDidRegister.fire({viewContainer:r,viewContainerLocation:m}),r}deregisterViewContainer(f){for(const m of this.viewContainers.keys()){const _=this.viewContainers.get(m),I=_?.indexOf(f);if(I!==-1){_?.splice(I,1),_.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:m});return}}}get(f){return this.all.filter(m=>m.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(_=>_?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===f)}}y.Registry.add(u.ViewContainersRegistry,new A);var o;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function p(c,f){const m=c.group??o.More,_=f.group??o.More;return m!==_?m.localeCompare(_):(c.order??5)-(f.order??5)}class v extends k.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(f,m){this.registerViews2([{views:f,viewContainer:m}])}registerViews2(f){f.forEach(({views:m,viewContainer:_})=>this.addViews(m,_)),this._onViewsRegistered.fire(f)}deregisterViews(f,m){const _=this.removeViews(f,m);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:m})}moveViews(f,m){for(const _ of this._views.keys())if(_!==m){const I=this.removeViews(f,_);I.length&&(this.addViews(I,m),this._onDidChangeContainer.fire({views:I,from:_,to:m}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const m of this._viewContainers){const _=(this._views.get(m)||[]).filter(I=>I.id===f)[0];if(_)return _}return null}getViewContainer(f){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(I=>I.id===f)[0])return m;return null}registerViewWelcomeContent(f,m){return this._viewWelcomeContents.add(f,m),this._onDidChangeViewWelcomeContent.fire(f),(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(f,m),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,m){const _=new Map;for(const[I,r]of m)this._viewWelcomeContents.add(f,r),_.set(I,(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(f,r),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),_}getViewWelcomeContent(f){const m=[];return this._viewWelcomeContents.forEach(f,_=>m.push(_)),m.sort(p)}addViews(f,m){let _=this._views.get(m);_||(_=[],this._views.set(m,_),this._viewContainers.push(m));for(const I of f){if(this.getView(I.id)!==null)throw new Error((0,D.localize)(1,null,I.id));_.push(I)}}removeViews(f,m){const _=this._views.get(m);if(!_)return[];const I=[],r=[];for(const P of _)f.includes(P)?I.push(P):r.push(P);return I.length&&(r.length?this._views.set(m,r):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),I}}y.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,D.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var a;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(a=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(f,m){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,f),this._hasResolve=!!m,this.resolve=async _=>{if(m&&!this.resolved){const I=await m(_);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[171],be([0,1,3,15,142]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(E){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=E}onEvent(E){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=E}onRequest(E){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=E}sendResponse(E){E.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${E.command}`)):this.internalSend("response",E)}sendRequest(E,y,T,n){const C={command:E};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(C.seq);if(h){this.pendingRequests.delete(C.seq);const u={type:"response",seq:0,request_seq:C.seq,success:!1,command:E,message:(0,D.localize)(0,null,n,E)};h(u)}},n)}return T&&this.pendingRequests.set(C.seq,T),C.seq}acceptMessage(E){this.messageCallback?this.messageCallback(E):(this.queue.push(E),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(E,y){return E.type!=="event"||y.type!=="event"}async processQueue(){let E;for(;this.queue.length;){if((!E||this.needsTaskBoundaryBetween(this.queue[0],E))&&await(0,R.timeout)(0),E=this.queue.shift(),!E)return;switch(E.type){case"event":this.eventCallback&&this.eventCallback(E);break;case"request":this.requestCallback&&this.requestCallback(E);break;case"response":const y=E,T=this.pendingRequests.get(y.request_seq);T&&(this.pendingRequests.delete(y.request_seq),T(y));break}}}internalSend(E,y){y.type=E,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const E=new Map;this.pendingRequests.forEach((y,T)=>E.set(T,y)),await(0,R.timeout)(500),E.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(we[172],be([0,1,8,2,14,23,11]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const E=/{([^}]+)}/g;function y(s,i,c){return s.replace(E,function(f,m){return i&&m.length>0&&m[0]!=="_"?f:c&&c.hasOwnProperty(m)?c[m]:f})}e.formatPII=y;function T(s){const i={};for(const c of Object.keys(s))c.startsWith("!")||(i[c]=s[c]);return i}e.filterExceptionsFromTelemetry=T;function n(s){return s.configuration.request==="attach"&&!C(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function C(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(i,"extensionhost")||(0,d.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?C(s.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=l;function h(s,i,c){let f,m=0,_=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=_.exec(s);){let r=I.index+1,P=r+I[0].length;if(r<=i&&P>=c){f=I[0],m=r;break}}if(f){let r=/\w+/g,P=null;for(;(P=r.exec(f))&&!(P.index+1+m+P[0].length>=c););P&&(f=f.substring(0,r.lastIndex))}return f?{start:m,end:m+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(s){return!!(s&&s.match(u))}e.isUri=g;function b(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(g(s.path))return R.URI.parse(s.path);if((0,D.isAbsolute)(s.path))return R.URI.file(s.path)}return s.path}function w(s){if(typeof s.path=="object"){const i=R.URI.revive(s.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return s.path}function A(s,i){const c=i?b:w,f=(0,S.deepClone)(s);return p(f,(m,_)=>{m&&_&&(_.path=c(_))}),f}e.convertToDAPaths=A;function o(s,i){const c=i?b:w,f=(0,S.deepClone)(s);return p(f,(m,_)=>{!m&&_&&(_.path=c(_))}),f}e.convertToVSCPaths=o;function p(s,i){switch(s.type){case"event":const c=s;switch(c.event){case"output":i(!1,c.body.source);break;case"loadedSource":i(!1,c.body.source);break;case"breakpoint":i(!1,c.body.breakpoint.source);break;default:break}break;case"request":const f=s;switch(f.command){case"setBreakpoints":i(!0,f.arguments.source);break;case"breakpointLocations":i(!0,f.arguments.source);break;case"source":i(!0,f.arguments.source);break;case"gotoTargets":i(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(_=>i(!1,_));break;default:break}break;case"response":const m=s;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(_=>i(!1,_.source));break;case"loadedSources":m.body.sources.forEach(_=>i(!1,_));break;case"scopes":m.body.scopes.forEach(_=>i(!1,_.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(_=>i(!1,_.source));break;case"setBreakpoints":m.body.breakpoints.forEach(_=>i(!1,_.source));break;default:break}break}}function v(s){return s.filter(i=>!i.presentation?.hidden).sort((i,c)=>i.presentation?c.presentation?i.presentation.group?c.presentation.group?i.presentation.group!==c.presentation.group?i.presentation.group.localeCompare(c.presentation.group):t(i.presentation.order,c.presentation.order):-1:c.presentation.group?1:t(i.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function a(s,i){const c=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(c!=="none"&&(await i.saveAll(),c==="allEditorsInActiveGroup")){const f=i.activeEditorPane;f&&await i.save({editor:f.input,groupId:f.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=a}),define(we[98],be([0,1,27,84,11,14,22,45]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(r){r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeLanguage=5]="ChangeLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var b;(function(r){r.scheme=D.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function F(V,H){return V.with({scheme:r.scheme,fragment:`ch${H.toString().padStart(7,"0")}${V.scheme!==D.Schemas.file?V.scheme:""}`})}r.generate=F;function B(V){if(V.scheme!==r.scheme)return;const H=P.exec(V.fragment);return H?{handle:Number(H[1]),notebook:V.with({scheme:V.fragment.substr(H[0].length)||D.Schemas.file,fragment:null})}:void 0}r.parse=B;function j(V){if(V.scheme!==D.Schemas.vscodeNotebookCellMetadata)return;const H=P.exec(V.fragment);return H?{handle:Number(H[1]),notebook:V.with({scheme:V.fragment.substr(H[0].length)||D.Schemas.file,fragment:null})}:void 0}r.parseCellMetadataUri=j;function ae(V,H,M){return V.with({scheme:M,fragment:`ch${H.toString().padStart(7,"0")}${V.scheme!==D.Schemas.file?V.scheme:""}`})}r.generateCellUri=ae;function oe(V,H){if(V.scheme!==H)return;const M=P.exec(V.fragment);return M?{handle:Number(M[1]),notebook:V.with({scheme:V.fragment.substr(M[0].length)||D.Schemas.file,fragment:null})}:void 0}r.parseCellUri=oe})(b=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function A(r){return w.get(r)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=A;function o(r){return w.get(r)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function p(r){return w.get(r)?.mergeable??!1}e.mimeTypeIsMergeable=p;function v(r,P){return k.isWindows&&(r=r.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),d.match(r,P)}function t(r,P,F){let B=0;for(let j=0;j<P.length;j++){if(v(P[j],r))return B;B++}for(let j=0;j<F.length;j++){if(v(F[j],r))return B;B++}return B}function a(r,P,F){return r.sort((B,j)=>t(B,P,F)-t(j,P,F))}e.sortMimeTypes=a;function s(r,P,F,B=(j,ae)=>j===ae){const j=[];function ae(H,M,K){if(M===0&&K.length===0)return;const N=j[j.length-1];N&&N.start+N.deleteCount===H?(N.deleteCount+=M,N.toInsert.push(...K)):j.push({start:H,deleteCount:M,toInsert:K})}let oe=0,V=0;for(;;){if(oe===r.length){ae(oe,0,P.slice(V));break}if(V===P.length){ae(oe,r.length-oe,[]);break}const H=r[oe],M=P[V];if(B(H,M)){oe+=1,V+=1;continue}F(M)?(ae(oe,1,[]),oe+=1):(ae(oe,0,[M]),V+=1)}return j}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(r){r.default="default",r.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(r){const P=r;return!!((typeof P.include=="string"||d.isRelativePattern(P.include))&&(typeof P.exclude=="string"||d.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=c;function f(r,P,F){if(Array.isArray(r.viewType)&&r.viewType.indexOf(P)>=0||r.viewType===P)return!0;if(r.filenamePattern){let B=c(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,j=c(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(d.match(B,(0,S.basename)(F.fsPath).toLowerCase()))return!(j&&d.match(j,(0,S.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)P[F]=this.textModel.cells[F].getHashValue();return P}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var _;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(_=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class I{static create(P){return`${I._prefix}${P}`}static parse(P){if(P.startsWith(I._prefix))return P.substr(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/"}),define(we[173],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(R=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(we[174],be([0,1,144,4,45]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[175],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=d;function R(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=R}),define(we[99],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var R;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(R=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(C){C[C.Error=0]="Error",C[C.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var S;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=k;var E;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var y;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(l){}update(l){}remove(l,h){}complete(){}}e.IncrementalChangeCollector=T;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const h=this.createChangeCollector();for(const u of l)switch(u[0]){case 0:{const g=u[1];if(g.parent){if(this.items.has(g.parent)){const b=this.items.get(g.parent);b.children.add(g.item.extId);const w=this.createItem(g,b);this.items.set(g.item.extId,w),h.add(w)}}else{const b=this.createItem(g);this.roots.add(b),this.items.set(g.item.extId,b),h.add(b)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=u[1],b=this.items.get(g.extId);if(!b)break;g.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,g),h.update(b);break}case 2:{const g=this.items.get(u[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const b=[[u[1]]];for(;b.length;)for(const w of b.pop()){const A=this.items.get(w);A&&(b.push(A.children),this.items.delete(w),h.remove(A,A!==g),A.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break}h.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=n}),define(we[72],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(S){S.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class D{constructor(k,E=k.length){if(this.path=k,this.viewEnd=E,k.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,E,y=k.parent){if(k.id===E)return new D([E]);let T=[k.id];for(let n=y;n&&n.id!==E;n=n.parent)T.push(n.id);return T.push(E),new D(T.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new D(k.split("\0"))}static join(k,E){return new D([...k.path,E])}static joinToString(k,E){return k.toString()+"\0"+E}static compare(k,E){return k===E?0:E.startsWith(k+"\0")?2:k.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new D(this.path,k)}compare(k){if(typeof k=="string")return D.compare(this.toString(),k);for(let E=0;E<k.viewEnd&&E<this.viewEnd;E++)if(k.path[E]!==this.path[E])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=D}),define(we[176],be([0,1,14,42,10,23,22,83,145]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(C,l,h){this._contributedVariables=new Map,this._context=C,this._labelService=l,h&&(this._envVariablesPromise=h.then(u=>this.prepareEnv(u)))}prepareEnv(C){if(k.isWindows){const l=Object.create(null);return Object.keys(C).forEach(h=>{l[h.toLowerCase()]=C[h]}),l}return C}resolveWithEnvironment(C,l,h){return this.recursiveResolve(this.prepareEnv(C),l?l.uri:void 0,h)}async resolveAsync(C,l){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,l)}async resolveAnyBase(C,l,h,u){const g=S.deepClone(l);return k.isWindows&&g.windows?Object.keys(g.windows).forEach(b=>g[b]=g.windows[b]):k.isMacintosh&&g.osx?Object.keys(g.osx).forEach(b=>g[b]=g.osx[b]):k.isLinux&&g.linux&&Object.keys(g.linux).forEach(b=>g[b]=g.linux[b]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g,h,u)}async resolveAnyAsync(C,l,h){return this.resolveAnyBase(C,l,h)}async resolveAnyMap(C,l,h){const u=new Map;return{newConfig:await this.resolveAnyBase(C,l,h,u),resolvedVariables:u}}resolveWithInteractionReplace(C,l,h,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,l,h,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,l){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,l)}recursiveResolve(C,l,h,u,g){if(D.isString(h))return this.resolveString(C,l,h,u,g);if(D.isArray(h))return h.map(b=>this.recursiveResolve(C,l,b,u,g));if(D.isObject(h)){let b=Object.create(null);return Object.keys(h).forEach(w=>{const A=this.resolveString(C,l,w,u,g);b[A]=this.recursiveResolve(C,l,h[w],u,g)}),b}return h}resolveString(C,l,h,u,g){return h.replace(T.VARIABLE_REGEXP,(w,A)=>{if(A.includes(T.VARIABLE_LHS))return w;let o=this.evaluateSingleVariable(C,w,A,l,u);return g&&g.set(A,o),o!==w&&D.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(C,l,o,u,g)),o})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,l,h,u,g){let b;const w=h.split(":");w.length>1&&(h=w[0],b=w[1]);const A=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,y.localize)(0,null,l))},o=()=>{const v=A();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,l,d.basename(v)))},p=()=>{if(b){const v=this._context.getFolderUri(b);if(v)return v;throw new Error((0,y.localize)(2,null,l,b))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,l)):new Error((0,y.localize)(4,null,l))};switch(h){case"env":if(b){if(C){const v=C[k.isWindows?b.toLowerCase():b];if(D.isString(v))return v}return""}throw new Error((0,y.localize)(5,null,l));case"config":if(b){const v=this._context.getConfigurationValue(u,b);if(D.isUndefinedOrNull(v))throw new Error((0,y.localize)(6,null,l,b));if(D.isObject(v))throw new Error((0,y.localize)(7,null,l,b));return v}throw new Error((0,y.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,g,"command");case"input":return this.resolveFromMap(l,b,g,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return u||b?(0,E.normalizeDriveLetter)(this.fsPath(p())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(p()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,y.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,l));case"file":return A();case"fileWorkspaceFolder":return o();case"relativeFile":return u||b?d.relative(this.fsPath(p()),A()):A();case"relativeFileDirname":const a=d.dirname(A());if(u||b){const f=d.relative(this.fsPath(p()),a);return f.length===0?".":f}return a;case"fileDirname":return d.dirname(A());case"fileExtname":return d.extname(A());case"fileBasename":return d.basename(A());case"fileBasenameNoExtension":const s=d.basename(A());return s.slice(0,s.length-d.extname(s).length);case"fileDirnameBasename":return d.basename(d.dirname(A()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return d.sep;default:try{const f=b?`${h}:${b}`:h;return this.resolveFromMap(l,f,g,void 0)}catch(f){return l}}}}resolveFromMap(C,l,h,u){if(l&&h){const g=u===void 0?h[l]:h[u+":"+l];if(typeof g=="string")return g;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[100],be([0,1,4,169]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var D;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var S;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var E;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(g){const b=g;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=T;var n;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=8]="EDITOR_PIN",g[g.EDITOR_STICKY=9]="EDITOR_STICKY",g[g.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const b=g;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=h;function u(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(we[177],be([0,1,4,100]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(S){const k=S;return typeof S=="number"||(0,R.isEditorGroup)(k)}e.isPreferredGroup=D}),define(we[9],be([0,1,17,82,234,58,23,10,2,31,62,146,91,68,98,72,177,7]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var A;(function(Ee){function he($){const{selectionStartLineNumber:Ie,selectionStartColumn:Le,positionLineNumber:Ze,positionColumn:ze}=$,ft=new w.Position(Ie-1,Le-1),bt=new w.Position(Ze-1,ze-1);return new w.Selection(ft,bt)}Ee.to=he;function ce($){const{anchor:Ie,active:Le}=$;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Ee.from=ce})(A=e.Selection||(e.Selection={}));var o;(function(Ee){function he($){if(!$)return;const{start:Ie,end:Le}=$;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Ee.from=he;function ce($){if(!$)return;const{startLineNumber:Ie,startColumn:Le,endLineNumber:Ze,endColumn:ze}=$;return new w.Range(Ie-1,Le-1,Ze-1,ze-1)}Ee.to=ce})(o=e.Range||(e.Range={}));var p;(function(Ee){function he(ce){switch(ce){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}Ee.to=he})(p=e.TokenType||(e.TokenType={}));var v;(function(Ee){function he($){return new w.Position($.lineNumber-1,$.column-1)}Ee.to=he;function ce($){return{lineNumber:$.line+1,column:$.character+1}}Ee.from=ce})(v=e.Position||(e.Position={}));var t;(function(Ee){function he($){switch($){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}Ee.from=he;function ce($){switch($){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(Ee){function he($){let Ie;return $.code&&((0,E.isString)($.code)||(0,E.isNumber)($.code)?Ie=String($.code):Ie={value:String($.code.value),target:$.code.target}),{...o.from($.range),message:$.message,source:$.source,code:Ie,severity:i.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(s.from),tags:Array.isArray($.tags)?(0,d.coalesce)($.tags.map(t.from)):void 0}}Ee.from=he;function ce($){const Ie=new w.Diagnostic(o.to($),$.message,i.to($.severity));return Ie.source=$.source,Ie.code=(0,E.isString)($.code)?$.code:$.code?.value,Ie.relatedInformation=$.relatedInformation&&$.relatedInformation.map(s.to),Ie.tags=$.tags&&(0,d.coalesce)($.tags.map(t.to)),Ie}Ee.to=ce})(a=e.Diagnostic||(e.Diagnostic={}));var s;(function(Ee){function he($){return{...o.from($.location.range),message:$.message,resource:$.location.uri}}Ee.from=he;function ce($){return new w.DiagnosticRelatedInformation(new w.Location($.resource,o.to($)),$.message)}Ee.to=ce})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(Ee){function he($){switch($){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=he;function ce($){switch($){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}Ee.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(Ee){function he($){return typeof $=="number"&&$>=w.ViewColumn.One?$-1:$===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}Ee.from=he;function ce($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(c=e.ViewColumn||(e.ViewColumn={}));function f(Ee){return typeof Ee.range!="undefined"}function m(Ee){return Ee.length===0?!0:!!f(Ee[0])}e.isDecorationOptionsArr=m;var _;(function(Ee){function he(ze){return ze.map(Ee.from)}Ee.fromMany=he;function ce(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function $(ze){let ft;if(ce(ze)){const{language:ut,value:ht}=ze;ft={value:"```"+ut+`
`+ht+"\n```\n"}}else w.MarkdownString.isMarkdownString(ze)?ft={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons}:typeof ze=="string"?ft={value:ze}:ft={value:""};const bt=Object.create(null);ft.uris=bt;const kt=ut=>{try{let ht=y.URI.parse(ut,!0);ht=ht.with({query:Ie(ht.query,bt)}),bt[ut]=ht}catch(ht){}return""},dt=new D.Renderer;return dt.link=kt,dt.image=ut=>kt(R.parseHrefAndDimensions(ut).href),D(ft.value,{renderer:dt}),ft}Ee.from=$;function Ie(ze,ft){if(!ze)return ze;let bt;try{bt=(0,S.parse)(ze)}catch(dt){}if(!bt)return ze;let kt=!1;return bt=(0,k.cloneAndChange)(bt,dt=>{if(y.URI.isUri(dt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ut]=dt,kt=!0,ut}else return}),kt?JSON.stringify(bt):ze}function Le(ze){const ft=new w.MarkdownString(ze.value,ze.supportThemeIcons);return ft.isTrusted=ze.isTrusted,ft}Ee.to=Le;function Ze(ze){if(!!ze)return typeof ze=="string"?ze:Ee.from(ze)}Ee.fromStrict=Ze})(_=e.MarkdownString||(e.MarkdownString={}));function I(Ee){return m(Ee)?Ee.map(he=>({range:o.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?_.fromMany(he.hoverMessage):he.hoverMessage?_.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):Ee.map(he=>({range:o.from(he)}))}e.fromRangeOrRangeWithMessage=I;function r(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?y.URI.file(Ee):Ee}e.pathOrURIToURI=r;var P;(function(Ee){function he(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?r(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=he})(P=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Ee){function he(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?r(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?P.from(ce.before):void 0,after:ce.after?P.from(ce.after):void 0}}Ee.from=he})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ee){function he(ce){if(typeof ce=="undefined")return ce;switch(ce){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=he})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(Ee){function he(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?B.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?r(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?P.from(ce.before):void 0,after:ce.after?P.from(ce.after):void 0}}Ee.from=he})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ae;(function(Ee){function he($){return{text:$.newText,eol:$.newEol&&fe.from($.newEol),range:o.from($.range)}}Ee.from=he;function ce($){const Ie=new w.TextEdit(o.to($.range),$.text);return Ie.newEol=typeof $.eol=="undefined"?void 0:fe.to($.eol),Ie}Ee.to=ce})(ae=e.TextEdit||(e.TextEdit={}));var oe;(function(Ee){function he($,Ie,Le){const Ze={edits:[]};if($ instanceof w.WorkspaceEdit)for(let ze of $._allEntries())if(ze._type===1)Ze.edits.push({_type:1,oldUri:ze.from,newUri:ze.to,options:ze.options,metadata:ze.metadata});else if(ze._type===2){const ft=Ie?.getDocument(ze.uri);Ze.edits.push({_type:2,resource:ze.uri,edit:ae.from(ze.edit),modelVersionId:ft?.version,metadata:ze.metadata})}else ze._type===3?Ze.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,edit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version}):ze._type===5&&Ze.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,notebookVersionId:Le?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version,edit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(le.from)}});return Ze}Ee.from=he;function ce($){const Ie=new w.WorkspaceEdit;for(const Le of $.edits)Le.edit?Ie.replace(y.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):Ie.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return Ie}Ee.to=ce})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ee){const he=Object.create(null);he[w.SymbolKind.File]=0,he[w.SymbolKind.Module]=1,he[w.SymbolKind.Namespace]=2,he[w.SymbolKind.Package]=3,he[w.SymbolKind.Class]=4,he[w.SymbolKind.Method]=5,he[w.SymbolKind.Property]=6,he[w.SymbolKind.Field]=7,he[w.SymbolKind.Constructor]=8,he[w.SymbolKind.Enum]=9,he[w.SymbolKind.Interface]=10,he[w.SymbolKind.Function]=11,he[w.SymbolKind.Variable]=12,he[w.SymbolKind.Constant]=13,he[w.SymbolKind.String]=14,he[w.SymbolKind.Number]=15,he[w.SymbolKind.Boolean]=16,he[w.SymbolKind.Array]=17,he[w.SymbolKind.Object]=18,he[w.SymbolKind.Key]=19,he[w.SymbolKind.Null]=20,he[w.SymbolKind.EnumMember]=21,he[w.SymbolKind.Struct]=22,he[w.SymbolKind.Event]=23,he[w.SymbolKind.Operator]=24,he[w.SymbolKind.TypeParameter]=25;function ce(Ie){return typeof he[Ie]=="number"?he[Ie]:6}Ee.from=ce;function $(Ie){for(const Le in he)if(he[Le]===Ie)return Number(Le);return w.SymbolKind.Property}Ee.to=$})(V=e.SymbolKind||(e.SymbolKind={}));var H;(function(Ee){function he($){switch($){case w.SymbolTag.Deprecated:return 1}}Ee.from=he;function ce($){switch($){case 1:return w.SymbolTag.Deprecated}}Ee.to=ce})(H=e.SymbolTag||(e.SymbolTag={}));var M;(function(Ee){function he($){return{name:$.name,kind:V.from($.kind),tags:$.tags&&$.tags.map(H.from),containerName:$.containerName,location:W.from($.location)}}Ee.from=he;function ce($){const Ie=new w.SymbolInformation($.name,V.to($.kind),$.containerName,W.to($.location));return Ie.tags=$.tags&&$.tags.map(H.to),Ie}Ee.to=ce})(M=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(Ee){function he($){const Ie={name:$.name||"!!MISSING: name!!",detail:$.detail,range:o.from($.range),selectionRange:o.from($.selectionRange),kind:V.from($.kind),tags:$.tags?.map(H.from)??[]};return $.children&&(Ie.children=$.children.map(he)),Ie}Ee.from=he;function ce($){const Ie=new w.DocumentSymbol($.name,$.detail,V.to($.kind),o.to($.range),o.to($.selectionRange));return(0,d.isNonEmptyArray)($.tags)&&(Ie.tags=$.tags.map(H.to)),$.children&&(Ie.children=$.children.map(ce)),Ie}Ee.to=ce})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(Ee){function he($){const Ie=new w.CallHierarchyItem(V.to($.kind),$.name,$.detail||"",y.URI.revive($.uri),o.to($.range),o.to($.selectionRange));return Ie._sessionId=$._sessionId,Ie._itemId=$._itemId,Ie}Ee.to=he;function ce($,Ie,Le){if(Ie=Ie??$._sessionId,Le=Le??$._itemId,Ie===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Le,name:$.name,detail:$.detail,kind:V.from($.kind),uri:$.uri,range:o.from($.range),selectionRange:o.from($.selectionRange),tags:$.tags?.map(H.from)}}Ee.from=ce})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var G;(function(Ee){function he(ce){return new w.CallHierarchyIncomingCall(N.to(ce.from),ce.fromRanges.map($=>o.to($)))}Ee.to=he})(G=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(Ee){function he(ce){return new w.CallHierarchyOutgoingCall(N.to(ce.to),ce.fromRanges.map($=>o.to($)))}Ee.to=he})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(Ee){function he($){return{range:$.range&&o.from($.range),uri:$.uri}}Ee.from=he;function ce($){return new w.Location(y.URI.revive($.uri),o.to($.range))}Ee.to=ce})(W=e.location||(e.location={}));var ne;(function(Ee){function he($){const Ie=$,Le=$;return{originSelectionRange:Ie.originSelectionRange?o.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Le.uri,range:o.from(Ie.targetRange?Ie.targetRange:Le.range),targetSelectionRange:Ie.targetSelectionRange?o.from(Ie.targetSelectionRange):void 0}}Ee.from=he;function ce($){return{targetUri:y.URI.revive($.uri),targetRange:o.to($.range),targetSelectionRange:$.targetSelectionRange?o.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?o.to($.originSelectionRange):void 0}}Ee.to=ce})(ne=e.DefinitionLink||(e.DefinitionLink={}));var ge;(function(Ee){function he($){return{range:o.from($.range),contents:_.fromMany($.contents)}}Ee.from=he;function ce($){return new w.Hover($.contents.map(_.to),o.to($.range))}Ee.to=ce})(ge=e.Hover||(e.Hover={}));var _e;(function(Ee){function he($){return{range:o.from($.range),expression:$.expression}}Ee.from=he;function ce($){return new w.EvaluatableExpression(o.to($.range),$.expression)}Ee.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(Ee){function he($){if($ instanceof w.InlineValueText)return{type:"text",range:o.from($.range),text:$.text};if($ instanceof w.InlineValueVariableLookup)return{type:"variable",range:o.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:o.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=he;function ce($){switch($.type){case"text":return{range:o.to($.range),text:$.text};case"variable":return{range:o.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:o.to($.range),expression:$.expression}}}Ee.to=ce})(Me=e.InlineValue||(e.InlineValue={}));var Fe;(function(Ee){function he($){return{frameId:$.frameId,stoppedLocation:o.from($.stoppedLocation)}}Ee.from=he;function ce($){return new w.InlineValueContext($.frameId,o.to($.stoppedLocation))}Ee.to=ce})(Fe=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(Ee){function he($){return{range:o.from($.range),kind:$.kind}}Ee.from=he;function ce($){return new w.DocumentHighlight(o.to($.range),$.kind)}Ee.to=ce})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ye;(function(Ee){function he(ce){switch(ce){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}Ee.to=he})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(Ee){function he(ce){return{triggerKind:Ye.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=he})(Ve=e.CompletionContext||(e.CompletionContext={}));var qe;(function(Ee){function he($){switch($){case w.CompletionItemTag.Deprecated:return 1}}Ee.from=he;function ce($){switch($){case 1:return w.CompletionItemTag.Deprecated}}Ee.to=ce})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));var x;(function(Ee){const he=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ce(Le){return he.get(Le)??9}Ee.from=ce;const $=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Ie(Le){return $.get(Le)??w.CompletionItemKind.Property}Ee.to=Ie})(x=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Ee){function he(ce,$){const Ie=new w.CompletionItem(ce.label);return Ie.insertText=ce.insertText,Ie.kind=x.to(ce.kind),Ie.tags=ce.tags?.map(qe.to),Ie.detail=ce.detail,Ie.documentation=R.isMarkdownString(ce.documentation)?_.to(ce.documentation):ce.documentation,Ie.sortText=ce.sortText,Ie.filterText=ce.filterText,Ie.preselect=ce.preselect,Ie.commitCharacters=ce.commitCharacters,T.Range.isIRange(ce.range)?Ie.range=o.to(ce.range):typeof ce.range=="object"&&(Ie.range={inserting:o.to(ce.range.insert),replacing:o.to(ce.range.replace)}),Ie.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ie.insertText=new w.SnippetString(ce.insertText):(Ie.insertText=ce.insertText,Ie.textEdit=Ie.range instanceof w.Range?new w.TextEdit(Ie.range,Ie.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ce.additionalTextEdits.map(Le=>ae.to(Le))),Ie.command=$&&ce.command?$.fromInternal(ce.command):void 0,Ie}Ee.to=he})(Q=e.CompletionItem||(e.CompletionItem={}));var X;(function(Ee){function he($){return{label:$.label,documentation:$.documentation?_.fromStrict($.documentation):void 0}}Ee.from=he;function ce($){return{label:$.label,documentation:R.isMarkdownString($.documentation)?_.to($.documentation):$.documentation}}Ee.to=ce})(X=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(Ee){function he($){return{label:$.label,documentation:$.documentation?_.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(X.from):[],activeParameter:$.activeParameter}}Ee.from=he;function ce($){return{label:$.label,documentation:R.isMarkdownString($.documentation)?_.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(X.to):[],activeParameter:$.activeParameter}}Ee.to=ce})(re=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(Ee){function he($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(re.from):[]}}Ee.from=he;function ce($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(re.to):[]}}Ee.to=ce})(q=e.SignatureHelp||(e.SignatureHelp={}));var ie;(function(Ee){function he($){return{text:$.text,position:v.from($.position),kind:pe.from($.kind??w.InlayHintKind.Other),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}Ee.from=he;function ce($){const Ie=new w.InlayHint($.text,v.to($.position),pe.to($.kind));return Ie.whitespaceAfter=$.whitespaceAfter,Ie.whitespaceBefore=$.whitespaceBefore,Ie}Ee.to=ce})(ie=e.InlayHint||(e.InlayHint={}));var pe;(function(Ee){function he($){return $}Ee.from=he;function ce($){return $}Ee.to=ce})(pe=e.InlayHintKind||(e.InlayHintKind={}));var Te;(function(Ee){function he($){return{range:o.from($.range),url:$.target,tooltip:$.tooltip}}Ee.from=he;function ce($){let Ie;if($.url)try{Ie=typeof $.url=="string"?y.URI.parse($.url,!0):y.URI.revive($.url)}catch(Le){}return new w.DocumentLink(o.to($.range),Ie)}Ee.to=ce})(Te=e.DocumentLink||(e.DocumentLink={}));var Be;(function(Ee){function he($){const Ie=new w.ColorPresentation($.label);return $.textEdit&&(Ie.textEdit=ae.to($.textEdit)),$.additionalTextEdits&&(Ie.additionalTextEdits=$.additionalTextEdits.map(Le=>ae.to(Le))),Ie}Ee.to=he;function ce($){return{label:$.label,textEdit:$.textEdit?ae.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(Ie=>ae.from(Ie)):void 0}}Ee.from=ce})(Be=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(Ee){function he($){return new w.Color($[0],$[1],$[2],$[3])}Ee.to=he;function ce($){return[$.red,$.green,$.blue,$.alpha]}Ee.from=ce})(ve=e.Color||(e.Color={}));var Ke;(function(Ee){function he($){return{range:o.from($.range)}}Ee.from=he;function ce($){return new w.SelectionRange(o.to($.range))}Ee.to=ce})(Ke=e.SelectionRange||(e.SelectionRange={}));var z;(function(Ee){function he(ce){switch(ce){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}Ee.to=he})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(Ee){function he($){switch($){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=he;function ce($){switch($){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}Ee.to=ce})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var fe;(function(Ee){function he($){if($===w.EndOfLine.CRLF)return 1;if($===w.EndOfLine.LF)return 0}Ee.from=he;function ce($){if($===1)return w.EndOfLine.CRLF;if($===0)return w.EndOfLine.LF}Ee.to=ce})(fe=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(Ee){function he(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=he})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(Ee){function he(ce){const $={start:ce.start+1,end:ce.end+1};return ce.kind&&($.kind=Xe.from(ce.kind)),$}Ee.from=he})(Ne=e.FoldingRange||(e.FoldingRange={}));var Xe;(function(Ee){function he(ce){if(ce)switch(ce){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}Ee.from=he})(Xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var De;(function(Ee){function he(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?o.from(ce.selection):void 0,override:typeof ce.override=="boolean"?C.EditorResolution.DISABLED:void 0}}Ee.from=he})(De=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ye;(function(Ee){function he($){return $ instanceof w.RelativePattern||typeof $=="string"?$:ce($)?new w.RelativePattern($.base,$.pattern):$}Ee.from=he;function ce($){const Ie=$;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(ye=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Ee){function he(ce){if(ce){if(Array.isArray(ce))return ce.map(he);if(typeof ce=="string")return ce;{const $=ce;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:ye.from($.pattern),exclusive:$.exclusive}}}else return}Ee.from=he})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(Ee){function he($){return{start:$.start,end:$.end}}Ee.from=he;function ce($){return new w.NotebookRange($.start,$.end)}Ee.to=ce})(se=e.NotebookRange||(e.NotebookRange={}));var ue;(function(Ee){function he($){return{timing:typeof $.runStartTime=="number"&&typeof $.runEndTime=="number"?{startTime:$.runStartTime,endTime:$.runEndTime}:void 0,executionOrder:$.executionOrder,success:$.lastRunSuccess}}Ee.to=he;function ce($){return{lastRunSuccess:$.success,runStartTime:$.timing?.startTime,runEndTime:$.timing?.endTime,executionOrder:$.executionOrder}}Ee.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var O;(function(Ee){function he($){switch($){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}Ee.from=he;function ce($){switch($){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}Ee.to=ce})(O=e.NotebookCellKind||(e.NotebookCellKind={}));var Y;(function(Ee){function he($){const Ie={metadata:$.metadata??Object.create(null),cells:[]};for(let Le of $.cells)w.NotebookCellData.validate(Le),Ie.cells.push(le.from(Le));return Ie}Ee.from=he;function ce($){const Ie=new w.NotebookData($.cells.map(le.to));return(0,E.isEmptyObject)($.metadata)||(Ie.metadata=$.metadata),Ie}Ee.to=ce})(Y=e.NotebookData||(e.NotebookData={}));var le;(function(Ee){function he($){return{cellKind:O.from($.kind),language:$.languageId,mime:$.mime,source:$.value,metadata:$.metadata,internalMetadata:ue.from($.executionSummary??{}),outputs:$.outputs?$.outputs.map(Pe.from):[]}}Ee.from=he;function ce($){return new w.NotebookCellData(O.to($.cellKind),$.source,$.language,$.mime,$.outputs?$.outputs.map(Pe.to):void 0,$.metadata,$.internalMetadata?ue.to($.internalMetadata):void 0)}Ee.to=ce})(le=e.NotebookCellData||(e.NotebookCellData={}));var Ae;(function(Ee){function he($){return{mime:$.mime,valueBytes:Array.from($.data)}}Ee.from=he;function ce($){return new w.NotebookCellOutputItem(new Uint8Array($.valueBytes),$.mime)}Ee.to=ce})(Ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(Ee){function he($){return{outputId:$.id,items:$.items.map(Ae.from),metadata:$.metadata}}Ee.from=he;function ce($){const Ie=$.items.map(Ae.to);return new w.NotebookCellOutput(Ie,$.outputId,$.metadata)}Ee.to=ce})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(Ee){function he(Le){if(Le!=null){if(Le instanceof w.RelativePattern||typeof Le=="string")return Le;if(Ie(Le))return new w.RelativePattern(Le.base,Le.pattern);if($(Le))return{include:ye.from(Le.include)||void 0,exclude:ye.from(Le.exclude)||void 0}}}Ee.from=he;function ce(Le){return typeof Le=="string"?Le:Ie(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}Ee.to=ce;function $(Le){const Ze=Le,ze=ye.from(Ze.include);if(!(ze&&ze instanceof w.RelativePattern||typeof ze=="string"))return!1;const ft=ye.from(Ze.exclude);return!!(ft&&ft instanceof w.RelativePattern||typeof ft=="string")}function Ie(Le){const Ze=Le;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var je;(function(Ee){function he(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?P.from(ce.top):void 0}}Ee.from=he})(je=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var et;(function(Ee){function he(ce,$,Ie){const Le=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(Le,Ie),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Ee.from=he})(et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(Ee){function he(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}Ee.from=he})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Je;(function(Ee){function he($){return{uri:$.uri,provides:$.provides}}Ee.from=he;function ce($){return new w.NotebookRendererScript(y.URI.revive($.uri),$.provides)}Ee.to=ce})(Je=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Qe;(function(Ee){function he($){return{message:_.fromStrict($.message)||"",type:0,expected:$.expectedOutput,actual:$.actualOutput,location:$.location?W.from($.location):void 0}}Ee.from=he;function ce($){const Ie=new w.TestMessage(typeof $.message=="string"?$.message:_.to($.message));return Ie.actualOutput=$.actual,Ie.expectedOutput=$.expected,Ie}Ee.to=ce})(Qe=e.TestMessage||(e.TestMessage={}));var mt;(function(Ee){let he;(function($){$.Delimiter="\0"})(he||(he={})),Ee.namespace=($,Ie)=>$+"\0"+Ie;function ce($,Ie){return{displayId:Ie.id,id:Ee.namespace($,Ie.id),label:Ie.label}}Ee.display=ce,Ee.denamespace=$=>{const Ie=$.indexOf("\0");return{ctrlId:$.slice(0,Ie),tagId:$.slice(Ie+1)}}})(mt=e.TestTag||(e.TestTag={}));var vt;(function(Ee){function he(Le){const Ze=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:g.TestId.fromExtHostTestItem(Le,Ze).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(ze=>mt.namespace(Ze,ze.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&_.fromStrict(Le.error)||null}}Ee.from=he;function ce(Le){return{id:g.TestId.fromString(Le.extId).localId,label:Le.label,uri:y.URI.revive(Le.uri),tags:(Le.tags||[]).map(Ze=>{const{tagId:ze}=mt.denamespace(Ze);return new w.TestTag(ze,ze)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}Ee.toPlain=ce;function $(Le){const Ze=g.TestId.fromString(Le.extId),ze=new h.TestItemImpl(Ze.controllerId,Ze.localId,Le.label,y.URI.revive(Le.uri));return ze.range=o.to(Le.range||void 0),ze.description=Le.description||void 0,ze}function Ie(Le){let Ze;for(const ze of Le.tests){const ft=$(ze.item);(0,h.getPrivateApiFor)(ft).parent=Ze,Ze=ft}return Ze}Ee.toItemFromContext=Ie})(vt=e.TestItem||(e.TestItem={})),function(Ee){function he($){return{id:$.id,label:$.label}}Ee.from=he;function ce($){return new w.TestTag($.id,$.label)}Ee.to=ce}(mt=e.TestTag||(e.TestTag={}));var Et;(function(Ee){const he=($,Ie)=>{const Le={...vt.toPlain($.item),parent:void 0,taskStates:$.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(ze=>ze.type===0).map(Qe.to)})),children:$.children.map(Ze=>Ie.get(Ze)).filter(E.isDefined).map(Ze=>he(Ze,Ie))};for(const Ze of Le.children)Ze.parent=Le;return Le};function ce($){const Ie=[],Le=new Map;for(const Ze of $.items)Le.set(Ze.item.extId,Ze),$.request.targets.some(ze=>ze.controllerId===Ze.controllerId&&ze.testIds.includes(Ze.item.extId))&&Ie.push(Ze);return{completedAt:$.completedAt,results:Ie.map(Ze=>he(Ze,Le))}}Ee.to=ce})(Et=e.TestResults||(e.TestResults={}));var ot;(function(Ee){function he(Le){return{covered:Le.covered,total:Le.covered}}function ce(Le){return"line"in Le?v.from(Le):o.from(Le)}function $(Le){return"branches"in Le?{count:Le.executionCount,location:ce(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Le.executionCount,location:ce(Le.location)}}Ee.fromDetailed=$;function Ie(Le){return{uri:Le.uri,statement:he(Le.statementCoverage),branch:Le.branchCoverage&&he(Le.branchCoverage),function:Le.functionCoverage&&he(Le.functionCoverage),details:Le.detailedCoverage?.map($)}}Ee.fromFile=Ie})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(Ee){function he(ce){switch(ce){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}Ee.to=he})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Dt;(function(Ee){function he($){const Ie=new w.TypeHierarchyItem(V.to($.kind),$.name,$.detail||"",y.URI.revive($.uri),o.to($.range),o.to($.selectionRange));return Ie._sessionId=$._sessionId,Ie._itemId=$._itemId,Ie}Ee.to=he;function ce($,Ie,Le){if(Ie=Ie??$._sessionId,Le=Le??$._itemId,Ie===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Le,kind:V.from($.kind),name:$.name,detail:$.detail??"",uri:$.uri,range:o.from($.range),selectionRange:o.from($.selectionRange),tags:$.tags?.map(H.from)}}Ee.from=ce})(Dt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[178],be([0,1,2,12,7,9,79]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class E{constructor(T,n,C,l={timeout:1500,errors:3}){this._logService=T,this._documents=n,this._mainThreadBulkEdits=C,this._thresholds=l,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(n,C,l)=>{const u={dispose:this._callbacks.push([n,C,T])};return Array.isArray(l)&&l.push(u),u}}async $participateInSave(T,n){const C=d.URI.revive(T);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),u=[];try{for(let g of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(g,{document:b,reason:S.TextDocumentSaveReason.to(n)});u.push(w)}}finally{clearTimeout(h)}return u}_deliverEventAsyncAndBlameBadListeners([T,n,C],l){const h=this._badListeners.get(T);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,T,n,l).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const g=this._badListeners.get(T);this._badListeners.set(T,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,n,C,l){const h=[],u=Date.now(),{document:g,reason:b}=l,{version:w}=g,A=Object.freeze({document:g,reason:b,waitUntil(o){if(Object.isFrozen(h))throw(0,R.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(o))}});try{n.apply(C,[A])}catch(o){return Promise.reject(o)}return Object.freeze(h),new Promise((o,p)=>{const v=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),o(t)}).catch(t=>{clearTimeout(v),p(t)})}).then(o=>{const p={edits:[]};for(const v of o)if(Array.isArray(v)&&v.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:a,range:s}of v)p.edits.push({_type:2,resource:g.uri,edit:{range:s&&S.Range.from(s),text:t,eol:a&&S.EndOfLine.from(a)}});if(p.edits.length!==0)return w===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=E}),define(we[179],be([0,1,3,27,2,9,7]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(n,C,l,h,u){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,l&&(this._config+=1),h&&(this._config+=2),u&&(this._config+=4);const g=(0,R.parse)(C),b=n(w=>{if(!l)for(let A of w.created){const o=D.URI.revive(A);g(o.fsPath)&&this._onDidCreate.fire(o)}if(!h)for(let A of w.changed){const o=D.URI.revive(A);g(o.fsPath)&&this._onDidChange.fire(o)}if(!u)for(let A of w.deleted){const o=D.URI.revive(A);g(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,C,l){this._logService=C,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,C,l,h){return new E(this._onFileSystemEvent.event,n,C,l,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,C){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(l=>({oldUri:D.URI.revive(l.source),newUri:D.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(l=>D.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:C.map(l=>D.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,C){return(l,h,u)=>{const g=function(w){l.call(h,w)};return g.extension=n,C.event(g,void 0,u)}}async $onWillRunFileOperation(n,C,l,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(u=>({oldUri:D.URI.revive(u.source),newUri:D.URI.revive(u.target)}))},l,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(u=>D.URI.revive(u.target))},l,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(u=>D.URI.revive(u.target))},l,h)}}async _fireWillEvent(n,C,l,h){const u=new Set,g=[];if(await n.fireAsync(C,h,async(w,A)=>{const o=Date.now(),p=await Promise.resolve(w);p instanceof k.WorkspaceEdit&&(g.push(p),u.add(A.extension.displayName??A.extension.identifier.value)),Date.now()-o>l&&this._logService.warn("SLOW file-participant",A.extension.identifier)}),h.isCancellationRequested||g.length===0)return;const b={edits:[]};for(let w of g){let{edits:A}=S.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(A)}return{edit:b,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=y}),define(we[180],be([0,1,11,23,2,9,7,98]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(l,h,u,g){this.start=l,this.deletedCount=h,this.deletedItems=u,this.items=g}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(u=>u.apiCell)}))}}class T{constructor(l,h,u){this.notebook=l,this._extHostDocument=h,this._cellData=u,this.handle=u.handle,this.uri=D.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return l._mime},set mime(u){l._mime=u},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(S.NotebookCellOutput.to)}setOutputItems(l,h,u){const g=u.map(S.NotebookCellOutputItem.to),b=this._outputs.find(w=>w.id===l);b&&(h||(b.items.length=0),b.items.push(...g))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=T;class n{constructor(l,h,u,g,b,w){this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=u,this._emitter=g,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===d.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(g=>g.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const u of l.rawEvents)u.kind===E.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===E.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===E.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===E.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===E.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===E.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===E.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,u=l.end|0;return h<0&&(h=0),u>this._cells.length&&(u=this._cells.length),l.with({start:h,end:u})}_getCells(l){l=this._validateRange(l);const h=[];for(let u=l.start;u<l.end;u++)h.push(this._cells[u]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const u=[],g=[],b=[];l.reverse().forEach(w=>{const o=w[2].map(t=>{const a=new T(this,this._textDocumentsAndEditors,t);return h||g.push(T.asModelAddData(this.apiNotebook,t)),a}),p=new y(w[0],w[1],[],o),v=this._cells.splice(w[0],w[1],...o);for(const t of v)b.push(t.uri),p.deletedItems.push(t.apiCell);u.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:b}),h||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(u)}))}_moveCell(l,h){const u=this._cells.splice(l,1);this._cells.splice(h,0,...u);const g=[new y(l,1,u.map(b=>b.apiCell),[]),new y(h,0,[],u)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(g)}))}_setCellOutputs(l,h){const u=this._cells[l];u.setOutputs(h),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(l,h,u,g){const b=this._cells[l];b.setOutputItems(h,u,g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(l,h){const u=this._cells[l];u.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(u.uri,h)}_changeCellMime(l,h){const u=this._cells[l];u.apiCell.mime=h}_changeCellMetadata(l,h){const u=this._cells[l],g=u.apiCell.metadata;u.setMetadata(h);const b=u.apiCell.metadata;(0,R.equals)(g,b)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(l,h){const u=this._cells[l],g=u.internalMetadata;if(u.setInternalMetadata(h),g.runState!==h.runState){const b=h.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(we[101],be([0,1,7,9,12]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:T})}replaceCells(y,T,n){this._throwIfFinalized(),!(y===T&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:T-y,cells:n.map(R.NotebookCellData.from)})}}class k{constructor(y,T,n,C,l,h){this.id=y,this._proxy=T,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=C,this._viewColumn=h}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");y._selections=T,y._trySetSelections(T)},get visibleRanges(){return y._visibleRanges},revealRange(T,n){y._proxy.$tryRevealRange(y.id,R.NotebookRange.from(T),n??d.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(T){const n=new S(this.document.version);return T(n),y._applyEdit(n.finalize())},setDecorations(T,n){return y.setDecorations(T,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(R.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const T=[];let n=-1;for(let C=0;C<y.cellEdits.length;C++){if(n<0){T.push(y.cellEdits[C]),n++;continue}const h=T[n],u=y.cellEdits[C];if(h.editType===1&&u.editType===1&&h.index===u.index){h.cells.push(...y.cellEdits[C].cells),h.count+=y.cellEdits[C].count;continue}T.push(y.cellEdits[C]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,T)}setDecorations(y,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return T.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(T),y.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(we[181],be([0,1,9,156,135,20,53]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,l,h){const u=this._handles++,{title:g,location:b,cancellable:w}=l,A={label:(0,D.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(b),title:g,source:A,cancellable:w},C),this._withProgress(u,h,!!w)}_withProgress(C,l,h){let u;h&&(u=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,u));const g=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let b;try{b=l(new T(this._proxy,C),h&&u?u.token:S.CancellationToken.None)}catch(w){throw g(C),w}return b.then(w=>g(C),w=>g(C)),b}$acceptProgressCanceled(C){const l=this._mapHandleToCancellationSource.get(C);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=E;function y(n,C){return n.message=C.message,typeof C.increment=="number"&&(typeof n.increment=="number"?n.increment+=C.increment:n.increment=C.increment),n}class T extends R.Progress{constructor(C,l){super(h=>this.throttledReport(h));this._proxy=C,this._handle=l}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}We([(0,k.throttle)(100,(n,C)=>y(n,C),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(we[102],be([0,1,41,12,55,9,7]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class E{constructor(l,h,u){const g=E._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,g,S.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=E,E._Keys=new D.IdGenerator("TextEditorDecorationType");class y{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let u=null;if(l instanceof k.Position)u=new k.Range(l,l);else if(l instanceof k.Range)u=l;else throw new Error("Unrecognized location");this._pushEdit(u,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new k.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof k.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,u){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:h,forceMoveMarkers:u})}setEndOfLine(l){if(this._throwIfFinalized(),l!==k.EndOfLine.LF&&l!==k.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=y;class T{constructor(l,h,u,g){this._proxy=l,this._id=h,this._accept(u),this._logService=g;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(w){b._setTabSize(w)},get insertSpaces(){return b._insertSpaces},set insertSpaces(w){b._setInsertSpaces(w)},get cursorStyle(){return b._cursorStyle},set cursorStyle(w){b._setCursorStyle(w)},get lineNumbers(){return b._lineNumbers},set lineNumbers(w){b._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let u=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(u=!0,h.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,u=!0,h.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(u=!0,h.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,u=!0,h.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,u=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,u=!0,h.lineNumbers=S.TextEditorLineNumbersStyle.from(l.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=T;class n{constructor(l,h,u,g,b,w,A,o){this.id=l,this._proxy=h,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new T(this._proxy,this.id,w,u),this._visibleRanges=A,this._viewColumn=o;const p=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(v){if(!(v instanceof k.Selection))throw(0,R.illegalArgument)("selection");p._selections=[v],p._trySetSelection()},get selections(){return p._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof k.Selection)))throw(0,R.illegalArgument)("selections");p._selections=v,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return p._options.value},set options(v){p._disposed||p._options.assign(v)},get viewColumn(){return p._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new y(g.getValue(),t);return v(a),p._applyEdit(a)},insertSnippet(v,t,a={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=p._selections.map(i=>S.Range.from(i));else if(t instanceof k.Position){const{lineNumber:i,column:c}=S.Position.from(t);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof k.Range)s=[S.Range.from(t)];else{s=[];for(const i of t)if(i instanceof k.Range)s.push(S.Range.from(i));else{const{lineNumber:c,column:f}=S.Position.from(i);s.push({startLineNumber:c,startColumn:f,endLineNumber:c,endColumn:f})}}return h.$tryInsertSnippet(l,v.value,s,a)},setDecorations(v,t){const a=t.length===0;a&&!p._hasDecorationsForKey.has(v.key)||(a?p._hasDecorationsForKey.delete(v.key):p._hasDecorationsForKey.add(v.key),p._runOnProxy(()=>{if(S.isDecorationOptionsArr(t))return h.$trySetDecorations(l,v.key,S.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const f=t[i];s[4*i]=f.start.line+1,s[4*i+1]=f.start.character+1,s[4*i+2]=f.end.line+1,s[4*i+3]=f.end.character+1}return h.$trySetDecorationsFast(l,v.key,s)}}))},revealRange(v,t){p._runOnProxy(()=>h.$tryRevealRange(l,S.Range.from(v),t||k.TextEditorRevealType.Default))},show(v){h.$tryShowEditor(l,S.ViewColumn.from(v))},hide(){h.$tryHideEditor(l)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,d.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,d.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,d.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,d.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const u=h.edits.map(b=>b.range);u.sort((b,w)=>b.end.line===w.end.line?b.end.character===w.end.character?b.start.line===w.start.line?b.start.character-w.start.character:b.start.line-w.start.line:b.end.character-w.end.character:b.end.line-w.end.line);for(let b=0,w=u.length-1;b<w;b++){const A=u[b].end;if(u[b+1].start.isBefore(A))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=h.edits.map(b=>({range:S.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,g,{setEndOfLine:typeof h.setEndOfLine=="number"?S.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(we[182],be([0,1,138,25,2,3,6,170,15,7,10,17,9,20,167]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(A,o){if((0,n.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let p;return Array.isArray(A.highlights)&&(p=A.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),p=p.length?p:void 0),{label:A.label,highlights:p}}}class b{constructor(o,p,v){this._proxy=o,this.commands=p,this.logService=v,this.treeViews=new Map;function t(a){return a&&a.$treeViewId&&a.$treeItemHandle}p.registerArgumentProcessor({processArgument:a=>t(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(s=>t(s)?this.convertArgument(s):s):a})}registerTreeDataProvider(o,p,v){const t=this.createTreeView(o,{treeDataProvider:p},v);return{dispose:()=>t.dispose()}}createTreeView(o,p,v){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=p.dragAndDropController!==void 0,a=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(o,p,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,c)=>s.reveal(i,c),dispose:async()=>{await a,this.treeViews.delete(o),s.dispose()}}}$getChildren(o,p){const v=this.treeViews.get(o);return v?v.getChildren(p):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,p,v){const t=this.treeViews.get(o);if(!t)return Promise.reject(new Error((0,d.localize)(1,null,o)));const a=u.TreeDataTransferConverter.toITreeDataTransfer(p);if(a.items.has(E.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await a.items.get(E.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?a.items.set(E.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):a.items.delete(E.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(a,v)}async $hasResolve(o){const p=this.treeViews.get(o);if(!p)throw new Error((0,d.localize)(2,null,o));return p.hasResolve}$resolve(o,p,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,d.localize)(3,null,o));return t.resolveTreeItem(p,v)}$setExpanded(o,p,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,d.localize)(4,null,o));t.setExpanded(p,v)}$setSelection(o,p){const v=this.treeViews.get(o);if(!v)throw new Error((0,d.localize)(5,null,o));v.setSelection(p)}$setVisible(o,p){const v=this.treeViews.get(o);if(!v)throw new Error((0,d.localize)(6,null,o));v.setVisible(p)}createExtHostTreeView(o,p,v){const t=new w(o,p,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(o,t),t}convertArgument(o){const p=this.treeViews.get(o.$treeViewId);return p?p.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=b;class w extends k.Disposable{constructor(o,p,v,t,a,s){super();if(this.viewId=o,this.proxy=v,this.commands=t,this.logService=a,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,s.contributes&&s.contributes.views)for(const f in s.contributes.views)for(const m of s.contributes.views[f])m.id===o&&(this._title=m.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let i,c;this._register(S.Event.debounce(this._onDidChangeData.event,(f,m)=>(f||(f={message:!1,elements:[]}),m.element!==!1&&(i||(i=new Promise(_=>c=_),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(m.element)?f.elements.push(...m.element):f.elements.push(m.element)),m.message&&(f.message=!0),f),200,!0)(({message:f,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=c;return i=null,this.refresh(m).then(()=>_())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,n.isUndefinedOrNull)(o))}getChildren(o){const p=o?this.getExtensionElement(o):void 0;if(o&&!p)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(o);return(v?Promise.resolve(v):this.fetchChildrenNodes(p)).then(t=>t.map(a=>a.item))}getExtensionElement(o){return this.elements.get(o)}reveal(o,p){p=p||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(p.select)?!0:p.select,t=(0,n.isUndefinedOrNull)(p.focus)?!1:p.focus,a=(0,n.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(c=>c.item)},{select:v,focus:t,expand:a})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:a})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,p){const v=this.getExtensionElement(o);v&&(p?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(o){(0,C.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,p){const v=this.getExtensionElement(p);if(!!v)return(0,y.asPromise)(()=>this.dndController?.onDrop(o,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,p){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(o);if(v){const t=this.nodes.get(v);if(t){const a=await this.dataProvider.resolveTreeItem(t.extensionItem,v,p)??t.extensionItem;return t.item.tooltip=this.getTooltip(a.tooltip),t.item.command=this.getCommand(t.disposableStore,a.command),t.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(p=>p?this.resolveUnknownParentChain(p).then(v=>this.resolveTreeNode(p,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(o){const p=this.nodes.get(o);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,p){const v=this.nodes.get(o);return v?Promise.resolve(v):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>this.createHandle(o,t,p,!0)).then(t=>this.getChildren(p?p.item.handle:void 0).then(()=>{const a=this.getExtensionElement(t);if(a){const s=this.nodes.get(a);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(o){if(o){let p;if(typeof o=="string"){const v=this.getExtensionElement(o);p=v?this.nodes.get(v):void 0}else p=o;return p&&p.children||null}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const p=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=o?this.nodes.get(o):void 0,t=await this.dataProvider.getChildren(o);if(p.token.isCancellationRequested)return[];const a=await Promise.all((0,C.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,v):null}));return p.token.isCancellationRequested?[]:(0,C.coalesce)(a)}finally{p.dispose()}}refresh(o){if(o.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(o);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const p=new Set,v=o.map(a=>this.nodes.get(a));for(const a of v)if(a&&!p.has(a.item.handle)){let s=a;for(;s&&s.parent&&v.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&p.add(a.item.handle)}const t=[];return p.forEach(a=>{const s=this.elements.get(a);if(s){const i=this.nodes.get(s);i&&(!i.parent||!p.has(i.parent.item.handle))&&t.push(a)}}),t}refreshHandles(o){const p={};return Promise.all(o.map(v=>this.refreshNode(v).then(t=>{t&&(p[v]=t.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(o){const p=this.getExtensionElement(o);if(p){const v=this.nodes.get(p);if(v)return this.clearChildren(p),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(t=>{if(t){const a=this.createTreeNode(p,t,v.parent);return this.updateNodeCache(p,a,v,v.parent),v.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,p,v){const t=this.createTreeNode(o,p,v);if(p.id&&this.elements.has(t.item.handle))throw new Error((0,d.localize)(7,null,p.id));return this.addNodeToCache(o,t),this.addNodeToParentCache(t,v),t}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?l.MarkdownString.from(o):o}getCommand(o,p){return p?this.commands.toInternal(p,o):void 0}createTreeNode(o,p,v){const t=new k.DisposableStore,a=this.createHandle(o,p,v),s=this.getLightIconPath(p);return{item:{handle:a,parentHandle:v?v.item.handle:void 0,label:g(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(t,p.command),contextValue:p.contextValue,icon:s,iconDark:this.getDarkIconPath(p)||s,themeIcon:this.getThemeIcon(p),collapsibleState:(0,n.isUndefinedOrNull)(p.collapsibleState)?T.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:p,label:v,resourceUri:t},a,s){if(p)return`${w.ID_HANDLE_PREFIX}/${p}`;const i=g(v,this.extension),c=a?a.item.handle:w.LABEL_HANDLE_PREFIX;let f=i?i.label:t?(0,R.basename)(t):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const m=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,_=this.getChildrenNodes(a)||[];let I,r=0;do{if(I=`${c}/${r}:${f}`,s||!this.elements.has(I)||m===I)break;r++}while(r<=_.length);return I}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||D.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return D.URI.isUri(o)?o:D.URI.file(o)}addNodeToCache(o,p){this.elements.set(p.item.handle,o),this.nodes.set(o,p)}updateNodeCache(o,p,v,t){this.elements.delete(p.item.handle),this.nodes.delete(o),p.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(o,p);const a=this.getChildrenNodes(t)||[],s=a.filter(i=>i.item.handle===v.item.handle)[0];s&&a.splice(a.indexOf(s),1,p)}addNodeToParentCache(o,p){p?(p.children||(p.children=[]),p.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const p=this.nodes.get(o);if(p){if(p.children)for(const v of p.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}p.children=void 0}}else this.clearAll()}clear(o){const p=this.nodes.get(o);if(p){if(p.children)for(const v of p.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(o),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(we[183],be([0,1,15,3,6,10,68,9,99,72]),function(ee,e,d,R,D,S,k,E,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends D.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const l=this.diff;return this.diff=[],l}*tags(){const l=new Set;for(const h of this.tree.values())for(const u of h.actual.tags)l.has(u.id)||(l.add(u.id),yield u)}pushDiff(l){const h=this.diff[this.diff.length-1];if(h&&l[0]===1){if(h[0]===1&&h[1].extId===l[1].extId){(0,y.applyTestItemUpdate)(h[1],l[1]);return}if(h[0]===0&&h[1].item.extId===l[1].extId){(0,y.applyTestItemUpdate)(h[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,h){const u=this.tree.get(l);if(!!u){if((u.expandLevels===void 0||h>u.expandLevels)&&(u.expandLevels=h),u.expand===1){const g=this.resolveChildren(u);return g.isOpen()?this.expandChildren(u,h-1):g.wait().then(()=>this.expandChildren(u,h-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,h-1)):this.expandChildren(u,h-1)}}dispose(){for(const l of this.tree.values())(0,k.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,h){switch(h.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(l.fullId,h.id));break;case 0:this.upsertItem(h.item,l);break;case 4:for(const w of h.ops)this.onTestItemEvent(l,w);break;case 3:const{key:u,value:g}=h,b=l.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.pushDiff([1,{extId:b,item:{tags:g.map(w=>w.id)}}]);break;case"range":this.pushDiff([1,{extId:b,item:{range:E.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:E.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:g??null}}]);break}break;default:(0,S.assertNever)(h)}}upsertItem(l,h){if(!(l instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const u=T.TestId.fromExtHostTestItem(l,this.root.id,h?.actual),g=(0,k.getPrivateApiFor)(l);g.parent&&g.parent!==h?.actual&&g.parent.children.delete(l.id);let b=this.tree.get(u.toString());if(!b){b={fullId:u,actual:l,parent:h?u.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},this.tree.set(b.fullId.toString(),b),this.setItemParent(l,h),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:E.TestItem.from(l)}]),this.connectItemAndChildren(l,b,h);return}if(b.actual===l){this.connectItem(l,b,h);return}const w=b.actual.children,A=b.actual,o=(0,k.diffTestItems)(A,l);(0,k.getPrivateApiFor)(A).listener=void 0,b.actual=l,b.expand=0;for(const[p,v]of o)this.onTestItemEvent(b,{op:3,key:p,value:v});this.connectItemAndChildren(l,b,h);for(const p of w)l.children.get(p.id)||this.removeItem(T.TestId.joinToString(u,p.id))}setItemParent(l,h){(0,k.getPrivateApiFor)(l).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(l,h,u){this.setItemParent(l,u);const g=(0,k.getPrivateApiFor)(l);g.parent=u?.actual,g.listener=b=>this.onTestItemEvent(h,b),this.updateExpandability(h)}connectItemAndChildren(l,h,u){this.connectItem(l,h,u);for(const g of l.children)this.upsertItem(g,h)}updateExpandability(l){let h;this._resolveHandler?l.resolveBarrier?h=l.resolveBarrier.isOpen()?3:2:h=l.actual.canResolveChildren?1:0:h=0,h!==l.expand&&(l.expand=h,this.pushDiff([1,{extId:l.fullId.toString(),expand:h}]),h===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,h){if(h<0)return;const u=[];for(const g of l.actual.children){const b=this.expand(T.TestId.joinToString(l.fullId,g.id),h);(0,d.isThenable)(b)&&u.push(b)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const b=new d.Barrier;return b.open(),b}l.expand=2,this.pushExpandStateUpdate(l);const h=l.resolveBarrier=new d.Barrier,u=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=b.stack||b.message||String(b))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(b){u(b)}return(0,d.isThenable)(g)?g.catch(u).then(()=>{h.open(),this.updateExpandability(l)}):(h.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const h=this.tree.get(l);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const u=[h];for(;u.length;){const g=u.pop();if(!!g){(0,k.getPrivateApiFor)(g.actual).listener=void 0,this.tree.delete(g.fullId.toString());for(const b of g.actual.children)u.push(this.tree.get(T.TestId.joinToString(g.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(we[184],be([0,1,4,151]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(R.IEnvironmentService)}),define(we[185],be([0,1,26,3,14]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=S;class k{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let C of n.activationEvents)C==="onUri"&&(C=`onUri:${d.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(n)}}keepOnly(n){const C=new Set;n.forEach(l=>C.add(d.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>C.has(d.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,C){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=k._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(l.map(h=>h.identifier)),C.length>0){const h=new Set;C.forEach(u=>h.add(d.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!h.has(d.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(l)}static _findLoopingExtensions(n){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,w){this.addNode(b),this.addNode(w),this._arcs.has(b)?this._arcs.get(b).push(w):this._arcs.set(b,[w])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,w){const A=C.getArcs(b);for(let o=0;o<A.length;o++)if(!w.has(A[o]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of n){const w=d.ExtensionIdentifier.toKey(b.identifier);if(l.set(w,b),b.extensionDependencies)for(let A of b.extensionDependencies){const o=d.ExtensionIdentifier.toKey(A);C.addArc(w,o)}}let h=new Set;C.getNodes().filter(b=>C.getArcs(b).length===0).forEach(b=>h.add(b));let u=C.getNodes().filter(b=>!h.has(b)),g;do{g=!1;for(let b=0;b<u.length;b++){const w=u[b];C.hasOnlyGoodArcs(w,h)&&(u.splice(b,1),b--,h.add(w),g=!0)}}while(g);return u.map(b=>l.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const C=this._activationMap.get(n);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const C=this._extensionsMap.get(d.ExtensionIdentifier.toKey(n));return C||void 0}}e.ExtensionDescriptionRegistry=k;var E;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(E||(E={}));function y(T,n){const C=T.isBuiltin?0:T.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(C!==l)return C-l;const h=D.posix.basename(T.extensionLocation.path),u=D.posix.basename(n.extensionLocation.path);return h<u?-1:h>u?1:0}}),define(we[186],be([0,1,24]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function S(E){const y=d.VSBuffer.alloc(1);switch(E){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=S;function k(E,y){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=k}),define(we[30],be([0,1,3,2,4,26,152]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class E{constructor(A){this.dependency=A}}e.MissingExtensionDependency=E;var y;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class T{constructor(A,o,p,v){this.codeLoadingTime=A,this.activateCallTime=o,this.activateResolvedTime=p,this.activationReason=v}}e.ActivationTimes=T;class n{constructor(A,o){this.description=A,this.value=o}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||h(w)}e.checkProposedApiEnabled=l;function h(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=h;function u(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=u;function g(w,A){return{identifier:new S.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!A,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=g;class b{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(A){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(A){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(A){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(A){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(A,o){return Promise.resolve()}_onWillActivateExtension(A){}_onDidActivateExtension(A,o,p,v,t){}_onDidActivateExtensionError(A,o){}_onExtensionRuntimeError(A,o){}_onExtensionHostExit(A){}}e.NullExtensionService=b}),define(we[187],be([0,1,26,30,16]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class k{constructor(u,g,b,w){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class E{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,g){return u===-1||g===-1?-1:g-u}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class y{constructor(u,g,b,w,A,o){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=b,this.module=w,this.exports=A,this.subscriptions=o}}e.ActivatedExtension=y;class T extends y{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class n extends y{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class C extends y{constructor(u){super(!0,u,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let l=class{constructor(u,g,b,w,A){this._logService=A,this._registry=u,this._resolvedExtensionsSet=new Set,g.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,b.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const g=d.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(g)}getActivatedExtension(u){const g=d.ExtensionIdentifier.toKey(u),b=this._activatedExtensions.get(g);if(!b)throw new Error("Extension `"+u.value+"` is not known or not activated");return b}activateByEvent(u,g){if(this._alreadyActivatedEvents[u])return S;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:g,extensionId:w.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,g){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:b.identifier,reason:g}])}_handleActivateRequest(u,g,b){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(u.id))){g[d.ExtensionIdentifier.toKey(u.id)]=u;return}const w=this._registry.getExtensionDescription(u.id);if(!w){const p=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,p,new R.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(u.id),new C(p));return}const A=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let o=!0;for(let p=0,v=A.length;p<v;p++){const t=A[p];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(t)))continue;const a=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(t));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const f=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),_=m&&m.displayName||t,I=new Error(`Cannot activate the '${f}' extension because its dependency '${_}' failed to activate`);I.detail=a.activationFailedError,this._host.onExtensionActivationError(w.identifier,I,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(w.identifier),new C(I));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(t))){o=!1,g[d.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){o=!1,g[d.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:u.reason};continue}const i=w.displayName||w.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,c,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(w.identifier),new C(c));return}o?g[d.ExtensionIdentifier.toKey(w.identifier)]=u:b.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(A=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(A.id))),u.length===0))return Promise.resolve(void 0);const g=Object.create(null),b=[];for(let A=0,o=u.length;A<o;A++)this._handleActivateRequest(u[A],g,b);for(let A=0,o=b.length;A<o;A++){const p=d.ExtensionIdentifier.toKey(b[A].id);g[p]&&delete g[p]}const w=Object.keys(g).map(A=>g[A]);return b.length===0?Promise.all(w.map(A=>this._activateExtension(A.id,A.reason))).then(A=>{}):this._activateExtensions(w).then(A=>this._activateExtensions(b))}_activateExtension(u,g){const b=d.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const w=this._activatingExtensions.get(b);if(w)return w;const A=this._host.actualActivateExtension(u,g).then(void 0,o=>{const p=new Error;return o&&o.name&&(p.name=o.name),o&&o.message?p.message=`Activating extension '${u.value}' failed: ${o.message}.`:p.message=`Activating extension '${u.value}' failed: ${o}.`,o&&o.stack&&(p.stack=o.stack),this._host.onExtensionActivationError(u,p,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(o),new C(o)}).then(o=>{this._activatedExtensions.set(b,o),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,A),A}};l=We([He(4,D.ILogService)],l),e.ExtensionsActivator=l}),define(we[188],be([0,1,12]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,k)=>{this._actualOk=S,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,d.onUnexpectedError)(S))}then(S,k){return this._ensureActual().then(S,k)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=R}),define(we[103],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(y,T){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=T,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const R=[];function D(E){const y=new d(!0,E);return R[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function S(E){const y=new d(!1,E);return R[y.nid]=y,y}e.createExtHostContextProxyIdentifier=S;function k(E){return R[E].sid}e.getStringIdentifierForProxy=k}),define(we[5],be([0,1,58,2,103]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var k;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var E;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(o){o.name="$ident";function p(t,a){return Object.defineProperty(t,o.name,{value:a,enumerable:!0}),t}o.mixin=p;function v(t){return t[o.name]}o.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(p){return p._id=h._n++,p}}e.IdObject=h,h._n=0;var u;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(o){if(o&&o.edits)for(const p of o.edits)typeof p.resource=="object"?p.resource=R.URI.revive(p.resource):(p.newUri=R.URI.revive(p.newUri),p.oldUri=R.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,d.revive)(p.metadata));return o}e.reviveWorkspaceEditDto=w;var A;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(A=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[73],be([0,1,5,3,4]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(E){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=E.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(E){this._onDidChangePassword.fire(E)}get(E,y){return this._proxy.$getPassword(E,y)}store(E,y,T){return this._proxy.$setPassword(E,y,T)}delete(E,y){return this._proxy.$deletePassword(E,y)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(we[74],be([0,1,4,16,5,13]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(y,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,T,n){const C=this.getUsageKey(y,T);this._reportedUsages.has(C)||(this._reportedUsages.add(C),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}getUsageKey(y,T){return`${y}-${T.identifier.value}`}};k=We([He(0,S.IExtHostRpcService),He(1,R.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(E,y,T){}})}),define(we[189],be([0,1,3,5,7,26]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,T,n,C={}){const l=S.ExtensionIdentifier.toKey(y.identifier),h=this._inFlightRequests.get(l)||[],u=[...n].sort().join(" ");let g=h.find(b=>b.scopes===u);if(g)return g.result;{const b=this._getSession(y,l,T,n,C);g={scopes:u,result:b},h.push(g),this._inFlightRequests.set(l,h);try{await b}finally{const w=h.findIndex(A=>A.scopes===u);w>-1&&(h.splice(w),this._inFlightRequests.set(l,h))}return b}}async _getSession(y,T,n,C,l={}){await this._proxy.$ensureProvider(n);const h=y.displayName||y.name;return this._proxy.$getSession(n,C,T,h,l)}async removeSession(y,T){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(T):this._proxy.$removeSession(y,T)}registerAuthenticationProvider(y,T,n,C){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:T,provider:n,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===y)||this._providers.push({id:y,label:T});const l=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(y,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,T,C?.supportsMultipleAccounts??!1),new D.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(y);const h=this._providers.findIndex(u=>u.id===y);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this._onDidChangeSessions.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(we[190],be([0,1,5,13,9]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(E,y){this._extHostDocumentsAndEditors=y,this._proxy=E.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(E){const y=D.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};S=We([He(0,R.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(we[191],be([0,1,5]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(S){const k=S.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(E){return k.$writeText(E)}})}}e.ExtHostClipboard=R}),define(we[49],be([0,1,10,7,9,23,5,17,16,58,31,38,2,6,4,13]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,a){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=a,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return i?.result===o.Void?i:void 0},a),this._argumentProcessors=[{processArgument(s){return(0,T.revive)(s)}},{processArgument(s){return(0,S.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return D.Range.to(i);if(C.Position.isIPosition(i))return D.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return D.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const a=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((f,m)=>{if(!f.validate(s[m]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${s[m]}`);return f.convert(s[m])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{a.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,a,s,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:s,thisArg:i,description:c}),t&&this._proxy.$registerCommand(a),new R.Disposable(()=>{this._commands.delete(a)&&t&&this._proxy.$unregisterCommand(a)})}executeCommand(t,...a){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,a,!0)}async _doExecuteCommand(t,a,s){if(this._commands.has(t))return this._executeContributedCommand(t,a);{const i=(0,S.cloneAndChange)(a,function(c){if(c instanceof R.Position)return D.Position.from(c);if(c instanceof R.Range)return D.Range.from(c);if(c instanceof R.Location)return D.location.from(c);if(R.NotebookRange.isNotebookRange(c))return D.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,s);return(0,T.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,a,!1);throw c}}}async _executeContributedCommand(t,a){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:c,description:f}=s;if(f)for(let m=0;m<f.args.length;m++)try{(0,d.validateConstraint)(a[m],f.args[m].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[m].name}' - ${f.args[m].description}`)}try{return await i.apply(c,a)}catch(m){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...a);_&&(t=_.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(a=a.map(s=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),s)),this._executeContributedCommand(t,a)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(a=>(t&&(a=a.filter(s=>s[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[a,s]of this._commands){let{description:i}=s;i&&(t[a]=i)}return Promise.resolve(t)}};b=We([He(0,g.IExtHostRpcService),He(1,y.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class w{constructor(t,a,s){this._commands=t,this._lookupApiCommand=a,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,a){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((c,f)=>c.convert(t.arguments&&t.arguments[f]));else if((0,E.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),a.add((0,h.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),s.$ident=c,s.id=this.delegatingCommandId,s.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return s}fromInternal(t){const a=k.ObjectIdentifier.of(t);return typeof a=="number"?this._cache.get(a):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const a=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class A{constructor(t,a,s,i){this.name=t,this.description=a,this.validate=s,this.convert=i}optional(){return new A(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,a){return new A(t??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=A,A.Uri=new A("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v),A.Position=new A("position","A position in a text document",v=>R.Position.isPosition(v),D.Position.from),A.Range=new A("range","A range in a text document",v=>R.Range.isRange(v),D.Range.from),A.Selection=new A("selection","A selection in a text document",v=>R.Selection.isSelection(v),D.Selection.from),A.Number=new A("number","",v=>typeof v=="number",v=>v),A.String=new A("string","",v=>typeof v=="string",v=>v),A.CallHierarchyItem=new A("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,D.CallHierarchyItem.from),A.TypeHierarchyItem=new A("item","A type hierarchy item",v=>v instanceof R.TypeHierarchyItem,D.TypeHierarchyItem.from);class o{constructor(t,a){this.description=t,this.convert=a}}e.ApiCommandResult=o,o.Void=new o("no result",v=>v);class p{constructor(t,a,s,i,c){this.id=t,this.internalId=a,this.description=s,this.args=i,this.result=c}}e.ApiCommand=p}),define(we[192],be([0,1,9,7,62,49,17,88]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(d.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if((0,k.isFalsyOrEmpty)(l))return;class u extends R.SymbolInformation{static to(b){const w=new u(b.name,d.SymbolKind.to(b.kind),b.containerName||"",new R.Location(h[0],d.Range.to(b.range)));return w.detail=b.detail,w.range=w.location.range,w.selectionRange=d.Range.to(b.selectionRange),w.children=b.children?b.children.map(u.to):[],w}}return l.map(u.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(d.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(d.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(d.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(d.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(d.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>R.Position.isPosition(h)),l=>l.map(d.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let u;for(const g of h.reverse())u=new R.SelectionRange(d.Range.to(g),u);return u}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let u of l)h.push(...u[1].map(d.WorkspaceSymbol.to));return h})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(d.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(d.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(d.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return d.WorkspaceEdit.to(l)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(d.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,E.decodeSemanticTokensDto)(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,E.decodeSemanticTokensDto)(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,u)=>{if(!l)return new R.CompletionList([]);const g=l.suggestions.map(b=>d.CompletionItem.to(b,u));return new R.CompletionList(g,l.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return d.SignatureHelp.to(l)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,u)=>n(g=>new R.CodeLens(d.Range.to(g.range),g.command&&u.fromInternal(g.command)))(l))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?d.Selection.from(l):d.Range.from(l)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,u)=>n(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const b=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=d.WorkspaceEdit.to(g.edit)),g.command&&(b.command=u.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(l))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new R.ColorInformation(d.Range.to(h.range),d.Color.to(h.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,d.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:d.Range.from(l.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(d.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(d.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>d.NotebookExclusiveDocumentPattern.to(h))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(d.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[d.ViewColumn.from(l.viewColumn),d.TextEditorOpenOptions.from(l)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[d.ViewColumn.from(l.viewColumn),d.TextEditorOpenOptions.from(l)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[d.ViewColumn.from(l.viewColumn),d.TextEditorOpenOptions.from(l)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(d.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(d.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(d.TypeHierarchyItem.to)))];class T{static register(h){y.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=T;function n(l){return h=>{if(Array.isArray(h))return h.map(l)}}function C(l){if(!Array.isArray(l))return;const h=[];for(const u of l)D.isLocationLink(u)?h.push(d.DefinitionLink.to(u)):h.push(d.location.to(u));return h}}),define(we[193],be([0,1,15,53,3,6,2,62,26,9,7,5]),function(ee,e,d,R,D,S,k,E,y,T,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(h,u,g){const b=h.getProxy(C.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.commentThreadHandle);return f||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.thread.commentThreadHandle);return f?{thread:f,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let m=i.commentUniqueId,_=f.getCommentByUniqueId(m);return _||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const f=c.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let m=i.text,_=i.commentUniqueId,I=f.getCommentByUniqueId(_);return I?(I.body=m,I):i}return i}})}createCommentController(i,c,f){const m=w.handlePool++,_=new o(i,m,c,f);this._commentControllers.set(_.handle,_);const I=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return I.push(_),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),I),_.value}$createCommentThreadTemplate(i,c,f){const m=this._commentControllers.get(i);!m||m.$createCommentThreadTemplate(c,f)}async $updateCommentThreadTemplate(i,c,f){const m=this._commentControllers.get(i);!m||m.$updateCommentThreadTemplate(c,f)}$deleteCommentThread(i,c){const f=this._commentControllers.get(i);f&&f.$deleteCommentThread(c)}$provideCommentingRanges(i,c,f){const m=this._commentControllers.get(i);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const _=g.getDocument(k.URI.revive(c));return(0,d.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(_,f)).then(I=>I?I.map(r=>T.Range.from(r)):void 0)}$toggleReaction(i,c,f,m,_){const I=this._commentControllers.get(i);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const r=I.getCommentThread(c);if(r){const P=r.getCommentByUniqueId(m.uniqueIdInThread);if(I!==void 0&&P&&I.reactionHandler)return I.reactionHandler(P,t(_))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class A{constructor(i,c,f,m,_,I,r){this._commentControllerHandle=c,this._id=f,this._uri=m,this._range=_,this._comments=I,this.handle=A._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),b.$createCommentThread(c,this.handle,this._id,this._uri,T.Range.from(this._range),r),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this._localDisposables.push({dispose:()=>{b.$deleteCommentThread(c,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(F){P.range=F},get comments(){return P.comments},set comments(F){P.comments=F},get collapsibleState(){return P.collapsibleState},set collapsibleState(F){P.collapsibleState=F},get canReply(){return P.canReply},set canReply(F){P.canReply=F},get contextValue(){return P.contextValue},set contextValue(F){P.contextValue=F},get label(){return P.label},set label(F){P.label=F},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const i=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),c={};i("range")&&(c.range=T.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(f=>p(this,f,this._commentsMap))),i("collapsibleState")&&(c.collapseState=a(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},b.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let f=c[0],m=c[1];if(i===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}A._handlePool=0,We([(0,R.debounce)(100)],A.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,c,f,m){this._extension=i,this._handle=c,this._id=f,this._label=m,this._threads=new Map,b.$registerCommentController(this.handle,f,m);const _=this;this.value=Object.freeze({id:_.id,label:_.label,get options(){return _.options},set options(I){_.options=I},get commentingRangeProvider(){return _.commentingRangeProvider},set commentingRangeProvider(I){_.commentingRangeProvider=I},get reactionHandler(){return _.reactionHandler},set reactionHandler(I){_.reactionHandler=I},createCommentThread(I,r,P){return _.createCommentThread(I,r,P).value},dispose:()=>{_.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{b.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,b.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,b.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,f,m){if(typeof i=="string"){const _=new A(this.id,this.handle,i,c,f,m,this._extension.identifier);return this._threads.set(_.handle,_),_}else{const _=new A(this.id,this.handle,void 0,i,c,f,this._extension.identifier);return this._threads.set(_.handle,_),_}}$createCommentThreadTemplate(i,c){const f=new A(this.id,this.handle,void 0,k.URI.revive(i),T.Range.to(c),[],this._extension.identifier);return f.collapsibleState=E.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(i,c){let f=this._threads.get(i);f&&(f.range=T.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(s,i,c){let f=c.get(i);f||(f=++s.commentHandle,c.set(i,f));const m=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:f,body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:m,label:i.label,commentReactions:i.reactions?i.reactions.map(_=>v(_)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?T.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?k.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function a(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return E.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return E.CommentThreadCollapsibleState.Collapsed}return E.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(we[104],be([0,1,2,5,7,4,13,16,17,8,14]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class bn{constructor(h,u){this._logService=u,this._provider=new Map,this._proxy=h.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,u){const g=bn._handlePool++;this._provider.set(g,{provider:h,extensionId:u}),this._proxy.$registerDecorationProvider(g,u.value);const b=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(g,null);return}let A=(0,y.asArray)(w);if(A.length<=bn._maxEventSize){this._proxy.$onDidChange(g,A);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,A.length);const o=A.map(t=>({uri:t,rank:(0,T.count)(t.path,"/")})),p=(0,y.groupBy)(o,(t,a)=>t.rank-a.rank||(0,T.compare)(t.uri.path,a.uri.path));let v=[];e:for(let t of p){let a;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(a!==i&&(a=i,v.push(s.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new D.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(h,u,g){if(!this._provider.has(h))return Object.create(null);const b=Object.create(null),{provider:w,extensionId:A}=this._provider.get(h);return await Promise.all(u.map(async o=>{try{const{uri:p,id:v}=o,t=await Promise.resolve(w.provideFileDecoration(d.URI.revive(p),g));if(!t)return;try{D.FileDecoration.validate(t),b[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(a){this._logService.warn(`INVALID decoration from extension '${A.value}': ${a}`)}}catch(p){this._logService.error(p)}})),b}};C._handlePool=0,C._maxEventSize=250,C=We([He(0,k.IExtHostRpcService),He(1,E.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")}),define(we[194],be([0,1,133,91,2,5,7,9,3,16,21]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(u,g,b,w,A){this._name=u,this._owner=g,this._maxDiagnosticsPerFile=b,this._proxy=w,this._onDidChangeDiagnostics=A,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,g){if(!u){this.clear();return}this._checkDisposed();let b=[];if(D.URI.isUri(u)){if(!g){this.delete(u);return}this._data.set(u,g.slice()),b=[u]}else if(Array.isArray(u)){b=[];let A;u=[...u].sort(C._compareIndexedTuplesByUri);for(const o of u){const[p,v]=o;if((!A||p.toString()!==A.toString())&&(A&&this._data.get(A).length===0&&this._data.delete(A),A=p,b.push(p),this._data.set(p,[])),v){const t=this._data.get(p);t&&t.push(...v)}else{const t=this._data.get(p);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const w=[];for(let A of b){let o=[];const p=this._data.get(A);if(p)if(p.length>this._maxDiagnosticsPerFile){o=[];const v=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let a of p)if(a.severity===v[t]&&o.push(E.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;o.push({severity:R.MarkerSeverity.Info,message:(0,d.localize)(0,null,p.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=p.map(v=>E.Diagnostic.from(v));w.push([A,o])}this._proxy.$changeMany(this._owner,w)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,g){this._checkDisposed();for(let b of this._data.keys())u.apply(g,[b,this.get(b),this])}get(u){this._checkDisposed();const g=this._data.get(u);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,g){return u[0].toString()<g[0].toString()?-1:u[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=C;let l=class Qt{constructor(u,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=u.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(u){const g=new n.ResourceMap;for(const b of u)g.set(b,b);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(u,g){const{_collections:b,_proxy:w,_onDidChangeDiagnostics:A,_logService:o}=this,p=new class{$changeMany(a,s){w.$changeMany(a,s),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,a,s.length===0?"CLEARING":s)}$clear(a){w.$clear(a),o.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,a)}dispose(){w.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=g;else if(!b.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Qt._idPool++;while(b.has(v))}return new class extends C{constructor(){super(g,v,Qt._maxDiagnosticsPerFile,p,A);b.set(v,this)}dispose(){super.dispose(),b.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const g=new Map,b=[];for(const w of this._collections.values())w.forEach((A,o)=>{let p=g.get(A.toString());typeof p=="undefined"&&(p=b.length,g.set(A.toString(),p),b.push([A,[]])),b[p][1]=b[p][1].concat(...o)});return b}}_getDiagnostics(u){let g=[];for(let b of this._collections.values())b.has(u)&&(g=g.concat(b.get(u)));return g}$acceptMarkersChange(u){if(!this._mirrorCollection){const g="_generated_mirror",b=new C(g,g,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,b),this._mirrorCollection=b}for(const[g,b]of u)this._mirrorCollection.set(D.URI.revive(g),b.map(E.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=We([He(1,T.ILogService)],l),e.ExtHostDiagnostics=l}),define(we[195],be([0,1,2,5]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(k){this._proxy=k.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(E=>E?E.map(y=>d.URI.revive(y)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(E=>E?d.URI.revive(E):void 0)}}e.ExtHostDialogs=D}),define(we[196],be([0,1,12,2,7,5,11,20,8]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(C,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=C.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(k.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const h=T._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,C);let u;return typeof l.onDidChange=="function"&&(u=l.onDidChange(g=>{if(g.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(h,g).then(b=>{if(!b&&typeof b!="string")return;const w=this._documentsAndEditors.getDocument(g);if(!w)return;const A=(0,y.splitLines)(b);if(!w.equalLines(A))return this._proxy.$onVirtualDocumentChange(g,b)},d.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(C,l){const h=this._documentContentProviders.get(C);return h?Promise.resolve(h.provideTextDocumentContent(R.URI.revive(l),E.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(we[197],be([0,1,3,6,2,5,97,9,10,23,7]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(h,u){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const b of g)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const b of g)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const u=this._documentsAndEditors.getDocument(h);if(u)return u}getDocument(h){const u=this.getDocumentData(h);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return u.document}ensureDocumentData(h){const u=this._documentsAndEditors.getDocument(h);if(u)return Promise.resolve(u);let g=this._documentLoader.get(h.toString());return g||(g=this._proxy.$tryOpenDocument(h).then(b=>{this._documentLoader.delete(h.toString());const w=D.URI.revive(b);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(w))},b=>(this._documentLoader.delete(h.toString()),Promise.reject(b))),this._documentLoader.set(h.toString(),g)),g}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(u=>D.URI.revive(u))}$acceptModelModeChanged(h,u){const g=D.URI.revive(h),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(u),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(h){const u=D.URI.revive(h),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(h,u){const g=D.URI.revive(h),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");b._acceptIsDirty(u),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,u,g){const b=D.URI.revive(h),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");w._acceptIsDirty(g),w.onEvents(u);let A;u.isUndoing?A=n.TextDocumentChangeReason.Undo:u.isRedoing&&(A=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:w.document,contentChanges:u.changes.map(o=>({range:E.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:A}))}setWordDefinitionFor(h,u){(0,k.setWordDefinitionFor)(h,u)}}e.ExtHostDocuments=C}),define(we[50],be([0,1,41,3,6,2,4,5,97,13,102,9,16,21,11,56,112]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let A=class{constructor(p,v){this._extHostRpc=p,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const v=[],t=[],a=[];if(p.removedDocuments)for(const s of p.removedDocuments){const i=S.URI.revive(s),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(p.addedDocuments)for(const s of p.addedDocuments){const i=S.URI.revive(s.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new w(new y.ExtHostDocumentData(this._extHostRpc.getProxy(E.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(p.removedEditors)for(const s of p.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&a.push(i)}if(p.addedEditors)for(const s of p.addedEditors){const i=S.URI.revive(s.documentUri);d.ok(this._documents.has(i),`document '${i}' does not exist`),d.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(i).value,f=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(E.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>c.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(m=>C.Range.to(m)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,f)}p.newActiveEditor!==void 0&&(d.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(a),p.removedDocuments&&this._onDidRemoveDocuments.fire(v),p.addedDocuments&&this._onDidAddDocuments.fire(t),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return p?v:v?.value}allEditors(){return[...this._editors.values()]}};A=We([He(0,T.IExtHostRpcService),He(1,l.ILogService)],A),e.ExtHostDocumentsAndEditors=A,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[198],be([0,1,2,5,6,7,9,122,8,24]),function(ee,e,d,R,D,S,k,E,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const u=this._schemes.indexOf(h);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),u=[];let g,b,w=14,A=14;for(const o of h){let p=g?(0,y.commonPrefixLength)(g,o):0;for(p===0?b=1:b=A;p<o.length;p++)p+1===o.length?(w=A,A=9):A+=1,u.push([b,o.toUpperCase().charCodeAt(p),A]),u.push([b,o.toLowerCase().charCodeAt(p),A]),b=A;g=o,A=w}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new E.StateMachine(u)}}provideDocumentLinks(h){this._initStateMachine();const u=[],g=E.LinkComputer.computeLinks({getLineContent(b){return h.lineAt(b-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const b of g){const w=k.DocumentLink.to(b);w.target&&u.push(w)}return u}}class C{constructor(h,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,u,g,b={},w){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const A=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(A,g),this._enableProposedApi.set(A,w??!1);let o=2;b.isCaseSensitive&&(o+=1024),b.isReadonly&&(o+=2048),typeof g.copy=="function"&&(o+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(o+=4),this._proxy.$registerFileSystemProvider(A,u,o).catch(v=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${u}`),console.error(v)});const p=g.onDidChangeFile(v=>{const t=[];for(const a of v){let{uri:s,type:i}=a;if(s.scheme!==u)continue;let c;switch(i){case S.FileChangeType.Changed:c=0;break;case S.FileChangeType.Created:c=1;break;case S.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:c})}this._proxy.$onFileSystemChange(A,t)});return(0,D.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(A),this._enableProposedApi.delete(A),this._proxy.$unregisterProvider(A)})}static _asIStat(h,u){const{type:g,ctime:b,mtime:w,size:A,permissions:o}=h;return u?{type:g,ctime:b,mtime:w,size:A,permissions:o}:{type:g,ctime:b,mtime:w,size:A}}$stat(h,u){return Promise.resolve(this._getFsProvider(h).stat(d.URI.revive(u))).then(g=>C._asIStat(g,this._enableProposedApi.get(h)??!1))}$readdir(h,u){return Promise.resolve(this._getFsProvider(h).readDirectory(d.URI.revive(u)))}$readFile(h,u){return Promise.resolve(this._getFsProvider(h).readFile(d.URI.revive(u))).then(g=>T.VSBuffer.wrap(g))}$writeFile(h,u,g,b){return Promise.resolve(this._getFsProvider(h).writeFile(d.URI.revive(u),g.buffer,b))}$delete(h,u,g){return Promise.resolve(this._getFsProvider(h).delete(d.URI.revive(u),g))}$rename(h,u,g,b){return Promise.resolve(this._getFsProvider(h).rename(d.URI.revive(u),d.URI.revive(g),b))}$copy(h,u,g,b){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(d.URI.revive(u),d.URI.revive(g),b))}$mkdir(h,u){return Promise.resolve(this._getFsProvider(h).createDirectory(d.URI.revive(u)))}$watch(h,u,g,b){const w=this._getFsProvider(h).watch(d.URI.revive(g),b);this._watches.set(u,w)}$unwatch(h,u){const g=this._watches.get(u);g&&(g.dispose(),this._watches.delete(u))}$open(h,u,g){const b=this._getFsProvider(h);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(d.URI.revive(u),g))}$close(h,u){const g=this._getFsProvider(h);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(u))}$read(h,u,g,b){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const A=T.VSBuffer.alloc(b);return Promise.resolve(w.read(u,g,A.buffer,0,b)).then(o=>A.slice(0,o))}$write(h,u,g,b){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(u,g,b.buffer,0,b.byteLength))}_getFsProvider(h){const u=this._fsProvider.get(h);if(!u){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return u}}e.ExtHostFileSystem=C}),define(we[75],be([0,1,5,63,7,24,4,13,48]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Ut{constructor(C,l){const h=C.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return h.$stat(u).catch(Ut._handleError)},readDirectory(u){return h.$readdir(u).catch(Ut._handleError)},createDirectory(u){return h.$mkdir(u).catch(Ut._handleError)},async readFile(u){return h.$readFile(u).then(g=>g.buffer).catch(Ut._handleError)},writeFile(u,g){return h.$writeFile(u,S.VSBuffer.wrap(g)).catch(Ut._handleError)},delete(u,g){return h.$delete(u,{recursive:!1,useTrash:!1,...g}).catch(Ut._handleError)},rename(u,g,b){return h.$rename(u,g,{overwrite:!1,...b}).catch(Ut._handleError)},copy(u,g,b){return h.$copy(u,g,{overwrite:!1,...b}).catch(Ut._handleError)},isWritableFileSystem(u){const g=l.getCapabilities(u);if(typeof g=="number")return!(g&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new D.FileSystemError(String(C));if(C.name==="ENOPRO")throw D.FileSystemError.Unavailable(C.message);switch(C.name){case R.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(C.message);case R.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(C.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(C.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(C.message);case R.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(C.message);case R.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(C.message);default:throw new D.FileSystemError(C.message,C.name)}}};T=We([He(0,E.IExtHostRpcService),He(1,y.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(we[199],be([0,1,2,49]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(k,E,y,T){this._extHostNotebooks=E,this._textDocumentsAndEditors=y,this._commands=T;const n=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new R.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new R.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new R.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new R.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:d.URI.revive(C.notebookUri),inputUri:d.URI.revive(C.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:d.URI.revive(C.notebookUri),inputUri:d.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(k,E,y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:E,lines:[""],modeId:y,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=D}),define(we[200],be([0,1,6,5]),function(ee,e,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(k){this._handlePool=0,this._proxy=k.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const E=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(E,k),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(E)})}}e.ExtHostLabelService=D}),define(we[201],be([0,1,2,23,9,7,5,8,31,17,10,119,6,88,55,66,57,12,3]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentSymbols(x,Q){const X=this._documents.getDocument(x),re=await this._provider.provideDocumentSymbols(X,Q);if(!(0,T.isFalsyOrEmpty)(re))return re[0]instanceof S.DocumentSymbol?re.map(D.DocumentSymbol.from):o._asDocumentSymbolTree(re)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((re,q)=>{let ie=re.location.range.start.compareTo(q.location.range.start);return ie===0&&(ie=q.location.range.end.compareTo(re.location.range.end)),ie});const Q=[],X=[];for(const re of x){const q={name:re.name||"!!MISSING: name!!",kind:D.SymbolKind.from(re.kind),tags:re.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:D.Range.from(re.location.range),selectionRange:D.Range.from(re.location.range),children:[]};for(;;){if(X.length===0){X.push(q),Q.push(q);break}const ie=X[X.length-1];if(y.Range.containsRange(ie.range,q.range)&&!y.Range.equalsRange(ie.range,q.range)){ie.children&&ie.children.push(q),X.push(q);break}X.pop()}}return Q}}class p{constructor(x,Q,X){this._documents=x,this._commands=Q,this._provider=X,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Q){const X=this._documents.getDocument(x),re=await this._provider.provideCodeLenses(X,Q);if(!re||Q.isCancellationRequested)return;const q=this._cache.add(re),ie=new l.DisposableStore;this._disposables.set(q,ie);const pe={cacheId:q,lenses:[]};for(let Te=0;Te<re.length;Te++)pe.lenses.push({cacheId:[q,Te],range:D.Range.from(re[Te].range),command:this._commands.toInternal(re[Te].command,ie)});return pe}async resolveCodeLens(x,Q){const X=x.cacheId&&this._cache.get(...x.cacheId);if(!X)return;let re;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?re=X:re=await this._provider.resolveCodeLens(X,Q),re||(re=X),Q.isCancellationRequested)return;const q=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!q)return x.command=this._commands.toInternal(re.command??p._badCmd,q),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(qe){return Array.isArray(qe)?qe.map(D.DefinitionLink.from):qe?[D.DefinitionLink.from(qe)]:[]}class t{constructor(x,Q){this._documents=x,this._provider=Q}async provideDefinition(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideDefinition(re,q,X);return v(ie)}}class a{constructor(x,Q){this._documents=x,this._provider=Q}async provideDeclaration(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideDeclaration(re,q,X);return v(ie)}}class s{constructor(x,Q){this._documents=x,this._provider=Q}async provideImplementation(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideImplementation(re,q,X);return v(ie)}}class i{constructor(x,Q){this._documents=x,this._provider=Q}async provideTypeDefinition(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideTypeDefinition(re,q,X);return v(ie)}}class c{constructor(x,Q){this._documents=x,this._provider=Q}async provideHover(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideHover(re,q,X);if(!(!ie||(0,T.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=re.getWordRangeAtPosition(q)),ie.range||(ie.range=new S.Range(q,q)),D.Hover.from(ie)}}class f{constructor(x,Q){this._documents=x,this._provider=Q}async provideEvaluatableExpression(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideEvaluatableExpression(re,q,X);if(ie)return D.EvaluatableExpression.from(ie)}}class m{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlineValues(x,Q,X,re){const q=this._documents.getDocument(x),ie=await this._provider.provideInlineValues(q,D.Range.to(Q),D.InlineValueContext.to(X),re);if(Array.isArray(ie))return ie.map(pe=>D.InlineValue.from(pe))}}class _{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentHighlights(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideDocumentHighlights(re,q,X);if(Array.isArray(ie))return ie.map(D.DocumentHighlight.from)}}class I{constructor(x,Q){this._documents=x,this._provider=Q}async provideLinkedEditingRanges(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.provideLinkedEditingRanges(re,q,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,T.coalesce)(ie.ranges.map(D.Range.from)),wordPattern:ie.wordPattern}}}class r{constructor(x,Q){this._documents=x,this._provider=Q}async provideReferences(x,Q,X,re){const q=this._documents.getDocument(x),ie=D.Position.to(Q),pe=await this._provider.provideReferences(q,ie,X,re);if(Array.isArray(pe))return pe.map(D.location.from)}}class P{constructor(x,Q,X,re,q,ie,pe){this._documents=x,this._commands=Q,this._diagnostics=X,this._provider=re,this._logService=q,this._extension=ie,this._apiDeprecation=pe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Q,X,re){const q=this._documents.getDocument(x),ie=C.Selection.isISelection(Q)?D.Selection.to(Q):D.Range.to(Q),pe=[];for(const Z of this._diagnostics.getDiagnostics(x))if(ie.intersection(Z.range)&&pe.push(Z)>P._maxCodeActionsPerFile)break;const Te={diagnostics:pe,only:X.only?new S.CodeActionKind(X.only):void 0,triggerKind:D.CodeActionTriggerKind.to(X.trigger)},Be=await this._provider.provideCodeActions(q,ie,Te,re);if(!(0,T.isNonEmptyArray)(Be)||re.isCancellationRequested)return;const ve=this._cache.add(Be),Ke=new l.DisposableStore;this._disposables.set(ve,Ke);const z=[];for(let Z=0;Z<Be.length;Z++){const fe=Be[Z];!fe||(P._isCommand(fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),z.push({_isSynthetic:!0,title:fe.title,command:this._commands.toInternal(fe,Ke)})):(Te.only&&(fe.kind?Te.only.contains(fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),z.push({cacheId:[ve,Z],title:fe.title,command:fe.command&&this._commands.toInternal(fe.command,Ke),diagnostics:fe.diagnostics&&fe.diagnostics.map(D.Diagnostic.from),edit:fe.edit&&D.WorkspaceEdit.from(fe.edit),kind:fe.kind&&fe.kind.value,isPreferred:fe.isPreferred,disabled:fe.disabled?.reason})))}return{cacheId:ve,actions:z}}async resolveCodeAction(x,Q){const[X,re]=x,q=this._cache.get(X,re);if(!q||P._isCommand(q)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(q,Q)??q;return ie?.edit?D.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}P._maxCodeActionsPerFile=1e3;class F{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentFormattingEdits(x,Q,X){const re=this._documents.getDocument(x),q=await this._provider.provideDocumentFormattingEdits(re,Q,X);if(Array.isArray(q))return q.map(D.TextEdit.from)}}class B{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeFormattingEdits(x,Q,X,re){const q=this._documents.getDocument(x),ie=D.Range.to(Q),pe=await this._provider.provideDocumentRangeFormattingEdits(q,ie,X,re);if(Array.isArray(pe))return pe.map(D.TextEdit.from)}}class j{constructor(x,Q){this._documents=x,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Q,X,re,q){const ie=this._documents.getDocument(x),pe=D.Position.to(Q),Te=await this._provider.provideOnTypeFormattingEdits(ie,pe,X,re,q);if(Array.isArray(Te))return Te.map(D.TextEdit.from)}}class ae{constructor(x,Q){this._provider=x,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Q){const X=k.IdObject.mixin({symbols:[]}),re=await this._provider.provideWorkspaceSymbols(x,Q);if((0,T.isNonEmptyArray)(re))for(const q of re){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ie=k.IdObject.mixin(D.WorkspaceSymbol.from(q));this._symbolCache.set(ie._id,q),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(x,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const X=this._symbolCache.get(x._id);if(X){const re=await this._provider.resolveWorkspaceSymbol(X,Q);return re&&(0,R.mixin)(x,D.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(x){const Q=this._resultCache.get(x);if(Q){for(let[X,re]=Q;X<=re;X++)this._symbolCache.delete(X);this._resultCache.delete(x)}}}class oe{constructor(x,Q,X){this._documents=x,this._provider=Q,this._logService=X}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Q,X,re){const q=this._documents.getDocument(x),ie=D.Position.to(Q);try{const pe=await this._provider.provideRenameEdits(q,ie,X,re);return pe?D.WorkspaceEdit.from(pe):void 0}catch(pe){const Te=oe._asMessage(pe);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(x,Q,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(x),q=D.Position.to(Q);try{const ie=await this._provider.prepareRename(re,q,X);let pe,Te;if(S.Range.isRange(ie)?(pe=ie,Te=re.getText(ie)):(0,n.isObject)(ie)&&(pe=ie.range,Te=ie.placeholder),!pe||!Te)return;if(pe.start.line>q.line||pe.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(pe),text:Te}}catch(ie){const pe=oe._asMessage(ie);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class V{constructor(x,Q){this.resultId=x,this.tokens=Q}}class H{constructor(x,Q){this._documents=x,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Q,X){const re=this._documents.getDocument(x),q=Q!==0?this._previousResults.get(Q):null;let ie=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(re,q.resultId,X):await this._provider.provideDocumentSemanticTokens(re,X);return q&&this._previousResults.delete(Q),ie?(ie=H._fixProvidedSemanticTokens(ie),this._send(H._convertToEdits(q,ie),ie)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return H._isSemanticTokens(x)?H._isCorrectSemanticTokens(x)?x:new S.SemanticTokens(new Uint32Array(x.data),x.resultId):H._isSemanticTokensEdits(x)?H._isCorrectSemanticTokensEdits(x)?x:new S.SemanticTokensEdits(x.edits.map(Q=>new S.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Q of x.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Q){if(!H._isSemanticTokens(Q)||!x||!x.tokens)return Q;const X=x.tokens,re=X.length,q=Q.data,ie=q.length;let pe=0;const Te=Math.min(re,ie);for(;pe<Te&&X[pe]===q[pe];)pe++;if(pe===re&&pe===ie)return new S.SemanticTokensEdits([],Q.resultId);let Be=0;const ve=Te-pe;for(;Be<ve&&X[re-Be-1]===q[ie-Be-1];)Be++;return new S.SemanticTokensEdits([{start:pe,deleteCount:re-pe-Be,data:q.subarray(pe,ie-Be)}],Q.resultId)}_send(x,Q){if(H._isSemanticTokens(x)){const X=this._nextResultId++;return this._previousResults.set(X,new V(x.resultId,x.data)),(0,h.encodeSemanticTokensDto)({id:X,type:"full",data:x.data})}if(H._isSemanticTokensEdits(x)){const X=this._nextResultId++;return H._isSemanticTokens(Q)?this._previousResults.set(X,new V(Q.resultId,Q.data)):this._previousResults.set(X,new V(x.resultId)),(0,h.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(x.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class M{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeSemanticTokens(x,Q,X){const re=this._documents.getDocument(x),q=await this._provider.provideDocumentRangeSemanticTokens(re,D.Range.to(Q),X);return q?this._send(q):null}_send(x){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=M;class K{constructor(x,Q,X,re,q){this._documents=x,this._commands=Q,this._provider=X,this._apiDeprecation=re,this._extension=q,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Q,X,re){const q=this._documents.getDocument(x),ie=D.Position.to(Q),pe=q.getWordRangeAtPosition(ie)||new S.Range(ie,ie),Te=pe.with({end:ie}),Be=new b.StopWatch(!0),ve=await this._provider.provideCompletionItems(q,ie,re,D.CompletionContext.to(X));if(!ve||re.isCancellationRequested)return;const Ke=Array.isArray(ve)?new S.CompletionList(ve):ve,z=K.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),Z=new l.DisposableStore;this._disposables.set(z,Z);const fe=[],Oe={x:z,b:fe,a:{replace:D.Range.from(pe),insert:D.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Be.elapsed()};for(let Ne=0;Ne<Ke.items.length;Ne++){const Xe=Ke.items[Ne],De=this._convertCompletionItem(Xe,[z,Ne],Te,pe);fe.push(De)}return Oe}async resolveCompletionItem(x,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...x);if(!X)return;const re=await this._provider.resolveCompletionItem(X,Q);if(!!re)return this._convertCompletionItem(re,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Q,X,re){const q=this._disposables.get(Q[0]);if(!q)throw Error("DisposableStore is missing...");const ie={x:Q,a:x.label,b:x.kind!==void 0?D.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(D.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(x.command,q)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=x.textEdit.newText):typeof x.insertText=="string"?ie.h=x.insertText:x.insertText instanceof S.SnippetString&&(ie.h=x.insertText.value,ie.i|=4);let pe;return x.textEdit?pe=x.textEdit.range:x.range&&(pe=x.range),S.Range.isRange(pe)?ie.j=D.Range.from(pe):pe&&(!X?.isEqual(pe.inserting)||!re?.isEqual(pe.replacing))&&(ie.j={insert:D.Range.from(pe.inserting),replace:D.Range.from(pe.replacing)}),ie}}class N{constructor(x,Q,X){this._documents=x,this._provider=Q,this._commands=X,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Q,X,re){const q=this._documents.getDocument(x),ie=D.Position.to(Q),pe=await this._provider.provideInlineCompletionItems(q,ie,X,re);if(!pe||re.isCancellationRequested)return;const Te=(0,n.isArray)(pe)?{items:pe}:pe,Be=this._cache.add(Te.items);let ve;return{pid:Be,items:Te.items.map((Ke,z)=>{let Z;return Ke.command&&(ve||(ve=new l.DisposableStore,this._disposables.set(Be,ve)),Z=this._commands.toInternal(Ke.command,ve)),{text:Ke.text,range:Ke.range?D.Range.from(Ke.range):void 0,command:Z,idx:z}})}}disposeCompletions(x){this._cache.delete(x);const Q=this._disposables.get(x);Q&&Q.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Q){const X=this._cache.get(x,Q);X&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new A.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Q=G.map.get(x);return Q||(Q=new G,G.map.set(x,Q)),Q}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=G,G.map=new WeakMap;class me{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(x,Q,X,re){const q=this._documents.getDocument(x),ie=D.Position.to(Q),pe=this.reviveContext(X),Te=await this._provider.provideSignatureHelp(q,ie,re,pe);if(Te){const Be=this._cache.add([Te]);return{...D.SignatureHelp.from(Te),id:Be}}}reviveContext(x){let Q;if(x.activeSignatureHelp){const X=D.SignatureHelp.to(x.activeSignatureHelp),re=this._cache.get(x.activeSignatureHelp.id,0);re?(Q=re,Q.activeSignature=X.activeSignature,Q.activeParameter=X.activeParameter):Q=X}return{...x,activeSignatureHelp:Q}}releaseSignatureHelp(x){this._cache.delete(x)}}class W{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlayHints(x,Q,X){const re=this._documents.getDocument(x),q=await this._provider.provideInlayHints(re,D.Range.to(Q),X);return q?{hints:q.map(D.InlayHint.from)}:void 0}}class ne{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new g.Cache("DocumentLink")}async provideLinks(x,Q){const X=this._documents.getDocument(x),re=await this._provider.provideDocumentLinks(X,Q);if(!(!Array.isArray(re)||re.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(ne._validateLink).map(D.DocumentLink.from)};{const q=this._cache.add(re),ie={links:[],id:q};for(let pe=0;pe<re.length;pe++){if(!ne._validateLink(re[pe]))continue;const Te=D.DocumentLink.from(re[pe]);Te.cacheId=[q,pe],ie.links.push(Te)}return ie}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...x);if(!X)return;const re=await this._provider.resolveDocumentLink(X,Q);if(!(!re||!ne._validateLink(re)))return D.DocumentLink.from(re)}releaseLinks(x){this._cache.delete(x)}}class ge{constructor(x,Q){this._documents=x,this._provider=Q}async provideColors(x,Q){const X=this._documents.getDocument(x),re=await this._provider.provideDocumentColors(X,Q);return Array.isArray(re)?re.map(ie=>({color:D.Color.from(ie.color),range:D.Range.from(ie.range)})):[]}async provideColorPresentations(x,Q,X){const re=this._documents.getDocument(x),q=D.Range.to(Q.range),ie=D.Color.to(Q.color),pe=await this._provider.provideColorPresentations(ie,{document:re,range:q},X);if(!!Array.isArray(pe))return pe.map(D.ColorPresentation.from)}}class _e{constructor(x,Q){this._documents=x,this._provider=Q}async provideFoldingRanges(x,Q,X){const re=this._documents.getDocument(x),q=await this._provider.provideFoldingRanges(re,Q,X);if(!!Array.isArray(q))return q.map(D.FoldingRange.from)}}class Me{constructor(x,Q,X){this._documents=x,this._provider=Q,this._logService=X}async provideSelectionRanges(x,Q,X){const re=this._documents.getDocument(x),q=Q.map(D.Position.to),ie=await this._provider.provideSelectionRanges(re,q,X);if(!(0,T.isNonEmptyArray)(ie))return[];if(ie.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Te=0;Te<q.length;Te++){const Be=[];pe.push(Be);let ve=q[Te],Ke=ie[Te];for(;;){if(!Ke.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(D.SelectionRange.from(Ke)),!Ke.parent)break;ve=Ke.range,Ke=Ke.parent}}return pe}}class Fe{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.prepareCallHierarchy(re,q,X);if(!ie)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ie)?ie.map(Te=>this._cacheAndConvertItem(pe,Te)):[this._cacheAndConvertItem(pe,ie)]}async provideCallsTo(x,Q,X){const re=this._itemFromCache(x,Q);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(re,X);if(!!q)return q.map(ie=>({from:this._cacheAndConvertItem(x,ie.from),fromRanges:ie.fromRanges.map(pe=>D.Range.from(pe))}))}async provideCallsFrom(x,Q,X){const re=this._itemFromCache(x,Q);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(re,X);if(!!q)return q.map(ie=>({to:this._cacheAndConvertItem(x,ie.to),fromRanges:ie.fromRanges.map(pe=>D.Range.from(pe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const X=this._cache.get(x),re=D.CallHierarchyItem.from(Q,x,X.size.toString(36));return X.set(re._itemId,Q),re}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class xe{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,X){const re=this._documents.getDocument(x),q=D.Position.to(Q),ie=await this._provider.prepareTypeHierarchy(re,q,X);if(!ie)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ie)?ie.map(Te=>this._cacheAndConvertItem(pe,Te)):[this._cacheAndConvertItem(pe,ie)]}async provideSupertypes(x,Q,X){const re=this._itemFromCache(x,Q);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(x,ie))}async provideSubtypes(x,Q,X){const re=this._itemFromCache(x,Q);if(!re)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(re,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(x,ie))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const X=this._cache.get(x),re=D.TypeHierarchyItem.from(Q,x,X.size.toString(36));return X.set(re._itemId,Q),re}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Ye{constructor(x,Q){this.adapter=x,this.extension=Q}}class Ve{constructor(x,Q,X,re,q,ie,pe){this._adapter=new Map,this._uriTransformer=Q,this._proxy=x.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=re,this._diagnostics=q,this._logService=ie,this._apiDeprecation=pe}_transformDocumentSelector(x){return(0,T.coalesce)((0,T.asArray)(x).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:D.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new S.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Ve._handlePool++}_withAdapter(x,Q,X,re,q=!1){const ie=this._adapter.get(x);if(!ie)return Promise.resolve(re);if(ie.adapter instanceof Q){let pe;ie.extension&&(pe=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Te=X(ie.adapter,ie.extension),Be=ie.extension;return Be&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-pe}ms`),ve=>{q&&ve instanceof w.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(ve))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Q){const X=this._nextHandle();return this._adapter.set(X,new Ye(x,Q)),X}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Q,X,re){const q=this._addNewAdapter(new o(this._documents,X),x),ie=re&&re.label||Ve._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(Q),ie),this._createDisposable(q)}$provideDocumentSymbols(x,Q,X){return this._withAdapter(x,o,re=>re.provideDocumentSymbols(d.URI.revive(Q),X),void 0)}registerCodeLensProvider(x,Q,X){const re=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ye(new p(this._documents,this._commands.converter,X),x)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Q),q);let ie=this._createDisposable(re);if(q!==void 0){const pe=X.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(q));ie=S.Disposable.from(ie,pe)}return ie}$provideCodeLenses(x,Q,X){return this._withAdapter(x,p,re=>re.provideCodeLenses(d.URI.revive(Q),X),void 0)}$resolveCodeLens(x,Q,X){return this._withAdapter(x,p,re=>re.resolveCodeLens(Q,X),void 0)}$releaseCodeLenses(x,Q){this._withAdapter(x,p,X=>Promise.resolve(X.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(x,Q,X){const re=this._addNewAdapter(new t(this._documents,X),x);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDefinition(x,Q,X,re){return this._withAdapter(x,t,q=>q.provideDefinition(d.URI.revive(Q),X,re),[])}registerDeclarationProvider(x,Q,X){const re=this._addNewAdapter(new a(this._documents,X),x);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDeclaration(x,Q,X,re){return this._withAdapter(x,a,q=>q.provideDeclaration(d.URI.revive(Q),X,re),[])}registerImplementationProvider(x,Q,X){const re=this._addNewAdapter(new s(this._documents,X),x);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideImplementation(x,Q,X,re){return this._withAdapter(x,s,q=>q.provideImplementation(d.URI.revive(Q),X,re),[])}registerTypeDefinitionProvider(x,Q,X){const re=this._addNewAdapter(new i(this._documents,X),x);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideTypeDefinition(x,Q,X,re){return this._withAdapter(x,i,q=>q.provideTypeDefinition(d.URI.revive(Q),X,re),[])}registerHoverProvider(x,Q,X,re){const q=this._addNewAdapter(new c(this._documents,X),x);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideHover(x,Q,X,re){return this._withAdapter(x,c,q=>q.provideHover(d.URI.revive(Q),X,re),void 0)}registerEvaluatableExpressionProvider(x,Q,X,re){const q=this._addNewAdapter(new f(this._documents,X),x);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideEvaluatableExpression(x,Q,X,re){return this._withAdapter(x,f,q=>q.provideEvaluatableExpression(d.URI.revive(Q),X,re),void 0)}registerInlineValuesProvider(x,Q,X,re){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new m(this._documents,X),x);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(Q),q);let pe=this._createDisposable(ie);if(q!==void 0){const Te=X.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(q));pe=S.Disposable.from(pe,Te)}return pe}$provideInlineValues(x,Q,X,re,q){return this._withAdapter(x,m,ie=>ie.provideInlineValues(d.URI.revive(Q),X,re,q),void 0)}registerDocumentHighlightProvider(x,Q,X){const re=this._addNewAdapter(new _(this._documents,X),x);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentHighlights(x,Q,X,re){return this._withAdapter(x,_,q=>q.provideDocumentHighlights(d.URI.revive(Q),X,re),void 0)}registerLinkedEditingRangeProvider(x,Q,X){const re=this._addNewAdapter(new I(this._documents,X),x);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideLinkedEditingRanges(x,Q,X,re){return this._withAdapter(x,I,async q=>{const ie=await q.provideLinkedEditingRanges(d.URI.revive(Q),X,re);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ve._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Q,X){const re=this._addNewAdapter(new r(this._documents,X),x);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideReferences(x,Q,X,re,q){return this._withAdapter(x,r,ie=>ie.provideReferences(d.URI.revive(Q),X,re,q),void 0)}registerCodeActionProvider(x,Q,X,re){const q=new l.DisposableStore,ie=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,X,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(Q),{providedKinds:re?.providedCodeActionKinds?.map(pe=>pe.value),documentation:re?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,q)}))},Ve._extLabel(x),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ie)),q}$provideCodeActions(x,Q,X,re,q){return this._withAdapter(x,P,ie=>ie.provideCodeActions(d.URI.revive(Q),X,re,q),void 0)}$resolveCodeAction(x,Q,X){return this._withAdapter(x,P,re=>re.resolveCodeAction(Q,X),void 0)}$releaseCodeActions(x,Q){this._withAdapter(x,P,X=>Promise.resolve(X.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(x,Q,X){const re=this._addNewAdapter(new F(this._documents,X),x);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(re)}$provideDocumentFormattingEdits(x,Q,X,re){return this._withAdapter(x,F,q=>q.provideDocumentFormattingEdits(d.URI.revive(Q),X,re),void 0)}registerDocumentRangeFormattingEditProvider(x,Q,X){const re=this._addNewAdapter(new B(this._documents,X),x);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(x,Q,X,re,q){return this._withAdapter(x,B,ie=>ie.provideDocumentRangeFormattingEdits(d.URI.revive(Q),X,re,q),void 0)}registerOnTypeFormattingEditProvider(x,Q,X,re){const q=this._addNewAdapter(new j(this._documents,X),x);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(Q),re,x.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(x,Q,X,re,q,ie){return this._withAdapter(x,j,pe=>pe.provideOnTypeFormattingEdits(d.URI.revive(Q),X,re,q,ie),void 0)}registerWorkspaceSymbolProvider(x,Q){const X=this._addNewAdapter(new ae(Q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(x,Q,X){return this._withAdapter(x,ae,re=>re.provideWorkspaceSymbols(Q,X),{symbols:[]})}$resolveWorkspaceSymbol(x,Q,X){return this._withAdapter(x,ae,re=>re.resolveWorkspaceSymbol(Q,X),void 0)}$releaseWorkspaceSymbols(x,Q){this._withAdapter(x,ae,X=>X.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(x,Q,X){const re=this._addNewAdapter(new oe(this._documents,X,this._logService),x);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Q),oe.supportsResolving(X)),this._createDisposable(re)}$provideRenameEdits(x,Q,X,re,q){return this._withAdapter(x,oe,ie=>ie.provideRenameEdits(d.URI.revive(Q),X,re,q),void 0)}$resolveRenameLocation(x,Q,X,re){return this._withAdapter(x,oe,q=>q.resolveRenameLocation(d.URI.revive(Q),X,re),void 0)}registerDocumentSemanticTokensProvider(x,Q,X,re){const q=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Ye(new H(this._documents,X),x)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(Q),re,ie);let pe=this._createDisposable(q);if(ie){const Te=X.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(ie));pe=S.Disposable.from(pe,Te)}return pe}$provideDocumentSemanticTokens(x,Q,X,re){return this._withAdapter(x,H,q=>q.provideDocumentSemanticTokens(d.URI.revive(Q),X,re),null,!0)}$releaseDocumentSemanticTokens(x,Q){this._withAdapter(x,H,X=>X.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(x,Q,X,re){const q=this._addNewAdapter(new M(this._documents,X),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(Q),re),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(x,Q,X,re){return this._withAdapter(x,M,q=>q.provideDocumentRangeSemanticTokens(d.URI.revive(Q),X,re),null,!0)}registerCompletionItemProvider(x,Q,X,re){const q=this._addNewAdapter(new K(this._documents,this._commands.converter,X,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(Q),re,K.supportsResolving(X),`${x.identifier.value}(${re.join("")})`),this._createDisposable(q)}$provideCompletionItems(x,Q,X,re,q){return this._withAdapter(x,K,ie=>ie.provideCompletionItems(d.URI.revive(Q),X,re,q),void 0)}$resolveCompletionItem(x,Q,X){return this._withAdapter(x,K,re=>re.resolveCompletionItem(Q,X),void 0)}$releaseCompletionItems(x,Q){this._withAdapter(x,K,X=>X.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(x,Q,X){const re=this._addNewAdapter(new N(this._documents,X,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideInlineCompletions(x,Q,X,re,q){return this._withAdapter(x,N,ie=>ie.provideInlineCompletions(d.URI.revive(Q),X,re,q),void 0)}$handleInlineCompletionDidShow(x,Q,X){this._withAdapter(x,N,async re=>{re.handleDidShowCompletionItem(Q,X)},void 0)}$freeInlineCompletionsList(x,Q){this._withAdapter(x,N,async X=>{X.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(x,Q,X,re){const q=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,ie=this._addNewAdapter(new me(this._documents,X),x);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(Q),q),this._createDisposable(ie)}$provideSignatureHelp(x,Q,X,re,q){return this._withAdapter(x,me,ie=>ie.provideSignatureHelp(d.URI.revive(Q),X,re,q),void 0)}$releaseSignatureHelp(x,Q){this._withAdapter(x,me,X=>X.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(x,Q,X){const re=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new W(this._documents,X),x);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(Q),re);let ie=this._createDisposable(q);if(re!==void 0){const pe=X.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(re));ie=S.Disposable.from(ie,pe)}return ie}$provideInlayHints(x,Q,X,re){return this._withAdapter(x,W,q=>q.provideInlayHints(d.URI.revive(Q),X,re),void 0)}registerDocumentLinkProvider(x,Q,X){const re=this._addNewAdapter(new ne(this._documents,X),x);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Q),typeof X.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(x,Q,X){return this._withAdapter(x,ne,re=>re.provideLinks(d.URI.revive(Q),X),void 0)}$resolveDocumentLink(x,Q,X){return this._withAdapter(x,ne,re=>re.resolveLink(Q,X),void 0)}$releaseDocumentLinks(x,Q){this._withAdapter(x,ne,X=>X.releaseLinks(Q),void 0)}registerColorProvider(x,Q,X){const re=this._addNewAdapter(new ge(this._documents,X),x);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentColors(x,Q,X){return this._withAdapter(x,ge,re=>re.provideColors(d.URI.revive(Q),X),[])}$provideColorPresentations(x,Q,X,re){return this._withAdapter(x,ge,q=>q.provideColorPresentations(d.URI.revive(Q),X,re),void 0)}registerFoldingRangeProvider(x,Q,X){const re=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ye(new _e(this._documents,X),x)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Q),q);let ie=this._createDisposable(re);if(q!==void 0){const pe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ie=S.Disposable.from(ie,pe)}return ie}$provideFoldingRanges(x,Q,X,re){return this._withAdapter(x,_e,q=>q.provideFoldingRanges(d.URI.revive(Q),X,re),void 0)}registerSelectionRangeProvider(x,Q,X){const re=this._addNewAdapter(new Me(this._documents,X,this._logService),x);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideSelectionRanges(x,Q,X,re){return this._withAdapter(x,Me,q=>q.provideSelectionRanges(d.URI.revive(Q),X,re),[])}registerCallHierarchyProvider(x,Q,X){const re=this._addNewAdapter(new Fe(this._documents,X),x);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$prepareCallHierarchy(x,Q,X,re){return this._withAdapter(x,Fe,q=>Promise.resolve(q.prepareSession(d.URI.revive(Q),X,re)),void 0)}$provideCallHierarchyIncomingCalls(x,Q,X,re){return this._withAdapter(x,Fe,q=>q.provideCallsTo(Q,X,re),void 0)}$provideCallHierarchyOutgoingCalls(x,Q,X,re){return this._withAdapter(x,Fe,q=>q.provideCallsFrom(Q,X,re),void 0)}$releaseCallHierarchy(x,Q){this._withAdapter(x,Fe,X=>Promise.resolve(X.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(x,Q,X){const re=this._addNewAdapter(new xe(this._documents,X),x);return this._proxy.$registerTypeHierarchyProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$prepareTypeHierarchy(x,Q,X,re){return this._withAdapter(x,xe,q=>Promise.resolve(q.prepareSession(d.URI.revive(Q),X,re)),void 0)}$provideTypeHierarchySupertypes(x,Q,X,re){return this._withAdapter(x,xe,q=>q.provideSupertypes(Q,X,re),void 0)}$provideTypeHierarchySubtypes(x,Q,X,re){return this._withAdapter(x,xe,q=>q.provideSubtypes(Q,X,re),void 0)}$releaseTypeHierarchy(x,Q){this._withAdapter(x,xe,X=>Promise.resolve(X.releaseSession(Q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,E.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Ve._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Ve._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Ve._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Ve._serializeRegExp(x.beforeText),afterText:x.afterText?Ve._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Ve._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(x,Q,X){let{wordPattern:re}=X;if(re&&(0,E.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Q,re):this._documents.setWordDefinitionFor(Q,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const q=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,Q,ie),this._createDisposable(q)}$setWordDefinitions(x){for(const Q of x)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(we[202],be([0,1,5,9,7,36,15]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(T,n){this._handlePool=0,this._proxy=T.getProxy(d.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(T,n){await this._proxy.$changeLanguage(T,n);const C=this._documents.getDocumentData(T);if(!C)throw new Error(`document '${T.toString}' NOT found`);return C.document}async tokenAtPosition(T,n){const C=T.version,l=R.Position.from(n),h=await this._proxy.$tokensAtPosition(T.uri,l),u={type:D.StandardTokenType.Other,range:T.getWordRangeAtPosition(n)??new D.Range(n.line,n.character,n.line,n.character)};if(!h)return u;const g={range:R.Range.to(h.range),type:R.TokenType.to(h.type)};return!g.range.contains(n)||C!==T.version?u:g}createLanguageStatusItem(T){const n=this._handlePool++,C=this._proxy,l={selector:T,text:"",detail:"",severity:D.LanguageStatusSeverity.Information};let h;const u=()=>{h?.dispose(),h=(0,k.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:l.selector,text:l.text,message:typeof l.detail=="string"?l.detail:R.MarkdownString.from(l.detail),severity:l.severity===D.LanguageStatusSeverity.Error?S.default.Error:l.severity===D.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info})},0)},g={get selector(){return l.selector},set selector(b){l.selector=b,u()},get text(){return l.text},set text(b){l.text=b,u()},get detail(){return l.detail},set detail(b){l.detail=b,u()},get severity(){return l.severity},set severity(b){l.severity=b,u()},dispose(){h?.dispose(),C.$removeLanguageStatus(n)}};return u(),g}}e.ExtHostLanguages=E}),define(we[203],be([0,1,5,16,30]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(E){return E&&E.title}let k=class{constructor(y,T){this._logService=T,this._proxy=y.getProxy(d.MainContext.MainThreadMessageService)}showMessage(y,T,n,C,l){const h={extension:y};let u;typeof C=="string"||S(C)?u=[C,...l]:(h.modal=C?.modal,h.useCustom=C?.useCustom,h.detail=C?.detail,u=l),h.useCustom&&(0,D.checkProposedApiEnabled)(y);const g=[];for(let b=0;b<u.length;b++){const w=u[b];if(typeof w=="string")g.push({title:w,handle:b,isCloseAffordance:!1});else if(typeof w=="object"){let{title:A,isCloseAffordance:o}=w;g.push({title:A,isCloseAffordance:!!o,handle:b})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(T,n,h,g).then(b=>{if(typeof b=="number")return u[b]})}};k=We([He(1,R.ILogService)],k),e.ExtHostMessageService=k}),define(we[204],be([0,1,24,3,43,6,21,8,10,2,66,5,9,7,180,101]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(A,o,p,v,t){this._textDocumentsAndEditors=p,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=A.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=A.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=A.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const s=a.notebookEditor?.notebookUri,i=a.cell.handle,f=this._documents.get(s)?.getCell(i);if(f)return f.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(A=>A.apiEditor)}getEditorById(A){const o=this._editors.get(A);if(!o)throw new Error(`unknown text editor: ${A}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(A){for(const[o,p]of this._editors)if(p.apiEditor===A)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(A,o){const p=this._documents.get(A);if(!p&&!o)throw new Error(`NO notebook document for '${A}'`);return p}_getProviderData(A){const o=this._notebookContentProviders.get(A);if(!o)throw new Error(`NO provider for '${A}'`);return o}registerNotebookContentProvider(A,o,p,v,t){if((0,E.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:A,provider:p});let a;return p.onDidChangeNotebookContentOptions&&(a=p.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(o,s)})),this._notebookProxy.$registerNotebookProvider({id:A.identifier,location:A.extensionLocation},o,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(A,t)),new h.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(A,o){if(!o)return;const p=o.filenamePattern.map(v=>l.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(o.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:A.identifier,providerDisplayName:A.displayName||A.name,displayName:o.displayName,filenamePattern:p,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(A,o,p){const v=b._notebookStatusBarItemProviderHandlePool++,t=typeof p.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,o);let a;return t!==void 0&&(a=p.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),a&&a.dispose()})}async createNotebookDocument(A){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:A.viewType,content:A.content&&l.NotebookData.from(A.content)});return T.URI.revive(o)}async openNotebookDocument(A){const o=this._documents.get(A);if(o)return o.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(A),v=this._documents.get(T.URI.revive(p));return(0,y.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(A,o){T.URI.isUri(A)&&(A=await this.openNotebookDocument(A));let p;typeof o=="object"?p={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:p={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(A.uri,A.notebookType,p),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(A,o,p,v){const t=this._notebookStatusBarItemProviders.get(A),a=T.URI.revive(o),s=this._documents.get(a);if(!s||!t)return;const i=s.getCellFromIndex(p);if(!i)return;const c=await t.provideCellStatusBarItems(i.apiCell,v);if(!c)return;const f=new S.DisposableStore,m=this._statusBarCache.add([f]),I=(Array.isArray(c)?c:[c]).map(r=>l.NotebookStatusBarItem.from(r,this._commandsConverter,f));return{cacheId:m,items:I}}$releaseNotebookCellStatusBarItems(A){this._statusBarCache.delete(A)}registerNotebookSerializer(A,o,p,v,t){if((0,E.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,p),this._notebookProxy.$registerNotebookSerializer(a,{id:A.identifier,location:A.extensionLocation},o,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(A,t)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(A,o,p){const v=this._notebookSerializer.get(A);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(o.buffer,p);return l.NotebookData.from(t)}async $notebookToData(A,o,p){const v=this._notebookSerializer.get(A);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(l.NotebookData.to(o),p);return d.VSBuffer.wrap(t)}async $openNotebook(A,o,p,v,t){const{provider:a}=this._getProviderData(A),s=await a.openNotebook(T.URI.revive(o),{backupId:p,untitledDocumentData:v?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(l.NotebookCellData.from)}}async $saveNotebook(A,o,p){const v=this.getNotebookDocument(T.URI.revive(o)),{provider:t}=this._getProviderData(A);return await t.saveNotebook(v.apiNotebook,p),!0}async $saveNotebookAs(A,o,p,v){const t=this.getNotebookDocument(T.URI.revive(o)),{provider:a}=this._getProviderData(A);return await a.saveNotebookAs(T.URI.revive(p),t.apiNotebook,v),!0}async $backupNotebook(A,o,p){const v=this.getNotebookDocument(T.URI.revive(o)),t=this._getProviderData(A),a=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,D.hash)([v.uri.toString(),this._backupIdPool++])),i=T.URI.joinPath(a,s),c=await t.provider.backupNotebook(v.apiNotebook,{destination:i},p);return v.updateBackup(c),c.id}_createExtHostEditor(A,o,p){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const v=new g.ExtHostNotebookEditor(o,this._notebookEditorsProxy,A,p.visibleRanges.map(l.NotebookRange.to),p.selections.map(l.NotebookRange.to),typeof p.viewColumn=="number"?l.ViewColumn.to(p.viewColumn):void 0);this._editors.set(o,v)}$acceptDocumentAndEditorsDelta(A){if(A.removedDocuments)for(const p of A.removedDocuments){const v=T.URI.revive(p),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===v.toString()&&this._editors.delete(a.id)}if(A.addedDocuments){const p=[];for(const v of A.addedDocuments){const t=T.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const a=this,s=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){a._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){a._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){a._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){a._onDidChangeCellExecutionState.fire(i)}},t,v);p.push(...v.cells.map(i=>u.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(A.addedEditors)for(const p of A.addedEditors){if(this._editors.has(p.id))return;const v=T.URI.revive(p.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,p.id,p)}const o=[];if(A.removedEditors)for(const p of A.removedEditors){const v=this._editors.get(p);v&&(this._editors.delete(p),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),o.push(v))}if(A.visibleEditors){this._visibleNotebookEditors=A.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const p=new Set;this._visibleNotebookEditors.forEach(v=>p.add(v.id));for(const v of this._editors.values()){const t=p.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}A.newActiveEditor===null?this._activeNotebookEditor=void 0:A.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(A.newActiveEditor)),A.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(we[205],be([0,1,3,55,16,5,13,9]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(C,l){const h=y._Keys.nextId();C.$registerNotebookEditorDecorationType(h,E.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){C.$removeNotebookEditorDecorationType(h)}}}}y._Keys=new R.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(C,l,h){this._logService=C,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new y(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,l);const h=this._notebooksAndEditors.getEditorById(C);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(E.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(E.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const l in C)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(E.ViewColumn.to(C[l]))}};T=We([He(0,D.ILogService),He(1,k.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(we[206],be([0,1,17,15,20,3,6,21,2,26,16,5,9,7,71,173,30]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,a,s,i){this._initData=a,this._extHostNotebook=s,this._logService=i,this._activeExecutions=new E.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(t,a,s,i,c,f){for(let N of this._kernelData.values())if(N.controller.id===a&&T.ExtensionIdentifier.equals(t.identifier,N.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const m=this._handlePool++,_=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${a}`);const I=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let r=!1;const P=new k.DisposableStore,F=new S.Emitter,B=new S.Emitter,j={id:`${t.identifier.value}/${a}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:f?f.map(l.NotebookRendererScript.from):[]};let ae=c??I,oe;this._proxy.$addKernel(m,j).catch(N=>{console.log(N),r=!0});let V=0;const H=()=>{if(r)return;const N=++V;Promise.resolve().then(()=>{N===V&&this._proxy.$updateKernel(m,j)})},M=new E.ResourceMap,K={get id(){return a},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return j.label},set label(N){j.label=N??t.displayName??t.name,H()},get detail(){return j.detail??""},set detail(N){j.detail=N,H()},get description(){return j.description??""},set description(N){j.description=N,H()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(N){j.supportedLanguages=N,H()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(N){j.supportsExecutionOrder=N,H()},get rendererScripts(){return j.preloads?j.preloads.map(l.NotebookRendererScript.to):[]},get executeHandler(){return ae},set executeHandler(N){ae=N??I},get interruptHandler(){return oe},set interruptHandler(N){oe=N,j.supportsInterrupt=Boolean(N),H()},createNotebookCellExecution(N){if(r)throw new Error("notebook controller is DISPOSED");if(!M.has(N.notebook.uri))throw _._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(G=>G.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return _._createNotebookCellExecution(N)},dispose:()=>{r||(this._logService.trace(`NotebookController[${m}], DISPOSED`),r=!0,this._kernelData.delete(m),P.dispose(),F.dispose(),B.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(N,G){_._proxy.$updateNotebookPriority(m,N.uri,G)},onDidReceiveMessage:B.event,postMessage(N,G){return(0,b.checkProposedApiEnabled)(t),_._proxy.$postMessage(m,G&&_._extHostNotebook.getIdByEditor(G),N)},asWebviewUri(N){return(0,b.checkProposedApiEnabled)(t),(0,u.asWebviewUri)(N,_._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:K,onDidReceiveMessage:B,onDidChangeSelection:F,associatedNotebooks:M}),K}$acceptNotebookAssociation(t,a,s){const i=this._kernelData.get(t);if(i){const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(a));s?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:c.apiNotebook})}}async $executeCells(t,a,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(a)),f=[];for(let m of s){const _=c.getCell(m);_&&f.push(_.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),f.length),await i.controller.executeHandler.call(i.controller,f,c.apiNotebook,i.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,a,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(a));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(let f of s){const m=c.getCell(f);m&&this._activeExecutions.get(m.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,a,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getEditorById(a);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new o(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,i);const c=i.onDidChangeState(()=>{i.state===A.Resolved&&(i.dispose(),c.dispose(),this._activeExecutions.delete(s.uri))});return i.asApiObject()}};w=We([He(3,n.ILogService)],w),e.ExtHostNotebookKernels=w;var A;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(A||(A={}));class o extends k.Disposable{constructor(t,a,s){super();this._document=t,this._cell=a,this._proxy=s,this._handle=o.HANDLE++,this._onDidChangeState=new S.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=A.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new p(10,i=>this.update(i)),this._executionOrder=a.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const a=Array.isArray(t)?t:[t];return this._proxy.$updateExecutions(a)}verifyStateForOutput(){if(this._state===A.Init)throw new Error("Must call start before modifying cell output");if(this._state===A.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(t){let a=this._cell;if(t&&(a=this._document.getCellFromApiCell(t)),!a)throw new Error("INVALID cell");return a.handle}validateAndConvertOutputs(t){return t.map(a=>{const s=h.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return s===a.items?l.NotebookCellOutput.from(a):l.NotebookCellOutput.from({items:s,id:a.id,metadata:a.metadata})})}async updateOutputs(t,a,s){const i=this.cellIndexToHandle(a),c=this.validateAndConvertOutputs((0,d.asArray)(t));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:i,append:s,outputs:c})}async updateOutputItems(t,a,s){return t=h.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(t),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:t.map(l.NotebookCellOutputItem.from),outputId:a.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:t._handle,executionOrder:t._executionOrder}])},start(s){if(t._state===A.Resolved||t._state===A.Started)throw new Error("Cannot call start again");t._state=A.Started,t._onDidChangeState.fire(),t.update({editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:t._handle,runStartTime:s})},end(s,i){if(t._state===A.Resolved)throw new Error("Cannot call resolve twice");t._state=A.Resolved,t._onDidChangeState.fire(),t.updateSoon({editType:g.CellExecutionUpdateType.Complete,executionHandle:t._handle,runEndTime:i,lastRunSuccess:s}),t._collector.flush(),t._proxy.$removeExecution(t._handle)},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!0)},replaceOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!1)},appendOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!0)},replaceOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!1)}})}}o.HANDLE=0;class p{constructor(t,a){this.delay=t,this.callback=a,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,R.timeout)(this.delay).then(()=>this.flush())),this.waitPromise}flush(){this.waitPromise=void 0;const t=this.batch;return this.batch=[],this.callback(t)}}}),define(we[207],be([0,1,3,5,101]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(E,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,y,T){const n=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:T})}createRendererMessaging(E,y){if(!E.contributes?.notebookRenderer?.some(l=>l.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const T=!!E.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(l,h,u)=>{const g=T?l:b=>{const w={};n.set(w,b.editor),l({editor:w,message:b.message})};return this.getOrCreateEmitterFor(y).event(g,h,u)},postMessage:(l,h)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,h]=[h,l]);const u=T?h:n.get(h),g=u&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(g?.id,y,l)}}}getOrCreateEmitterFor(E){let y=this._rendererMessageEmitters.get(E);return y||(y=new d.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,y),y)}}e.ExtHostNotebookRenderers=S}),define(we[105],be([0,1,5,3,6,24,4,13]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends D.Disposable{constructor(u,g,b,w,A){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=A,this._id=A.$register(this.name,g,b,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?S.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(g=>this._proxy.$clear(g,u))}show(u,g){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof u=="boolean"?u:g)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class T extends y{constructor(u,g,b){super(u,!1,void 0,g,b)}append(u){super.append(u),this._id.then(g=>this._proxy.$append(g,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class n extends y{constructor(u,g,b){super(u,!0,g,void 0,b)}append(u){throw new Error("Not supported")}}class C{constructor(u,g){this.name=u,this._channel=g}append(u){this._channel.then(g=>g.append(u))}appendLine(u){this._channel.then(g=>g.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,g){this._channel.then(b=>b.show(u,g))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=C;let l=class{constructor(u){this._proxy=u.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new T(u,g.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new n(u,g,this._proxy)}};l=We([He(0,E.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(we[208],be([0,1,15,20,3,6,5,2,7,12,17,36,46]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(u,g,b){const w=u.getProxy(k.MainContext.MainThreadQuickOpen);class A{constructor(f,m){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=m}showQuickPick(f,m,_,I=R.CancellationToken.None){this._onDidSelectItem=void 0;const r=Promise.resolve(f),P=++this._instances,F=w.$show(P,{title:_?.title,placeHolder:_?.placeHolder,matchOnDescription:_?.matchOnDescription,matchOnDetail:_?.matchOnDetail,ignoreFocusLost:_?.ignoreFocusOut,canPickMany:_?.canPickMany},I),B={},j=F.then(()=>B);return Promise.race([j,r]).then(ae=>{if(ae!==B)return r.then(oe=>{const V=[];for(let H=0;H<oe.length;H++){const M=oe[H];let K,N,G,me,W;typeof M=="string"?K=M:(K=M.label,N=M.description,G=M.detail,me=M.picked,W=M.alwaysShow),V.push({label:K,description:N,handle:H,detail:G,picked:me,alwaysShow:W})}return _&&typeof _.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{_.onDidSelectItem(oe[H])}),w.$setItems(P,V),F.then(H=>{if(typeof H=="number")return oe[H];if(Array.isArray(H))return H.map(M=>oe[M])})})}).then(void 0,ae=>{if(!(0,T.isPromiseCanceledError)(ae))return w.$setError(P,ae),Promise.reject(ae)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,m=R.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,w.$input(f,typeof this._validateInput=="function",m).then(void 0,_=>{if(!(0,T.isPromiseCanceledError)(_))return Promise.reject(_)})}$validateInput(f){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,m=R.CancellationToken.None){const _=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!_)return;const I=await this._workspace.getWorkspaceFolders2();if(!!I)return I.find(r=>r.uri.toString()===_.uri.toString())}createQuickPick(f,m){const _=new s(f,m,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}createInputBox(f){const m=new i(f,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(f,m){const _=this._sessions.get(f);_&&_._fireDidChangeValue(m)}$onDidAccept(f){const m=this._sessions.get(f);m&&m._fireDidAccept()}$onDidChangeActive(f,m){const _=this._sessions.get(f);_ instanceof s&&_._fireDidChangeActive(m)}$onDidChangeSelection(f,m){const _=this._sessions.get(f);_ instanceof s&&_._fireDidChangeSelection(m)}$onDidTriggerButton(f,m){const _=this._sessions.get(f);_&&_._fireDidTriggerButton(m)}$onDidTriggerItemButton(f,m,_){const I=this._sessions.get(f);I instanceof s&&I._fireDidTriggerItemButton(m,_)}$onDidHide(f){const m=this._sessions.get(f);m&&m._fireDidHide()}}class o{constructor(f,m){this._extensionId=f,this._onDidDispose=m,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((m,_)=>{const I=m===y.QuickInputButtons.Back?-1:_;this._handlesToButtons.set(I,m)}),this.update({buttons:f.map((m,_)=>({...a(m),tooltip:m.tooltip,handle:m===y.QuickInputButtons.Back?-1:_}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const m=this._handlesToButtons.get(f);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(f){if(!this._disposed){for(const m of Object.keys(f)){const _=f[m];this._pendingUpdate[m]=_===void 0?null:_}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function p(c){if(c instanceof y.ThemeIcon)return{id:c.id};const f=t(c),m=v(c);return{dark:typeof f=="string"?E.URI.file(f):f,light:typeof m=="string"?E.URI.file(m):m}}function v(c){return typeof c=="object"&&"light"in c?c.light:c}function t(c){return typeof c=="object"&&"dark"in c?c.dark:c}function a(c){const f=p(c.iconPath);let m,_;return"id"in f?_=l.ThemeIcon.asClassName(f):m=f,{iconPath:m,iconClass:_}}class s extends o{constructor(f,m,_){super(f,_);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((m,_)=>{this._handlesToItems.set(_,m),this._itemsToHandles.set(m,_)}),this.update({items:f.map((m,_)=>({label:m.label,description:m.description,handle:_,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((I,r)=>({...a(I),tooltip:I.tooltip,handle:r})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(f){const m=(0,n.coalesce)(f.map(_=>this._handlesToItems.get(_)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(f){const m=(0,n.coalesce)(f.map(_=>this._handlesToItems.get(_)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(f,m){const _=this._handlesToItems.get(f);if(!_||!_.buttons||!_.buttons.length)return;const I=_.buttons[m];I&&this._onDidTriggerItemButtonEmitter.fire({button:I,item:_})}}class i extends o{constructor(f,m){super(f,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?C.default.Error:C.default.Ignore})}}return new A(g,b)}e.createExtHostQuickOpen=h}),define(we[209],be([0,1,2,3,53,6,15,5,17,116,16,26,30,46,9]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(f){if(f)return typeof f.iconPath=="string"?d.URI.file(f.iconPath):d.URI.isUri(f.iconPath)||h.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function b(f,m){if(!f.iconPath&&!m.iconPath)return 0;if(f.iconPath){if(!m.iconPath)return 1}else return-1;const _=typeof f.iconPath=="string"?f.iconPath:d.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,I=typeof m.iconPath=="string"?m.iconPath:d.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,T.comparePaths)(_,I)}function w(f,m){let _=0;if(f.strikeThrough!==m.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==m.faded)return f.faded?1:-1;if(f.tooltip!==m.tooltip)return(f.tooltip||"").localeCompare(m.tooltip||"");if(_=b(f,m),_!==0)return _;if(f.light&&m.light)_=b(f.light,m.light);else{if(f.light)return 1;if(m.light)return-1}if(_!==0)return _;if(f.dark&&m.dark)_=b(f.dark,m.dark);else{if(f.dark)return 1;if(m.dark)return-1}return _}function A(f,m){if(f.command!==m.command)return f.command<m.command?-1:1;if(f.title!==m.title)return f.title<m.title?-1:1;if(f.tooltip!==m.tooltip){if(f.tooltip!==void 0&&m.tooltip!==void 0)return f.tooltip<m.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(f.arguments===m.arguments)return 0;if(f.arguments)if(m.arguments){if(f.arguments.length!==m.arguments.length)return f.arguments.length-m.arguments.length}else return 1;else return-1;for(let _=0;_<f.arguments.length;_++){const I=f.arguments[_],r=m.arguments[_];if(I!==r)return I<r?-1:1}return 0}function o(f,m){let _=(0,T.comparePaths)(f.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(_!==0)return _;if(f.command&&m.command)_=A(f.command,m.command);else{if(f.command)return 1;if(m.command)return-1}if(_!==0)return _;if(f.decorations&&m.decorations)_=w(f.decorations,m.decorations);else{if(f.decorations)return 1;if(m.decorations)return-1}return _}function p(f,m){for(let _=0;_<f.length;_++)if(f[_]!==m[_])return!1;return!0}function v(f,m){return f.command===m.command&&f.title===m.title&&f.tooltip===m.tooltip&&(f.arguments&&m.arguments?p(f.arguments,m.arguments):f.arguments===m.arguments)}function t(f,m){return(0,y.equals)(f,m,v)}class a{constructor(m,_,I){this._extension=m,this._proxy=_,this._sourceControlHandle=I,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,l.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,_){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,_)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=a;class s{constructor(m,_,I,r,P){this._proxy=m,this._commands=_,this._sourceControlHandle=I,this._id=r,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,_){const I=this._resourceStatesCommandsMap.get(m);return I?(0,k.asPromise)(()=>this._commands.executeCommand(I.command,...I.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(o),I=(0,y.sortedDiff)(this._resourceSnapshot,m,o).map(F=>{const B=F.toInsert.map(j=>{const ae=this._resourceHandlePool++;this._resourceStatesMap.set(ae,j);const oe=j.resourceUri;let V;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const _e=new S.DisposableStore;V=this._commands.converter.toInternal(j.command,_e),this._resourceStatesDisposablesMap.set(ae,_e)}else this._resourceStatesCommandsMap.set(ae,j.command);const H=g(j.decorations),M=j.decorations&&g(j.decorations.light)||H,K=j.decorations&&g(j.decorations.dark)||H,N=[M,K],G=j.decorations&&j.decorations.tooltip||"",me=j.decorations&&!!j.decorations.strikeThrough,W=j.decorations&&!!j.decorations.faded,ne=j.contextValue||"";return{rawResource:[ae,oe,N,G,me,W,ne,V],handle:ae}});return{start:F.start,deleteCount:F.deleteCount,toInsert:B}}),r=I.map(({start:F,deleteCount:B,toInsert:j})=>[F,B,j.map(ae=>ae.rawResource)]),P=I.reverse();for(const{start:F,deleteCount:B,toInsert:j}of P){const ae=j.map(V=>V.handle),oe=this._handlesSnapshot.splice(F,B,...ae);for(const V of oe)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=m,r}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(m,_,I,r,P,F){this._proxy=_,this._commands=I,this._id=r,this._label=P,this._rootUri=F,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,r,P,F)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=m;const _=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:_})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&t(this._statusBarCommands,m))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=m;const _=(m||[]).map(I=>this._commands.converter.toInternal(I,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}createResourceGroup(m,_){const I=new s(this._proxy,this._commands,this.handle,m,_),r=R.Event.once(I.onDidDispose)(()=>this.createdResourceGroups.delete(I));return this.createdResourceGroups.set(I,r),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const m=[],_=[];for(const[I,r]of this.createdResourceGroups){r.dispose();const P=I.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(I),this.eventuallyUpdateResourceStates()});R.Event.once(I.onDidDispose)(()=>{this.updatedResourceGroups.delete(I),P.dispose(),this._groups.delete(I.handle),this._proxy.$unregisterGroup(this.handle,I.handle)}),m.push([I.handle,I.id,I.label,I.features]);const F=I._takeResourceStateSnapshot();F.length>0&&_.push([I.handle,F]),this._groups.set(I.handle,I)}this._proxy.$registerGroups(this.handle,m,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(_=>{const I=_._takeResourceStateSnapshot();I.length!==0&&m.push([_.handle,I])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,We([(0,D.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),We([(0,D.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let c=class xn{constructor(m,_,I){this._commands=_,this.logService=I,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=m.getProxy(E.MainContext.MainThreadSCM),this._telemetry=m.getProxy(E.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===3){const P=this._sourceControls.get(r.sourceControlHandle);if(!P)return r;const F=P.getResourceGroup(r.groupHandle);return F?F.getResourceState(r.handle):r}else if(r&&r.$mid===4){const P=this._sourceControls.get(r.sourceControlHandle);return P?P.getResourceGroup(r.groupHandle):r}else if(r&&r.$mid===5){const P=this._sourceControls.get(r.handle);return P||r}return r}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,_,I,r){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,_,I,r),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const P=xn._handlePool++,F=new i(m,this._proxy,this._commands,_,I,r);this._sourceControls.set(P,F);const B=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(m.identifier))||[];return B.push(F),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(m.identifier),B),F}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const _=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(m.identifier)),I=_&&_[_.length-1];return I&&I.inputBox}$provideOriginalResource(m,_,I){const r=d.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,r.toString());const P=this._sourceControls.get(m);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(r,I)).then(F=>F||null)}$onInputBoxValueChange(m,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const I=this._sourceControls.get(m);return I&&I.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(m,_,I,r){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,_,I);const P=this._sourceControls.get(m);if(!P)return Promise.resolve(void 0);const F=P.getResourceGroup(_);return F?F.$executeResourceCommand(I,r):Promise.resolve(void 0)}$validateInput(m,_,I){this.logService.trace("ExtHostSCM#$validateInput",m);const r=this._sourceControls.get(m);return!r||!r.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>r.inputBox.validateInput(_,I)).then(P=>{if(!P)return Promise.resolve(void 0);const F=u.MarkdownString.fromStrict(P.message);return F?Promise.resolve([F,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};c._handlePool=0,c=We([He(2,n.ILogService)],c),e.ExtHostSCM=c});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[210],be([0,1,7,5,136,6,9]),function(ee,e,d,R,D,S,k){"use strict";var E,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(h,u,g,b,w=d.StatusBarAlignment.Left,A){E.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,nt(this,E,h,"f"),nt(this,y,u,"f"),this._entryId=T.ID_GEN++,this._extension=g,this._id=b,this._alignment=w,this._priority=A}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!T.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ue(this,y,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ue(this,y,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let u;this._name?u=this._name:u=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Ue(this,E,"f").$setEntry(this._entryId,h,u,this._text,b,this._command?.internal,g,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,E=new WeakMap,y=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const u={message:h};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const g=this._messages.indexOf(u);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class C{constructor(h,u){this._proxy=h.getProxy(R.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(h,u,g,b){return new T(this._proxy,this._commands,h,u,g,b)}setStatusBarMessage(h,u){const g=this._statusMessage.setMessage(h);let b;return typeof u=="number"?b=setTimeout(()=>g.dispose(),u):typeof u!="undefined"&&u.then(()=>g.dispose(),()=>g.dispose()),new d.Disposable(()=>{g.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=C}),define(we[76],be([0,1,5,3,4]),function(ee,e,d,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(E){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=E.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(E,y){this._proxy.$registerExtensionStorageKeysToSync(E,y)}getValue(E,y,T){return this._proxy.$getValue(E,y).then(n=>n||T)}setValue(E,y,T){return this._proxy.$setValue(E,y,T)}$acceptValue(E,y,T){this._onDidChangeStorage.fire({shared:E,key:y,value:T})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(we[77],be([0,1,4,29,16,75,2]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let E=class{constructor(T,n,C){this._logService=n,this._extHostFileSystem=C,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(T){return k.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,n=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(T){if(this._value)return k.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return k.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};E=We([He(0,R.IExtHostInitDataService),He(1,D.ILogService),He(2,S.IExtHostConsumerFileSystem)],E),e.ExtensionStoragePaths=E}),define(we[39],be([0,1,3,5,4,2,13,6,7,137,12,175,20,37,158,46,10]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(c,f,m,_){this._proxy=c,this._id=f,this._creationOptions=m,this._name=_,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(r=>this._pidPromiseComplete=r);const I=this;this.value={get name(){return I._name||""},get processId(){return I._pidPromise},get creationOptions(){return I._creationOptions},get exitStatus(){return I._exitStatus},get state(){return I._state},sendText(r,P=!0){I._checkDisposed(),I._proxy.$sendText(I._id,r,P)},show(r){I._checkDisposed(),I._proxy.$show(I._id,r)},hide(){I._checkDisposed(),I._proxy.$hide(I._id)},dispose(){I._disposed||(I._disposed=!0,I._proxy.$dispose(I._id))},get dimensions(){if(!(I._cols===void 0||I._rows===void 0))return{columns:I._cols,rows:I._rows}}}}async create(c,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,b.withNullAsUndefined)(c.shellPath),shellArgs:(0,b.withNullAsUndefined)(c.shellArgs),cwd:(0,b.withNullAsUndefined)(c.cwd),env:(0,b.withNullAsUndefined)(c.env),icon:(0,b.withNullAsUndefined)(a(c.iconPath)),color:g.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,b.withNullAsUndefined)(c.message),strictEnv:(0,b.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(f?.useShellEnvironment),isSplitTerminal:f?.isSplitTerminal,target:f?.target})}async createExtensionTerminal(c,f,m,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:g.ThemeColor.isThemeColor(_)?_.id:void 0,isSplitTerminal:c,target:f}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,f){return c===this._cols&&f===this._rows||c===0||f===0?!1:(this._cols=c,this._rows=f,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=w;class A{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,f){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:f})}async processBinary(c){}acknowledgeDataEvent(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose&&this._pty.onDidClose((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f&&{cols:f.columns,rows:f.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(f=>this._onProcessTitleChanged.fire(f)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=A;let o=1,p=class extends E.Disposable{constructor(c,f){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=f.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[m,_]of this._terminalProcesses)_.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,f){const m=new w(this._proxy,(0,h.generateUuid)(),c,c.name),_=new A(c.pty);return m.createExtensionTerminal(f?.isSplitTerminal,f?.target,a(c.iconPath),s(c.color)).then(I=>{const r=this._setupExtHostProcessListeners(I,_);this._terminalProcessDisposables[I]=r}),this._terminals.push(m),m.value}attachPtyToTerminal(c,f){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const _=new A(f),I=this._setupExtHostProcessListeners(c,_);this._terminalProcessDisposables[c]=I}async $acceptActiveTerminalChanged(c){const f=this._activeTerminal;if(c===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(c);m&&(this._activeTerminal=m,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,f){const m=this._getTerminalById(c);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:f})}async $acceptTerminalDimensions(c,f,m){const _=this._getTerminalById(c);_&&_.setDimensions(f,m)&&this._onDidChangeTerminalDimensions.fire({terminal:_.value,dimensions:_.value.dimensions})}async $acceptTerminalMaximumDimensions(c,f,m){this._terminalProcesses.get(c)?.resize(f,m)}async $acceptTerminalTitleChange(c,f){const m=this._getTerminalById(c);m&&(m.name=f)}async $acceptTerminalClosed(c,f){const m=this._getTerminalObjectIndexById(this._terminals,c);if(m!==null){const _=this._terminals.splice(m,1)[0];_.setExitCode(f),this._onDidCloseTerminal.fire(_.value)}}$acceptTerminalOpened(c,f,m,_){if(f){const P=this._getTerminalObjectIndexById(this._terminals,f);if(P!==null){this._terminals[P]._id=c,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const I={name:_.name,shellPath:_.executable,shellArgs:_.args,cwd:typeof _.cwd=="string"?_.cwd:S.URI.revive(_.cwd),env:_.env,hideFromUser:_.hideFromUser},r=new w(this._proxy,c,I,m);this._terminals.push(r),this._onDidOpenTerminal.fire(r.value),r.isOpen=!0}async $acceptTerminalProcessId(c,f){const m=this._getTerminalById(c);m&&m._setProcessId(f)}async $startExtensionTerminal(c,f){const m=this._getTerminalById(c);if(!m)return{message:(0,T.localize)(0,null,c)};m.isOpen||await new Promise(I=>{const r=this.onDidOpenTerminal(async P=>{P===m.value&&(r.dispose(),I())})});const _=this._terminalProcesses.get(c);_?_.startSendingEvents(f):this._extensionTerminalAwaitingStart[c]={initialDimensions:f}}_setupExtHostProcessListeners(c,f){const m=new E.DisposableStore;m.add(f.onProcessReady(I=>this._proxy.$sendProcessReady(c,I.pid,I.cwd))),m.add(f.onProcessTitleChanged(I=>this._proxy.$sendProcessTitle(c,I))),this._bufferer.startBuffering(c,f.onProcessData),m.add(f.onProcessExit(I=>this._onProcessExit(c,I))),f.onProcessOverrideDimensions&&m.add(f.onProcessOverrideDimensions(I=>this._proxy.$sendOverrideDimensions(c,I))),this._terminalProcesses.set(c,f);const _=this._extensionTerminalAwaitingStart[c];return _&&f instanceof A&&(f.startSendingEvents(_.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),m}$acceptProcessAckDataEvent(c,f){this._terminalProcesses.get(c)?.acknowledgeDataEvent(f)}$acceptProcessInput(c,f){this._terminalProcesses.get(c)?.input(f)}$acceptTerminalInteraction(c){const f=this._getTerminalById(c);f?.setInteractedWith()&&this._onDidChangeTerminalState.fire({terminal:f.value,state:f.value.state})}$acceptProcessResize(c,f,m){try{this._terminalProcesses.get(c)?.resize(f,m)}catch(_){if(_.code!=="EPIPE"&&_.code!=="ERR_IPC_CHANNEL_CLOSED")throw _}}$acceptProcessShutdown(c,f){this._terminalProcesses.get(c)?.shutdown(f)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(f=>this._proxy.$sendProcessInitialCwd(c,f))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(f=>this._proxy.$sendProcessCwd(c,f))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,f,m){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,m),this._proxy.$registerProfileProvider(f,c.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}async $createContributedProfileTerminal(c,f){const m=new l.CancellationTokenSource().token,_=await this._profileProviders.get(c)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!_||!("options"in _))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in _.options){this.createExtensionTerminal(_.options,f);return}this.createTerminalFromOptions(_.options,f)}}async $provideLinks(c,f){const m=this._getTerminalById(c);if(!m)return[];this._terminalLinkCache.delete(c);const _=this._terminalLinkCancellationSource.get(c);_&&_.dispose(!0);const I=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,I);const r=[],P={terminal:m.value,line:f},F=[];for(const ae of this._linkProviders)F.push(new Promise(async oe=>{I.token.onCancellationRequested(()=>oe({provider:ae,links:[]}));const V=await ae.provideTerminalLinks(P,I.token)||[];I.token.isCancellationRequested||oe({provider:ae,links:V})}));const B=await Promise.all(F);if(I.token.isCancellationRequested)return[];const j=new Map;for(const ae of B)ae&&ae.links.length>0&&r.push(...ae.links.map(oe=>{const V={id:o++,startIndex:oe.startIndex,length:oe.length,label:oe.tooltip};return j.set(V.id,{provider:ae.provider,link:oe}),V}));return this._terminalLinkCache.set(c,j),r}$activateLink(c,f){const m=this._terminalLinkCache.get(c)?.get(f);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(c,f){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const m=this._terminalProcessDisposables[c];m&&(m.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,f)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,f){const m=this._getTerminalObjectIndexById(c,f);return m!==null?c[m]:null}_getTerminalObjectIndexById(c,f){let m=null;return c.some((_,I)=>_._id===f?(m=I,!0):!1),m}getEnvironmentVariableCollection(c){let f=this._environmentVariableCollections.get(c.identifier.value);return f||(f=new v,this._setEnvironmentVariableCollection(c.identifier.value,f)),f}_syncEnvironmentVariableCollection(c,f){const m=(0,C.serializeEnvironmentVariableCollection)(f.map);this._proxy.$setEnvironmentVariableCollection(c,f.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(c){c.forEach(f=>{const m=f[0],_=new v(f[1]);this._setEnvironmentVariableCollection(m,_)})}$acceptDefaultProfile(c,f){this._defaultProfile=c,this._defaultAutomationProfile=f}_setEnvironmentVariableCollection(c,f){this._environmentVariableCollections.set(c,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,f)})}};p=We([He(1,k.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class v{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,f){this._setIfDiffers(c,{value:f,type:y.EnvironmentVariableMutatorType.Replace})}append(c,f){this._setIfDiffers(c,{value:f,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,f){this._setIfDiffers(c,{value:f,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,f){const m=this.map.get(c);(!m||m.value!==f.value||m.type!==f.type)&&(this.map.set(c,f),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,f){this.map.forEach((m,_)=>c.call(f,_,m,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends p{constructor(c){super(!1,c)}createTerminal(c,f,m){throw new n.NotSupportedError}createTerminalFromOptions(c,f){throw new n.NotSupportedError}};t=We([He(0,k.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function a(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function s(i){return g.ThemeColor.isThemeColor(i)?i:void 0}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[211],be([0,1,24,20,3,54,43,56,6,23,10,37,5,13,68,9,7,183,99,72]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(F,B){this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(l.MainContext.MainThreadTesting),this.observer=new _(this.proxy),this.runTracker=new a(this.proxy),B.registerArgumentProcessor({processArgument:j=>j?.$mid===13?g.TestItem.toItemFromContext(j):j})}createTestController(F,B){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const j=new y.DisposableStore,ae=j.add(new w.SingleUseTestCollection(F));ae.root.label=B;const oe=new Map,V=this.proxy,H={items:ae.root.children,get label(){return B},set label(K){B=K,ae.root.label=K,V.$updateControllerLabel(F,B)},get id(){return F},createRunProfile:(K,N,G,me,W)=>{let ne=(0,k.hash)(K);for(;oe.has(ne);)ne++;const ge=new I(this.proxy,F,ne,K,N,G,me,W);return oe.set(ne,ge),ge},createTestItem(K,N,G){return new u.TestItemImpl(F,K,N,G)},createTestRun:(K,N,G=!0)=>this.runTracker.createTestRun(F,ae,K,N,G),set resolveHandler(K){ae.resolveHandler=K},get resolveHandler(){return ae.resolveHandler},dispose:()=>{j.dispose()}};H.createRunConfiguration=H.createRunProfile,V.$registerTestController(F,B),j.add((0,y.toDisposable)(()=>V.$unregisterTestController(F)));const M={controller:H,collection:ae,profiles:oe};return this.controllers.set(F,M),j.add((0,y.toDisposable)(()=>this.controllers.delete(F))),j.add(ae.onDidGenerateDiff(K=>V.$publishDiff(F,K))),H}createTestObserver(){return this.observer.checkout()}async runTests(F,B=R.CancellationToken.None){const j=s(F);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ae=this.controllers.get(j.controllerId);if(!ae)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(oe=>oe.id)??[ae.collection.root.id],profileGroup:r[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:F.exclude?.map(oe=>oe.id)},B)}$provideFileCoverage(F,B,j){return E.Iterable.find(this.runTracker.trackers,ae=>ae.id===F)?.getCoverage(B)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(F,B,j,ae){return E.Iterable.find(this.runTracker.trackers,oe=>oe.id===F)?.getCoverage(B)?.resolveFileCoverage(j,ae)??Promise.resolve([])}$configureRunProfile(F,B){this.controllers.get(F)?.profiles.get(B)?.configureHandler?.()}$getTestTags(F){const B=this.controllers.get(F);if(!B)return Promise.resolve([]);const j=new Map;for(const ae of B.profiles.values())if(ae.tag){const oe=g.TestTag.display(F,ae.tag);j.set(oe.id,oe)}for(const ae of B.collection.tags()){const oe=g.TestTag.display(F,ae);j.set(oe.id,oe)}return Promise.resolve([...j.values()])}$publishTestResults(F){this.results=Object.freeze(F.map(B=>(0,T.deepFreeze)(g.TestResults.to(B))).concat(this.results).sort((B,j)=>j.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,B){const j=this.controllers.get(o.TestId.fromString(F).controllerId)?.collection;j&&(await j.expand(F,B<0?Infinity:B),j.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,B){const j=this.controllers.get(F.controllerId);if(!j)return;const{collection:ae,profiles:oe}=j,V=oe.get(F.profileId);if(!V)return;const H=F.testIds.map(G=>ae.tree.get(G)).filter(n.isDefined),M=F.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(n.isDefined).filter(G=>H.some(me=>me.fullId.compare(G.fullId)===2));if(!H.length)return;const K=new b.TestRunRequest(H.some(G=>G.actual instanceof u.TestItemRootImpl)?void 0:H.map(G=>G.actual),M.map(G=>G.actual),V),N=this.runTracker.prepareForMainThreadTestRun(K,i.fromInternal(F,j.collection),B);try{await V.runHandler(K,B)}finally{N.isRunning&&!B.isCancellationRequested&&await D.Event.toPromise(N.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};v=We([He(0,h.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends y.Disposable{constructor(F,B,j){super();this.dto=F,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new D.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new R.CancellationTokenSource(j)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ae}of this.tasks.values())ae.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const B=this.dto.id,j=this.dto.controllerId,ae=(0,C.generateUuid)(),oe=new c(this.proxy,B,ae),V=K=>(N,...G)=>{if(H){console.warn(`Setting the state of test "${N.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(N)||(this.ensureTestIsKnown(N),K(N,...G))};let H=!1;const M={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return oe.coverageProvider},set coverageProvider(K){oe.coverageProvider=K},enqueued:V(K=>{this.proxy.$updateTestStateInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),1)}),skipped:V(K=>{this.proxy.$updateTestStateInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),5)}),started:V(K=>{this.proxy.$updateTestStateInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),2)}),errored:V((K,N,G)=>{this.proxy.$appendTestMessagesInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),N instanceof Array?N.map(g.TestMessage.from):[g.TestMessage.from(N)]),this.proxy.$updateTestStateInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),6,G)}),failed:V((K,N,G)=>{this.proxy.$appendTestMessagesInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),N instanceof Array?N.map(g.TestMessage.from):[g.TestMessage.from(N)]),this.proxy.$updateTestStateInRun(B,ae,o.TestId.fromExtHostTestItem(K,j).toString(),4,G)}),passed:V((K,N)=>{this.proxy.$updateTestStateInRun(B,ae,o.TestId.fromExtHostTestItem(K,this.dto.controllerId).toString(),3,N)}),appendOutput:(K,N,G)=>{H||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(B,ae,d.VSBuffer.fromString(K),N&&g.location.from(N),G&&o.TestId.fromExtHostTestItem(G,j).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(B,ae),this.tasks.delete(ae),this.isRunning||this.dispose())}};return this.tasks.set(ae,{run:M,coverage:oe}),this.proxy.$startedTestRunTask(B,{id:ae,name:F,running:!0}),M}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof u.TestItemImpl))throw new u.InvalidTestItemError(F.id);if(this.sharedTestIds.has(F.id))return;const B=[];for(;B.unshift(g.TestItem.from(F)),!(this.sharedTestIds.has(F.id)||(this.sharedTestIds.add(F.id),!F.parent));)F=F.parent;const j=this.dto.colllection.root;this.sharedTestIds.has(j.id)||(this.sharedTestIds.add(j.id),B.unshift(g.TestItem.from(j))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class a{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,B,j){return this.getTracker(F,B,j)}cancelRunById(F){for(const B of this.tracked.values())if(B.id===F){B.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,B,j,ae,oe){const V=this.tracked.get(j);if(V)return V.createRun(ae);const H=i.fromPublic(F,B,j,oe),M=s(j);this.proxy.$startedExtensionTestRun({controllerId:F,profile:M&&{group:r[M.kind],id:M.profileId},exclude:j.exclude?.map(N=>N.id)??[],id:H.id,include:j.include?.map(N=>N.id)??[B.root.id],persist:oe});const K=this.getTracker(j,H);return K.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),K.createRun(ae)}getTracker(F,B,j){const ae=new t(B,this.proxy,j);return this.tracked.set(F,ae),ae.onEnd(()=>this.tracked.delete(F)),ae}}e.TestRunCoordinator=a;const s=P=>{if(!!P.profile){if(!(P.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(F,B,j,ae,oe,V){this.controllerId=F,this.id=B,this.isPersisted=oe,this.colllection=V,this.includePrefix=j.map(H=>H+"\0"),this.excludePrefix=ae.map(H=>H+"\0")}static fromPublic(F,B,j,ae){return new i(F,(0,C.generateUuid)(),j.include?.map(oe=>o.TestId.fromExtHostTestItem(oe,F).toString())??[F],j.exclude?.map(oe=>o.TestId.fromExtHostTestItem(oe,F).toString())??[],ae,B)}static fromInternal(F,B){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,B)}isIncluded(F){const B=o.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const j of this.excludePrefix)if(B===j||B.startsWith(j))return!1;for(const j of this.includePrefix)if(B===j||B.startsWith(j))return!0;return!1}}e.TestRunDto=i;class c{constructor(F,B,j){this.proxy=F,this.runId=B,this.taskId=j}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(F,B){const j=await this.fileCoverage;let ae=j?.[F];return!this._coverageProvider||!j||!ae?[]:(ae.detailedCoverage||(ae=j[F]=await this._coverageProvider.resolveFileCoverage?.(ae,B)??ae),ae.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class f extends A.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,g.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:B,removed:j}=this;return{get added(){return[...F].map(ae=>ae.revived)},get updated(){return[...B].map(ae=>ae.revived)},get removed(){return[...j].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,B){return{...F,revived:g.TestItem.toPlain(F.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=m;class _{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(B=>B.revived)},dispose:(0,S.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class I{constructor(F,B,j,ae,oe,V,H=!1,M=void 0){this.controllerId=B,this.profileId=j,this._label=ae,this.kind=oe,this.runHandler=V,this._isDefault=H,this._tag=M,p.set(this,void 0),nt(this,p,F,"f");const K=r[oe];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${oe}`);Ue(this,p,"f").$publishTestRunProfile({profileId:j,controllerId:B,tag:M?g.TestTag.namespace(this.controllerId,M.id):null,label:ae,group:K,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?g.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Ue(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Ue(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=I,p=new WeakMap;const r={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(we[212],be([0,1,3,17,5,102,9,7]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const C=this._extHostDocumentsAndEditors.allEditors();return n?C:C.map(l=>l.value)}async showTextDocument(n,C,l){let h;typeof C=="number"?h={position:k.ViewColumn.from(C),preserveFocus:l}:typeof C=="object"?h={position:k.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?k.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:h={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,h),g=u&&this._extHostDocumentsAndEditors.getEditor(u);if(g)return g.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,C){return new S.TextEditorDecorationType(this._proxy,n,C).value}$acceptEditorPropertiesChanged(n,C){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(C.options&&l._acceptOptions(C.options),C.selections){const h=C.selections.selections.map(k.Selection.to);l._acceptSelections(h)}if(C.visibleRanges){const h=R.coalesce(C.visibleRanges.map(k.Range.to));l._acceptVisibleRanges(h)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...C.options,lineNumbers:k.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const h=E.TextEditorSelectionChangeKind.fromValue(C.selections.source),u=C.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:u,kind:h})}if(C.visibleRanges){const h=R.coalesce(C.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const C in n){const l=this._extHostDocumentsAndEditors.getEditor(C);if(!l)throw new Error("Unknown text editor");const h=k.ViewColumn.to(n[C]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(we[213],be([0,1,2,4,5,6,7]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class E{constructor(n,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(D.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const h=l.uri===void 0?void 0:d.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(y(h))?.get(l.handle)}return l}})}async $getTimeline(n,C,l,h,u){return this._providers.get(n)?.provideTimeline(d.URI.revive(C),l,h,u)}registerTimelineProvider(n,C,l,h){const u=new S.DisposableStore,g=this.convertTimelineItem(C.id,h,u).bind(this);let b;C.onDidChange&&(b=C.onDidChange(A=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...A,id:C.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:n,onDidChange:void 0,async provideTimeline(A,o,p,v){v?.resetCache&&(u.clear(),w.get(C.id)?.clear());const t=await C.provideTimeline(A,o,p);if(t==null)return;const a=g(A,v);return{...t,source:C.id,items:t.items.map(a)}},dispose(){for(const A of w.values())A.get(C.id)?.clear();b?.dispose(),u.dispose()}})}convertTimelineItem(n,C,l){return(h,u)=>{let g;if(u?.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const w=y(h);g=b.get(w),g===void 0&&(g=new Map,b.set(w,g))}return b=>{const{iconPath:w,...A}=b,o=`${n}|${b.id??b.timestamp}`;g?.set(o,b);let p,v,t;return b.iconPath&&(w instanceof k.ThemeIcon?t={id:w.id,color:w.color}:d.URI.isUri(w)?(p=w,v=w):{light:p,dark:v}=w),{...A,id:A.id??void 0,handle:o,source:n,command:b.command?C.toInternal(b.command,l):void 0,icon:p,iconDark:v,themeIcon:t,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,S.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=E;function y(T){return T?.toString()}}),define(we[214],be([0,1,6,11,2,5]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(y){this._openers=new Map,this._proxy=y.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,n,C){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const l=C.schemes.find(h=>!k.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,n),this._proxy.$registerUriOpener(T,C.schemes,y,C.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(y,T,n){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const l=D.URI.revive(T);return C.canOpenExternalUri(l,n)}async $openUri(y,T,n){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(D.URI.revive(T.resolvedUri),{sourceUri:D.URI.revive(T.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(we[215],be([0,1,5,2,6,12,26]),function(ee,e,d,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class E{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,n){if(this.handles.has(k.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const C=E.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(T)),this.handlers.set(C,n),this._proxy.$registerUriHandler(C,T),(0,D.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(T)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(T,n){const C=this.handlers.get(T);if(!C)return Promise.resolve(void 0);try{C.handleUri(R.URI.revive(n))}catch(l){(0,S.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(T){return R.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=E,E.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[51],be([0,1,3,2,147,166,71,5]),function(ee,e,d,R,D,S,k,E){"use strict";var y,T,n,C,l,h,u,g,b,w,A,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(m,_,I,r,P,F,B){y.set(this,void 0),T.set(this,void 0),n.set(this,void 0),C.set(this,void 0),l.set(this,void 0),h.set(this,void 0),u.set(this,""),g.set(this,void 0),b.set(this,!1),w.set(this,!1),A.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new d.Emitter),this._onDidDispose=Ue(this,o,"f").event,nt(this,y,m,"f"),nt(this,T,_,"f"),nt(this,g,I,"f"),nt(this,C,r,"f"),nt(this,l,P,"f"),nt(this,h,F,"f"),nt(this,A,v(F),"f"),nt(this,n,B,"f")}dispose(){nt(this,b,!0,"f"),Ue(this,o,"f").fire(),Ue(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return nt(this,w,!0,"f"),(0,k.asWebviewUri)(m,Ue(this,C,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,u,"f")}set html(m){this.assertNotDisposed(),Ue(this,u,"f")!==m&&(nt(this,u,m,"f"),!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(nt(this,w,!0,"f"),Ue(this,n,"f").report("Webview vscode-resource: uris",Ue(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,T,"f").$setHtml(Ue(this,y,"f"),m))}get options(){return this.assertNotDisposed(),Ue(this,g,"f")}set options(m){this.assertNotDisposed(),Ue(this,T,"f").$setOptions(Ue(this,y,"f"),s(Ue(this,h,"f"),Ue(this,l,"f"),m)),nt(this,g,m,"f")}async postMessage(m){if(Ue(this,b,"f"))return!1;const _=(0,S.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ue(this,A,"f")});return Ue(this,T,"f").$postMessage(Ue(this,y,"f"),_.message,..._.buffers)}assertNotDisposed(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,y=new WeakMap,T=new WeakMap,n=new WeakMap,C=new WeakMap,l=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,A=new WeakMap,o=new WeakMap;function v(f){try{const m=(0,D.normalizeVersion)((0,D.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(m,_,I,r,P){this.initData=_,this.workspace=I,this._logService=r,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=m.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(m,_,...I){const r=this.getWebview(m);if(r){const{message:P}=(0,S.deserializeWebviewMessage)(_,I);r._onMessageEmitter.fire(P)}}$onMissingCsp(m,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,_,I){const r=new p(m,this._webviewProxy,i(_),this.initData,this.workspace,I,this._deprecationService);return this._webviews.set(m,r),r._onDidDispose(()=>{this._webviews.delete(m)}),r}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function a(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=a;function s(f,m,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||c(f,m)}}e.serializeWebviewOptions=s;function i(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>R.URI.from(m))}}e.reviveOptions=i;function c(f,m){return[...(m?.getWorkspaceFolders()||[]).map(_=>_.uri),f.extensionLocation]}}),define(we[216],be([0,1,20,43,6,11,25,2,9,51,66,5,7]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,a){this.document=t,this._storagePath=a,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,a){await this.getEdit(t).undo(),a||this.disposeBackup()}async redo(t,a){await this.getEdit(t).redo(),a||this.disposeBackup()}disposeEdits(t){for(const a of t)this._edits.delete(a)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=p(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const a=this._edits.get(t,0);if(!a)throw new Error("No edit found");return a}}class u{constructor(){this._documents=new Map}get(t,a){return this._documents.get(this.key(t,a))}add(t,a,s){const i=this.key(t,a.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${a.uri}`);const c=new h(a,s);return this._documents.set(i,c),c}delete(t,a){const s=this.key(t,a.uri);this._documents.delete(s)}key(t,a){return`${t}@@@${a}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class b{constructor(){this._providers=new Map}addTextProvider(t,a,s){return this.add(0,t,a,s)}addCustomProvider(t,a,s){return this.add(1,t,a,s)}get(t){return this._providers.get(t)}add(t,a,s,i){if(this._providers.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this._providers.set(a,{type:t,extension:s,provider:i}),new l.Disposable(()=>this._providers.delete(a))}}class w{constructor(t,a,s,i,c){this._extHostDocuments=a,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new b,this._documents=new u,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,a,s,i){const c=new D.DisposableStore;return A(s)?(c.add(this._editorProviders.addTextProvider(a,t,s)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(t),a,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(a,t,s)),this.supportEditing(s)&&c.add(s.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(a,f.document.uri);if(o(f)){const _=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,a,_,f.label)}else this._proxy.$onContentChange(f.document.uri,a)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(t),a,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(a)}))}async $createCustomDocument(t,a,s,i,c){const f=this._editorProviders.get(a);if(!f)throw new Error(`No provider found for '${a}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${a}'`);const m=E.URI.revive(t),_=await f.provider.openCustomDocument(m,{backupId:s,untitledDocumentData:i?.buffer},c);let I;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(I=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(a,_,I),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,a){const s=this._editorProviders.get(a);if(!s)throw new Error(`No provider found for '${a}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${a}'`);const i=E.URI.revive(t),{document:c}=this.getCustomDocumentEntry(a,i);this._documents.delete(a,c),c.dispose()}async $resolveWebviewEditor(t,a,s,i,c,f){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const _=y.ViewColumn.to(c),I=this._extHostWebview.createNewWebview(a,i.webviewOptions,m.extension),r=this._extHostWebviewPanels.createNewWebviewPanel(a,s,i.title,_,i.panelOptions,I),P=E.URI.revive(t);switch(m.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,P);return m.provider.resolveCustomEditor(F,r,f)}case 0:{const F=this._extHostDocuments.getDocument(P);return m.provider.resolveCustomTextEditor(F,r,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,a,s){this.getCustomDocumentEntry(a,t).disposeEdits(s)}async $onMoveCustomEditor(t,a,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const f=E.URI.revive(a),m=this._extHostDocuments.getDocument(f);await i.provider.moveCustomTextEditor(m,c,d.CancellationToken.None)}async $undo(t,a,s,i){return this.getCustomDocumentEntry(a,t).undo(s,i)}async $redo(t,a,s,i){return this.getCustomDocumentEntry(a,t).redo(s,i)}async $revert(t,a,s){const i=this.getCustomDocumentEntry(a,t);await this.getCustomEditorProvider(a).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,a,s){const i=this.getCustomDocumentEntry(a,t);await this.getCustomEditorProvider(a).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,a,s,i){const c=this.getCustomDocumentEntry(a,t);return this.getCustomEditorProvider(a).saveCustomDocumentAs(c.document,E.URI.revive(s),i)}async $backup(t,a,s){const i=this.getCustomDocumentEntry(a,t),f=await this.getCustomEditorProvider(a).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(f),f.id}getCustomDocumentEntry(t,a){const s=this._documents.get(t,E.URI.revive(a));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function A(v){return typeof v.resolveCustomTextEditor=="function"}function o(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function p(v){const t=v.scheme===S.Schemas.file||v.scheme===S.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[217],be([0,1,3,6,2,37,9,51,5,7]),function(ee,e,d,R,D,S,k,E,y,T){"use strict";var n,C,l,h,u,g,b,w,A,o,p,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends R.Disposable{constructor(f,m,_,I,r,P,F){super();n.set(this,void 0),C.set(this,void 0),l.set(this,void 0),h.set(this,void 0),u.set(this,void 0),g.set(this,void 0),b.set(this,void 0),w.set(this,void 0),A.set(this,!0),o.set(this,!0),p.set(this,!1),v.set(this,this._register(new d.Emitter)),this.onDidDispose=Ue(this,v,"f").event,t.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,n,f,"f"),nt(this,C,m,"f"),nt(this,l,_,"f"),nt(this,u,P,"f"),nt(this,w,r,"f"),nt(this,g,I,"f"),nt(this,h,F,"f")}dispose(){Ue(this,p,"f")||(nt(this,p,!0,"f"),Ue(this,v,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,n,"f")),Ue(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,l,"f")}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(f){this.assertNotDisposed(),Ue(this,g,"f")!==f&&(nt(this,g,f,"f"),Ue(this,C,"f").$setTitle(Ue(this,n,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ue(this,b,"f")}set iconPath(f){this.assertNotDisposed(),Ue(this,b,"f")!==f&&(nt(this,b,f,"f"),Ue(this,C,"f").$setIconPath(Ue(this,n,"f"),D.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ue(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,o,"f")}get visible(){return this.assertNotDisposed(),Ue(this,A,"f")}_updateViewState(f){Ue(this,p,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(nt(this,o,f.active,"f"),nt(this,A,f.visible,"f"),nt(this,w,f.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,n,"f"),{viewColumn:f?k.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,C=new WeakMap,l=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,w=new WeakMap,A=new WeakMap,o=new WeakMap,p=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(f,m,_){this.webviews=m,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(f,m,_,I,r={}){const P=typeof I=="object"?I.viewColumn:I,F={viewColumn:k.ViewColumn.from(P),preserveFocus:typeof I=="object"&&!!I.preserveFocus},B=(0,E.shouldSerializeBuffersForPostMessage)(f),j=s.newHandle();this._proxy.$createWebviewPanel((0,E.toExtensionData)(f),j,m,{title:_,panelOptions:i(r),webviewOptions:(0,E.serializeWebviewOptions)(f,this.workspace,r),serializeBuffersForPostMessage:B},F);const ae=this.webviews.createNewWebview(j,r,f);return this.createNewWebviewPanel(j,m,_,P,r,ae)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((_,I)=>{const r=f[_],P=f[I];return r.active?1:P.active?-1:+r.visible-+P.visible});for(const _ of m){const I=this.getWebviewPanel(_);if(!I)continue;const r=f[_];I._updateViewState({active:r.active,visible:r.visible,viewColumn:k.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,_){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:_,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,E.shouldSerializeBuffersForPostMessage)(f)}),new T.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,_,I){const r=this._serializers.get(m);if(!r)throw new Error(`No serializer found for '${m}'`);const{serializer:P,extension:F}=r,B=this.webviews.createNewWebview(f,_.webviewOptions,F),j=this.createNewWebviewPanel(f,m,_.title,I,_.panelOptions,B);await P.deserializeWebviewPanel(j,_.state)}createNewWebviewPanel(f,m,_,I,r,P){const F=new a(f,this._proxy,m,_,I,r,P);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=s;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[218],be([0,1,3,6,51,5,7]),function(ee,e,d,R,D,S,k){"use strict";var E,y,T,n,C,l,h,u,g,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(p,v,t,a,s,i){super();E.set(this,void 0),y.set(this,void 0),T.set(this,void 0),n.set(this,void 0),C.set(this,!1),l.set(this,void 0),h.set(this,void 0),u.set(this,void 0),g.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ue(this,g,"f").event,b.set(this,this._register(new d.Emitter)),this.onDidDispose=Ue(this,b,"f").event,nt(this,T,t,"f"),nt(this,h,a,"f"),nt(this,E,p,"f"),nt(this,y,v,"f"),nt(this,n,s,"f"),nt(this,l,i,"f")}dispose(){Ue(this,C,"f")||(nt(this,C,!0,"f"),Ue(this,b,"f").fire(),Ue(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,h,"f")}set title(p){this.assertNotDisposed(),Ue(this,h,"f")!==p&&(nt(this,h,p,"f"),Ue(this,y,"f").$setWebviewViewTitle(Ue(this,E,"f"),p))}get description(){return this.assertNotDisposed(),Ue(this,u,"f")}set description(p){this.assertNotDisposed(),Ue(this,u,"f")!==p&&(nt(this,u,p,"f"),Ue(this,y,"f").$setWebviewViewDescription(Ue(this,E,"f"),p))}get visible(){return Ue(this,l,"f")}get webview(){return Ue(this,n,"f")}get viewType(){return Ue(this,T,"f")}_setVisible(p){p===Ue(this,l,"f")||Ue(this,C,"f")||(nt(this,l,p,"f"),Ue(this,g,"f").fire())}show(p){this.assertNotDisposed(),Ue(this,y,"f").$show(Ue(this,E,"f"),!!p)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,y=new WeakMap,T=new WeakMap,n=new WeakMap,C=new WeakMap,l=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap;class A{constructor(p,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,v,t,a){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:p}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(p),v,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(p,v,t,a,s){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:f}=i,m=this._extHostWebview.createNewWebview(p,{},f),_=new w(p,this._proxy,v,t,m,!0);this._webviewViews.set(p,_),await c.resolveWebviewView(_,{state:a},s)}async $onDidChangeWebviewViewVisibility(p,v){this.getWebviewView(p)._setVisible(v)}async $disposeWebviewView(p){const v=this.getWebviewView(p);this._webviewViews.delete(p),v.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const v=this._webviewViews.get(p);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=A}),define(we[106],be([0,1,3,5,2,11,8,4,13]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Bn{constructor(C){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=C.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,l){let h;if(typeof C=="string"){h=C;try{C=D.URI.parse(C)}catch(u){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,k.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,h,l)}async asExternalUri(C,l){if((0,k.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(C,l);return D.URI.from(h)}};T.InitialState={focused:!0},T=We([He(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,E.createDecorator)("IExtHostWindow")}),define(we[219],be([0,1,16,5,29,13]),function(ee,e,d,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends d.AbstractLogger{constructor(y,T){super();this._proxy=y.getProxy(R.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(y,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(y,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(y,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(y,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(y,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};k=We([He(0,S.IExtHostRpcService),He(1,D.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(we[220],be([0,1,15,20,12,3,6,117,188,103,24]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,c){try{return JSON.stringify(i,c)}catch(f){return"null"}}function h(i,c){return JSON.stringify(i,c)}function u(i){return i?(c,f)=>f&&f.$mid===1?i.transformOutgoing(f):f:null}var g;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},A=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class p extends k.Disposable{constructor(c,f=null,m=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=f,this._uriTransformer=m,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,I=T.ProxyIdentifier.count;_<I;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,E.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:f,sid:m}=c;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,m)),this._proxies[f]}_createProxy(c,f){let m={get:(_,I)=>(typeof I=="string"&&!_[I]&&I.charCodeAt(0)===36&&(_[I]=(...r)=>this._remoteCall(c,I,r)),I===o?f:_[I])};return new Proxy(Object.create(null),m)}set(c,f){return this._locals[c.nid]=f,f}assertRegistered(c){for(let f=0,m=c.length;f<m;f++){const _=c[f];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const f=c.byteLength,m=v.read(c,0),_=m.readUInt8(),I=m.readUInt32();switch(_){case 1:case 2:{let{rpcId:r,method:P,args:F}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(F=(0,E.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,I,r,P,F,_===2);break}case 3:case 4:{let{rpcId:r,method:P,args:F}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(F=(0,E.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,I,r,P,F,_===4);break}case 5:{this._logger&&this._logger.logIncoming(f,I,0,"ack"),this._onDidReceiveAcknowledge(I);break}case 6:{this._receiveCancel(f,I);break}case 7:{this._receiveReply(f,I,void 0);break}case 9:{let r=t.deserializeReplyOKJSON(m);this._uriTransformer&&(r=(0,E.transformIncomingURIs)(r,this._uriTransformer)),this._receiveReply(f,I,r);break}case 8:{let r=t.deserializeReplyOKVSBuffer(m);this._receiveReply(f,I,r);break}case 10:{let r=t.deserializeReplyErrError(m);this._uriTransformer&&(r=(0,E.transformIncomingURIs)(r,this._uriTransformer)),this._receiveReplyErr(f,I,r);break}case 11:{this._receiveReplyErr(f,I,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,f,m,_,I,r){this._logger&&this._logger.logIncoming(c,f,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(m)}.${_}(`,I);const P=String(f);let F,B;if(r){const ae=new R.CancellationTokenSource;I.push(ae.token),F=this._invokeHandler(m,_,I),B=()=>ae.cancel()}else F=this._invokeHandler(m,_,I),B=w;this._cancelInvokedHandlers[P]=B;const j=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(j.byteLength,f,1,"ack"),this._protocol.send(j),F.then(ae=>{delete this._cancelInvokedHandlers[P];const oe=t.serializeReplyOK(f,ae,this._uriReplacer);this._logger&&this._logger.logOutgoing(oe.byteLength,f,1,"reply:",ae),this._protocol.send(oe)},ae=>{delete this._cancelInvokedHandlers[P];const oe=t.serializeReplyErr(f,ae);this._logger&&this._logger.logOutgoing(oe.byteLength,f,1,"replyErr:",ae),this._protocol.send(oe)})}_receiveCancel(c,f){this._logger&&this._logger.logIncoming(c,f,1,"receiveCancel");const m=String(f);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(c,f,m){this._logger&&this._logger.logIncoming(c,f,0,"receiveReply:",m);const _=String(f);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const I=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],I.resolveOk(m)}_receiveReplyErr(c,f,m){this._logger&&this._logger.logIncoming(c,f,0,"receiveReplyErr:",m);const _=String(f);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const I=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let r;m&&(m.$isError?(r=new Error,r.name=m.name,r.message=m.message,r.stack=m.stack):r=m),I.resolveErr(r)}_invokeHandler(c,f,m){try{return Promise.resolve(this._doInvokeHandler(c,f,m))}catch(_){return Promise.reject(_)}}_doInvokeHandler(c,f,m){const _=this._locals[c];if(!_)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(c));let I=_[f];if(typeof I!="function")throw new Error("Unknown method "+f+" on actor "+(0,T.getStringIdentifierForProxy)(c));return I.apply(_,m)}_remoteCall(c,f,m){if(this._isDisposed)return Promise.reject(D.canceled());let _=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(_=m.pop()),_&&_.isCancellationRequested)return Promise.reject(D.canceled());const I=t.serializeRequestArguments(m,this._uriReplacer),r=++this._lastMessageId,P=String(r),F=new y.LazyPromise;_&&_.onCancellationRequested(()=>{const j=t.serializeCancel(r);this._logger&&this._logger.logOutgoing(j.byteLength,r,0,"cancel"),this._protocol.send(t.serializeCancel(r))}),this._pendingRPCReplies[P]=F,this._onWillSendRequest(r);const B=t.serializeRequest(r,c,f,I,!!_);return this._logger&&this._logger.logOutgoing(B.byteLength,r,0,`request: ${(0,T.getStringIdentifierForProxy)(c)}.${f}(`,m),this._protocol.send(B),F}}e.RPCProtocol=p,C=A,p.UNRESPONSIVE_TIME=3*1e3;class v{constructor(c,f){this._buff=c,this._offset=f}static alloc(c,f,m){let _=new v(n.VSBuffer.alloc(m+1+4),0);return _.writeUInt8(c),_.writeUInt32(f),_}static read(c,f){return new v(c,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,m}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,m}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,f}static sizeMixedArray(c,f){let m=0;m+=1;for(let _=0,I=c.length;_<I;_++){const r=c[_],P=f[_];switch(m+=1,P){case 1:m+=this.sizeLongString(r);break;case 2:m+=this.sizeVSBuffer(r);break;case 3:break}}return m}writeMixedArray(c,f){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let m=0,_=c.length;m<_;m++){const I=c[m];switch(f[m]){case 1:this.writeUInt8(1),this.writeLongString(I);break;case 2:this.writeUInt8(2),this.writeVSBuffer(I);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(c);for(let m=0;m<c;m++)switch(this.readUInt8()){case 1:f[m]=this.readLongString();break;case 2:f[m]=this.readVSBuffer();break;case 3:f[m]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(c){for(let f=0,m=c.length;f<m;f++)if(c[f]instanceof n.VSBuffer||typeof c[f]=="undefined")return!0;return!1}static serializeRequestArguments(c,f){if(this._arrayContainsBufferOrUndefined(c)){let m=[],_=[];for(let I=0,r=c.length;I<r;I++){const P=c[I];P instanceof n.VSBuffer?(m[I]=P,_[I]=2):typeof P=="undefined"?(m[I]=n.VSBuffer.alloc(0),_[I]=3):(m[I]=n.VSBuffer.fromString(h(P,f)),_[I]=1)}return{type:"mixed",args:m,argsType:_}}return{type:"simple",args:h(c,f)}}static serializeRequest(c,f,m,_,I){return _.type==="mixed"?this._requestMixedArgs(c,f,m,_.args,_.argsType,I):this._requestJSONArgs(c,f,m,_.args,I)}static _requestJSONArgs(c,f,m,_,I){const r=n.VSBuffer.fromString(m),P=n.VSBuffer.fromString(_);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(r),F+=v.sizeLongString(P);let B=v.alloc(I?2:1,c,F);return B.writeUInt8(f),B.writeShortString(r),B.writeLongString(P),B.buffer}static deserializeRequestJSONArgs(c){const f=c.readUInt8(),m=c.readShortString(),_=c.readLongString();return{rpcId:f,method:m,args:JSON.parse(_)}}static _requestMixedArgs(c,f,m,_,I,r){const P=n.VSBuffer.fromString(m);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(P),F+=v.sizeMixedArray(_,I);let B=v.alloc(r?4:3,c,F);return B.writeUInt8(f),B.writeShortString(P),B.writeMixedArray(_,I),B.buffer}static deserializeRequestMixedArgs(c){const f=c.readUInt8(),m=c.readShortString(),_=c.readMixedArray(),I=new Array(_.length);for(let r=0,P=_.length;r<P;r++){const F=_[r];typeof F=="string"?I[r]=JSON.parse(F):I[r]=F}return{rpcId:f,method:m,args:I}}static serializeAcknowledged(c){return v.alloc(5,c,0).buffer}static serializeCancel(c){return v.alloc(6,c,0).buffer}static serializeReplyOK(c,f,m){return typeof f=="undefined"?this._serializeReplyOKEmpty(c):f instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,f):this._serializeReplyOKJSON(c,l(f,m))}static _serializeReplyOKEmpty(c){return v.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,f){let m=0;m+=v.sizeVSBuffer(f);let _=v.alloc(8,c,m);return _.writeVSBuffer(f),_.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,f){const m=n.VSBuffer.fromString(f);let _=0;_+=v.sizeLongString(m);let I=v.alloc(9,c,_);return I.writeLongString(m),I.buffer}static deserializeReplyOKJSON(c){const f=c.readLongString();return JSON.parse(f)}static serializeReplyErr(c,f){return f?this._serializeReplyErrEror(c,f):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,f){const m=n.VSBuffer.fromString(l(D.transformErrorForSerialization(f),null));let _=0;_+=v.sizeLongString(m);let I=v.alloc(10,c,_);return I.writeLongString(m),I.buffer}static deserializeReplyErrError(c){const f=c.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(c){return v.alloc(11,c,0).buffer}}var a;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(a||(a={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(we[221],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(S){const k=E=>{self.removeEventListener("message",k);const y=E.data;Object.defineProperties(self,{postMessage:{value(T,n){y.postMessage(T,n)}},onmessage:{get(){return y.onmessage},set(T){y.onmessage=T}}}),y.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(S)};self.addEventListener("message",k)}.toString();class R extends EventTarget{constructor(S,k,E){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${d})('${k}'))`,T=new Blob([y],{type:"application/javascript"}),n=URL.createObjectURL(T),C=new MessageChannel,l=n,h={type:"_newWorker",id:l,port:C.port2,url:n,options:E};S(h,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:l};C.port1.postMessage(u),URL.revokeObjectURL(n),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(u){C.port1.onmessage=u}},onmessageerror:{get(){return C.port1.onmessageerror},set(u){C.port1.onmessageerror=u}}}),C.port1.addEventListener("messageerror",u=>{const g=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(g)}),C.port1.addEventListener("message",u=>{const g=new MessageEvent("message",{data:u.data});this.dispatchEvent(g)}),C.port1.start()}}e.NestedWorker=R}),define(we[222],be([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(we[223],be([0,1,11,14,22,2,4,95,47,184,222]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let C=class $n{constructor(h,u,g,b){this.localUserHome=h,this.remoteAgentService=u,this.environmentService=g,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||h})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,u){if(h.remoteAuthority)return d.Schemas.vscodeRemote;const g=(0,E.getVirtualWorkspaceScheme)(u.getWorkspace());if(g)return g;const b=u.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:d.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?R.win32:R.posix)}async fileURI(h){let u="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const b=h.indexOf("/",2);b===-1?(u=h.substring(2),h="/"):(u=h.substring(2,b),h=h.substring(b)||"/")}return S.URI.from({scheme:d.Schemas.file,authority:u,path:h,query:"",fragment:""})}};C=We([He(1,n.IRemoteAgentService),He(2,T.IWorkbenchEnvironmentService),He(3,y.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(we[107],be([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(k,E){this.line=k,this.character=E}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,E){return new d(0,0)}with(k){return new d(0,0)}}e.Position=d;class R{constructor(k,E,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(k,E),this.end=new d(y,T)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new R(0,0,0,0)}with(k){return new R(0,0,0,0)}}e.Range=R;var D;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[40],be([0,1,17,27,23,44,8,4,14,12,107]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",l=" characters skipped \u27EB",h=(C.length+l.length+5)*2;e.ISearchService=(0,E.createDecorator)("searchService");var u;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function b(M){return!!M.preview}e.resultIsMatch=b;function w(M){return!!M.resource}e.isFileMatch=w;function A(M){return!!M.message}e.isProgressMessage=A;var o;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(K){this.resource=K,this.results=[]}}e.FileMatch=p;class v{constructor(K,N,G){this.ranges=N;const me=Array.isArray(N)?N:[N];if(G&&G.matchLines===1&&t(me)){K=(0,k.getNLines)(K,G.matchLines);let W="",ne=0,ge=0;const _e=Math.floor(G.charsPerLine/5),Me=[];for(const Fe of me){const xe=Math.max(Fe.startColumn-_e,0),Ye=Fe.startColumn+G.charsPerLine;if(xe>ge+_e+h){const Ve=C+(xe-ge)+l;W+=Ve+K.slice(xe,Ye),ne+=xe-(ge+Ve.length)}else W+=K.slice(ge,Ye);Me.push(new s(0,Fe.startColumn-ne,Fe.endColumn-ne)),ge=Ye}this.preview={text:W,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const W=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:K,matches:(0,d.mapArrayOrNot)(N,ne=>new a(ne.startLineNumber-W,ne.startColumn,ne.endLineNumber-W,ne.endColumn))}}}}e.TextSearchMatch=v;function t(M){const K=M[0].startLineNumber;for(const N of M)if(N.startLineNumber!==K||N.endLineNumber!==K)return!1;return!0}class a{constructor(K,N,G,me){this.startLineNumber=K,this.startColumn=N,this.endLineNumber=G,this.endColumn=me}}e.SearchRange=a;class s extends a{constructor(K,N,G){super(K,N,K,G)}}e.OneLineRange=s;var i;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(M,K=!0){const N=M&&M.files&&M.files.exclude,G=K&&M&&M.search&&M.search.exclude;if(!N&&!G)return;if(!N||!G)return N||G;let me=Object.create(null);return me=D.mixin(me,D.deepClone(N)),me=D.mixin(me,D.deepClone(G),!0),me}e.getExcludes=c;function f(M,K){return M.excludePattern&&R.match(M.excludePattern,K)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&R.match(M.includePattern,K)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(N=>{const G=N.folder.fsPath;if(S.isEqualOrParent(K,G)){const me=y.relative(G,K);return!N.includePattern||!!R.match(N.includePattern,me)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var m;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(K,N){super(K);this.code=N}}e.SearchError=_;function I(M){const K=M.message;if((0,T.isPromiseCanceledError)(M))return new _(K,m.canceled);try{const N=JSON.parse(K);return new _(N.message,N.code)}catch(N){return new _(K,m.other)}}e.deserializeSearchError=I;function r(M){const K={message:M.message,code:M.code};return new Error(JSON.stringify(K))}e.serializeSearchError=r;function P(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=P;function F(M){return M.type==="success"}e.isSerializedSearchSuccess=F;function B(M){return!!M.path}e.isSerializedFileMatch=B;function j(M,K){const N=M.searchPath?M.searchPath:M.relativePath;return(0,k.fuzzyContains)(N,K)}e.isFilePatternMatch=j;class ae{constructor(K){this.path=K,this.results=[]}addMatch(K){this.results.push(K)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ae;function oe(M,K){const N={...M||{},...K||{}};return Object.keys(N).filter(G=>{const me=N[G];return typeof me=="boolean"&&me})}e.resolvePatternsForProvider=oe;class V{constructor(K,N){this._parsedIncludeExpression=null,this._excludeExpression={...K.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let G=K.includePattern;N.includePattern&&(G?G={...G,...N.includePattern}:G=N.includePattern),G&&(this._parsedIncludeExpression=R.parse(G))}includedInQuerySync(K,N,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(K,N,G))}includedInQuery(K,N,G){return Promise.resolve(this._parsedExcludeExpression(K,N,G)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(K,N,G)).then(ne=>!!ne):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=V;function H(M){for(const K in M)if(typeof M[K]!="boolean")return!0;return!1}}),define(we[32],be([0,1,17,15,20,3,21,11,80,25,8,10,2,139,4,16,154,47,48,29,13,7,40,5]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o,p,v,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(P,F,B){return new T.ExtUri(j=>m(j,B)).isEqual(P,F)}function i(P,F,B){return s(P.uri,F.uri,B)?0:(0,n.compare)(P.uri.toString(),F.uri.toString())}function c(P,F,B){return P.index!==F.index?P.index<F.index?-1:1:s(P.uri,F.uri,B)?(0,n.compare)(P.name,F.name):(0,n.compare)(P.uri.toString(),F.uri.toString())}function f(P,F,B,j){const ae=P.slice(0).sort((V,H)=>B(V,H,j)),oe=F.slice(0).sort((V,H)=>B(V,H,j));return(0,d.delta)(ae,oe,(V,H)=>B(V,H,j))}function m(P,F){const B=F.getCapabilities(P.scheme);return!(B&&B&1024)}class _ extends w.Workspace{constructor(F,B,j,ae,oe,V){super(F,j.map(H=>new w.WorkspaceFolder(H)),ae,V);this._name=B,this._isUntitled=oe,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(V),j.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(F,B,j,ae){if(!F)return{workspace:null,added:[],removed:[]};const{id:oe,name:V,folders:H,configuration:M,isUntitled:K}=F,N=[],G=B;B?H.forEach((ge,_e)=>{const Me=l.URI.revive(ge.uri),Fe=_._findFolder(j||B,Me,ae);Fe?(Fe.name=ge.name,Fe.index=ge.index,N.push(Fe)):N.push({uri:Me,name:ge.name,index:_e})}):N.push(...H.map(({uri:ge,name:_e,index:Me})=>({uri:l.URI.revive(ge),name:_e,index:Me}))),N.sort((ge,_e)=>ge.index<_e.index?-1:1);const me=new _(oe,V,N,M?l.URI.revive(M):null,!!K,ge=>m(ge,ae)),{added:W,removed:ne}=f(G?G.workspaceFolders:[],me.workspaceFolders,i,ae);return{workspace:me,added:W,removed:ne}}static _findFolder(F,B,j){for(let ae=0;ae<F.folders.length;ae++){const oe=F.workspaceFolders[ae];if(s(oe.uri,B,j))return oe}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,B){return B&&this._structure.get(F)&&(F=(0,T.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let I=class{constructor(F,B,j,ae){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ae,this._extHostFileSystemInfo=j,this._requestIdProvider=new y.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(a.MainContext.MainThreadMessageService);const oe=B.workspace;this._confirmedWorkspace=oe?new _(oe.id,oe.name,[],oe.configuration?l.URI.revive(oe.configuration):null,!!oe.isUntitled,V=>m(V,j)):void 0}$initializeWorkspace(F,B){this._trusted=B,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:E.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,j,...ae){const oe=[];if(Array.isArray(ae)&&ae.forEach(N=>{l.URI.isUri(N.uri)&&!oe.some(G=>s(G.uri,N.uri,this._extHostFileSystemInfo))&&oe.push({uri:N.uri,name:N.name||(0,T.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[B,j].some(N=>typeof N!="number"||N<0)||j===0&&oe.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+j>V.length)return!1;const H=V.slice(0);H.splice(B,j,...oe.map(N=>({uri:N.uri,name:N.name||(0,T.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<H.length;N++){const G=H[N];if(H.some((me,W)=>W!==N&&s(G.uri,me.uri,this._extHostFileSystemInfo)))return!1}H.forEach((N,G)=>N.index=G);const{added:M,removed:K}=f(V,H,c,this._extHostFileSystemInfo);if(M.length===0&&K.length===0)return!1;if(this._proxy){const N=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(N,B,j,oe).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,h.localize)(0,null,N,G.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(F,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,B){let j,ae="";if(typeof F=="string"?(j=l.URI.file(F),ae=F):typeof F!="undefined"&&(j=F,ae=F.fsPath),!j)return ae;const oe=this.getWorkspaceFolder(j,!0);if(!oe)return ae;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let V=(0,T.relativePath)(oe.uri,j);return B&&oe.name&&(V=`${oe.name}/${V}`),V}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:j,removed:ae}=_.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:ae}))}findFiles(F,B,j,ae,oe=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ae.value}, entryPoint: findFiles`);let V;if(B===null?V=!1:B&&(typeof B=="string"?V=B:V=B.pattern),oe&&oe.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:M}=r(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(H),(0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)(V),(0,C.withUndefinedAsNull)(j),oe).then(K=>Array.isArray(K)?K.map(N=>l.URI.revive(N)):[])}async findTextInFiles(F,B,j,ae,oe=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ae.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),H=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:M,folder:K}=r(B.include),N=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,G={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:H,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:M,excludePattern:N},me=!1;if(this._activeSearchCallbacks[V]=W=>{if(me)return;const ne=l.URI.revive(W.resource);W.results.forEach(ge=>{(0,t.resultIsMatch)(ge)?j({uri:ne,preview:{text:ge.preview.text,matches:(0,d.mapArrayOrNot)(ge.preview.matches,_e=>new v.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,d.mapArrayOrNot)(ge.ranges,_e=>new v.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):j({uri:ne,text:ge.text,lineNumber:ge.lineNumber})})},oe.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(K),G,V,oe);return delete this._activeSearchCallbacks[V],W||{}}catch(W){throw delete this._activeSearchCallbacks[V],W}}$handleTextSearchResult(F,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};I=We([He(0,p.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,A.IExtHostFileSystemInfo),He(3,g.ILogService)],I),e.ExtHostWorkspace=I,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function r(P){let F,B;return P&&(typeof P=="string"?F=P:(F=P.pattern,B=P.baseFolder||l.URI.file(P.base))),{includePattern:F,folder:B}}}),define(we[33],be([0,1,23,3,32,5,7,157,65,10,15,4,13,16,2]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(a,s){if(s){const i=s.split(".");let c=a;for(let f=0;c&&f<i.length;f++)c=c[i[f]];return c}}function b(a){return a instanceof u.URI}function w(a){return a&&a.uri instanceof u.URI&&a.languageId&&typeof a.languageId=="string"}function A(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function o(a){return a&&a.uri instanceof u.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function p(a){if(b(a))return{resource:a};if(w(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(A(a))return{overrideIdentifier:a.languageId};if(o(a))return{resource:a.uri};if(a===null)return{resource:null}}let v=class{constructor(s,i,c){this._proxy=s.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};v=We([He(0,l.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,h.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,i,c,f){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=f,this._extHostWorkspace=i,this._configuration=E.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=E.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(s,i,c){const f=p(i)||{},m=this._toReadonlyValue(s?g(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,f,c?.identifier);function _(r){if(r==null)return null;if(typeof r=="boolean")return r?1:4;switch(r){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const I={has(r){return typeof g(m,r)!="undefined"},get:(r,P)=>{this._validateConfigurationAccess(s?`${s}.${r}`:r,f,c?.identifier);let F=g(m,r);if(typeof F=="undefined")F=P;else{let B;const j=(ae,oe)=>{let V;const H=()=>{B=B||(0,d.deepClone)(m),V=V||g(B,oe)};return(0,T.isObject)(ae)?new Proxy(ae,{get:(M,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return H(),()=>V;if(B)return V=V||g(B,oe),V[K];const N=M[K];return typeof K=="string"?j(N,`${oe}.${K}`):N},set:(M,K,N)=>(H(),V&&(V[K]=N),!0),deleteProperty:(M,K)=>(H(),V&&delete V[K],!0),defineProperty:(M,K,N)=>(H(),V&&Object.defineProperty(V,K,N),!0)}):ae};F=j(F,r)}return F},update:(r,P,F,B)=>{r=s?`${s}.${r}`:r;const j=_(F);return P!==void 0?this._proxy.$updateConfigurationOption(j,r,P,f,B):this._proxy.$removeConfigurationOption(j,r,f,B)},inspect:r=>{r=s?`${s}.${r}`:r;const P=(0,d.deepClone)(this._configuration.inspect(r,f,this._extHostWorkspace.workspace));if(P)return{key:r,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof m=="object"&&(0,d.mixin)(I,m,!1),Object.freeze(I)}_toReadonlyValue(s){const i=c=>(0,T.isObject)(c)?new Proxy(c,{get:(f,m)=>i(f[m]),set:(f,m,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}_validateConfigurationAccess(s,i,c){const f=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=c?`[${c.value}] `:"";if(f===4){typeof i?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const c=new E.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>c.affectsConfiguration(f,p(m))})}_toMap(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[108],be([0,1,2,15,3,5,23,7,32,50,33,20,39,13,29,4,11,22,16,74,174,12]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o,p,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(V){function H(K){if(K!=null)return K}V.from=H;function M(K){if(K!=null)return K}V.to=M})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(V){function H(K){if(K!=null)return K}V.from=H;function M(K){if(K!=null)return K}V.to=M})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(V){function H(K){if(K!=null)return K}V.from=H;function M(K){if(K!=null)return K}V.to=M})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(V){function H(N){if(N){const G=N;return G&&!!G.process}else return!1}V.is=H;function M(N){if(N==null)return;const G={process:N.process,args:N.args};return N.options&&(G.options=i.from(N.options)),G}V.from=M;function K(N){if(N!=null)return new E.ProcessExecution(N.process,N.args,N.options)}V.to=K})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(V){function H(K){if(K!=null)return K}V.from=H;function M(K){if(K!=null)return K}V.to=M})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(V){function H(N){if(N){const G=N;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=H;function M(N){if(N==null)return;const G={};return N.commandLine!==void 0?G.commandLine=N.commandLine:(G.command=N.command,G.args=N.args),N.options&&(G.options=f.from(N.options)),G}V.from=M;function K(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new E.ShellExecution(N.commandLine,N.options):new E.ShellExecution(N.command,N.args?N.args:[],N.options)}V.to=K})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var _;(function(V){function H(N){if(N){let G=N;return G&&G.customExecution==="customExecution"}else return!1}V.is=H;function M(N){return{customExecution:"customExecution"}}V.from=M;function K(N,G){return G.get(N)}V.to=K})(_=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(V){function H(M,K){let N;return M.scope!==void 0&&typeof M.scope!="number"?N=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===E.TaskScope.Workspace&&K&&K.workspaceFile?N=K.workspaceFile:N=p.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:N}}V.from=H})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var r;(function(V){function H(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}V.from=H})(r=e.TaskGroupDTO||(e.TaskGroupDTO={}));var P;(function(V){function H(N,G){if(N==null)return[];const me=[];for(let W of N){const ne=M(W,G);ne&&me.push(ne)}return me}V.fromMany=H;function M(N,G){if(N==null)return;let me;N.execution instanceof E.ProcessExecution?me=c.from(N.execution):N.execution instanceof E.ShellExecution?me=m.from(N.execution):N.execution&&N.execution instanceof E.CustomExecution&&(me=_.from(N.execution));const W=a.from(N.definition);let ne;return N.scope?typeof N.scope=="number"?ne=N.scope:ne=N.scope.uri:ne=E.TaskScope.Workspace,!W||!ne?void 0:{_id:N._id,definition:W,name:N.name,source:{extensionId:G.identifier.value,label:N.source,scope:ne},execution:me,isBackground:N.isBackground,group:r.from(N.group),presentationOptions:s.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=M;async function K(N,G,me){if(N==null)return;let W;c.is(N.execution)?W=c.to(N.execution):m.is(N.execution)?W=m.to(N.execution):_.is(N.execution)&&(W=_.to(N._id,me));const ne=a.to(N.definition);let ge;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?ge=N.source.scope:ge=await G.resolveWorkspaceFolder(d.URI.revive(N.source.scope)):ge=E.TaskScope.Workspace),!ne||!ge)return;const _e=new E.Task(ne,ge,N.name,N.source.label,W,N.problemMatchers);return N.isBackground!==void 0&&(_e.isBackground=N.isBackground),N.group!==void 0&&(_e.group=E.TaskGroup.from(N.group._id),_e.group&&(_e.group=k.deepClone(_e.group),N.group.isDefault&&(_e.group.isDefault=N.group.isDefault))),N.presentationOptions&&(_e.presentationOptions=s.to(N.presentationOptions)),N._id&&(_e._id=N._id),N.detail&&(_e.detail=N.detail),_e}V.to=K})(P=e.TaskDTO||(e.TaskDTO={}));var F;(function(V){function H(K){return K}V.from=H;function M(K){if(!!K)return Object.assign(Object.create(null),K)}V.to=M})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class B{constructor(H,M,K){this._id=M,this._task=K,t.set(this,void 0),nt(this,t,H,"f")}get task(){return this._task}terminate(){Ue(this,t,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}t=new WeakMap;var j;(function(V){function H(M){return{id:M._id,task:void 0}}V.from=H})(j=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let ae=class{constructor(H,M,K,N,G,me,W,ne){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=H.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=N,this._configurationService=G,this._terminalService=me,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,M,K){if(!K)return new E.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:M,provider:K,extension:H}),this._proxy.$registerTaskProvider(N,M),new E.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(H,M){this._proxy.$registerTaskSystem(H,M)}fetchTasks(H){return this._proxy.$fetchTasks(F.from(H)).then(async M=>{const K=[];for(let N of M){const G=await P.to(N,this._workspaceProvider,this._providedCustomExecutions2);G&&K.push(G)}return K})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(M=>H.push(M)),H}terminateTask(H){if(!(H instanceof B))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,M,K){const N=this._providedCustomExecutions2.get(H.id);if(N){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,N),this._terminalService.attachPtyToTerminal(M,await N.callback(K))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const M=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const M=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:M,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const M=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:H.exitCode})}$provideTasks(H,M){const K=this._handlers.get(H);if(!K)return Promise.reject(new Error("no handler found"));const N=[],G=(0,R.asPromise)(()=>K.provider.provideTasks(C.CancellationToken.None)).then(me=>this.provideTasksInternal(M,N,K,me));return new Promise(me=>{G.then(W=>{Promise.all(N).then(()=>{me(W)})})})}async $resolveTask(H,M){const K=this._handlers.get(H);if(!K)return Promise.reject(new Error("no handler found"));if(M.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${K.type}].`);const N=await P.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const G=await K.provider.resolveTask(N,C.CancellationToken.None);if(!G)return;this.checkDeprecation(G,K);const me=P.from(G,K.extension);if(!me)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return _.is(me.execution)&&await this.addCustomExecution(me,G,!0),await this.resolveTaskInternal(me)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,M,K){const N=await this._proxy.$createTaskId(H);!K&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,M.execution)}async getTaskExecution(H,M){if(typeof H=="string"){const G=this._taskExecutionPromises.get(H);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let K=this._taskExecutionPromises.get(H.id);if(K)return K;const N=new Promise(async(G,me)=>{const W=M||await P.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);W?G(new B(this,H.id,W)):me("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,N),N.then(G=>(this._taskExecutions.set(H.id,G),G),G=>Promise.reject(G))}checkDeprecation(H,M){H._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let K=this._notProvidedCustomExecutions.values(),N=K.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=K.next()}};ae=We([He(0,h.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,y.IExtHostWorkspace),He(3,T.IExtHostDocumentsAndEditors),He(4,n.IExtHostConfiguration),He(5,l.IExtHostTerminalService),He(6,A.ILogService),He(7,o.IExtHostApiDeprecationService)],ae),e.ExtHostTaskBase=ae;let oe=class extends ae{constructor(H,M,K,N,G,me,W,ne){super(H,M,K,N,G,me,W,ne);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(H,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const K=P.from(M,H);if(K===void 0)throw new Error("Task is not valid");if(_.is(K.execution))await this.addCustomExecution(K,M,!1);else throw new v.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),M);return this._proxy.$executeTask(K).catch(G=>{throw new Error(G)}),N}provideTasksInternal(H,M,K,N){const G=[];if(N)for(let me of N){this.checkDeprecation(me,K),(!me.definition||!H[me.definition.type])&&this._logService.warn(`The task [${me.source}, ${me.name}] uses an undefined task type. The task will be ignored in the future.`);const W=P.from(me,K.extension);W&&_.is(W.execution)?(G.push(W),M.push(this.addCustomExecution(W,me,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:K.extension}}async resolveTaskInternal(H){if(_.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,M,K){}};oe=We([He(0,h.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,y.IExtHostWorkspace),He(3,T.IExtHostDocumentsAndEditors),He(4,n.IExtHostConfiguration),He(5,l.IExtHostTerminalService),He(6,A.ILogService),He(7,o.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(we[224],be([0,1,17,52,27,83,21,11,14,25,8,10,2,120,143,93,47,100,223,40]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(_,I,r,P){this.configurationService=_,this.workspaceContextService=I,this.editorGroupsService=r,this.pathService=P}text(_,I,r={}){_=this.getContentPattern(_,r);const P=this.configurationService.getValue(),F=I&&I.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep);return{...this.commonQuery(I?.map(b.toWorkspaceFolder),r),type:2,contentPattern:_,previewOptions:r.previewOptions,maxFileSize:r.maxFileSize,usePCRE2:P.search.usePCRE2||F||!1,beforeContext:r.beforeContext,afterContext:r.afterContext,userDisabledExcludesAndIgnoreFiles:r.disregardExcludeSettings&&r.disregardIgnoreFiles}}getContentPattern(_,I){const r=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const P={..._,wordSeparators:r.editor.wordSeparators};return this.isCaseSensitive(_,I)&&(P.isCaseSensitive=!0),this.isMultiline(_)&&(P.isMultiline=!0),P}file(_,I={}){return{...this.commonQuery(_,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}handleIncludeExclude(_,I){return _?(_=Array.isArray(_)?_.map(i):i(_),I?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],I={}){const r=this.handleIncludeExclude(I.includePattern,I.expandPatterns),P=this.handleIncludeExclude(I.excludePattern,I.expandPatterns),F=_.length>1,B=(r.searchPaths&&r.searchPaths.length?r.searchPaths.map(oe=>this.getFolderQueryForSearchPath(oe,I,P)):_.map(oe=>this.getFolderQueryForRoot(oe,I,P,F))).filter(oe=>!!oe),j={_reason:I._reason,folderQueries:B,usingSearchPaths:!!(r.searchPaths&&r.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:P.pattern,includePattern:r.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const V=d.coalesce(d.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(K=>K.resource)))).filter(M=>(0,o.pathIncludedInQuery)(j,M.fsPath)),H=this.commonQueryFromFileList(V);return{...j,...H}}const ae=I.extraFileResources&&I.extraFileResources.filter(oe=>(0,o.pathIncludedInQuery)(j,oe.fsPath));return j.extraFileResources=ae&&ae.length?ae:void 0,j}commonQueryFromFileList(_){const I=[],r=new k.ResourceMap,P={};let F=!1;return _.forEach(B=>{if(B.scheme===E.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(B)){const ae=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:y.dirname(B.fsPath)});let oe=r.get(ae);oe||(F=!0,oe={folder:ae,includePattern:{}},I.push(oe),r.set(ae,oe));const V=y.relative(ae.fsPath,B.fsPath);(0,C.assertIsDefined)(oe.includePattern)[V.replace(/\\/g,"/")]=!0}else B.fsPath&&(F=!0,P[B.fsPath]=!0)}),{folderQueries:I,includePattern:P,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(_,I){if(I.isSmartCase){if(_.isRegExp){if(n.containsUppercaseCharacter(_.pattern,!0))return!0}else if(n.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,h.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const I=H=>y.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),P=(Array.isArray(_)?_:a(_)).map(H=>{const M=this.pathService.resolvedUserHome;return M?(0,S.untildify)(H,M.scheme===E.Schemas.file?M.fsPath:M.path):H}),F=R.groupBy(P,H=>I(H)?"searchPaths":"exprSegments"),B=(F.exprSegments||[]).map(H=>n.rtrim(H,"/")).map(H=>n.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),j={},ae=this.expandSearchPathPatterns(F.searchPaths||[]);ae&&ae.length&&(j.searchPaths=ae);const oe=d.flatten(B),V=t(...oe);return V&&(j.pattern=V),j}getExcludesForFolder(_,I){return I.disregardExcludeSettings?void 0:(0,o.getExcludes)(_,!I.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const I=d.flatten(_.map(P=>{let{pathPortion:F,globPortion:B}=v(P);B&&(B=c(B));const j=this.expandOneSearchPath(F);return d.flatten(j.map(ae=>this.resolveOneSearchPathPattern(ae,B)))})),r=new Map;return I.forEach(P=>{const F=P.searchPath.toString(),B=r.get(F);B?P.pattern&&(B.pattern=B.pattern||{},B.pattern[P.pattern]=!0):r.set(F,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(r.values())}expandOneSearchPath(_){if(y.isAbsolute(_)){const I=this.workspaceContextService.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==E.Schemas.file?[{searchPath:I[0].uri.with({path:_})}]:[{searchPath:l.URI.file(y.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const I=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=i(_),_.startsWith("../")||_===".."){const P=y.posix.resolve(I.path,_);return[{searchPath:I.with({path:P})}]}const r=c(_);return[{searchPath:I,pattern:r}]}else{if(_==="./"||_===".\\")return[];{const I=_.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(F=>{const B=I.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return B?{match:B,folder:F}:null}).filter(C.isDefined);if(P.length)return P.map(F=>{const B=F.match[1];return{searchPath:F.folder.uri,pattern:B&&c(B)}});{const F=_.match(/\.[\/\\](.+)[\/\\]?/),B=F?F[1]:_,j=u.localize(0,null,B);throw new Error(j)}}}}resolveOneSearchPathPattern(_,I){const r=_.pattern&&I?`${_.pattern}/${I}`:_.pattern||I,P=[{searchPath:_.searchPath,pattern:r}];return r&&!r.endsWith("**")&&P.push({searchPath:_.searchPath,pattern:r+"/**"}),P}getFolderQueryForSearchPath(_,I,r){const P=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(_.searchPath),I,r,!1);return P?{...P,includePattern:_.pattern}:null}getFolderQueryForRoot(_,I,r,P){let F;const B=l.URI.isUri(_)?_:_.uri;if(r.searchPaths){const H=r.searchPaths.filter(M=>(0,T.isEqual)(M.searchPath,B))[0];if(H&&!H.pattern)return null;H&&(F=H.pattern)}const j=this.configurationService.getValue({resource:B}),oe={...this.getExcludesForFolder(j,I)||{},...F||{}},V=l.URI.isUri(_)?(0,T.basename)(_):_.name;return{folder:B,folderName:P?V:void 0,excludePattern:Object.keys(oe).length>0?oe:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!j.search.followSymlinks}}};p=We([He(0,g.IConfigurationService),He(1,b.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,A.IPathService)],p),e.QueryBuilder=p;function v(m){const _=m.match(/[\*\{\}\(\)\[\]\?]/);if(_){const I=_.index,r=m.substr(0,I).match(/[/|\\][^/\\]*$/);if(r){let P=m.substr(0,r.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:m.substr((r.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((_,I)=>(_[I]=!0,_),Object.create(null)):void 0}function a(m){return D.splitGlobAware(m,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function i(m){return m.replace(/\\/g,"/")}function c(m){return i(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,_){m=d.distinct(m,P=>P.toString());const I=[],r=_.getWorkspace();return m&&m.forEach(P=>{let F;if(_.getWorkbenchState()===2)F=(0,T.relativePath)(r.folders[0].uri,P),F&&F!=="."&&(F="./"+F);else{const B=_.getWorkspaceFolder(P);if(B){const j=B.name;if(r.folders.filter(oe=>oe.name===j).length===1){const oe=(0,T.relativePath)(B.uri,P);oe===""?F=`./${B.name}`:F=`./${B.name}/${oe}`}else F=P.fsPath}}F&&I.push(F)}),I}e.resolveResourcesForSearchIncludes=f}),define(we[225],be([0,1,25,2,20,12,4,224,40,47]),function(ee,e,d,R,D,S,k,E,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function C(g,b){const w=b.activationEvents;if(!w)return Promise.resolve(void 0);const A=[],o=[];for(const i of w)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||g.forceUsingSearch?o.push(c):A.push(c)}if(A.length===0&&o.length===0)return Promise.resolve(void 0);let p;const v=new Promise((i,c)=>{p=i}),t=i=>p({activationEvent:i}),a=Promise.all(A.map(i=>l(g,i,t))).then(()=>{}),s=h(g,b.identifier,o,t);return Promise.all([a,s]).then(()=>{p(void 0)}),v}e.checkActivateWorkspaceContainsExtension=C;async function l(g,b,w){for(const A of g.folders)if(await g.exists(d.joinPath(R.URI.revive(A),b))){w(`workspaceContains:${b}`);return}}async function h(g,b,w,A){if(w.length===0)return Promise.resolve(void 0);const o=new D.CancellationTokenSource,p=g.checkExists(g.folders,w,o.token),v=setTimeout(async()=>{o.cancel(),A(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await p}catch(a){S.isPromiseCanceledError(a)||S.onUnexpectedError(a)}o.dispose(),clearTimeout(v),t&&A(`workspaceContains:${w.join(",")}`)}function u(g,b,w,A){const o=g.get(k.IInstantiationService),p=g.get(y.ISearchService),t=o.createInstance(E.QueryBuilder).file(b.map(a=>(0,T.toWorkspaceFolder)(R.URI.revive(a))),{_reason:"checkExists",includePattern:w,exists:!0});return p.fileSearch(t,A).then(a=>!!a.limitHit,a=>S.isPromiseCanceledError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=u});var nt=this&&this.__classPrivateFieldSet||function(ee,e,d,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(ee,d):D?D.value=d:e.set(ee,d),d},Ue=this&&this.__classPrivateFieldGet||function(ee,e,d,R){if(d==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!R:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?R:d==="a"?R.call(ee):R?R.value:e.get(ee)};define(we[34],be([0,1,134,14,78,25,15,6,21,2,16,5,33,187,76,32,30,185,12,26,24,161,7,94,4,29,77,13,64,69,39,3,225,73,163]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o,p,v,t,a,s,i,c,f,m,_,I,r,P,F,B){"use strict";var j,ae,oe;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=class Wn extends E.Disposable{constructor(N,G,me,W,ne,ge,_e,Me,Fe,xe){super();this._onDidChangeRemoteConnectionData=this._register(new r.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=me,this._initData=_e,this._extHostWorkspace=W,this._extHostConfiguration=ne,this._logService=ge,this._extHostTunnelService=Fe,this._extHostTerminalService=xe,this._disposables=new E.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Me,this._instaService=N.createChild(new m.ServiceCollection([u.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Ve=>Ye.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,A.transformErrorForSerialization(qe),x)},actualActivateExtension:async(Ve,qe)=>{if(Ye.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,qe),new h.HostExtension;const x=this._registry.getExtensionDescription(Ve);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){A.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this._deactivate(ne))}catch(G){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,G){return this._activator.activateByEvent(N,G)}_activateById(N,G){return this._activator.activateById(N,G)}activateByIdWithErrors(N,G){return this._activateById(N,G).then(()=>{const me=this._activator.getActivatedExtension(N);if(me.activationFailed)return Promise.reject(me.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=y.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(me=>{if(!!this._getEntryPoint(me))return this._hostUtils.realpath(me.extensionLocation.fsPath).then(W=>N.set(T.URI.file(W).fsPath,me))});this._extensionPathIndex=Promise.all(G).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return G;const me=this._activator.getActivatedExtension(N);if(!me)return G;try{typeof me.module.deactivate=="function"&&(G=Promise.resolve(me.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,E.dispose)(me.subscriptions)}catch(W){this._logService.error(W)}return G}async _activateExtension(N,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,G).then(me=>{const W=me.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,G),this._logExtensionActivationTimes(N,G,"success",W),me},me=>{throw this._logExtensionActivationTimes(N,G,"failure"),me})}_logExtensionActivationTimes(N,G,me,W){const ne=H(N,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ne,...W||{},outcome:me})}_doActivateExtension(N,G){const me=H(N,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",me);const W=this._getEntryPoint(N);if(!W)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const ne=new h.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,S.joinPath)(N.extensionLocation,W),ne),this._loadExtensionContext(N)]).then(ge=>(D.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),Wn._callActivate(this._logService,N.identifier,ge[0],ge[1],ne))).then(ge=>(D.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),ge))}_loadExtensionContext(N){const G=new v.ExtensionGlobalMemento(N,this._storage),me=new v.ExtensionMemento(N.identifier.value,!1,this._storage),W=new B.ExtensionSecrets(N,this._secretState),ne=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([G.whenReady,me.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let Me;return Object.freeze({globalState:G,workspaceState:me,secrets:W,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(Fe){return R.join(N.extensionLocation.fsPath,Fe)},get storagePath(){return _e._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(N).fsPath},get logPath(){return R.join(_e._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return T.URI.joinPath(_e._initData.logsLocation,N.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(N)},get globalStorageUri(){return _e._storagePath.globalValue(N)},get extensionMode(){return ne},get extension(){return Me===void 0&&(Me=new M(_e,N.identifier,N,ge)),Me},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(N),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,G,me,W,ne){return me=me||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,G,me,W,ne).then(ge=>new h.ActivatedExtension(!1,null,ne.build(),me,ge,W.subscriptions))}static _callActivateOptional(N,G,me,W,ne){if(typeof me.activate=="function")try{ne.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${G.value}`);const ge=typeof global=="object"?global:self,_e=me.activate.apply(ge,[W]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(_e).then(Me=>(ne.activateResolveStop(),Me))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(me)}_activateOneStartupFinished(N,G){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:G}).then(void 0,me=>{this._logService.error(me)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const G of N.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(N,G)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],me=this._handleWorkspaceContainsEagerExtensions(G),W=Promise.all([N,me]).then(()=>{});return Promise.race([W,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(N,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,G){if(this.isActivated(G.identifier))return;const me=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:N.map(ge=>ge.uri),forceUsingSearch:me,exists:ge=>this._hostUtils.exists(ge.fsPath),checkExists:(ge,_e,Me)=>this._mainThreadWorkspaceProxy.$checkExists(ge,_e,Me)},ne=await(0,P.checkActivateWorkspaceContainsExtension)(W,G);if(!!ne)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ne.activationEvent}).then(void 0,ge=>this._logService.error(ge))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:G}=this._initData.environment;if(!N||!G)throw new Error(d.localize(0,null));const me=await this._loadCommonJSModule(null,G,new h.ExtensionActivationTimesBuilder(!1));if(!me||typeof me.run!="function")throw new Error(d.localize(1,null,G.toString()));return new Promise((W,ne)=>{const ge=(Fe,xe)=>{Fe?ne(Fe):W(typeof xe=="number"&&xe>0?1:0)},_e=(0,S.originalFSPath)(G),Me=me.run(_e,ge);Me&&Me.then&&Me.then(()=>{W(0)}).catch(Fe=>{ne(Fe.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,G){return this._resolvers[N]=G,(0,E.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const G=N.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const me=N.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${me}`,!1),{authorityPrefix:me,resolver:this._resolvers[me]}}async $resolveAuthority(N,G){const{authorityPrefix:me,resolver:W}=await this._activateAndGetResolver(N);if(!W)return{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${me}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),D.mark(`code/extHost/willResolveAuthority/${me}`);const ne=await W.resolve(N,{resolveAttempt:G});D.mark(`code/extHost/didResolveAuthorityOK/${me}`);const ge={authority:N,host:ne.host,port:ne.port,connectionToken:ne.connectionToken},_e={extensionHostEnv:ne.extensionHostEnv,isTrusted:ne.isTrusted};return{type:"ok",value:{authority:ge,options:_e,tunnelInformation:{environmentTunnels:ne.environmentTunnels}}}}catch(ne){if(D.mark(`code/extHost/didResolveAuthorityError/${me}`),ne instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ne._code,message:ne._message,detail:ne._detail}};throw ne}}async $getCanonicalURI(N,G){const{authorityPrefix:me,resolver:W}=await this._activateAndGetResolver(N);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${me}`);const ne=T.URI.revive(G);if(typeof W.getCanonicalURI=="undefined")return ne;const ge=await(0,k.asPromise)(()=>W.getCanonicalURI(ne));return ge||ne}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,G){return G===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(me=>this._activateByEvent(N,!1))}async $activate(N,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,G),!0):!1}async $deltaExtensions(N,G){N.forEach(W=>W.extensionLocation=T.URI.revive(W.extensionLocation));const me=await this.getExtensionPathIndex();return await Promise.all(G.map(async W=>{const ne=this._registry.getExtensionDescription(W);if(!ne)return;const ge=await this._hostUtils.realpath(ne.extensionLocation.fsPath);me.delete(T.URI.file(ge).fsPath)})),await Promise.all(N.map(async W=>{const ne=await this._hostUtils.realpath(W.extensionLocation.fsPath);me.set(T.URI.file(ne).fsPath,W)})),this._registry.deltaExtensions(N,G),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let G=p.VSBuffer.alloc(N),me=Math.random()%256;for(let W=0;W<N;W++)G.writeUInt8(me,W);return G}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};V=We([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,f.IExtHostRpcService),He(3,g.IExtHostWorkspace),He(4,l.IExtHostConfiguration),He(5,n.ILogService),He(6,i.IExtHostInitDataService),He(7,c.IExtensionStoragePaths),He(8,_.IExtHostTunnelService),He(9,I.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function H(K,N){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class M{constructor(N,G,me,W){j.set(this,void 0),ae.set(this,void 0),oe.set(this,void 0),nt(this,j,N,"f"),nt(this,ae,G,"f"),nt(this,oe,me.identifier,"f"),this.id=me.identifier.value,this.extensionUri=me.extensionLocation,this.extensionPath=R.normalize((0,S.originalFSPath)(me.extensionLocation)),this.packageJSON=me,this.extensionKind=W}get isActive(){return Ue(this,j,"f").isActivated(Ue(this,oe,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,j,"f").getExtensionExports(Ue(this,oe,"f"))}activate(){return Ue(this,j,"f").activateByIdWithErrors(Ue(this,oe,"f"),{startup:!1,extensionId:Ue(this,ae,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,j=new WeakMap,ae=new WeakMap,oe=new WeakMap}),define(we[109],be([0,1,14,2,3,15,5,7,171,32,34,50,176,33,172,13,4,10,42,67]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let p=class{constructor(m,_,I,r,P,F){this._workspaceService=_,this._extensionService=I,this._editorsService=r,this._configurationService=P,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=m.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(j=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,_){const I=m;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let r=`debug:${encodeURIComponent(I.path||"")}`,P="?";return _&&(r+=`${P}session=${encodeURIComponent(_.id)}`,P="&"),r+=`${P}ref=${I.sourceReference}`,R.URI.parse(r)}else{if(I.path)return R.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const _=[];for(const I of m.getAllExtensionDescriptions())if(I.contributes){const r=I.contributes.debuggers;if(r&&r.length>0)for(const P of r)(0,u.isDebuggerMainContribution)(P)&&_.push(P.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(_=>m.push(_)),m}addBreakpoints(m){this.startBreakpoints();const _=m.filter(P=>{const F=P.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,P),!0)});this.fireBreakpointChanges(_,[],[]);const I=[],r=new Map;for(const P of _)if(P instanceof E.SourceBreakpoint){let F=r.get(P.location.uri.toString());F||(F={type:"sourceMulti",uri:P.location.uri,lines:[]},r.set(P.location.uri.toString(),F),I.push(F)),F.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof E.FunctionBreakpoint&&I.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(I)}removeBreakpoints(m){this.startBreakpoints();const _=m.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],_,[]);const I=_.filter(F=>F instanceof E.SourceBreakpoint).map(F=>F.id),r=_.filter(F=>F instanceof E.FunctionBreakpoint).map(F=>F.id),P=_.filter(F=>F instanceof E.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(I,r,P)}startDebugging(m,_,I){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,_,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,debugUI:I.debugUI})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,_,I){if(!_)return new E.Disposable(()=>{});const r=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:r,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,I,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,r),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(m,_,I){if(!I)return new E.Disposable(()=>{});if(!this.definesDebugType(m,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:r,factory:I}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,r),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==I),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(m,_){if(!_)return new E.Disposable(()=>{});const I=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:I,factory:_}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(r=>r.factory!==_)})}async $runInTerminal(m,_){return Promise.resolve(void 0)}async $substituteVariables(m,_){if(!this._variableResolver){const[P,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,F)}let I;const r=await this.getFolder(m);return r&&(I={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(I,_)}createDebugAdapter(m,_){if(m.type==="implementation")return new i(m.implementation)}createSignService(){}async $startDASession(m,_){const I=this,r=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(r.type),r).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const F=this.convertToDto(P),B=this.createDebugAdapter(F,r);if(!B)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const j=B;return this._debugAdapters.set(m,j),this.getDebugAdapterTrackers(r).then(ae=>(ae&&this._debugAdaptersTrackers.set(m,ae),j.onMessage(async oe=>{if(oe.type==="request"&&oe.command==="handshake"){const V=oe,H={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(V.arguments.value);H.body={signature:M},j.sendResponse(H)}else throw new Error("no signer")}catch(M){H.success=!1,H.message=M.message,j.sendResponse(H)}}else ae&&ae.onDidSendMessage&&ae.onDidSendMessage(oe),oe=(0,u.convertToVSCPaths)(oe,!0),I._debugServiceProxy.$acceptDAMessage(m,oe)}),j.onError(oe=>{ae&&ae.onError&&ae.onError(oe),this._debugServiceProxy.$acceptDAError(m,oe.name,oe.message,oe.stack)}),j.onExit(oe=>{ae&&ae.onExit&&ae.onExit((0,w.withNullAsUndefined)(oe),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,w.withNullAsUndefined)(oe),void 0)}),ae&&ae.onWillStartSession&&ae.onWillStartSession(),j.startSession()))})}$sendDAMessage(m,_){_=(0,u.convertToDAPaths)(_,!1);const I=this._debugAdaptersTrackers.get(m);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(_);const r=this._debugAdapters.get(m);r&&r.sendMessage(_)}$stopDASession(m){const _=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),_&&_.onWillStopSession&&_.onWillStopSession();const I=this._debugAdapters.get(m);return this._debugAdapters.delete(m),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const _=[],I=[],r=[];if(m.added)for(const P of m.added){const F=P.id;if(F&&!this._breakpoints.has(F)){let B;if(P.type==="function")B=new E.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")B=new E.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const j=R.URI.revive(P.uri);B=new E.SourceBreakpoint(new E.Location(j,new E.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}B._id=F,this._breakpoints.set(F,B),_.push(B)}}if(m.removed)for(const P of m.removed){const F=this._breakpoints.get(P);F&&(this._breakpoints.delete(P),I.push(F))}if(m.changed){for(const P of m.changed)if(P.id){const F=this._breakpoints.get(P.id);if(F){if(F instanceof E.FunctionBreakpoint&&P.type==="function"){const B=F;B.enabled=P.enabled,B.condition=P.condition,B.hitCondition=P.hitCondition,B.logMessage=P.logMessage,B.functionName=P.functionName}else if(F instanceof E.SourceBreakpoint&&P.type==="source"){const B=F;B.enabled=P.enabled,B.condition=P.condition,B.hitCondition=P.hitCondition,B.logMessage=P.logMessage,B.location=new E.Location(R.URI.revive(P.uri),new E.Position(P.line,P.character))}r.push(F)}}}this.fireBreakpointChanges(_,I,r)}$provideDebugConfigurations(m,_,I){return(0,S.asPromise)(async()=>{const r=this.getConfigProviderByHandle(m);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(_);return r.provideDebugConfigurations(P,I)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(m,_,I,r){return(0,S.asPromise)(async()=>{const P=this.getConfigProviderByHandle(m);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(_);return P.resolveDebugConfiguration(F,I,r)})}$resolveDebugConfigurationWithSubstitutedVariables(m,_,I,r){return(0,S.asPromise)(async()=>{const P=this.getConfigProviderByHandle(m);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(_);return P.resolveDebugConfigurationWithSubstitutedVariables(F,I,r)})}async $provideDebugAdapter(m,_){const I=this.getAdapterDescriptorFactoryByHandle(m);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.getSession(_);return this.getAdapterDescriptor(I,r).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(m){const _=await this.getSession(m);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(m){const _=await this.getSession(m);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,_){const I=await this.getSession(m);I&&I._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(m,_){const r={session:await this.getSession(m),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(r)}convertToDto(m){if(m instanceof E.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof E.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const _=this._adapterFactories.filter(I=>I.type===m);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(m){const _=this._adapterFactories.filter(I=>I.handle===m);if(_.length>0)return _[0].factory}getConfigProviderByHandle(m){const _=this._configProviders.filter(I=>I.handle===m);if(_.length>0)return _[0].provider}definesDebugType(m,_){if(m.contributes){const I=m.contributes.debuggers;if(I&&I.length>0){for(const r of I)if(r.label&&r.type&&r.type===_)return!0}}return!1}getDebugAdapterTrackers(m){const I=m.configuration.type,r=this._trackerFactories.filter(P=>P.type===I||P.type==="*").map(P=>(0,S.asPromise)(()=>P.factory.createDebugAdapterTracker(m)).then(F=>F,F=>null));return Promise.race([Promise.all(r).then(P=>{const F=P.filter(B=>!!B);if(F.length>0)return new s(F)}),new Promise((P,F)=>{const B=setTimeout(()=>{clearTimeout(B),F(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(m,_){const I=_.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new E.DebugAdapterServer(I));if(m){const P=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>m.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,P))).then(F=>{if(F)return F})}const r=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,r))}daExecutableFromPackage(m,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,_,I){(m.length>0||_.length>0||I.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:_,changed:I}))}async getSession(m){if(m)if(typeof m=="string"){const _=this._debugSessions.get(m);if(_)return _}else{let _=this._debugSessions.get(m.id);if(!_){const I=await this.getFolder(m.folderUri),r=m.parent?this._debugSessions.get(m.parent):void 0;_=new v(this._debugServiceProxy,m.id,m.type,m.name,I,m.configuration,r),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(m){if(m){const _=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};p=We([He(0,g.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,n.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class v{constructor(m,_,I,r,P,F,B){this._debugServiceProxy=m,this._id=_,this._type=I,this._name=r,this._workspaceFolder=P,this._configuration=F,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,_)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=v;class t{constructor(m){this.value=Object.freeze({append(_){m.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class a extends l.AbstractVariableResolverService{constructor(m,_,I,r,P){function F(){if(_){const B=_.activeEditor();if(B)return B.document.uri;const j=r.tabs.filter(ae=>ae.isActive);if(j.length>0)return j[0].resource}}super({getFolderUri:B=>{const j=m.filter(ae=>ae.name===B);if(j&&j.length>0)return j[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(B,j)=>I.getConfiguration(void 0,B).get(j),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=F();if(B)return d.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const B=F();if(B){const j=P.getWorkspaceFolder(B);if(j)return d.normalize(j.uri.fsPath)}}},getSelectedText:()=>{if(_){const B=_.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(_){const B=_.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(A.env))}}e.ExtHostVariableResolverService=a;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(_=>_.onError?_.onError(m):void 0)}onExit(m,_){this.trackers.forEach(I=>I.onExit?I.onExit(m,_):void 0)}}class i extends y.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends p{constructor(m,_,I,r,P,F){super(m,_,I,r,P,F)}createVariableResolver(m,_,I){return new a(m,_,I,this._editorTabs)}};c=We([He(0,g.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,n.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(we[226],be([0,1,78,2,5,33,30,26,13,29,4,34,42,16]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(o,p,v,t,a,s,i){this._apiFactory=o,this._extensionRegistry=p,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=a,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,p,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,p,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let p of o.nodeModuleName)this._factories.set(p,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(p=>o.alternativeModuleName(p))}};u=We([He(2,n.IInstantiationService),He(3,S.IExtHostConfiguration),He(4,C.IExtHostExtensionService),He(5,T.IExtHostInitDataService),He(6,h.ILogService)],u),e.RequireInterceptor=u;class g{constructor(o,p,v,t,a){this._apiFactory=o,this._extensionPaths=p,this._extensionRegistry=v,this._configProvider=t,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,p){const v=this._extensionPaths.findSubstr(p.fsPath);if(v){let t=this._extApiImpl.get(E.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(E.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((a,s)=>t+=`	${s} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(o,p){this.nodeModuleName="keytar";const{environment:v}=p,t=o.getProxy(D.MainContext.MainThreadKeytar);if(v.appRoot){let a=v.appRoot.fsPath;l.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,s)=>t.$getPassword(a,s),setPassword:(a,s,i)=>t.$setPassword(a,s,i),deletePassword:(a,s)=>t.$deletePassword(a,s),findPassword:a=>t.$findPassword(a),findCredentials(a){return t.$findCredentials(a)}}}load(o,p){return this._impl}alternativeModuleName(o){const p=o.length;if(p<=7||!this.alternativeNames)return;const v=p-7;if((o.charAt(v)==="/"||o.charAt(v)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};b=We([He(0,y.IExtHostRpcService),He(1,T.IExtHostInitDataService)],b);let w=class{constructor(o,p,v){this._extensionPaths=o,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(D.MainContext.MainThreadTelemetry);const t=v.getProxy(D.MainContext.MainThreadWindow);this._impl=(a,s)=>{const i=R.URI.parse(a);return s?this.callOriginal(a,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,a,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,a,{}):this.callOriginal(a,s)}}load(o,p,v){const t=this._extensionPaths.findSubstr(p.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(o),this._impl}callOriginal(o,p){return this.sendNoForwardTelemetry(),this._original(o,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=We([He(2,y.IExtHostRpcService)],w)}),define(we[227],be([0,1,15,12,78,6,2,5,220,16,61,64,29,153,13,70,34,39]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class A{constructor(p,v,t,a){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(p,null,a),v=A._transform(v,this._rpcProtocol);const s=new C.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),s.set(g.IURITransformerService,new g.URITransformerService(a)),s.set(b.IHostUtils,t);const i=new h.InstantiationService(s,!0),c=i.invokeFunction(I=>I.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(I=>I.get(T.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(I=>I.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(I=>{Error.prepareStackTrace=(r,P)=>{let F="",B,j;for(const ae of P)F+=`
	at ${ae.toString()}`,j=ae.getFileName(),!B&&j&&(B=I.findSubstr(j));return f.set(r,B),`${r.name||"Error"}: ${r.message||""}${F}`}});const m=this._rpcProtocol.getProxy(E.MainContext.MainThreadExtensionService),_=this._rpcProtocol.getProxy(E.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(I=>{const r=R.transformErrorForSerialization(I),P=f.get(I);P?m.$onExtensionRuntimeError(P.identifier,r):_.$onUnexpectedError(r)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(p,v){p.extensions.forEach(a=>a.extensionLocation=k.URI.revive(v.transformIncomingURIs(a.extensionLocation))),p.environment.appRoot=k.URI.revive(v.transformIncomingURIs(p.environment.appRoot));const t=p.environment.extensionDevelopmentLocationURI;return t&&(p.environment.extensionDevelopmentLocationURI=t.map(a=>k.URI.revive(v.transformIncomingURIs(a)))),p.environment.extensionTestsLocationURI=k.URI.revive(v.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=k.URI.revive(v.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=k.URI.revive(v.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=k.URI.revive(v.transformIncomingURIs(p.logsLocation)),p.logFile=k.URI.revive(v.transformIncomingURIs(p.logFile)),p.workspace=v.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=A}),define(we[228],be([0,1,14,20,60,27,25,57,40]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(l,h,u){this.config=l,this.provider=h,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((u,g)=>{const b=w=>{this.resultCount++,l(w)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const A=w.toString(),o=d.basename(A);this.globalExcludePattern&&this.globalExcludePattern(A,o)||this.matchFile(b,{base:w,basename:o})}),Promise.all(h.map(w=>this.searchInFolder(w,b))).then(w=>{u({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{g(new Error((0,D.toErrorMessage)(w)))})})}async searchInFolder(l,h){const u=new R.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),w=new y.QueryGlobTester(this.config,l),A=!w.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(u),o=E.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,u.token),v=o.elapsed(),t=E.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(a=>{const s=d.posix.relative(l.folder.path,a.path);if(A){const i=d.basename(a.path);this.matchFile(h,{base:l.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(b,l.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,w,h),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(l){const h=(0,y.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),u=(0,y.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:u,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,u,g){if(u===this.filePattern){const w=d.basename(this.filePattern);this.matchFile(g,{base:h,relativePath:this.filePattern,basename:w})}function b(w){const A=d.basename(w),o=d.dirname(w);let p=l[o];p||(p=l[o]=[],b(o)),p.push({base:h,relativePath:w,basename:A})}b(u)}matchDirectoryTree({rootEntries:l,pathToEntries:h},u,g){const b=this,w=this.filePattern;function A(o){const p=S.hasSiblingFn(()=>o.map(v=>v.basename));for(let v=0,t=o.length;v<t;v++){const a=o[v],{relativePath:s,basename:i}=a;if(!u.includedInQuerySync(s,i,w!==i?p:void 0))continue;const c=h[s];if(c)A(c);else{if(s===w)continue;b.matchFile(g,a)}if(b.isLimitHit)break}}A(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class n{constructor(){this.sessions=new Map}fileSearch(l,h,u,g){const b=this.getSessionTokenSource(l.cacheKey),w=new T(l,h,b&&b.token);let A=0;const o=p=>{A+=p.length,u(p.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,n.BATCH_SIZE,o,g).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:A,detailStats:p.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:k.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,u,g){g.onCancellationRequested(()=>{l.cancel()});const b=A=>{A&&(w.push(A),h>0&&w.length>=h&&(u(w),w=[]))};let w=[];return l.search(b).then(A=>(w.length&&u(w),A),A=>(w.length&&u(w),Promise.reject(A)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(we[229],be([0,1,14,17,20,60,25,27,2,40,11,10]),function(ee,e,d,R,D,S,k,E,y,T,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(o,p,v){this.query=o,this.provider=p,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,p){const v=this.query.folderQueries||[],t=new D.CancellationTokenSource;return p.onCancellationRequested(()=>t.cancel()),new Promise((a,s)=>{this.collector=new u(o);let i=!1;const c=(f,m)=>{if(!i&&!this.isLimitHit){const _=this.resultSize(f);b(f)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const I=this.resultSize(f);this.resultCount+=I,(I>0||!b(f))&&this.collector.add(f,m)}};Promise.all(v.map((f,m)=>this.searchInFolder(f,_=>c(_,m),t.token))).then(f=>{t.dispose(),this.collector.flush();const m=f.some(_=>!!_&&!!_.limitHit);a({limitHit:this.isLimitHit||m,messages:(0,R.flatten)(f.map(_=>_?.message?(0,C.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const m=(0,S.toErrorMessage)(f);s(new Error(m))})})}resultSize(o){return b(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,p){const v=Array.isArray(o.ranges)?o.ranges:[o.ranges],t=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:v.slice(0,p),preview:{matches:t.slice(0,p),text:o.preview.text},uri:o.uri}}async searchInFolder(o,p,v){const t=new T.QueryGlobTester(this.query,o),a=[],s={report:f=>{if(!this.validateProviderResult(f))return;const m=o.folder.scheme===n.Schemas.file?E.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(f.uri))):void 0,_=k.relativePath(o.folder,f.uri);_&&a.push(t.includedInQuery(_,d.basename(_),m).then(I=>{I&&p(f)}))}},i=this.getSearchOptionsForFolder(o),c=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,s,v);return await Promise.all(a),c}validateProviderResult(o){if(b(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const p=(0,T.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),v=(0,T.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),t={folder:y.URI.from(o.folder),excludes:v,includes:p,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(A){return{isCaseSensitive:A.isCaseSensitive||!1,isRegExp:A.isRegExp||!1,isWordMatch:A.isWordMatch||!1,isMultiline:A.isMultiline||!1,pattern:A.pattern}}class u{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,p=>this.sendItems(p))}add(o,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!k.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(g(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=u;function g(A){return b(A)?{preview:{matches:(0,R.mapArrayOrNot)(A.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:A.preview.text},ranges:(0,R.mapArrayOrNot)(A.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:A.text,lineNumber:A.lineNumber}}function b(A){return!!A.preview}e.extensionResultIsMatch=b;class w{constructor(o,p){this.maxBatchSize=o,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,p){!o||this.addItemToBatch(o,p)}addItems(o,p){!o||this.addItemsToBatch(o,p)}addItemToBatch(o,p){this.batch.push(o),this.batchSize+=p,this.onUpdate()}addItemsToBatch(o,p){this.batch=this.batch.concat(o),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(we[110],be([0,1,6,5,4,228,13,70,16,2,229]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let C=class{constructor(g,b,w){this.extHostRpc=g,this._uriTransformer=b,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,b){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const w=this._handlePool++;return this._textSearchProvider.set(w,b),this._proxy.$registerTextSearchProvider(w,this._transformScheme(g)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(g,b){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const w=this._handlePool++;return this._fileSearchProvider.set(w,b),this._proxy.$registerFileSearchProvider(w,this._transformScheme(g)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(g,b,w,A){const o=l(w),p=this._fileSearchProvider.get(g);if(p)return this._fileSearchManager.fileSearch(o,p,v=>{this._proxy.$handleFileMatch(g,b,v.map(t=>t.resource))},A);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,b,w,A){const o=this._textSearchProvider.get(g);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const p=l(w);return this.createTextSearchManager(p,o).search(t=>this._proxy.$handleTextMatch(g,b,t),A)}createTextSearchManager(g,b){return new n.TextSearchManager(g,b,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=We([He(0,k.IExtHostRpcService),He(1,E.IURITransformerService),He(2,y.ILogService)],C),e.ExtHostSearch=C;function l(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(h),extraFileResources:u.extraFileResources&&u.extraFileResources.map(g=>T.URI.revive(g))}}e.reviveQuery=l;function h(u){return{...u,folder:T.URI.revive(u.folder)}}}),define(we[230],be([0,1,20,12,3,36,2,127,86,121,59,63,5,192,191,49,193,33,194,195,196,178,197,50,34,198,179,201,202,203,105,181,208,209,210,76,39,212,182,9,7,215,51,106,32,30,52,168,200,95,104,108,109,110,16,70,13,29,204,165,69,74,189,213,164,77,75,218,216,217,190,48,211,214,73,67,96,206,107,207,11,155,205,162,199]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o,p,v,t,a,s,i,c,f,m,_,I,r,P,F,B,j,ae,oe,V,H,M,K,N,G,me,W,ne,ge,_e,Me,Fe,xe,Ye,Ve,qe,x,Q,X,re,q,ie,pe,Te,Be,ve,Ke,z,Z,fe,Oe,Ne,Xe,De,ye,Ce,se,ue,O,Y,le,Ae,Pe,$e,je,et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function it(Je){const Qe=Je.get(X.IExtHostInitDataService),mt=Je.get(Xe.IExtHostFileSystemInfo),vt=Je.get(z.IExtHostConsumerFileSystem),Et=Je.get(s.IExtHostExtensionService),ot=Je.get(me.IExtHostWorkspace),at=Je.get(ue.IExtHostTelemetry),Dt=Je.get(w.IExtHostConfiguration),Ee=Je.get(x.IURITransformerService),he=Je.get(Q.IExtHostRpcService),ce=Je.get(j.IExtHostStorage),$=Je.get(Ke.IExtensionStoragePaths),Ie=Je.get(qe.ILogService),Le=Je.get(ie.IExtHostTunnelService),Ze=Je.get(pe.IExtHostApiDeprecationService),ze=Je.get(G.IExtHostWindow),ft=Je.get(Ce.IExtHostSecretState),bt=Je.get(se.IExtHostEditorTabs);he.set(l.ExtHostContext.ExtHostFileSystemInfo,mt),he.set(l.ExtHostContext.ExtHostLogService,Ie),he.set(l.ExtHostContext.ExtHostWorkspace,ot),he.set(l.ExtHostContext.ExtHostConfiguration,Dt),he.set(l.ExtHostContext.ExtHostExtensionService,Et),he.set(l.ExtHostContext.ExtHostStorage,ce),he.set(l.ExtHostContext.ExtHostTunnelService,Le),he.set(l.ExtHostContext.ExtHostWindow,ze),he.set(l.ExtHostContext.ExtHostSecretState,ft),he.set(l.ExtHostContext.ExtHostTelemetry,at),he.set(l.ExtHostContext.ExtHostEditorTabs,bt);const kt=he.set(l.ExtHostContext.ExtHostDecorations,Je.get(Fe.IExtHostDecorations)),dt=he.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Je.get(a.IExtHostDocumentsAndEditors)),ut=he.set(l.ExtHostContext.ExtHostCommands,Je.get(g.IExtHostCommands)),ht=he.set(l.ExtHostContext.ExtHostTerminalService,Je.get(ae.IExtHostTerminalService)),_t=he.set(l.ExtHostContext.ExtHostDebugService,Je.get(Ye.IExtHostDebugService)),Tt=he.set(l.ExtHostContext.ExtHostSearch,Je.get(Ve.IExtHostSearch)),It=he.set(l.ExtHostContext.ExtHostTask,Je.get(xe.IExtHostTask)),En=he.set(l.ExtHostContext.ExtHostOutputService,Je.get(I.IExtHostOutputService)),Vt=he.set(l.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(he)),yt=he.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(he,dt)),Yt=he.set(l.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(he,dt,Ie)),Jt=he.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Ie,yt,he.getProxy(l.MainContext.MainThreadBulkEdits))),gt=he.set(l.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(he,ut,dt,yt,$)),qt=he.set(l.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(Ie,gt)),Wt=he.set(l.ExtHostContext.ExtHostNotebookEditors,new $e.ExtHostNotebookEditors(Ie,he,gt)),Xt=he.set(l.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels(he,Qe,gt,Ie)),Zt=he.set(l.ExtHostContext.ExtHostNotebookRenderers,new le.ExtHostNotebookRenderers(he,gt)),Pt=he.set(l.ExtHostContext.ExtHostEditors,new oe.ExtHostEditors(he,dt)),hn=he.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(he.getProxy(l.MainContext.MainThreadTreeViews),ut,Ie)),en=he.set(l.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(he.getProxy(l.MainContext.MainThreadEditorInsets),Pt,Qe)),xt=he.set(l.ExtHostContext.ExtHostDiagnostics,new A.ExtHostDiagnostics(he,Ie)),ct=he.set(l.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(he,Ee,yt,ut,xt,Ie,Ze)),tn=he.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(he,ct)),Lt=he.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(he,Ie,dt)),Nt=he.set(l.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(he,ot,ut)),jt=he.set(l.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(he,ut,Ie)),_n=he.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(he,ut,yt)),fn=he.set(l.ExtHostContext.ExtHostProgress,new r.ExtHostProgress(he.getProxy(l.MainContext.MainThreadProgress))),yn=he.set(l.ExtHostContext.ExtHosLabelService,new _e.ExtHostLabelService(he)),mn=he.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(he)),nn=he.set(l.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(he)),rn=he.set(l.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(he,ut)),Ht=he.set(l.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(he,{remote:Qe.remote},ot,Ie,Ze)),sn=he.set(l.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(he,Ht,ot)),Sn=he.set(l.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(he,yt,$,Ht,sn)),Dn=he.set(l.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(he,Ht)),zt=he.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(he,ut)),Gt=he.set(l.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(he));he.set(l.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(he,gt,dt,ut));const Cn=(0,ne.values)(l.ExtHostContext);he.assertRegistered(Cn);const kn=new Ne.ExtHostBulkEdits(he,dt),on=new u.ExtHostClipboard(he),an=new _.ExtHostMessageService(he,Ie),Bt=new o.ExtHostDialogs(he),Ft=new B.ExtHostStatusBar(he,ut.converter),Kt=new m.ExtHostLanguages(he,yt);return h.ExtHostApiCommands.register(ut),function(Re,$t,gn){const pt=function(){let J=!Re.isUnderDevelopment;function de(ke){J||(Ie.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(st){if(Array.isArray(st))st.forEach(ke);else if(typeof st=="string")de(st);else{const wt=st;typeof wt.scheme=="undefined"&&de(st),!Re.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,W.throwProposedApiError)(Re)}return st}}(),In={getSession(J,de,ke){return ke?.forceNewSession&&(0,W.checkProposedApiEnabled)(Re),nn.getSession(Re,J,de,ke)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(J,de,ke,st){return nn.registerAuthenticationProvider(J,de,ke,st)}},Pn={registerCommand(J,de,ke){return ut.registerCommand(!0,J,de,ke)},registerTextEditorCommand(J,de,ke){return ut.registerCommand(!0,J,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Ie.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Ct=>{de.apply(ke,[wt,Ct,...st])}).then(Ct=>{Ct||Ie.warn("Edits from command "+J+" were not applied.")},Ct=>{Ie.warn("An error occurred while running command "+J,Ct)})})},registerDiffInformationCommand:(J,de,ke)=>((0,W.checkProposedApiEnabled)(Re),ut.registerCommand(!0,J,async(...st)=>{const wt=dt.activeEditor(!0);if(!wt){Ie.warn("Cannot execute "+J+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);de.apply(ke,[Ct,...st])})),executeCommand(J,...de){return ut.executeCommand(J,...de)},getCommands(J=!1){return ut.getCommands(J)}},pn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){return Qe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return Qe.environment.embedderIdentifier},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,de){return ze.openUri(J,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Qe.environment.appUriScheme)return Vt.createAppUri(J);try{return await ze.asExternalUri(J,{allowTunneling:!!Qe.remote.authority})}catch(de){if((0,Pe.matchesScheme)(J,Ae.Schemas.http)||(0,Pe.matchesScheme)(J,Ae.Schemas.https))return J;throw de}},get remoteName(){return(0,Me.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=Qe.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,An={createTestController(J,de){return zt.createTestController(J,de)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Re),zt.createTestObserver()},runTests(J){return(0,W.checkProposedApiEnabled)(Re),zt.runTests(J)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Re),zt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Re),zt.results}},ln={getExtension(J){const de=$t.getExtensionDescription(J);if(de)return new s.Extension(Et,Re.identifier,de,vn)},get all(){return $t.getAllExtensionDescriptions().map(J=>new s.Extension(Et,Re.identifier,J,vn))},get onDidChange(){return $t.onDidChange}},Tn={createDiagnosticCollection(J){return xt.createDiagnosticCollection(Re.identifier,J)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:J=>xt.getDiagnostics(J),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(J,de){return Kt.changeLanguage(J.uri,de)},match(J,de){return(0,n.score)(H.LanguageSelector.from(J),de.uri,de.languageId,!0)},registerCodeActionsProvider(J,de,ke){return ct.registerCodeActionProvider(Re,pt(J),de,ke)},registerCodeLensProvider(J,de){return ct.registerCodeLensProvider(Re,pt(J),de)},registerDefinitionProvider(J,de){return ct.registerDefinitionProvider(Re,pt(J),de)},registerDeclarationProvider(J,de){return ct.registerDeclarationProvider(Re,pt(J),de)},registerImplementationProvider(J,de){return ct.registerImplementationProvider(Re,pt(J),de)},registerTypeDefinitionProvider(J,de){return ct.registerTypeDefinitionProvider(Re,pt(J),de)},registerHoverProvider(J,de){return ct.registerHoverProvider(Re,pt(J),de,Re.identifier)},registerEvaluatableExpressionProvider(J,de){return ct.registerEvaluatableExpressionProvider(Re,pt(J),de,Re.identifier)},registerInlineValuesProvider(J,de){return ct.registerInlineValuesProvider(Re,pt(J),de,Re.identifier)},registerDocumentHighlightProvider(J,de){return ct.registerDocumentHighlightProvider(Re,pt(J),de)},registerLinkedEditingRangeProvider(J,de){return ct.registerLinkedEditingRangeProvider(Re,pt(J),de)},registerReferenceProvider(J,de){return ct.registerReferenceProvider(Re,pt(J),de)},registerRenameProvider(J,de){return ct.registerRenameProvider(Re,pt(J),de)},registerDocumentSymbolProvider(J,de,ke){return ct.registerDocumentSymbolProvider(Re,pt(J),de,ke)},registerWorkspaceSymbolProvider(J){return ct.registerWorkspaceSymbolProvider(Re,J)},registerDocumentFormattingEditProvider(J,de){return ct.registerDocumentFormattingEditProvider(Re,pt(J),de)},registerDocumentRangeFormattingEditProvider(J,de){return ct.registerDocumentRangeFormattingEditProvider(Re,pt(J),de)},registerOnTypeFormattingEditProvider(J,de,ke,...st){return ct.registerOnTypeFormattingEditProvider(Re,pt(J),de,[ke].concat(st))},registerDocumentSemanticTokensProvider(J,de,ke){return ct.registerDocumentSemanticTokensProvider(Re,pt(J),de,ke)},registerDocumentRangeSemanticTokensProvider(J,de,ke){return ct.registerDocumentRangeSemanticTokensProvider(Re,pt(J),de,ke)},registerSignatureHelpProvider(J,de,ke,...st){return typeof ke=="object"?ct.registerSignatureHelpProvider(Re,pt(J),de,ke):ct.registerSignatureHelpProvider(Re,pt(J),de,typeof ke=="undefined"?[]:[ke,...st])},registerCompletionItemProvider(J,de,...ke){return ct.registerCompletionItemProvider(Re,pt(J),de,ke)},registerInlineCompletionItemProvider(J,de){return(0,W.checkProposedApiEnabled)(Re),ct.registerInlineCompletionsProvider(Re,pt(J),de)},registerDocumentLinkProvider(J,de){return ct.registerDocumentLinkProvider(Re,pt(J),de)},registerColorProvider(J,de){return ct.registerColorProvider(Re,pt(J),de)},registerFoldingRangeProvider(J,de){return ct.registerFoldingRangeProvider(Re,pt(J),de)},registerSelectionRangeProvider(J,de){return ct.registerSelectionRangeProvider(Re,J,de)},registerCallHierarchyProvider(J,de){return ct.registerCallHierarchyProvider(Re,J,de)},setLanguageConfiguration:(J,de)=>ct.setLanguageConfiguration(Re,J,de),getTokenInformationAtPosition(J,de){return(0,W.checkProposedApiEnabled)(Re),Kt.tokenAtPosition(J,de)},registerInlayHintsProvider(J,de){return(0,W.checkProposedApiEnabled)(Re),ct.registerInlayHintsProvider(Re,J,de)},registerTypeHierarchyProvider(J,de){return(0,W.checkProposedApiEnabled)(Re),ct.registerTypeHierarchyProvider(Re,J,de)},createLanguageStatusItem(J){return(0,W.checkProposedApiEnabled)(Re),Kt.createLanguageStatusItem(J)}},Rn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(J,de,ke){const st=await(k.URI.isUri(J)?Promise.resolve(wn.openTextDocument(J)):Promise.resolve(J));return Pt.showTextDocument(st,de,ke)},createTextEditorDecorationType(J){return Pt.createTextEditorDecorationType(Re,J)},onDidChangeActiveTextEditor(J,de,ke){return Pt.onDidChangeActiveTextEditor(J,de,ke)},onDidChangeVisibleTextEditors(J,de,ke){return Pt.onDidChangeVisibleTextEditors(J,de,ke)},onDidChangeTextEditorSelection(J,de,ke){return Pt.onDidChangeTextEditorSelection(J,de,ke)},onDidChangeTextEditorOptions(J,de,ke){return Pt.onDidChangeTextEditorOptions(J,de,ke)},onDidChangeTextEditorVisibleRanges(J,de,ke){return Pt.onDidChangeTextEditorVisibleRanges(J,de,ke)},onDidChangeTextEditorViewColumn(J,de,ke){return Pt.onDidChangeTextEditorViewColumn(J,de,ke)},onDidCloseTerminal(J,de,ke){return ht.onDidCloseTerminal(J,de,ke)},onDidOpenTerminal(J,de,ke){return ht.onDidOpenTerminal(J,de,ke)},onDidChangeActiveTerminal(J,de,ke){return ht.onDidChangeActiveTerminal(J,de,ke)},onDidChangeTerminalDimensions(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),ht.onDidChangeTerminalDimensions(J,de,ke)},onDidChangeTerminalState(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),ht.onDidChangeTerminalState(J,de,ke)},onDidWriteTerminalData(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),ht.onDidWriteTerminalData(J,de,ke)},get state(){return ze.state},onDidChangeWindowState(J,de,ke){return ze.onDidChangeWindowState(J,de,ke)},showInformationMessage(J,...de){return an.showMessage(Re,S.default.Info,J,de[0],de.slice(1))},showWarningMessage(J,...de){return an.showMessage(Re,S.default.Warning,J,de[0],de.slice(1))},showErrorMessage(J,...de){return an.showMessage(Re,S.default.Error,J,de[0],de.slice(1))},showQuickPick(J,de,ke){return Nt.showQuickPick(J,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(J){return Nt.showWorkspaceFolderPick(J)},showInputBox(J,de){return Nt.showInput(J,de)},showOpenDialog(J){return Bt.showOpenDialog(J)},showSaveDialog(J){return Bt.showSaveDialog(J)},createStatusBarItem(J,de,ke){let st,wt,Ct;return typeof J=="string"?(st=J,wt=de,Ct=ke):(wt=J,Ct=de),Ft.createStatusBarEntry(Re,st,wt,Ct)},setStatusBarMessage(J,de){return Ft.setStatusBarMessage(J,de)},withScmProgress(J){return Ze.report("window.withScmProgress",Re,"Use 'withProgress' instead."),fn.withProgress(Re,{location:M.ProgressLocation.SourceControl},(de,ke)=>J({report(st){}}))},withProgress(J,de){return fn.withProgress(Re,J,de)},createOutputChannel(J){return En.createOutputChannel(J,Re)},createWebviewPanel(J,de,ke,st){return sn.createWebviewPanel(Re,J,de,ke,st)},createWebviewTextEditorInset(J,de,ke,st){return(0,W.checkProposedApiEnabled)(Re),en.createWebviewEditorInset(J,de,ke,st,Re)},createTerminal(J,de,ke){return typeof J=="object"?"pty"in J?ht.createExtensionTerminal(J):ht.createTerminalFromOptions(J):ht.createTerminal(J,de,ke)},registerTerminalLinkProvider(J){return ht.registerLinkProvider(J)},registerTerminalProfileProvider(J,de){return ht.registerProfileProvider(Re,J,de)},registerTreeDataProvider(J,de){return hn.registerTreeDataProvider(J,de,Re)},createTreeView(J,de){return hn.createTreeView(J,de,Re)},registerWebviewPanelSerializer:(J,de)=>sn.registerWebviewPanelSerializer(Re,J,de),registerCustomEditorProvider:(J,de,ke={})=>Sn.registerCustomEditorProvider(Re,J,de,ke),registerFileDecorationProvider(J){return kt.registerFileDecorationProvider(J,Re.identifier)},registerUriHandler(J){return Vt.registerUriHandler(Re.identifier,J)},createQuickPick(){return Nt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Nt.createInputBox(Re.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(J,de,ke){return mn.onDidChangeActiveColorTheme(J,de,ke)},registerWebviewViewProvider(J,de,ke){return Dn.registerWebviewViewProvider(Re,J,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(J,de,ke)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),Wt.onDidChangeNotebookEditorSelection(J,de,ke)},onDidChangeNotebookEditorVisibleRanges(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),Wt.onDidChangeNotebookEditorVisibleRanges(J,de,ke)},showNotebookDocument(J,de){return(0,W.checkProposedApiEnabled)(Re),gt.showNotebookDocument(J,de)},registerExternalUriOpener(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),Gt.registerExternalUriOpener(Re.identifier,J,de,ke)},get openEditors(){return(0,W.checkProposedApiEnabled)(Re),bt.tabs},get onDidChangeOpenEditors(){return(0,W.checkProposedApiEnabled)(Re),bt.onDidChangeTabs},getInlineCompletionItemController(J){return(0,W.checkProposedApiEnabled)(Re),f.InlineCompletionController.get(J)}},wn={get rootPath(){return Ze.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(J){throw R.readonly()},getWorkspaceFolder(J){return ot.getWorkspaceFolder(J)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(J){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(J){throw R.readonly()},updateWorkspaceFolders:(J,de,...ke)=>ot.updateWorkspaceFolders(Re,J,de||0,...ke),onDidChangeWorkspaceFolders:function(J,de,ke){return ot.onDidChangeWorkspace(J,de,ke)},asRelativePath:(J,de)=>ot.getRelativePath(J,de),findFiles:(J,de,ke,st)=>ot.findFiles(H.GlobPattern.from(J),H.GlobPattern.from(de),ke,Re.identifier,st),findTextInFiles:(J,de,ke,st)=>{let wt,Ct;return typeof de=="object"?(wt=de,Ct=ke):(wt={},Ct=de,st=ke),ot.findTextInFiles(J,wt||{},Ct,Re.identifier,st)},saveAll:J=>ot.saveAll(J),applyEdit(J){return kn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,de,ke,st)=>Lt.createFileSystemWatcher(H.GlobPattern.from(J),de,ke,st),get textDocuments(){return yt.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw R.readonly()},openTextDocument(J){let de;const ke=J;if(typeof J=="string")de=Promise.resolve(k.URI.file(J));else if(k.URI.isUri(J))de=Promise.resolve(J);else if(!ke||typeof ke=="object")de=yt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>yt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(J,de,ke)=>yt.onDidAddDocument(J,de,ke),onDidCloseTextDocument:(J,de,ke)=>yt.onDidRemoveDocument(J,de,ke),onDidChangeTextDocument:(J,de,ke)=>yt.onDidChangeDocument(J,de,ke),onDidSaveTextDocument:(J,de,ke)=>yt.onDidSaveDocument(J,de,ke),onWillSaveTextDocument:(J,de,ke)=>Jt.getOnWillSaveTextDocumentEvent(Re)(J,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,de){let ke;if(k.URI.isUri(J))ke=J,await gt.openNotebookDocument(J);else if(typeof J=="string")ke=k.URI.revive(await gt.createNotebookDocument({viewType:J,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,de,ke,st){return gt.registerNotebookSerializer(Re,J,de,ke,Re.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,de,ke,st)=>((0,W.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,J,de,ke,Re.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,de,ke)=>gn.onDidChangeConfiguration(J,de,ke),getConfiguration(J,de){return de=arguments.length===1?void 0:de,gn.getConfiguration(J,de,Re)},registerTextDocumentContentProvider(J,de){return Yt.registerTextDocumentContentProvider(J,de)},registerTaskProvider:(J,de)=>(Ze.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Re,J,de)),registerFileSystemProvider(J,de,ke){return tn.registerFileSystemProvider(Re.identifier,J,de,ke,Re.enableProposedApi)},get fs(){return vt.value},registerFileSearchProvider:(J,de)=>((0,W.checkProposedApiEnabled)(Re),Tt.registerFileSearchProvider(J,de)),registerTextSearchProvider:(J,de)=>((0,W.checkProposedApiEnabled)(Re),Tt.registerTextSearchProvider(J,de)),registerRemoteAuthorityResolver:(J,de)=>((0,W.checkProposedApiEnabled)(Re),Et.registerRemoteAuthorityResolver(J,de)),registerResourceLabelFormatter:J=>((0,W.checkProposedApiEnabled)(Re),yn.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,de,ke)=>Lt.onDidCreateFile(J,de,ke),onDidDeleteFiles:(J,de,ke)=>Lt.onDidDeleteFile(J,de,ke),onDidRenameFiles:(J,de,ke)=>Lt.onDidRenameFile(J,de,ke),onWillCreateFiles:(J,de,ke)=>Lt.getOnWillCreateFileEvent(Re)(J,de,ke),onWillDeleteFiles:(J,de,ke)=>Lt.getOnWillDeleteFileEvent(Re)(J,de,ke),onWillRenameFiles:(J,de,ke)=>Lt.getOnWillRenameFileEvent(Re)(J,de,ke),openTunnel:J=>((0,W.checkProposedApiEnabled)(Re),Le.openTunnel(Re,J).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,W.checkProposedApiEnabled)(Re),Le.getTunnels()},onDidChangeTunnels:(J,de,ke)=>((0,W.checkProposedApiEnabled)(Re),Le.onDidChangeTunnels(J,de,ke)),registerPortAttributesProvider:(J,de)=>((0,W.checkProposedApiEnabled)(Re),Le.registerPortsAttributesProvider(J,de)),registerTimelineProvider:(J,de)=>((0,W.checkProposedApiEnabled)(Re),rn.registerTimelineProvider(J,de,Re.identifier,ut.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:J=>((0,W.checkProposedApiEnabled)(Re),ot.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,de,ke)=>ot.onDidGrantWorkspaceTrust(J,de,ke)},Fn={get inputBox(){return Ze.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Re)},createSourceControl(J,de,ke){return jt.createSourceControl(Re,J,de,ke)}},Mn={createCommentController(J,de){return _n.createCommentController(Re,J,de)}},Ln={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(J,de,ke){return _t.onDidStartDebugSession(J,de,ke)},onDidTerminateDebugSession(J,de,ke){return _t.onDidTerminateDebugSession(J,de,ke)},onDidChangeActiveDebugSession(J,de,ke){return _t.onDidChangeActiveDebugSession(J,de,ke)},onDidReceiveDebugSessionCustomEvent(J,de,ke){return _t.onDidReceiveDebugSessionCustomEvent(J,de,ke)},onDidChangeBreakpoints(J,de,ke){return _t.onDidChangeBreakpoints(J,de,ke)},registerDebugConfigurationProvider(J,de,ke){return _t.registerDebugConfigurationProvider(J,de,ke||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,de){return _t.registerDebugAdapterDescriptorFactory(Re,J,de)},registerDebugAdapterTrackerFactory(J,de){return _t.registerDebugAdapterTrackerFactory(J,de)},startDebugging(J,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?_t.startDebugging(J,de,{parentSession:ke}):_t.startDebugging(J,de,ke||{})},stopDebugging(J){return _t.stopDebugging(J)},addBreakpoints(J){return _t.addBreakpoints(J)},removeBreakpoints(J){return _t.removeBreakpoints(J)},asDebugSourceUri(J,de){return _t.asDebugSourceUri(J,de)}},Nn={registerTaskProvider:(J,de)=>It.registerTaskProvider(Re,J,de),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Re,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,de,ke)=>It.onDidStartTask(J,de,ke),onDidEndTask:(J,de,ke)=>It.onDidEndTask(J,de,ke),onDidStartTaskProcess:(J,de,ke)=>It.onDidStartTaskProcess(J,de,ke),onDidEndTaskProcess:(J,de,ke)=>It.onDidEndTaskProcess(J,de,ke)},un={createNotebookController(J,de,ke,st,wt){return Xt.createNotebookController(Re,J,de,ke,st,Re.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,J,de),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Re),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,W.checkProposedApiEnabled)(Re),Wt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return Zt.createRendererMessaging(Re,J)},onDidChangeNotebookDocumentMetadata(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),qt.onDidChangeNotebookDocumentMetadata(J,de,ke)},onDidChangeNotebookCells(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(J,de,ke)},onDidChangeNotebookCellExecutionState(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(J,de,ke)},onDidChangeCellOutputs(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(J,de,ke)},onDidChangeCellMetadata(J,de,ke){return(0,W.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(J,de,ke)},createConcatTextDocument(J,de){return(0,W.checkProposedApiEnabled)(Re),new ve.ExtHostNotebookConcatDocument(gt,yt,J,de)}};return{version:Qe.version,authentication:In,commands:Pn,comments:Mn,debug:Ln,env:pn,extensions:ln,languages:Tn,notebooks:un,scm:Fn,tasks:Nn,tests:An,window:Rn,workspace:wn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:T.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,Task2:M.Task,TaskGroup:M.TaskGroup,TaskGroup2:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:l.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:Y.TextSearchCompleteMessageType,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=it}),define(we[231],be([0,1,61,105,32,104,33,49,50,39,108,109,110,76,69,74,106,75,48,73,96,67]),function(ee,e,d,R,D,S,k,E,y,T,n,C,l,h,u,g,b,w,A,o,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,d.registerSingleton)(E.IExtHostCommands,E.ExtHostCommands),(0,d.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,d.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,d.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,d.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,d.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(A.IExtHostFileSystemInfo,A.ExtHostFileSystemInfo),(0,d.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,d.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,d.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,d.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,d.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,d.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,d.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(we[232],be([0,1,230,34,226,7,15,5,11]),function(ee,e,d,R,D,S,k,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(u){const g=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...A)=>{A.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const o=A.slice(0,-1).join(","),p=A.pop().toString();return`(function anonymous(${o}) {
${p}
})`}});function b(...w){return g?self.eval(g.createScript("",...w)):new Function(...w)}u.create=b})(T||(T={}));class n extends D.RequireInterceptor{_installInterceptor(){}getModule(g,b){for(let w of this._alternatives){let A=w(g);if(A){g=A;break}}if(this._factories.has(g))return this._factories.get(g).load(g,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=S.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const g=this._extHostContext.getProxy(E.MainContext.MainThreadConsole);h(g,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(g){return g.browser}async _loadCommonJSModule(g,b,w){b=b.with({path:l(b.path,".js")}),g&&performance.mark(`code/extHost/willFetchExtensionCode/${g.value}`);const A=await fetch(y.FileAccess.asBrowserUri(b).toString(!0));if(g&&performance.mark(`code/extHost/didFetchExtensionCode/${g.value}`),A.status!==200)throw new Error(A.statusText);const o=await A.text(),p=`${b.toString(!0)}#vscode-extension`,v=`${o}
//# sourceURL=${p}`;let t;try{t=T.create(C._ttpExtensionScripts?.createScript("module")??"module",C._ttpExtensionScripts?.createScript("exports")??"exports",C._ttpExtensionScripts?.createScript("require")??"require",C._ttpExtensionScripts?.createScript(v)??v)}catch(c){throw console.error(g?`Loading code for extension ${g.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${b.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const a={},s={exports:a},i=c=>{const f=this._fakeModules.getModule(c,b);if(f===void 0)throw new Error(`Cannot load module '${c}'`);return f};try{return w.codeLoadingStart(),g&&performance.mark(`code/extHost/willLoadExtensionCode/${g.value}`),t(s,a,i),s.exports!==a?s.exports:a}finally{g&&performance.mark(`code/extHost/didLoadExtensionCode/${g.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(g){throw new Error("Not supported")}async _waitForDebuggerAttachment(g=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+g;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function l(u,g){return u.endsWith(g)?u:u+g}function h(u,g){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(o,p){const v=console[o];console[o]=function(){u.$logExtensionHostMessage({type:"__$console",severity:p,arguments:A(arguments)}),g&&v.apply(console,arguments)}}const w=1e5;function A(o){const p=[],v=[];if(o.length)for(let t=0;t<o.length;t++){if(typeof o[t]=="undefined")o[t]="undefined";else if(o[t]instanceof Error){const a=o[t];a.stack?o[t]=a.stack:o[t]=a.toString()}v.push(o[t])}try{const t=JSON.stringify(v,function(a,s){if(s&&typeof s=="object"){if(p.indexOf(s)!==-1)return"[Circular]";p.push(s)}return s});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[233],be([0,1,61,16,34,77,232,219]),function(ee,e,d,R,D,S,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(D.IExtHostExtensionService,k.ExtHostExtensionService),(0,d.registerSingleton)(R.ILogService,E.ExtHostLogService),(0,d.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths)}),define(we[235],be([0,1,24,3,186,227,221,14,78,11,2,231,233]),function(ee,e,d,R,D,S,k,E,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const A=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:p=>p}),o=self.Worker;Worker=function(p,v){/^file:/i.test(p.toString())&&(p=T.FileAccess.asBrowserUri(n.URI.parse(p.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${p}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||E.basename(p.toString());const a=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(a);return new o(A?A.createScriptURL(s):s,v)}}else self.Worker=class extends k.NestedWorker{constructor(A,o){super(l,A,{name:E.basename(A.toString()),...o})}};const h=new class{exit(A){C()}async exists(A){return!0}async realpath(A){return A}};class u{constructor(){const o=new MessageChannel,p=new R.Emitter;let v=!1;l(o.port2,[o.port2]),o.port1.onmessage=t=>{const{data:a}=t;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const s=d.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,D.isMessageOfType)(s,2)){v=!0,b("received terminate message from renderer");return}p.fire(s)},this.protocol={onMessage:p.event,send:t=>{if(!v){const a=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);o.port1.postMessage(a,[a])}}}}}function g(A){return new Promise(o=>{const p=A.onMessage(v=>{p.dispose();const t=JSON.parse(v.toString());A.send((0,D.createMessageOfType)(0)),o({protocol:A,initData:t})});A.send((0,D.createMessageOfType)(1))})}let b=A=>C();function w(){const A=new u;y.mark("code/extHost/willConnectToRenderer"),g(A.protocol).then(o=>{y.mark("code/extHost/didWaitForInitData");const p=new S.ExtensionHostMain(o.protocol,o.initData,h,null);b=v=>p.terminate(v)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9dd4f31a21d63deea5e1fc322cfc802413b31d95/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
