/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/editor/common/core/position","vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/errors","vs/base/common/functional","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lifecycle","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/editorSimpleWorker","vs/workbench/services/languageDetection/browser/languageDetectionSimpleWorker"],G=function(j){for(var t=[],P=0,R=j.length;P<R;P++)t[P]=V[j[P]];return t};define(V[13],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(F,c,g,h){this.originalStart=F,this.originalLength=c,this.modifiedStart=g,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),define(V[7],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(o=>{o(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}t.ErrorHandler=P,t.errorHandler=new P;function R(s){t.errorHandler.setUnexpectedErrorHandler(s)}t.setUnexpectedErrorHandler=R;function F(s){E(s)||t.errorHandler.onUnexpectedError(s)}t.onUnexpectedError=F;function c(s){E(s)||t.errorHandler.onUnexpectedExternalError(s)}t.onUnexpectedExternalError=c;function g(s){if(s instanceof Error){let{name:a,message:o}=s;const l=s.stacktrace||s.stack;return{$isError:!0,name:a,message:o,stack:l}}return s}t.transformErrorForSerialization=g;const h="Canceled";function E(s){return s instanceof Error&&s.name===h&&s.message===h}t.isPromiseCanceledError=E;class v extends Error{constructor(){super(h);this.name=this.message}}t.CancellationError=v;function U(){const s=new Error(h);return s.name=s.message,s}t.canceled=U;function I(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}t.illegalArgument=I;function L(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}t.illegalState=L;function d(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=d;function S(s){const a=new Error(`${s} has been disposed`);return a.name="DISPOSED",a}t.disposed=S;function w(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}t.getErrorMessage=w;class b extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}t.NotImplementedError=b;class A extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}t.NotSupportedError=A;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(s){const a=s;return a instanceof Error&&Array.isArray(a.actions)}t.isErrorWithActions=i;function r(s,a=Object.create(null)){const o=new Error(s);return a.actions&&(o.actions=a.actions),o}t.createErrorWithActions=r}),define(V[8],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function P(R){const F=this;let c=!1,g;return function(){return c||(c=!0,g=R.apply(F,arguments)),g}}t.once=P}),define(V[14],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(R){function F(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=F;const c=Object.freeze([]);function g(){return c}R.empty=g;function*h(s){yield s}R.single=h;function E(s){return s||c}R.from=E;function v(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=v;function U(s){return s[Symbol.iterator]().next().value}R.first=U;function I(s,a){for(const o of s)if(a(o))return!0;return!1}R.some=I;function L(s,a){for(const o of s)if(a(o))return o}R.find=L;function*d(s,a){for(const o of s)a(o)&&(yield o)}R.filter=d;function*S(s,a){let o=0;for(const l of s)yield a(l,o++)}R.map=S;function*w(...s){for(const a of s)for(const o of a)yield o}R.concat=w;function*b(s){for(const a of s)for(const o of a)yield o}R.concatNested=b;function A(s,a,o){let l=o;for(const u of s)l=a(l,u);return l}R.reduce=A;function*n(s,a,o=s.length){for(a<0&&(a+=s.length),o<0?o+=s.length:o>s.length&&(o=s.length);a<o;a++)yield s[a]}R.slice=n;function i(s,a=Number.POSITIVE_INFINITY){const o=[];if(a===0)return[o,s];const l=s[Symbol.iterator]();for(let u=0;u<a;u++){const m=l.next();if(m.done)return[o,R.empty()];o.push(m.value)}return[o,{[Symbol.iterator](){return l}}]}R.consume=i;function r(s,a,o=(l,u)=>l===u){const l=s[Symbol.iterator](),u=a[Symbol.iterator]();for(;;){const m=l.next(),N=u.next();if(m.done!==N.done)return!1;if(m.done)return!0;if(!o(m.value,N.value))return!1}}R.equals=r})(P=t.Iterable||(t.Iterable={}))}),define(V[15],G([0,1,7]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var R;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(R=t.KeyCode||(t.KeyCode={}));class F{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const c=new F,g=new F,h=new F;(function(){function n(i,r,s=r,a=s){c.define(i,r),g.define(i,s),h.define(i,a)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var E;(function(n){function i(l){return c.keyCodeToStr(l)}n.toString=i;function r(l){return c.strToKeyCode(l)}n.fromString=r;function s(l){return g.keyCodeToStr(l)}n.toUserSettingsUS=s;function a(l){return h.keyCodeToStr(l)}n.toUserSettingsGeneral=a;function o(l){return g.strToKeyCode(l)||h.strToKeyCode(l)}n.fromUserSettings=o})(E=t.KeyCodeUtils||(t.KeyCodeUtils={}));var v;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(v||(v={}));var U;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(U=t.KeyMod||(t.KeyMod={}));function I(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=I;function L(n,i){if(n===0)return null;const r=(n&65535)>>>0,s=(n&4294901760)>>>16;return s!==0?new w([d(r,i),d(s,i)]):new w([d(r,i)])}t.createKeybinding=L;function d(n,i){const r=!!(n&2048),s=!!(n&256),a=i===2?s:r,o=!!(n&1024),l=!!(n&512),u=i===2?r:s,m=n&255;return new S(a,o,l,u,m)}t.createSimpleKeybinding=d;class S{constructor(i,r,s,a,o){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=a,this.keyCode=o}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",s=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`${i}${r}${s}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=S;class w{constructor(i){if(i.length===0)throw(0,P.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,s=this.parts.length;r<s;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=w;class b{constructor(i,r,s,a,o,l){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=a,this.keyLabel=o,this.keyAriaLabel=l}}t.ResolvedKeybindingPart=b;class A{}t.ResolvedKeybinding=A}),define(V[16],G([0,1,8,14]),function(j,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const F=!1;let c=null;function g(l){c=l}if(t.setDisposableTracker=g,F){const l="__is_disposable_tracked__";g(new class{trackDisposable(u){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[l]||console.log(m)},3e3)}setParent(u,m){if(u&&u!==n.None)try{u[l]=!0}catch{}}markAsDisposed(u){if(u&&u!==n.None)try{u[l]=!0}catch{}}markAsSingleton(u){}})}function h(l){return c?.trackDisposable(l),l}function E(l){c?.markAsDisposed(l)}function v(l,u){c?.setParent(l,u)}function U(l,u){if(!!c)for(const m of l)c.setParent(m,u)}function I(l){return c?.markAsSingleton(l),l}t.markAsSingleton=I;class L extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}t.MultiDisposeError=L;function d(l){return typeof l.dispose=="function"&&l.dispose.length===0}t.isDisposable=d;function S(l){if(R.Iterable.is(l)){let u=[];for(const m of l)if(m)try{m.dispose()}catch(N){u.push(N)}if(u.length===1)throw u[0];if(u.length>1)throw new L(u);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}t.dispose=S;function w(...l){const u=b(()=>S(l));return U(l,u),u}t.combinedDisposable=w;function b(l){const u=h({dispose:(0,P.once)(()=>{E(u),l()})});return u}t.toDisposable=b;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return v(u,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}t.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this._store=new A,h(this),v(this._store,this)}dispose(){E(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}t.Disposable=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&v(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&v(u,null),u}}t.MutableDisposable=i;class r{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=r;class s{constructor(){this.references=new Map}acquire(u,...m){let N=this.references.get(u);N||(N={counter:0,object:this.createReferencedObject(u,...m)},this.references.set(u,N));const{object:_}=N,C=(0,P.once)(()=>{--N.counter==0&&(this.destroyReferencedObject(u,N.object),this.references.delete(u))});return N.counter++,{object:_,dispose:C}}}t.ReferenceCollection=s;class a{constructor(u){this.referenceCollection=u}async acquire(u,...m){const N=this.referenceCollection.acquire(u,...m);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(_){throw N.dispose(),_}}}t.AsyncReferenceCollection=a;class o{constructor(u){this.object=u}dispose(){}}t.ImmortalReference=o}),define(V[17],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{constructor(c){this.element=c,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class R{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let c=this._first;for(;c!==P.Undefined;){const g=c.next;c.prev=P.Undefined,c.next=P.Undefined,c=g}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,g){const h=new P(c);if(this._first===P.Undefined)this._first=h,this._last=h;else if(g){const v=this._last;this._last=h,h.prev=v,v.next=h}else{const v=this._first;this._first=h,h.next=v,v.prev=h}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(h))}}shift(){if(this._first!==P.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==P.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==P.Undefined&&c.next!==P.Undefined){const g=c.prev;g.next=c.next,c.next.prev=g}else c.prev===P.Undefined&&c.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):c.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):c.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==P.Undefined;)yield c.element,c=c.next}}t.LinkedList=R}),define(V[3],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const P="en";let R=!1,F=!1,c=!1,g=!1,h=!1,E=!1,v=!1,U,I=P,L,d;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?S=t.globals.vscode.process:typeof process!="undefined"&&(S=process);const w=typeof S?.versions?.electron=="string"&&S.type==="renderer";if(t.isElectronSandboxed=w&&S?.sandboxed,typeof navigator=="object"&&!w)d=navigator.userAgent,R=d.indexOf("Windows")>=0,F=d.indexOf("Macintosh")>=0,v=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=d.indexOf("Linux")>=0,E=!0,U=navigator.language,I=U;else if(typeof S=="object"){R=S.platform==="win32",F=S.platform==="darwin",c=S.platform==="linux",g=c&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,U=P,I=P;const l=S.env.VSCODE_NLS_CONFIG;if(l)try{const u=JSON.parse(l),m=u.availableLanguages["*"];U=u.locale,I=m||P,L=u._translationsConfigFile}catch(u){}h=!0}else console.error("Unable to resolve platform.");var b;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(b=t.Platform||(t.Platform={}));function A(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=A;let n=0;F?n=1:R?n=3:c&&(n=2),t.isWindows=R,t.isMacintosh=F,t.isLinux=c,t.isLinuxSnap=g,t.isNative=h,t.isWeb=E,t.isIOS=v,t.platform=n,t.userAgent=d,t.language=I;var i;(function(l){function u(){return t.language}l.value=u;function m(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}l.isDefaultVariant=m;function N(){return t.language==="en"}l.isDefault=N})(i=t.Language||(t.Language={})),t.locale=U,t.translationsConfigFile=L,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let m=[];t.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let C=0,M=m.length;C<M;C++){const k=m[C];if(k.id===_.data.vscodeSetImmediateId){m.splice(C,1),k.callback();return}}});let N=0;return _=>{const C=++N;m.push({id:C,callback:_}),t.globals.postMessage({vscodeSetImmediateId:C},"*")}}if(typeof S?.nextTick=="function")return S.nextTick.bind(S);const u=Promise.resolve();return m=>u.then(m)}();var r;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(r=t.OperatingSystem||(t.OperatingSystem={})),t.OS=F||v?2:R?1:3;let s=!0,a=!1;function o(){if(!a){a=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,s=new Uint16Array(l.buffer)[0]===(2<<8)+1}return s}t.isLittleEndian=o}),define(V[18],G([0,1,3]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;let R;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const F=P.globals.vscode.process;R={get platform(){return F.platform},get env(){return F.env},cwd(){return F.cwd()},nextTick(c){return(0,P.setImmediate)(c)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(F){return process.nextTick(F)}}:R={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},nextTick(F){return(0,P.setImmediate)(F)},get env(){return{}},cwd(){return"/"}};t.cwd=R.cwd,t.env=R.env,t.platform=R.platform,t.nextTick=R.nextTick}),define(V[19],G([0,1,18]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const R=65,F=97,c=90,g=122,h=46,E=47,v=92,U=58,I=63;class L extends Error{constructor(r,s,a){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const l=r.indexOf(".")!==-1?"property":"argument";let u=`The "${r}" ${l} ${o} of type ${s}`;u+=`. Received type ${typeof a}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,r){if(typeof i!="string")throw new L(r,"string",i)}function S(i){return i===E||i===v}function w(i){return i===E}function b(i){return i>=R&&i<=c||i>=F&&i<=g}function A(i,r,s,a){let o="",l=0,u=-1,m=0,N=0;for(let _=0;_<=i.length;++_){if(_<i.length)N=i.charCodeAt(_);else{if(a(N))break;N=E}if(a(N)){if(!(u===_-1||m===1))if(m===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==h||o.charCodeAt(o.length-2)!==h){if(o.length>2){const C=o.lastIndexOf(s);C===-1?(o="",l=0):(o=o.slice(0,C),l=o.length-1-o.lastIndexOf(s)),u=_,m=0;continue}else if(o.length!==0){o="",l=0,u=_,m=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",l=2)}else o.length>0?o+=`${s}${i.slice(u+1,_)}`:o=i.slice(u+1,_),l=_-u-1;u=_,m=0}else N===h&&m!==-1?++m:m=-1}return o}function n(i,r){if(r===null||typeof r!="object")throw new L("pathObject","Object",r);const s=r.dir||r.root,a=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${a}`:`${s}${i}${a}`:a}t.win32={resolve(...i){let r="",s="",a=!1;for(let o=i.length-1;o>=-1;o--){let l;if(o>=0){if(l=i[o],d(l,"path"),l.length===0)continue}else r.length===0?l=P.cwd():(l=P.env[`=${r}`]||P.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===v)&&(l=`${r}\\`));const u=l.length;let m=0,N="",_=!1;const C=l.charCodeAt(0);if(u===1)S(C)&&(m=1,_=!0);else if(S(C))if(_=!0,S(l.charCodeAt(1))){let M=2,k=M;for(;M<u&&!S(l.charCodeAt(M));)M++;if(M<u&&M!==k){const B=l.slice(k,M);for(k=M;M<u&&S(l.charCodeAt(M));)M++;if(M<u&&M!==k){for(k=M;M<u&&!S(l.charCodeAt(M));)M++;(M===u||M!==k)&&(N=`\\\\${B}\\${l.slice(k,M)}`,m=M)}}}else m=1;else b(C)&&l.charCodeAt(1)===U&&(N=l.slice(0,2),m=2,u>2&&S(l.charCodeAt(2))&&(_=!0,m=3));if(N.length>0)if(r.length>0){if(N.toLowerCase()!==r.toLowerCase())continue}else r=N;if(a){if(r.length>0)break}else if(s=`${l.slice(m)}\\${s}`,a=_,_&&r.length>0)break}return s=A(s,!a,"\\",S),a?`${r}\\${s}`:`${r}${s}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let s=0,a,o=!1;const l=i.charCodeAt(0);if(r===1)return w(l)?"\\":i;if(S(l))if(o=!0,S(i.charCodeAt(1))){let m=2,N=m;for(;m<r&&!S(i.charCodeAt(m));)m++;if(m<r&&m!==N){const _=i.slice(N,m);for(N=m;m<r&&S(i.charCodeAt(m));)m++;if(m<r&&m!==N){for(N=m;m<r&&!S(i.charCodeAt(m));)m++;if(m===r)return`\\\\${_}\\${i.slice(N)}\\`;m!==N&&(a=`\\\\${_}\\${i.slice(N,m)}`,s=m)}}}else s=1;else b(l)&&i.charCodeAt(1)===U&&(a=i.slice(0,2),s=2,r>2&&S(i.charCodeAt(2))&&(o=!0,s=3));let u=s<r?A(i.slice(s),!o,"\\",S):"";return u.length===0&&!o&&(u="."),u.length>0&&S(i.charCodeAt(r-1))&&(u+="\\"),a===void 0?o?`\\${u}`:u:o?`${a}\\${u}`:`${a}${u}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const s=i.charCodeAt(0);return S(s)||r>2&&b(s)&&i.charCodeAt(1)===U&&S(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,s;for(let l=0;l<i.length;++l){const u=i[l];d(u,"path"),u.length>0&&(r===void 0?r=s=u:r+=`\\${u}`)}if(r===void 0)return".";let a=!0,o=0;if(typeof s=="string"&&S(s.charCodeAt(0))){++o;const l=s.length;l>1&&S(s.charCodeAt(1))&&(++o,l>2&&(S(s.charCodeAt(2))?++o:a=!1))}if(a){for(;o<r.length&&S(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return t.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const s=t.win32.resolve(i),a=t.win32.resolve(r);if(s===a||(i=s.toLowerCase(),r=a.toLowerCase(),i===r))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===v;)o++;let l=i.length;for(;l-1>o&&i.charCodeAt(l-1)===v;)l--;const u=l-o;let m=0;for(;m<r.length&&r.charCodeAt(m)===v;)m++;let N=r.length;for(;N-1>m&&r.charCodeAt(N-1)===v;)N--;const _=N-m,C=u<_?u:_;let M=-1,k=0;for(;k<C;k++){const $=i.charCodeAt(o+k);if($!==r.charCodeAt(m+k))break;$===v&&(M=k)}if(k!==C){if(M===-1)return a}else{if(_>C){if(r.charCodeAt(m+k)===v)return a.slice(m+k+1);if(k===2)return a.slice(m+k)}u>C&&(i.charCodeAt(o+k)===v?M=k:k===2&&(M=3)),M===-1&&(M=0)}let B="";for(k=o+M+1;k<=l;++k)(k===l||i.charCodeAt(k)===v)&&(B+=B.length===0?"..":"\\..");return m+=M,B.length>0?`${B}${a.slice(m,N)}`:(a.charCodeAt(m)===v&&++m,a.slice(m,N))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===v){if(r.charCodeAt(1)===v){const s=r.charCodeAt(2);if(s!==I&&s!==h)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(b(r.charCodeAt(0))&&r.charCodeAt(1)===U&&r.charCodeAt(2)===v)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let s=-1,a=0;const o=i.charCodeAt(0);if(r===1)return S(o)?i:".";if(S(o)){if(s=a=1,S(i.charCodeAt(1))){let m=2,N=m;for(;m<r&&!S(i.charCodeAt(m));)m++;if(m<r&&m!==N){for(N=m;m<r&&S(i.charCodeAt(m));)m++;if(m<r&&m!==N){for(N=m;m<r&&!S(i.charCodeAt(m));)m++;if(m===r)return i;m!==N&&(s=a=m+1)}}}}else b(o)&&i.charCodeAt(1)===U&&(s=r>2&&S(i.charCodeAt(2))?3:2,a=s);let l=-1,u=!0;for(let m=r-1;m>=a;--m)if(S(i.charCodeAt(m))){if(!u){l=m;break}}else u=!1;if(l===-1){if(s===-1)return".";l=s}return i.slice(0,l)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let s=0,a=-1,o=!0,l;if(i.length>=2&&b(i.charCodeAt(0))&&i.charCodeAt(1)===U&&(s=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let u=r.length-1,m=-1;for(l=i.length-1;l>=s;--l){const N=i.charCodeAt(l);if(S(N)){if(!o){s=l+1;break}}else m===-1&&(o=!1,m=l+1),u>=0&&(N===r.charCodeAt(u)?--u==-1&&(a=l):(u=-1,a=m))}return s===a?a=m:a===-1&&(a=i.length),i.slice(s,a)}for(l=i.length-1;l>=s;--l)if(S(i.charCodeAt(l))){if(!o){s=l+1;break}}else a===-1&&(o=!1,a=l+1);return a===-1?"":i.slice(s,a)},extname(i){d(i,"path");let r=0,s=-1,a=0,o=-1,l=!0,u=0;i.length>=2&&i.charCodeAt(1)===U&&b(i.charCodeAt(0))&&(r=a=2);for(let m=i.length-1;m>=r;--m){const N=i.charCodeAt(m);if(S(N)){if(!l){a=m+1;break}continue}o===-1&&(l=!1,o=m+1),N===h?s===-1?s=m:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||o===-1||u===0||u===1&&s===o-1&&s===a+1?"":i.slice(s,o)},format:n.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.length;let a=0,o=i.charCodeAt(0);if(s===1)return S(o)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(S(o)){if(a=1,S(i.charCodeAt(1))){let M=2,k=M;for(;M<s&&!S(i.charCodeAt(M));)M++;if(M<s&&M!==k){for(k=M;M<s&&S(i.charCodeAt(M));)M++;if(M<s&&M!==k){for(k=M;M<s&&!S(i.charCodeAt(M));)M++;M===s?a=M:M!==k&&(a=M+1)}}}}else if(b(o)&&i.charCodeAt(1)===U){if(s<=2)return r.root=r.dir=i,r;if(a=2,S(i.charCodeAt(2))){if(s===3)return r.root=r.dir=i,r;a=3}}a>0&&(r.root=i.slice(0,a));let l=-1,u=a,m=-1,N=!0,_=i.length-1,C=0;for(;_>=a;--_){if(o=i.charCodeAt(_),S(o)){if(!N){u=_+1;break}continue}m===-1&&(N=!1,m=_+1),o===h?l===-1?l=_:C!==1&&(C=1):l!==-1&&(C=-1)}return m!==-1&&(l===-1||C===0||C===1&&l===m-1&&l===u+1?r.base=r.name=i.slice(u,m):(r.name=i.slice(u,l),r.base=i.slice(u,m),r.ext=i.slice(l,m))),u>0&&u!==a?r.dir=i.slice(0,u-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",s=!1;for(let a=i.length-1;a>=-1&&!s;a--){const o=a>=0?i[a]:P.cwd();d(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===E)}return r=A(r,!s,"/",w),s?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===E,s=i.charCodeAt(i.length-1)===E;return i=A(i,!r,"/",w),i.length===0?r?"/":s?"./":".":(s&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===E},join(...i){if(i.length===0)return".";let r;for(let s=0;s<i.length;++s){const a=i[s];d(a,"path"),a.length>0&&(r===void 0?r=a:r+=`/${a}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const s=1,a=i.length,o=a-s,l=1,u=r.length-l,m=o<u?o:u;let N=-1,_=0;for(;_<m;_++){const M=i.charCodeAt(s+_);if(M!==r.charCodeAt(l+_))break;M===E&&(N=_)}if(_===m)if(u>m){if(r.charCodeAt(l+_)===E)return r.slice(l+_+1);if(_===0)return r.slice(l+_)}else o>m&&(i.charCodeAt(s+_)===E?N=_:_===0&&(N=0));let C="";for(_=s+N+1;_<=a;++_)(_===a||i.charCodeAt(_)===E)&&(C+=C.length===0?"..":"/..");return`${C}${r.slice(l+N)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===E;let s=-1,a=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===E){if(!a){s=o;break}}else a=!1;return s===-1?r?"/":".":r&&s===1?"//":i.slice(0,s)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let s=0,a=-1,o=!0,l;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let u=r.length-1,m=-1;for(l=i.length-1;l>=0;--l){const N=i.charCodeAt(l);if(N===E){if(!o){s=l+1;break}}else m===-1&&(o=!1,m=l+1),u>=0&&(N===r.charCodeAt(u)?--u==-1&&(a=l):(u=-1,a=m))}return s===a?a=m:a===-1&&(a=i.length),i.slice(s,a)}for(l=i.length-1;l>=0;--l)if(i.charCodeAt(l)===E){if(!o){s=l+1;break}}else a===-1&&(o=!1,a=l+1);return a===-1?"":i.slice(s,a)},extname(i){d(i,"path");let r=-1,s=0,a=-1,o=!0,l=0;for(let u=i.length-1;u>=0;--u){const m=i.charCodeAt(u);if(m===E){if(!o){s=u+1;break}continue}a===-1&&(o=!1,a=u+1),m===h?r===-1?r=u:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||a===-1||l===0||l===1&&r===a-1&&r===s+1?"":i.slice(r,a)},format:n.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.charCodeAt(0)===E;let a;s?(r.root="/",a=1):a=0;let o=-1,l=0,u=-1,m=!0,N=i.length-1,_=0;for(;N>=a;--N){const C=i.charCodeAt(N);if(C===E){if(!m){l=N+1;break}continue}u===-1&&(m=!1,u=N+1),C===h?o===-1?o=N:_!==1&&(_=1):o!==-1&&(_=-1)}if(u!==-1){const C=l===0&&s?1:l;o===-1||_===0||_===1&&o===u-1&&o===l+1?r.base=r.name=i.slice(C,u):(r.name=i.slice(C,o),r.base=i.slice(C,u),r.ext=i.slice(o,u))}return l>0?r.dir=i.slice(0,l-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=P.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=P.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=P.platform==="win32"?t.win32.join:t.posix.join,t.resolve=P.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=P.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=P.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=P.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=P.platform==="win32"?t.win32.extname:t.posix.extname,t.format=P.platform==="win32"?t.win32.format:t.posix.format,t.parse=P.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=P.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=P.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=P.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(V[4],G([0,1,3]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const R=P.globals.performance&&typeof P.globals.performance.now=="function";class F{constructor(g){this._highResolution=R&&g,this._startTime=this._now(),this._stopTime=-1}static create(g=!0){return new F(g)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}t.StopWatch=F}),define(V[9],G([0,1,7,8,16,17,4]),function(j,t,P,R,F,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var h;(function(i){i.None=()=>F.Disposable.None;function r(e){return(Y,W=null,O)=>{let Q=!1,Z;return Z=e(y=>{if(!Q)return Z?Z.dispose():Q=!0,Y.call(W,y)},null,O),Q&&Z.dispose(),Z}}i.once=r;function s(e,Y){return N((W,O=null,Q)=>e(Z=>W.call(O,Y(Z)),null,Q))}i.map=s;function a(e,Y){return N((W,O=null,Q)=>e(Z=>{Y(Z),W.call(O,Z)},null,Q))}i.forEach=a;function o(e,Y){return N((W,O=null,Q)=>e(Z=>Y(Z)&&W.call(O,Z),null,Q))}i.filter=o;function l(e){return e}i.signal=l;function u(...e){return(Y,W=null,O)=>(0,F.combinedDisposable)(...e.map(Q=>Q(Z=>Y.call(W,Z),null,O)))}i.any=u;function m(e,Y,W){let O=W;return s(e,Q=>(O=Y(O,Q),O))}i.reduce=m;function N(e){let Y;const W=new L({onFirstListenerAdd(){Y=e(W.fire,W)},onLastListenerRemove(){Y.dispose()}});return W.event}function _(e,Y,W=100,O=!1,Q){let Z,y,K,se=0;const le=new L({leakWarningThreshold:Q,onFirstListenerAdd(){Z=e(ce=>{se++,y=Y(y,ce),O&&!K&&(le.fire(y),y=void 0),clearTimeout(K),K=setTimeout(()=>{const oe=y;y=void 0,K=void 0,(!O||se>1)&&le.fire(oe),se=0},W)})},onLastListenerRemove(){Z.dispose()}});return le.event}i.debounce=_;function C(e,Y=(W,O)=>W===O){let W=!0,O;return o(e,Q=>{const Z=W||!Y(Q,O);return W=!1,O=Q,Z})}i.latch=C;function M(e,Y){return[i.filter(e,Y),i.filter(e,W=>!Y(W))]}i.split=M;function k(e,Y=!1,W=[]){let O=W.slice(),Q=e(K=>{O?O.push(K):y.fire(K)});const Z=()=>{O&&O.forEach(K=>y.fire(K)),O=null},y=new L({onFirstListenerAdd(){Q||(Q=e(K=>y.fire(K)))},onFirstListenerDidAdd(){O&&(Y?setTimeout(Z):Z())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return y.event}i.buffer=k;class B{constructor(Y){this.event=Y}map(Y){return new B(s(this.event,Y))}forEach(Y){return new B(a(this.event,Y))}filter(Y){return new B(o(this.event,Y))}reduce(Y,W){return new B(m(this.event,Y,W))}latch(){return new B(C(this.event))}debounce(Y,W=100,O=!1,Q){return new B(_(this.event,Y,W,O,Q))}on(Y,W,O){return this.event(Y,W,O)}once(Y,W,O){return r(this.event)(Y,W,O)}}function $(e){return new B(e)}i.chain=$;function p(e,Y,W=O=>O){const O=(...K)=>y.fire(W(...K)),Q=()=>e.on(Y,O),Z=()=>e.removeListener(Y,O),y=new L({onFirstListenerAdd:Q,onLastListenerRemove:Z});return y.event}i.fromNodeEventEmitter=p;function z(e,Y,W=O=>O){const O=(...K)=>y.fire(W(...K)),Q=()=>e.addEventListener(Y,O),Z=()=>e.removeEventListener(Y,O),y=new L({onFirstListenerAdd:Q,onLastListenerRemove:Z});return y.event}i.fromDOMEventEmitter=z;function J(e){return new Promise(Y=>r(e)(Y))}i.toPromise=J})(h=t.Event||(t.Event={}));class E{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${E._idPool++}`}start(r){this._stopWatch=new g.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let v=-1;function U(i){const r=v;return v=i,{dispose(){v=r}}}t.setGlobalLeakWarningThreshold=U;class I{constructor(r,s=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r){let s=v;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||r<s)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(a)||0;if(this._stacks.set(a,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let l,u=0;for(const[m,N]of this._stacks)(!l||u<N)&&(l=m,u=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${u}):`),console.warn(l)}return()=>{const l=this._stacks.get(a)||0;this._stacks.set(a,l-1)}}}class L{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=v>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(r,s,a)=>{this._listeners||(this._listeners=new c.LinkedList);const o=this._listeners.isEmpty();o&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const l=this._listeners.push(s?[r,s]:r);o&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,s);const u=this._leakageMon?.check(this._listeners.size),m=(0,F.toDisposable)(()=>{u&&u(),this._disposed||(l(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof F.DisposableStore?a.add(m):Array.isArray(a)&&a.push(m),m}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new c.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,r]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,a]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(o){(0,P.onUnexpectedError)(o)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=L;class d extends L{async fireAsync(r,s,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new c.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,r]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[o,l]=this._asyncDeliveryQueue.shift(),u=[],m={...l,waitUntil:N=>{if(Object.isFrozen(u))throw new Error("waitUntil can NOT be called asynchronous");a&&(N=a(N,typeof o=="function"?o:o[0])),u.push(N)}};try{typeof o=="function"?o.call(void 0,m):o[0].call(o[1],m)}catch(N){(0,P.onUnexpectedError)(N);continue}Object.freeze(u),await Promise.allSettled(u).then(N=>{for(const _ of N)_.status==="rejected"&&(0,P.onUnexpectedError)(_.reason)})}}}}t.AsyncEmitter=d;class S extends L{constructor(r){super(r);this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}t.PauseableEmitter=S;class w extends S{constructor(r){super(r);this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}t.DebounceEmitter=w;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new L({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const s={event:r,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const a=()=>{this.hasListeners&&this.unhook(s);const o=this.events.indexOf(s);this.events.splice(o,1)};return(0,F.toDisposable)((0,R.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(s=>this.emitter.fire(s))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=b;class A{constructor(){this.buffers=[]}wrapEvent(r){return(s,a,o)=>r(l=>{const u=this.buffers[this.buffers.length-1];u?u.push(()=>s.call(a,l)):s.call(a,l)},void 0,o)}bufferEvents(r){const s=[];this.buffers.push(s);const a=r();return this.buffers.pop(),s.forEach(o=>o()),a}}t.EventBufferer=A;class n{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=F.Disposable.None,this.emitter=new L({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),define(V[20],G([0,1,9]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const R=Object.freeze(function(h,E){const v=setTimeout(h.bind(E),0);return{dispose(){clearTimeout(v)}}});var F;(function(h){function E(v){return v===h.None||v===h.Cancelled||v instanceof c?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}h.isCancellationToken=E,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(F=t.CancellationToken||(t.CancellationToken={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class g{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=F.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=F.None}}t.CancellationTokenSource=g}),define(V[5],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function P(f){return!f||typeof f!="string"?!0:f.trim().length===0}t.isFalsyOrWhitespace=P;const R=/{(\d+)}/g;function F(f,...D){return D.length===0?f:f.replace(R,function(T,H){const q=parseInt(H,10);return isNaN(q)||q<0||q>=D.length?T:D[q]})}t.format=F;const c=/{([^}]+)}/g;function g(f,D){return f.replace(c,(T,H)=>D[H]??T)}t.format2=g;function h(f){return f.replace(/[<>&]/g,function(D){switch(D){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return D}})}t.escape=h;function E(f){return f.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=E;function v(f,D){let T=0;const H=D.charCodeAt(0);for(let q=f.length-1;q>=0;q--)f.charCodeAt(q)===H&&T++;return T}t.count=v;function U(f,D,T="\u2026"){return f.length<=D?f:`${f.substr(0,D)}${T}`}t.truncate=U;function I(f,D=" "){const T=L(f,D);return d(T,D)}t.trim=I;function L(f,D){if(!f||!D)return f;const T=D.length;if(T===0||f.length===0)return f;let H=0;for(;f.indexOf(D,H)===H;)H=H+T;return f.substring(H)}t.ltrim=L;function d(f,D){if(!f||!D)return f;const T=D.length,H=f.length;if(T===0||H===0)return f;let q=H,X=-1;for(;X=f.lastIndexOf(D,q-1),!(X===-1||X+T!==q);){if(X===0)return"";q=X}return f.substring(0,q)}t.rtrim=d;function S(f){return f.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=S;function w(f){return f.replace(/\*/g,"")}t.stripWildcards=w;function b(f,D,T={}){if(!f)throw new Error("Cannot create regex from empty string");D||(f=E(f)),T.wholeWord&&(/\B/.test(f.charAt(0))||(f="\\b"+f),/\B/.test(f.charAt(f.length-1))||(f=f+"\\b"));let H="";return T.global&&(H+="g"),T.matchCase||(H+="i"),T.multiline&&(H+="m"),T.unicode&&(H+="u"),new RegExp(f,H)}t.createRegExp=b;function A(f){return f.source==="^"||f.source==="^$"||f.source==="$"||f.source==="^\\s*$"?!1:!!(f.exec("")&&f.lastIndex===0)}t.regExpLeadsToEndlessLoop=A;function n(f){return!!f.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=n;function i(f){return(f.global?"g":"")+(f.ignoreCase?"i":"")+(f.multiline?"m":"")+(f.unicode?"u":"")}t.regExpFlags=i;function r(f){return f.split(/\r\n|\r|\n/)}t.splitLines=r;function s(f){for(let D=0,T=f.length;D<T;D++){const H=f.charCodeAt(D);if(H!==32&&H!==9)return D}return-1}t.firstNonWhitespaceIndex=s;function a(f,D=0,T=f.length){for(let H=D;H<T;H++){const q=f.charCodeAt(H);if(q!==32&&q!==9)return f.substring(D,H)}return f.substring(D,T)}t.getLeadingWhitespace=a;function o(f,D=f.length-1){for(let T=D;T>=0;T--){const H=f.charCodeAt(T);if(H!==32&&H!==9)return T}return-1}t.lastNonWhitespaceIndex=o;function l(f,D){return f<D?-1:f>D?1:0}t.compare=l;function u(f,D,T=0,H=f.length,q=0,X=D.length){for(;T<H&&q<X;T++,q++){let ne=f.charCodeAt(T),te=D.charCodeAt(q);if(ne<te)return-1;if(ne>te)return 1}const x=H-T,ee=X-q;return x<ee?-1:x>ee?1:0}t.compareSubstring=u;function m(f,D){return N(f,D,0,f.length,0,D.length)}t.compareIgnoreCase=m;function N(f,D,T=0,H=f.length,q=0,X=D.length){for(;T<H&&q<X;T++,q++){let ne=f.charCodeAt(T),te=D.charCodeAt(q);if(ne===te)continue;const re=ne-te;if(!(re===32&&C(te))&&!(re===-32&&C(ne)))return _(ne)&&_(te)?re:u(f.toLowerCase(),D.toLowerCase(),T,H,q,X)}const x=H-T,ee=X-q;return x<ee?-1:x>ee?1:0}t.compareSubstringIgnoreCase=N;function _(f){return f>=97&&f<=122}t.isLowerAsciiLetter=_;function C(f){return f>=65&&f<=90}t.isUpperAsciiLetter=C;function M(f){return _(f)||C(f)}function k(f,D){return f.length===D.length&&B(f,D)}t.equalsIgnoreCase=k;function B(f,D,T=f.length){for(let H=0;H<T;H++){const q=f.charCodeAt(H),X=D.charCodeAt(H);if(q!==X){if(M(q)&&M(X)){const x=Math.abs(q-X);if(x!==0&&x!==32)return!1}else if(String.fromCharCode(q).toLowerCase()!==String.fromCharCode(X).toLowerCase())return!1}}return!0}function $(f,D){const T=D.length;return D.length>f.length?!1:B(f,D,T)}t.startsWithIgnoreCase=$;function p(f,D){let T,H=Math.min(f.length,D.length);for(T=0;T<H;T++)if(f.charCodeAt(T)!==D.charCodeAt(T))return T;return H}t.commonPrefixLength=p;function z(f,D){let T,H=Math.min(f.length,D.length);const q=f.length-1,X=D.length-1;for(T=0;T<H;T++)if(f.charCodeAt(q-T)!==D.charCodeAt(X-T))return T;return H}t.commonSuffixLength=z;function J(f){return 55296<=f&&f<=56319}t.isHighSurrogate=J;function e(f){return 56320<=f&&f<=57343}t.isLowSurrogate=e;function Y(f,D){return(f-55296<<10)+(D-56320)+65536}t.computeCodePoint=Y;function W(f,D,T){const H=f.charCodeAt(T);if(J(H)&&T+1<D){const q=f.charCodeAt(T+1);if(e(q))return Y(H,q)}return H}t.getNextCodePoint=W;function O(f,D){const T=f.charCodeAt(D-1);if(e(T)&&D>1){const H=f.charCodeAt(D-2);if(J(H))return Y(H,T)}return T}function Q(f,D){const T=ie.getInstance(),H=D,q=f.length,X=W(f,q,D);D+=X>=65536?2:1;let x=T.getGraphemeBreakType(X);for(;D<q;){const ee=W(f,q,D),ne=T.getGraphemeBreakType(ee);if(ue(x,ne))break;D+=ee>=65536?2:1,x=ne}return D-H}t.nextCharLength=Q;function Z(f,D){const T=ie.getInstance(),H=D,q=O(f,D);D-=q>=65536?2:1;let X=T.getGraphemeBreakType(q);for(;D>0;){const x=O(f,D),ee=T.getGraphemeBreakType(x);if(ue(ee,X))break;D-=x>=65536?2:1,X=ee}return H-D}t.prevCharLength=Z;function y(f,D){const T=ie.getInstance(),H=f.length,q=D,X=W(f,H,D),x=T.getGraphemeBreakType(X);D+=X>=65536?2:1;let ee=x;for(;D<H;){const te=W(f,H,D),re=T.getGraphemeBreakType(te);if(ue(ee,re))break;D+=te>=65536?2:1,ee=re}const ne=D;for(D=q,ee=x;D>0;){const te=O(f,D),re=T.getGraphemeBreakType(te);if(ue(re,ee))break;D-=te>=65536?2:1,ee=re}return[D,ne]}function K(f,D){return D>0&&e(f.charCodeAt(D))?y(f,D-1):y(f,D)}t.getCharContainingOffset=K;const se=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function le(f){return se.test(f)}t.containsRTL=le;const ce=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function oe(f){return ce.test(f)}t.containsEmoji=oe;const ge=/^[\t\n\r\x20-\x7E]*$/;function _e(f){return ge.test(f)}t.isBasicASCII=_e,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(f){return t.UNUSUAL_LINE_TERMINATORS.test(f)}t.containsUnusualLineTerminators=Le;function Se(f){for(let D=0,T=f.length;D<T;D++)if(fe(f.charCodeAt(D)))return!0;return!1}t.containsFullWidthCharacter=Se;function fe(f){return f=+f,f>=11904&&f<=55215||f>=63744&&f<=64255||f>=65281&&f<=65374}t.isFullWidthCharacter=fe;function he(f){return f>=127462&&f<=127487||f===8986||f===8987||f===9200||f===9203||f>=9728&&f<=10175||f===11088||f===11093||f>=127744&&f<=128591||f>=128640&&f<=128764||f>=128992&&f<=129003||f>=129280&&f<=129535||f>=129648&&f<=129750}t.isEmojiImprecise=he;function Ae(f,D){if(f.length<D)return f;const T=/\b/g;let H=0;for(;T.test(f)&&!(f.length-T.lastIndex<D);)H=T.lastIndex,T.lastIndex+=1;return f.substring(H).replace(/^\s/,"")}t.lcut=Ae;const Ne=/\x1B\x5B[12]?K/g,be=/\x1b\[\d+m/g,Ee=/\x1b\[0?m/g;function we(f){return f&&(f=f.replace(Ne,""),f=f.replace(be,""),f=f.replace(Ee,"")),f}t.removeAnsiEscapeCodes=we,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(f){return!!(f&&f.length>0&&f.charCodeAt(0)===65279)}t.startsWithUTF8BOM=me;function ve(f){return me(f)?f.substr(1):f}t.stripUTF8BOM=ve;function Ce(f,D){if(!f||!D||f.length<D.length)return!1;const T=D.length,H=f.toLowerCase();let q=0,X=-1;for(;q<T;){const x=H.indexOf(D[q],X+1);if(x<0)return!1;X=x,q++}return!0}t.fuzzyContains=Ce;function De(f,D=!1){return f?(D&&(f=f.replace(/\\./g,"")),f.toLowerCase()!==f):!1}t.containsUppercaseCharacter=De;function Me(f){return f.charAt(0).toUpperCase()+f.slice(1)}t.uppercaseFirstLetter=Me;function Pe(f,D=1){if(D===0)return"";let T=-1;do T=f.indexOf(`
`,T+1),D--;while(D>0&&T>=0);return T===-1?f:(f[T-1]==="\r"&&T--,f.substr(0,T))}t.getNLines=Pe;function Ue(f){const D=90-65+1;return f=f%(2*D),f<D?String.fromCharCode(97+f):String.fromCharCode(65+f-D)}t.singleLetterHash=Ue;function Fe(f){return ie.getInstance().getGraphemeBreakType(f)}t.getGraphemeBreakType=Fe;function ue(f,D){return f===0?D!==5&&D!==7:f===2&&D===3?!1:f===4||f===2||f===3||D===4||D===2||D===3?!0:!(f===8&&(D===8||D===9||D===11||D===12)||(f===11||f===9)&&(D===9||D===10)||(f===12||f===10)&&D===10||D===5||D===13||D===7||f===1||f===13&&D===14||f===6&&D===6)}t.breakBetweenGraphemeBreakType=ue;var Re;(function(f){f[f.Other=0]="Other",f[f.Prepend=1]="Prepend",f[f.CR=2]="CR",f[f.LF=3]="LF",f[f.Control=4]="Control",f[f.Extend=5]="Extend",f[f.Regional_Indicator=6]="Regional_Indicator",f[f.SpacingMark=7]="SpacingMark",f[f.L=8]="L",f[f.V=9]="V",f[f.T=10]="T",f[f.LV=11]="LV",f[f.LVT=12]="LVT",f[f.ZWJ=13]="ZWJ",f[f.Extended_Pictographic=14]="Extended_Pictographic"})(Re=t.GraphemeBreakType||(t.GraphemeBreakType={}));class ie{constructor(){this._data=Te()}static getInstance(){return ie._INSTANCE||(ie._INSTANCE=new ie),ie._INSTANCE}getGraphemeBreakType(D){if(D<32)return D===10?3:D===13?2:4;if(D<127)return 0;const T=this._data,H=T.length/3;let q=1;for(;q<=H;)if(D<T[3*q])q=2*q;else if(D>T[3*q+1])q=2*q+1;else return T[3*q+2];return 0}}ie._INSTANCE=null;function Te(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ie(f,D){if(f===0)return 0;const T=ke(f,D);if(T!==void 0)return T;const H=O(D,f);return f-=ae(H),f}t.getLeftDeleteOffset=Ie;function ke(f,D){let T=O(D,f);for(f-=ae(T);We(T)||T===65039||T===8419;){if(f===0)return;T=O(D,f),f-=ae(T)}if(!!he(T)){if(f>=0){const H=O(D,f);H===8205&&(f-=ae(H))}return f}}function ae(f){return f>=65536?2:1}function We(f){return 127995<=f&&f<=127999}var de;(function(f){f[f.zwj=8205]="zwj",f[f.emojiVariantSelector=65039]="emojiVariantSelector",f[f.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(V[21],G([0,1,5]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function R(A){return F(A,0)}t.hash=R;function F(A,n){switch(typeof A){case"object":return A===null?c(349,n):Array.isArray(A)?E(A,n):v(A,n);case"string":return h(A,n);case"boolean":return g(A,n);case"number":return c(A,n);case"undefined":return c(937,n);default:return c(617,n)}}t.doHash=F;function c(A,n){return(n<<5)-n+A|0}function g(A,n){return c(A?433:863,n)}function h(A,n){n=c(149417,n);for(let i=0,r=A.length;i<r;i++)n=c(A.charCodeAt(i),n);return n}t.stringHash=h;function E(A,n){return n=c(104579,n),A.reduce((i,r)=>F(r,i),n)}function v(A,n){return n=c(181387,n),Object.keys(A).sort().reduce((i,r)=>(i=h(r,i),F(A[r],i)),n)}class U{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=F(n,this._value),this._value}}t.Hasher=U;var I;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function L(A,n,i=32){const r=i-n,s=~((1<<r)-1);return(A<<n|(s&A)>>>r)>>>0}function d(A,n=0,i=A.byteLength,r=0){for(let s=0;s<i;s++)A[n+s]=r}function S(A,n,i="0"){for(;A.length<n;)A=i+A;return A}function w(A,n=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(i=>i.toString(16).padStart(2,"0")).join(""):S((A>>>0).toString(16),n/4)}t.toHexString=w;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let s=this._buffLen,a=this._leftoverHighSurrogate,o,l;for(a!==0?(o=a,l=-1,a=0):(o=n.charCodeAt(0),l=0);;){let u=o;if(P.isHighSurrogate(o))if(l+1<i){const m=n.charCodeAt(l+1);P.isLowSurrogate(m)?(l++,u=P.computeCodePoint(o,m)):u=65533}else{a=o;break}else P.isLowSurrogate(o)&&(u=65533);if(s=this._push(r,s,u),l++,l<i)o=n.charCodeAt(l);else break}this._buffLen=s,this._leftoverHighSurrogate=a}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=b._bigBlock32,i=this._buffDV;for(let _=0;_<64;_+=4)n.setUint32(_,i.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)n.setUint32(_,L(n.getUint32(_-12,!1)^n.getUint32(_-32,!1)^n.getUint32(_-56,!1)^n.getUint32(_-64,!1),1),!1);let r=this._h0,s=this._h1,a=this._h2,o=this._h3,l=this._h4,u,m,N;for(let _=0;_<80;_++)_<20?(u=s&a|~s&o,m=1518500249):_<40?(u=s^a^o,m=1859775393):_<60?(u=s&a|s&o|a&o,m=2400959708):(u=s^a^o,m=3395469782),N=L(r,5)+u+l+m+n.getUint32(_*4,!1)&4294967295,l=o,o=a,a=L(s,30),s=r,r=N;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+l&4294967295}}t.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(V[10],G([0,1,13,21]),function(j,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class F{constructor(L){this.source=L}getElements(){const L=this.source,d=new Int32Array(L.length);for(let S=0,w=L.length;S<w;S++)d[S]=L.charCodeAt(S);return d}}t.StringDiffSequence=F;function c(I,L,d){return new U(new F(I),new F(L)).ComputeDiff(d).changes}t.stringDiff=c;class g{static Assert(L,d){if(!L)throw new Error(d)}}t.Debug=g;class h{static Copy(L,d,S,w,b){for(let A=0;A<b;A++)S[w+A]=L[d+A]}static Copy2(L,d,S,w,b){for(let A=0;A<b;A++)S[w+A]=L[d+A]}}t.MyArray=h;var E;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(E||(E={}));class v{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(L,d){this.m_originalStart=Math.min(this.m_originalStart,L),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(L,d){this.m_originalStart=Math.min(this.m_originalStart,L),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class U{constructor(L,d,S=null){this.ContinueProcessingPredicate=S,this._originalSequence=L,this._modifiedSequence=d;const[w,b,A]=U._getElements(L),[n,i,r]=U._getElements(d);this._hasStrings=A&&r,this._originalStringElements=w,this._originalElementsOrHash=b,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(L){return L.length>0&&typeof L[0]=="string"}static _getElements(L){const d=L.getElements();if(U._isStringArray(d)){const S=new Int32Array(d.length);for(let w=0,b=d.length;w<b;w++)S[w]=(0,R.stringHash)(d[w],0);return[d,S,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(L,d){return this._originalElementsOrHash[L]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[L]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(L,d){if(!this.ElementsAreEqual(L,d))return!1;const S=U._getStrictElement(this._originalSequence,L),w=U._getStrictElement(this._modifiedSequence,d);return S===w}static _getStrictElement(L,d){return typeof L.getStrictElement=="function"?L.getStrictElement(d):null}OriginalElementsAreEqual(L,d){return this._originalElementsOrHash[L]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[L]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(L,d){return this._modifiedElementsOrHash[L]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[L]===this._modifiedStringElements[d]:!0}ComputeDiff(L){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,L)}_ComputeDiff(L,d,S,w,b){const A=[!1];let n=this.ComputeDiffRecursive(L,d,S,w,A);return b&&(n=this.PrettifyChanges(n)),{quitEarly:A[0],changes:n}}ComputeDiffRecursive(L,d,S,w,b){for(b[0]=!1;L<=d&&S<=w&&this.ElementsAreEqual(L,S);)L++,S++;for(;d>=L&&w>=S&&this.ElementsAreEqual(d,w);)d--,w--;if(L>d||S>w){let a;return S<=w?(g.Assert(L===d+1,"originalStart should only be one more than originalEnd"),a=[new P.DiffChange(L,0,S,w-S+1)]):L<=d?(g.Assert(S===w+1,"modifiedStart should only be one more than modifiedEnd"),a=[new P.DiffChange(L,d-L+1,S,0)]):(g.Assert(L===d+1,"originalStart should only be one more than originalEnd"),g.Assert(S===w+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const A=[0],n=[0],i=this.ComputeRecursionPoint(L,d,S,w,A,n,b),r=A[0],s=n[0];if(i!==null)return i;if(!b[0]){const a=this.ComputeDiffRecursive(L,r,S,s,b);let o=[];return b[0]?o=[new P.DiffChange(r+1,d-(r+1)+1,s+1,w-(s+1)+1)]:o=this.ComputeDiffRecursive(r+1,d,s+1,w,b),this.ConcatenateChanges(a,o)}return[new P.DiffChange(L,d-L+1,S,w-S+1)]}WALKTRACE(L,d,S,w,b,A,n,i,r,s,a,o,l,u,m,N,_,C){let M=null,k=null,B=new v,$=d,p=S,z=l[0]-N[0]-w,J=-1073741824,e=this.m_forwardHistory.length-1;do{const Y=z+L;Y===$||Y<p&&r[Y-1]<r[Y+1]?(a=r[Y+1],u=a-z-w,a<J&&B.MarkNextChange(),J=a,B.AddModifiedElement(a+1,u),z=Y+1-L):(a=r[Y-1]+1,u=a-z-w,a<J&&B.MarkNextChange(),J=a-1,B.AddOriginalElement(a,u+1),z=Y-1-L),e>=0&&(r=this.m_forwardHistory[e],L=r[0],$=1,p=r.length-1)}while(--e>=-1);if(M=B.getReverseChanges(),C[0]){let Y=l[0]+1,W=N[0]+1;if(M!==null&&M.length>0){const O=M[M.length-1];Y=Math.max(Y,O.getOriginalEnd()),W=Math.max(W,O.getModifiedEnd())}k=[new P.DiffChange(Y,o-Y+1,W,m-W+1)]}else{B=new v,$=A,p=n,z=l[0]-N[0]-i,J=1073741824,e=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Y=z+b;Y===$||Y<p&&s[Y-1]>=s[Y+1]?(a=s[Y+1]-1,u=a-z-i,a>J&&B.MarkNextChange(),J=a+1,B.AddOriginalElement(a+1,u+1),z=Y+1-b):(a=s[Y-1],u=a-z-i,a>J&&B.MarkNextChange(),J=a,B.AddModifiedElement(a+1,u+1),z=Y-1-b),e>=0&&(s=this.m_reverseHistory[e],b=s[0],$=1,p=s.length-1)}while(--e>=-1);k=B.getChanges()}return this.ConcatenateChanges(M,k)}ComputeRecursionPoint(L,d,S,w,b,A,n){let i=0,r=0,s=0,a=0,o=0,l=0;L--,S--,b[0]=0,A[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const u=d-L+(w-S),m=u+1,N=new Int32Array(m),_=new Int32Array(m),C=w-S,M=d-L,k=L-S,B=d-w,p=(M-C)%2==0;N[C]=L,_[M]=d,n[0]=!1;for(let z=1;z<=u/2+1;z++){let J=0,e=0;s=this.ClipDiagonalBound(C-z,z,C,m),a=this.ClipDiagonalBound(C+z,z,C,m);for(let W=s;W<=a;W+=2){W===s||W<a&&N[W-1]<N[W+1]?i=N[W+1]:i=N[W-1]+1,r=i-(W-C)-k;const O=i;for(;i<d&&r<w&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(N[W]=i,i+r>J+e&&(J=i,e=r),!p&&Math.abs(W-M)<=z-1&&i>=_[W])return b[0]=i,A[0]=r,O<=_[W]&&1447>0&&z<=1447+1?this.WALKTRACE(C,s,a,k,M,o,l,B,N,_,i,d,b,r,w,A,p,n):null}const Y=(J-L+(e-S)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(J,Y))return n[0]=!0,b[0]=J,A[0]=e,Y>0&&1447>0&&z<=1447+1?this.WALKTRACE(C,s,a,k,M,o,l,B,N,_,i,d,b,r,w,A,p,n):(L++,S++,[new P.DiffChange(L,d-L+1,S,w-S+1)]);o=this.ClipDiagonalBound(M-z,z,M,m),l=this.ClipDiagonalBound(M+z,z,M,m);for(let W=o;W<=l;W+=2){W===o||W<l&&_[W-1]>=_[W+1]?i=_[W+1]-1:i=_[W-1],r=i-(W-M)-B;const O=i;for(;i>L&&r>S&&this.ElementsAreEqual(i,r);)i--,r--;if(_[W]=i,p&&Math.abs(W-C)<=z&&i<=N[W])return b[0]=i,A[0]=r,O>=N[W]&&1447>0&&z<=1447+1?this.WALKTRACE(C,s,a,k,M,o,l,B,N,_,i,d,b,r,w,A,p,n):null}if(z<=1447){let W=new Int32Array(a-s+2);W[0]=C-s+1,h.Copy2(N,s,W,1,a-s+1),this.m_forwardHistory.push(W),W=new Int32Array(l-o+2),W[0]=M-o+1,h.Copy2(_,o,W,1,l-o+1),this.m_reverseHistory.push(W)}}return this.WALKTRACE(C,s,a,k,M,o,l,B,N,_,i,d,b,r,w,A,p,n)}PrettifyChanges(L){for(let d=0;d<L.length;d++){const S=L[d],w=d<L.length-1?L[d+1].originalStart:this._originalElementsOrHash.length,b=d<L.length-1?L[d+1].modifiedStart:this._modifiedElementsOrHash.length,A=S.originalLength>0,n=S.modifiedLength>0;for(;S.originalStart+S.originalLength<w&&S.modifiedStart+S.modifiedLength<b&&(!A||this.OriginalElementsAreEqual(S.originalStart,S.originalStart+S.originalLength))&&(!n||this.ModifiedElementsAreEqual(S.modifiedStart,S.modifiedStart+S.modifiedLength));){const r=this.ElementsAreStrictEqual(S.originalStart,S.modifiedStart);if(this.ElementsAreStrictEqual(S.originalStart+S.originalLength,S.modifiedStart+S.modifiedLength)&&!r)break;S.originalStart++,S.modifiedStart++}let i=[null];if(d<L.length-1&&this.ChangesOverlap(L[d],L[d+1],i)){L[d]=i[0],L.splice(d+1,1),d--;continue}}for(let d=L.length-1;d>=0;d--){const S=L[d];let w=0,b=0;if(d>0){const a=L[d-1];w=a.originalStart+a.originalLength,b=a.modifiedStart+a.modifiedLength}const A=S.originalLength>0,n=S.modifiedLength>0;let i=0,r=this._boundaryScore(S.originalStart,S.originalLength,S.modifiedStart,S.modifiedLength);for(let a=1;;a++){const o=S.originalStart-a,l=S.modifiedStart-a;if(o<w||l<b||A&&!this.OriginalElementsAreEqual(o,o+S.originalLength)||n&&!this.ModifiedElementsAreEqual(l,l+S.modifiedLength))break;const m=(o===w&&l===b?5:0)+this._boundaryScore(o,S.originalLength,l,S.modifiedLength);m>r&&(r=m,i=a)}S.originalStart-=i,S.modifiedStart-=i;const s=[null];if(d>0&&this.ChangesOverlap(L[d-1],L[d],s)){L[d-1]=s[0],L.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,S=L.length;d<S;d++){const w=L[d-1],b=L[d],A=b.originalStart-w.originalStart-w.originalLength,n=w.originalStart,i=b.originalStart+b.originalLength,r=i-n,s=w.modifiedStart,a=b.modifiedStart+b.modifiedLength,o=a-s;if(A<5&&r<20&&o<20){const l=this._findBetterContiguousSequence(n,r,s,o,A);if(l){const[u,m]=l;(u!==w.originalStart+w.originalLength||m!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=u-w.originalStart,w.modifiedLength=m-w.modifiedStart,b.originalStart=u+A,b.modifiedStart=m+A,b.originalLength=i-b.originalStart,b.modifiedLength=a-b.modifiedStart)}}}return L}_findBetterContiguousSequence(L,d,S,w,b){if(d<b||w<b)return null;const A=L+d-b+1,n=S+w-b+1;let i=0,r=0,s=0;for(let a=L;a<A;a++)for(let o=S;o<n;o++){const l=this._contiguousSequenceScore(a,o,b);l>0&&l>i&&(i=l,r=a,s=o)}return i>0?[r,s]:null}_contiguousSequenceScore(L,d,S){let w=0;for(let b=0;b<S;b++){if(!this.ElementsAreEqual(L+b,d+b))return 0;w+=this._originalStringElements[L+b].length}return w}_OriginalIsBoundary(L){return L<=0||L>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[L])}_OriginalRegionIsBoundary(L,d){if(this._OriginalIsBoundary(L)||this._OriginalIsBoundary(L-1))return!0;if(d>0){const S=L+d;if(this._OriginalIsBoundary(S-1)||this._OriginalIsBoundary(S))return!0}return!1}_ModifiedIsBoundary(L){return L<=0||L>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[L])}_ModifiedRegionIsBoundary(L,d){if(this._ModifiedIsBoundary(L)||this._ModifiedIsBoundary(L-1))return!0;if(d>0){const S=L+d;if(this._ModifiedIsBoundary(S-1)||this._ModifiedIsBoundary(S))return!0}return!1}_boundaryScore(L,d,S,w){const b=this._OriginalRegionIsBoundary(L,d)?1:0,A=this._ModifiedRegionIsBoundary(S,w)?1:0;return b+A}ConcatenateChanges(L,d){let S=[];if(L.length===0||d.length===0)return d.length>0?d:L;if(this.ChangesOverlap(L[L.length-1],d[0],S)){const w=new Array(L.length+d.length-1);return h.Copy(L,0,w,0,L.length-1),w[L.length-1]=S[0],h.Copy(d,1,w,L.length,d.length-1),w}else{const w=new Array(L.length+d.length);return h.Copy(L,0,w,0,L.length),h.Copy(d,0,w,L.length,d.length),w}}ChangesOverlap(L,d,S){if(g.Assert(L.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),g.Assert(L.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),L.originalStart+L.originalLength>=d.originalStart||L.modifiedStart+L.modifiedLength>=d.modifiedStart){const w=L.originalStart;let b=L.originalLength;const A=L.modifiedStart;let n=L.modifiedLength;return L.originalStart+L.originalLength>=d.originalStart&&(b=d.originalStart+d.originalLength-L.originalStart),L.modifiedStart+L.modifiedLength>=d.modifiedStart&&(n=d.modifiedStart+d.modifiedLength-L.modifiedStart),S[0]=new P.DiffChange(w,b,A,n),!0}else return S[0]=null,!1}ClipDiagonalBound(L,d,S,w){if(L>=0&&L<w)return L;const b=S,A=w-S-1,n=d%2==0;if(L<0){const i=b%2==0;return n===i?0:1}else{const i=A%2==0;return n===i?w-1:w-2}}}t.LcsDiff=U}),define(V[22],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function P(_){return Array.isArray(_)}t.isArray=P;function R(_){return typeof _=="string"}t.isString=R;function F(_){return Array.isArray(_)&&_.every(C=>R(C))}t.isStringArray=F;function c(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}t.isObject=c;function g(_){return typeof _=="number"&&!isNaN(_)}t.isNumber=g;function h(_){return!!_&&typeof _[Symbol.iterator]=="function"}t.isIterable=h;function E(_){return _===!0||_===!1}t.isBoolean=E;function v(_){return typeof _=="undefined"}t.isUndefined=v;function U(_){return!I(_)}t.isDefined=U;function I(_){return v(_)||_===null}t.isUndefinedOrNull=I;function L(_,C){if(!_)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}t.assertType=L;function d(_){if(I(_))throw new Error("Assertion Failed: argument is undefined or null");return _}t.assertIsDefined=d;function S(..._){const C=[];for(let M=0;M<_.length;M++){const k=_[M];if(I(k))throw new Error(`Assertion Failed: argument at index ${M} is undefined or null`);C.push(k)}return C}t.assertAllDefined=S;const w=Object.prototype.hasOwnProperty;function b(_){if(!c(_))return!1;for(let C in _)if(w.call(_,C))return!1;return!0}t.isEmptyObject=b;function A(_){return typeof _=="function"}t.isFunction=A;function n(..._){return _.length>0&&_.every(A)}t.areFunctions=n;function i(_,C){const M=Math.min(_.length,C.length);for(let k=0;k<M;k++)r(_[k],C[k])}t.validateConstraints=i;function r(_,C){if(R(C)){if(typeof _!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(A(C)){try{if(_ instanceof C)return}catch{}if(!I(_)&&_.constructor===C||C.length===1&&C.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function s(_){let C=[],M=Object.getPrototypeOf(_);for(;Object.prototype!==M;)C=C.concat(Object.getOwnPropertyNames(M)),M=Object.getPrototypeOf(M);return C}t.getAllPropertyNames=s;function a(_){const C=[];for(const M of s(_))typeof _[M]=="function"&&C.push(M);return C}t.getAllMethodNames=a;function o(_,C){const M=B=>function(){const $=Array.prototype.slice.call(arguments,0);return C(B,$)};let k={};for(const B of _)k[B]=M(B);return k}t.createProxyObject=o;function l(_){return _===null?void 0:_}t.withNullAsUndefined=l;function u(_){return typeof _=="undefined"?null:_}t.withUndefinedAsNull=u;function m(_){return class{constructor(){return new Proxy({},{get(C,M){if(C[M])return C[M];throw new Error(`Not Implemented: ${_}->${String(M)}`)}})}}}t.NotImplementedProxy=m;function N(_,C="Unreachable"){throw new Error(C)}t.assertNever=N}),define(V[11],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=t.Constants||(t.Constants={}));function R(c){return c<0?0:c>255?255:c|0}t.toUint8=R;function F(c){return c<0?0:c>4294967295?4294967295:c|0}t.toUint32=F}),define(V[12],G([0,1,19,3]),function(j,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const F=/^\w[\w\d+.-]*$/,c=/^\//,g=/^\/\//;function h(l,u){if(!l.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!F.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!c.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(g.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(l,u){return!l&&!u?"file":l}function v(l,u){switch(l){case"https":case"http":case"file":u?u[0]!==I&&(u=I+u):u=I;break}return u}const U="",I="/",L=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(u,m,N,_,C,M=!1){typeof u=="object"?(this.scheme=u.scheme||U,this.authority=u.authority||U,this.path=u.path||U,this.query=u.query||U,this.fragment=u.fragment||U):(this.scheme=E(u,M),this.authority=m||U,this.path=v(this.scheme,N||U),this.query=_||U,this.fragment=C||U,h(this,M))}static isUri(u){return u instanceof d?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return i(this,!1)}with(u){if(!u)return this;let{scheme:m,authority:N,path:_,query:C,fragment:M}=u;return m===void 0?m=this.scheme:m===null&&(m=U),N===void 0?N=this.authority:N===null&&(N=U),_===void 0?_=this.path:_===null&&(_=U),C===void 0?C=this.query:C===null&&(C=U),M===void 0?M=this.fragment:M===null&&(M=U),m===this.scheme&&N===this.authority&&_===this.path&&C===this.query&&M===this.fragment?this:new w(m,N,_,C,M)}static parse(u,m=!1){const N=L.exec(u);return N?new w(N[2]||U,o(N[4]||U),o(N[5]||U),o(N[7]||U),o(N[9]||U),m):new w(U,U,U,U,U)}static file(u){let m=U;if(R.isWindows&&(u=u.replace(/\\/g,I)),u[0]===I&&u[1]===I){const N=u.indexOf(I,2);N===-1?(m=u.substring(2),u=I):(m=u.substring(2,N),u=u.substring(N)||I)}return new w("file",m,u,U,U)}static from(u){const m=new w(u.scheme,u.authority,u.path,u.query,u.fragment);return h(m,!0),m}static joinPath(u,...m){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return R.isWindows&&u.scheme==="file"?N=d.file(P.win32.join(i(u,!0),...m)).path:N=P.posix.join(u.path,...m),u.with({path:N})}toString(u=!1){return r(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof d)return u;{const m=new w(u);return m._formatted=u.external,m._fsPath=u._sep===S?u.fsPath:null,m}}else return u}}t.URI=d;const S=R.isWindows?1:void 0;class w extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(u=!1){return u?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=S),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(l,u){let m,N=-1;for(let _=0;_<l.length;_++){const C=l.charCodeAt(_);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||u&&C===47)N!==-1&&(m+=encodeURIComponent(l.substring(N,_)),N=-1),m!==void 0&&(m+=l.charAt(_));else{m===void 0&&(m=l.substr(0,_));const M=b[C];M!==void 0?(N!==-1&&(m+=encodeURIComponent(l.substring(N,_)),N=-1),m+=M):N===-1&&(N=_)}}return N!==-1&&(m+=encodeURIComponent(l.substring(N))),m!==void 0?m:l}function n(l){let u;for(let m=0;m<l.length;m++){const N=l.charCodeAt(m);N===35||N===63?(u===void 0&&(u=l.substr(0,m)),u+=b[N]):u!==void 0&&(u+=l[m])}return u!==void 0?u:l}function i(l,u){let m;return l.authority&&l.path.length>1&&l.scheme==="file"?m=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?u?m=l.path.substr(1):m=l.path[1].toLowerCase()+l.path.substr(2):m=l.path,R.isWindows&&(m=m.replace(/\//g,"\\")),m}t.uriToFsPath=i;function r(l,u){const m=u?n:A;let N="",{scheme:_,authority:C,path:M,query:k,fragment:B}=l;if(_&&(N+=_,N+=":"),(C||_==="file")&&(N+=I,N+=I),C){let $=C.indexOf("@");if($!==-1){const p=C.substr(0,$);C=C.substr($+1),$=p.indexOf(":"),$===-1?N+=m(p,!1):(N+=m(p.substr(0,$),!1),N+=":",N+=m(p.substr($+1),!1)),N+="@"}C=C.toLowerCase(),$=C.indexOf(":"),$===-1?N+=m(C,!1):(N+=m(C.substr(0,$),!1),N+=C.substr($))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const $=M.charCodeAt(1);$>=65&&$<=90&&(M=`/${String.fromCharCode($+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const $=M.charCodeAt(0);$>=65&&$<=90&&(M=`${String.fromCharCode($+32)}:${M.substr(2)}`)}N+=m(M,!0)}return k&&(N+="?",N+=m(k,!1)),B&&(N+="#",N+=u?B:A(B,!1)),N}function s(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+s(l.substr(3)):l}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(l){return l.match(a)?l.replace(a,u=>s(u)):l}}),define(V[23],G([0,1,11]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class R{constructor(h){let E=(0,P.toUint8)(h);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(h){let E=new Uint8Array(256);for(let v=0;v<256;v++)E[v]=h;return E}set(h,E){let v=(0,P.toUint8)(E);h>=0&&h<256?this._asciiMap[h]=v:this._map.set(h,v)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}}t.CharacterClassifier=R;var F;(function(g){g[g.False=0]="False",g[g.True=1]="True"})(F||(F={}));class c{constructor(){this._actual=new R(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}}t.CharacterSet=c}),define(V[2],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(F,c){this.lineNumber=F,this.column=c}with(F=this.lineNumber,c=this.column){return F===this.lineNumber&&c===this.column?this:new P(F,c)}delta(F=0,c=0){return this.with(this.lineNumber+F,this.column+c)}equals(F){return P.equals(this,F)}static equals(F,c){return!F&&!c?!0:!!F&&!!c&&F.lineNumber===c.lineNumber&&F.column===c.column}isBefore(F){return P.isBefore(this,F)}static isBefore(F,c){return F.lineNumber<c.lineNumber?!0:c.lineNumber<F.lineNumber?!1:F.column<c.column}isBeforeOrEqual(F){return P.isBeforeOrEqual(this,F)}static isBeforeOrEqual(F,c){return F.lineNumber<c.lineNumber?!0:c.lineNumber<F.lineNumber?!1:F.column<=c.column}static compare(F,c){let g=F.lineNumber|0,h=c.lineNumber|0;if(g===h){let E=F.column|0,v=c.column|0;return E-v}return g-h}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(F){return new P(F.lineNumber,F.column)}static isIPosition(F){return F&&typeof F.lineNumber=="number"&&typeof F.column=="number"}}t.Position=P}),define(V[6],G([0,1,2]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class R{constructor(c,g,h,E){c>h||c===h&&g>E?(this.startLineNumber=h,this.startColumn=E,this.endLineNumber=c,this.endColumn=g):(this.startLineNumber=c,this.startColumn=g,this.endLineNumber=h,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return R.containsPosition(this,c)}static containsPosition(c,g){return!(g.lineNumber<c.startLineNumber||g.lineNumber>c.endLineNumber||g.lineNumber===c.startLineNumber&&g.column<c.startColumn||g.lineNumber===c.endLineNumber&&g.column>c.endColumn)}containsRange(c){return R.containsRange(this,c)}static containsRange(c,g){return!(g.startLineNumber<c.startLineNumber||g.endLineNumber<c.startLineNumber||g.startLineNumber>c.endLineNumber||g.endLineNumber>c.endLineNumber||g.startLineNumber===c.startLineNumber&&g.startColumn<c.startColumn||g.endLineNumber===c.endLineNumber&&g.endColumn>c.endColumn)}strictContainsRange(c){return R.strictContainsRange(this,c)}static strictContainsRange(c,g){return!(g.startLineNumber<c.startLineNumber||g.endLineNumber<c.startLineNumber||g.startLineNumber>c.endLineNumber||g.endLineNumber>c.endLineNumber||g.startLineNumber===c.startLineNumber&&g.startColumn<=c.startColumn||g.endLineNumber===c.endLineNumber&&g.endColumn>=c.endColumn)}plusRange(c){return R.plusRange(this,c)}static plusRange(c,g){let h,E,v,U;return g.startLineNumber<c.startLineNumber?(h=g.startLineNumber,E=g.startColumn):g.startLineNumber===c.startLineNumber?(h=g.startLineNumber,E=Math.min(g.startColumn,c.startColumn)):(h=c.startLineNumber,E=c.startColumn),g.endLineNumber>c.endLineNumber?(v=g.endLineNumber,U=g.endColumn):g.endLineNumber===c.endLineNumber?(v=g.endLineNumber,U=Math.max(g.endColumn,c.endColumn)):(v=c.endLineNumber,U=c.endColumn),new R(h,E,v,U)}intersectRanges(c){return R.intersectRanges(this,c)}static intersectRanges(c,g){let h=c.startLineNumber,E=c.startColumn,v=c.endLineNumber,U=c.endColumn,I=g.startLineNumber,L=g.startColumn,d=g.endLineNumber,S=g.endColumn;return h<I?(h=I,E=L):h===I&&(E=Math.max(E,L)),v>d?(v=d,U=S):v===d&&(U=Math.min(U,S)),h>v||h===v&&E>U?null:new R(h,E,v,U)}equalsRange(c){return R.equalsRange(this,c)}static equalsRange(c,g){return!!c&&!!g&&c.startLineNumber===g.startLineNumber&&c.startColumn===g.startColumn&&c.endLineNumber===g.endLineNumber&&c.endColumn===g.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(c){return new P.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(c){return new P.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,g){return new R(this.startLineNumber,this.startColumn,c,g)}setStartPosition(c,g){return new R(c,g,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(c){return new R(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}static fromPositions(c,g=c){return new R(c.lineNumber,c.column,g.lineNumber,g.column)}static lift(c){return c?new R(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,g){return!(c.endLineNumber<g.startLineNumber||c.endLineNumber===g.startLineNumber&&c.endColumn<g.startColumn||g.endLineNumber<c.startLineNumber||g.endLineNumber===c.startLineNumber&&g.endColumn<c.startColumn)}static areIntersecting(c,g){return!(c.endLineNumber<g.startLineNumber||c.endLineNumber===g.startLineNumber&&c.endColumn<=g.startColumn||g.endLineNumber<c.startLineNumber||g.endLineNumber===c.startLineNumber&&g.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,g){if(c&&g){const v=c.startLineNumber|0,U=g.startLineNumber|0;if(v===U){const I=c.startColumn|0,L=g.startColumn|0;if(I===L){const d=c.endLineNumber|0,S=g.endLineNumber|0;if(d===S){const w=c.endColumn|0,b=g.endColumn|0;return w-b}return d-S}return I-L}return v-U}return(c?1:0)-(g?1:0)}static compareRangesUsingEnds(c,g){return c.endLineNumber===g.endLineNumber?c.endColumn===g.endColumn?c.startLineNumber===g.startLineNumber?c.startColumn-g.startColumn:c.startLineNumber-g.startLineNumber:c.endColumn-g.endColumn:c.endLineNumber-g.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}}t.Range=R}),define(V[24],G([0,1,2,6]),function(j,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var F;(function(g){g[g.LTR=0]="LTR",g[g.RTL=1]="RTL"})(F=t.SelectionDirection||(t.SelectionDirection={}));class c extends R.Range{constructor(h,E,v,U){super(h,E,v,U);this.selectionStartLineNumber=h,this.selectionStartColumn=E,this.positionLineNumber=v,this.positionColumn=U}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return c.selectionsEqual(this,h)}static selectionsEqual(h,E){return h.selectionStartLineNumber===E.selectionStartLineNumber&&h.selectionStartColumn===E.selectionStartColumn&&h.positionLineNumber===E.positionLineNumber&&h.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,E){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,h,E):new c(h,E,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(h,E){return this.getDirection()===0?new c(h,E,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,h,E)}static fromPositions(h,E=h){return new c(h.lineNumber,h.column,E.lineNumber,E.column)}static liftSelection(h){return new c(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,E){if(h&&!E||!h&&E)return!1;if(!h&&!E)return!0;if(h.length!==E.length)return!1;for(let v=0,U=h.length;v<U;v++)if(!this.selectionsEqual(h[v],E[v]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,E,v,U,I){return I===0?new c(h,E,v,U):new c(v,U,h,E)}}t.Selection=c}),define(V[25],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class P{constructor(g,h,E){this._tokenBrand=void 0,this.offset=g|0,this.type=h,this.language=E}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=P;class R{constructor(g,h){this._tokenizationResultBrand=void 0,this.tokens=g,this.endState=h}}t.TokenizationResult=R;class F{constructor(g,h){this._tokenizationResult2Brand=void 0,this.tokens=g,this.endState=h}}t.TokenizationResult2=F}),define(V[26],G([0,1,10,5]),function(j,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const F=3;function c(w,b,A,n){return new P.LcsDiff(w,b,A).ComputeDiff(n)}class g{constructor(b){const A=[],n=[];for(let i=0,r=b.length;i<r;i++)A[i]=L(b[i],1),n[i]=d(b[i],1);this.lines=b,this._startColumns=A,this._endColumns=n}getElements(){const b=[];for(let A=0,n=this.lines.length;A<n;A++)b[A]=this.lines[A].substring(this._startColumns[A]-1,this._endColumns[A]-1);return b}getStrictElement(b){return this.lines[b]}getStartLineNumber(b){return b+1}getEndLineNumber(b){return b+1}createCharSequence(b,A,n){const i=[],r=[],s=[];let a=0;for(let o=A;o<=n;o++){const l=this.lines[o],u=b?this._startColumns[o]:1,m=b?this._endColumns[o]:l.length+1;for(let N=u;N<m;N++)i[a]=l.charCodeAt(N-1),r[a]=o+1,s[a]=N,a++}return new h(i,r,s)}}class h{constructor(b,A,n){this._charCodes=b,this._lineNumbers=A,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(b){return this._lineNumbers[b]}getStartColumn(b){return this._columns[b]}getEndLineNumber(b){return this._lineNumbers[b]}getEndColumn(b){return this._columns[b]+1}}class E{constructor(b,A,n,i,r,s,a,o){this.originalStartLineNumber=b,this.originalStartColumn=A,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=a,this.modifiedEndColumn=o}static createFromDiffChange(b,A,n){let i,r,s,a,o,l,u,m;return b.originalLength===0?(i=0,r=0,s=0,a=0):(i=A.getStartLineNumber(b.originalStart),r=A.getStartColumn(b.originalStart),s=A.getEndLineNumber(b.originalStart+b.originalLength-1),a=A.getEndColumn(b.originalStart+b.originalLength-1)),b.modifiedLength===0?(o=0,l=0,u=0,m=0):(o=n.getStartLineNumber(b.modifiedStart),l=n.getStartColumn(b.modifiedStart),u=n.getEndLineNumber(b.modifiedStart+b.modifiedLength-1),m=n.getEndColumn(b.modifiedStart+b.modifiedLength-1)),new E(i,r,s,a,o,l,u,m)}}function v(w){if(w.length<=1)return w;const b=[w[0]];let A=b[0];for(let n=1,i=w.length;n<i;n++){const r=w[n],s=r.originalStart-(A.originalStart+A.originalLength),a=r.modifiedStart-(A.modifiedStart+A.modifiedLength);Math.min(s,a)<F?(A.originalLength=r.originalStart+r.originalLength-A.originalStart,A.modifiedLength=r.modifiedStart+r.modifiedLength-A.modifiedStart):(b.push(r),A=r)}return b}class U{constructor(b,A,n,i,r){this.originalStartLineNumber=b,this.originalEndLineNumber=A,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(b,A,n,i,r,s,a){let o,l,u,m,N;if(A.originalLength===0?(o=n.getStartLineNumber(A.originalStart)-1,l=0):(o=n.getStartLineNumber(A.originalStart),l=n.getEndLineNumber(A.originalStart+A.originalLength-1)),A.modifiedLength===0?(u=i.getStartLineNumber(A.modifiedStart)-1,m=0):(u=i.getStartLineNumber(A.modifiedStart),m=i.getEndLineNumber(A.modifiedStart+A.modifiedLength-1)),s&&A.originalLength>0&&A.originalLength<20&&A.modifiedLength>0&&A.modifiedLength<20&&r()){const _=n.createCharSequence(b,A.originalStart,A.originalStart+A.originalLength-1),C=i.createCharSequence(b,A.modifiedStart,A.modifiedStart+A.modifiedLength-1);let M=c(_,C,r,!0).changes;a&&(M=v(M)),N=[];for(let k=0,B=M.length;k<B;k++)N.push(E.createFromDiffChange(M[k],_,C))}return new U(o,l,u,m,N)}}class I{constructor(b,A,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=b,this.modifiedLines=A,this.original=new g(b),this.modified=new g(A),this.continueLineDiff=S(n.maxComputationTime),this.continueCharDiff=S(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const b=c(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),A=b.changes,n=b.quitEarly;if(this.shouldIgnoreTrimWhitespace){const a=[];for(let o=0,l=A.length;o<l;o++)a.push(U.createFromDiffResult(this.shouldIgnoreTrimWhitespace,A[o],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:a}}const i=[];let r=0,s=0;for(let a=-1,o=A.length;a<o;a++){const l=a+1<o?A[a+1]:null,u=l?l.originalStart:this.originalLines.length,m=l?l.modifiedStart:this.modifiedLines.length;for(;r<u&&s<m;){const N=this.originalLines[r],_=this.modifiedLines[s];if(N!==_){{let C=L(N,1),M=L(_,1);for(;C>1&&M>1;){const k=N.charCodeAt(C-2),B=_.charCodeAt(M-2);if(k!==B)break;C--,M--}(C>1||M>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,C,s+1,1,M)}{let C=d(N,1),M=d(_,1);const k=N.length+1,B=_.length+1;for(;C<k&&M<B;){const $=N.charCodeAt(C-1),p=N.charCodeAt(M-1);if($!==p)break;C++,M++}(C<k||M<B)&&this._pushTrimWhitespaceCharChange(i,r+1,C,k,s+1,M,B)}}r++,s++}l&&(i.push(U.createFromDiffResult(this.shouldIgnoreTrimWhitespace,l,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=l.originalLength,s+=l.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(b,A,n,i,r,s,a){if(this._mergeTrimWhitespaceCharChange(b,A,n,i,r,s,a))return;let o;this.shouldComputeCharChanges&&(o=[new E(A,n,A,i,r,s,r,a)]),b.push(new U(A,A,r,r,o))}_mergeTrimWhitespaceCharChange(b,A,n,i,r,s,a){const o=b.length;if(o===0)return!1;const l=b[o-1];return l.originalEndLineNumber===0||l.modifiedEndLineNumber===0?!1:l.originalEndLineNumber+1===A&&l.modifiedEndLineNumber+1===r?(l.originalEndLineNumber=A,l.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&l.charChanges&&l.charChanges.push(new E(A,n,A,i,r,s,r,a)),!0):!1}}t.DiffComputer=I;function L(w,b){const A=R.firstNonWhitespaceIndex(w);return A===-1?b:A+1}function d(w,b){const A=R.lastNonWhitespaceIndex(w);return A===-1?b:A+2}function S(w){if(w===0)return()=>!0;const b=Date.now();return()=>Date.now()-b<w}}),define(V[27],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(h=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const v of t.USUAL_WORD_SEPARATORS)h.indexOf(v)>=0||(E+="\\"+v);return E+="\\s]+)",new RegExp(E,"g")}t.DEFAULT_WORD_REGEXP=P();function R(h){let E=t.DEFAULT_WORD_REGEXP;if(h&&h instanceof RegExp)if(h.global)E=h;else{let v="g";h.ignoreCase&&(v+="i"),h.multiline&&(v+="m"),h.unicode&&(v+="u"),E=new RegExp(h.source,v)}return E.lastIndex=0,E}t.ensureValidWordDefinition=R;const F={maxLen:1e3,windowSize:15,timeBudget:150};function c(h,E,v,U,I=F){if(v.length>I.maxLen){let b=h-I.maxLen/2;return b<0?b=0:U+=b,v=v.substring(b,h+I.maxLen/2),c(h,E,v,U,I)}const L=Date.now(),d=h-1-U;let S=-1,w=null;for(let b=1;!(Date.now()-L>=I.timeBudget);b++){const A=d-I.windowSize*b;E.lastIndex=Math.max(0,A);const n=g(E,v,d,S);if(!n&&w||(w=n,A<=0))break;S=A}if(w){let b={word:w[0],startColumn:U+1+w.index,endColumn:U+1+w.index+w[0].length};return E.lastIndex=0,b}return null}t.getWordAtText=c;function g(h,E,v,U){let I;for(;I=h.exec(E);){const L=I.index||0;if(L<=v&&h.lastIndex>=v)return I;if(U>0&&L>U)return null}return null}}),define(V[28],G([0,1,23]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var R;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(R=t.State||(t.State={}));class F{constructor(S,w,b){const A=new Uint8Array(S*w);for(let n=0,i=S*w;n<i;n++)A[n]=b;this._data=A,this.rows=S,this.cols=w}get(S,w){return this._data[S*this.cols+w]}set(S,w,b){this._data[S*this.cols+w]=b}}t.Uint8Matrix=F;class c{constructor(S){let w=0,b=0;for(let n=0,i=S.length;n<i;n++){let[r,s,a]=S[n];s>w&&(w=s),r>b&&(b=r),a>b&&(b=a)}w++,b++;let A=new F(b,w,0);for(let n=0,i=S.length;n<i;n++){let[r,s,a]=S[n];A.set(r,s,a)}this._states=A,this._maxCharCode=w}nextState(S,w){return w<0||w>=this._maxCharCode?0:this._states.get(S,w)}}t.StateMachine=c;let g=null;function h(){return g===null&&(g=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),g}var E;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let v=null;function U(){if(v===null){v=new P.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<d.length;w++)v.set(d.charCodeAt(w),1);const S=".,;";for(let w=0;w<S.length;w++)v.set(S.charCodeAt(w),2)}return v}class I{static _createLink(S,w,b,A,n){let i=n-1;do{const r=w.charCodeAt(i);if(S.get(r)!==2)break;i--}while(i>A);if(A>0){const r=w.charCodeAt(A-1),s=w.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:b,startColumn:A+1,endLineNumber:b,endColumn:i+2},url:w.substring(A,i+1)}}static computeLinks(S,w=h()){const b=U();let A=[];for(let n=1,i=S.getLineCount();n<=i;n++){const r=S.getLineContent(n),s=r.length;let a=0,o=0,l=0,u=1,m=!1,N=!1,_=!1,C=!1;for(;a<s;){let M=!1;const k=r.charCodeAt(a);if(u===13){let B;switch(k){case 40:m=!0,B=0;break;case 41:B=m?0:1;break;case 91:_=!0,N=!0,B=0;break;case 93:_=!1,B=N?0:1;break;case 123:C=!0,B=0;break;case 125:B=C?0:1;break;case 39:B=l===34||l===96?0:1;break;case 34:B=l===39||l===96?0:1;break;case 96:B=l===39||l===34?0:1;break;case 42:B=l===42?1:0;break;case 124:B=l===124?1:0;break;case 32:B=_?0:1;break;default:B=b.get(k)}B===1&&(A.push(I._createLink(b,r,n,o,a)),M=!0)}else if(u===12){let B;k===91?(N=!0,B=0):B=b.get(k),B===1?M=!0:u=13}else u=w.nextState(u,k),u===0&&(M=!0);M&&(u=1,m=!1,N=!1,C=!1,o=a+1,l=k),a++}u===13&&A.push(I._createLink(b,r,n,o,s))}return A}}t.LinkComputer=I;function L(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}t.computeLinks=L}),define(V[29],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(F,c,g,h,E){if(F&&c){let v=this.doNavigateValueSet(c,E);if(v)return{range:F,value:v}}if(g&&h){let v=this.doNavigateValueSet(h,E);if(v)return{range:g,value:v}}return null}doNavigateValueSet(F,c){let g=this.numberReplace(F,c);return g!==null?g:this.textReplace(F,c)}numberReplace(F,c){let g=Math.pow(10,F.length-(F.lastIndexOf(".")+1)),h=Number(F),E=parseFloat(F);return!isNaN(h)&&!isNaN(E)&&h===E?h===0&&!c?null:(h=Math.floor(h*g),h+=c?g:-g,String(h/g)):null}textReplace(F,c){return this.valueSetsReplace(this._defaultValueSet,F,c)}valueSetsReplace(F,c,g){let h=null;for(let E=0,v=F.length;h===null&&E<v;E++)h=this.valueSetReplace(F[E],c,g);return h}valueSetReplace(F,c,g){let h=F.indexOf(c);return h>=0?(h+=g?1:-1,h<0?h=F.length-1:h%=F.length,F[h]):null}}t.BasicInplaceReplace=P,P.INSTANCE=new P}),define(V[30],G([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var P;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(P=t.AccessibilitySupport||(t.AccessibilitySupport={}));var R;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(R=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var F;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(F=t.CompletionItemKind||(t.CompletionItemKind={}));var c;(function(e){e[e.Deprecated=1]="Deprecated"})(c=t.CompletionItemTag||(t.CompletionItemTag={}));var g;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var h;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(h=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var E;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(E=t.CursorChangeReason||(t.CursorChangeReason={}));var v;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(v=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var U;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(U=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var I;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(I=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var L;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.codeLens=12]="codeLens",e[e.codeLensFontFamily=13]="codeLensFontFamily",e[e.codeLensFontSize=14]="codeLensFontSize",e[e.colorDecorators=15]="colorDecorators",e[e.columnSelection=16]="columnSelection",e[e.comments=17]="comments",e[e.contextmenu=18]="contextmenu",e[e.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",e[e.cursorBlinking=20]="cursorBlinking",e[e.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",e[e.cursorStyle=22]="cursorStyle",e[e.cursorSurroundingLines=23]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",e[e.cursorWidth=25]="cursorWidth",e[e.disableLayerHinting=26]="disableLayerHinting",e[e.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",e[e.domReadOnly=28]="domReadOnly",e[e.dragAndDrop=29]="dragAndDrop",e[e.emptySelectionClipboard=30]="emptySelectionClipboard",e[e.extraEditorClassName=31]="extraEditorClassName",e[e.fastScrollSensitivity=32]="fastScrollSensitivity",e[e.find=33]="find",e[e.fixedOverflowWidgets=34]="fixedOverflowWidgets",e[e.folding=35]="folding",e[e.foldingStrategy=36]="foldingStrategy",e[e.foldingHighlight=37]="foldingHighlight",e[e.foldingImportsByDefault=38]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=40]="fontFamily",e[e.fontInfo=41]="fontInfo",e[e.fontLigatures=42]="fontLigatures",e[e.fontSize=43]="fontSize",e[e.fontWeight=44]="fontWeight",e[e.formatOnPaste=45]="formatOnPaste",e[e.formatOnType=46]="formatOnType",e[e.glyphMargin=47]="glyphMargin",e[e.gotoLocation=48]="gotoLocation",e[e.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",e[e.hover=51]="hover",e[e.inDiffEditor=52]="inDiffEditor",e[e.inlineSuggest=53]="inlineSuggest",e[e.letterSpacing=54]="letterSpacing",e[e.lightbulb=55]="lightbulb",e[e.lineDecorationsWidth=56]="lineDecorationsWidth",e[e.lineHeight=57]="lineHeight",e[e.lineNumbers=58]="lineNumbers",e[e.lineNumbersMinChars=59]="lineNumbersMinChars",e[e.linkedEditing=60]="linkedEditing",e[e.links=61]="links",e[e.matchBrackets=62]="matchBrackets",e[e.minimap=63]="minimap",e[e.mouseStyle=64]="mouseStyle",e[e.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=66]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",e[e.multiCursorModifier=68]="multiCursorModifier",e[e.multiCursorPaste=69]="multiCursorPaste",e[e.occurrencesHighlight=70]="occurrencesHighlight",e[e.overviewRulerBorder=71]="overviewRulerBorder",e[e.overviewRulerLanes=72]="overviewRulerLanes",e[e.padding=73]="padding",e[e.parameterHints=74]="parameterHints",e[e.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",e[e.quickSuggestions=77]="quickSuggestions",e[e.quickSuggestionsDelay=78]="quickSuggestionsDelay",e[e.readOnly=79]="readOnly",e[e.renameOnType=80]="renameOnType",e[e.renderControlCharacters=81]="renderControlCharacters",e[e.renderIndentGuides=82]="renderIndentGuides",e[e.renderFinalNewline=83]="renderFinalNewline",e[e.renderLineHighlight=84]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=86]="renderValidationDecorations",e[e.renderWhitespace=87]="renderWhitespace",e[e.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",e[e.roundedSelection=89]="roundedSelection",e[e.rulers=90]="rulers",e[e.scrollbar=91]="scrollbar",e[e.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=93]="scrollBeyondLastLine",e[e.scrollPredominantAxis=94]="scrollPredominantAxis",e[e.selectionClipboard=95]="selectionClipboard",e[e.selectionHighlight=96]="selectionHighlight",e[e.selectOnLineNumbers=97]="selectOnLineNumbers",e[e.showFoldingControls=98]="showFoldingControls",e[e.showUnused=99]="showUnused",e[e.snippetSuggestions=100]="snippetSuggestions",e[e.smartSelect=101]="smartSelect",e[e.smoothScrolling=102]="smoothScrolling",e[e.stickyTabStops=103]="stickyTabStops",e[e.stopRenderingLineAfter=104]="stopRenderingLineAfter",e[e.suggest=105]="suggest",e[e.suggestFontSize=106]="suggestFontSize",e[e.suggestLineHeight=107]="suggestLineHeight",e[e.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",e[e.suggestSelection=109]="suggestSelection",e[e.tabCompletion=110]="tabCompletion",e[e.tabIndex=111]="tabIndex",e[e.unusualLineTerminators=112]="unusualLineTerminators",e[e.useShadowDOM=113]="useShadowDOM",e[e.useTabStops=114]="useTabStops",e[e.wordSeparators=115]="wordSeparators",e[e.wordWrap=116]="wordWrap",e[e.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=119]="wordWrapColumn",e[e.wordWrapOverride1=120]="wordWrapOverride1",e[e.wordWrapOverride2=121]="wordWrapOverride2",e[e.wrappingIndent=122]="wrappingIndent",e[e.wrappingStrategy=123]="wrappingStrategy",e[e.showDeprecated=124]="showDeprecated",e[e.inlayHints=125]="inlayHints",e[e.editorClassName=126]="editorClassName",e[e.pixelRatio=127]="pixelRatio",e[e.tabFocusMode=128]="tabFocusMode",e[e.layoutInfo=129]="layoutInfo",e[e.wrappingInfo=130]="wrappingInfo"})(L=t.EditorOption||(t.EditorOption={}));var d;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(d=t.EndOfLinePreference||(t.EndOfLinePreference={}));var S;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(S=t.EndOfLineSequence||(t.EndOfLineSequence={}));var w;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(w=t.IndentAction||(t.IndentAction={}));var b;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(b=t.InlayHintKind||(t.InlayHintKind={}));var A;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(A=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(n=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(i=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var a;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(a=t.MouseTargetType||(t.MouseTargetType={}));var o;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(o=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var l;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(l=t.OverviewRulerLane||(t.OverviewRulerLane={}));var u;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(u=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var m;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(m=t.RenderMinimap||(t.RenderMinimap={}));var N;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(N=t.ScrollType||(t.ScrollType={}));var _;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(_=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var C;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));var M;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(M=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var k;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(k=t.SymbolKind||(t.SymbolKind={}));var B;(function(e){e[e.Deprecated=1]="Deprecated"})(B=t.SymbolTag||(t.SymbolTag={}));var $;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})($=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var p;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(p=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var z;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(z=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var J;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(J=t.WrappingIndent||(t.WrappingIndent={}))}),define(V[31],G([0,1,20,9,15,12,2,6,24,25,30]),function(j,t,P,R,F,c,g,h,E,v,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class I{static chord(S,w){return(0,F.KeyChord)(S,w)}}t.KeyMod=I,I.CtrlCmd=2048,I.Shift=1024,I.Alt=512,I.WinCtrl=256;function L(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:R.Emitter,KeyCode:U.KeyCode,KeyMod:I,Position:g.Position,Range:h.Range,Selection:E.Selection,SelectionDirection:U.SelectionDirection,MarkerSeverity:U.MarkerSeverity,MarkerTag:U.MarkerTag,Uri:c.URI,Token:v.Token}}t.createMonacoBaseAPI=L}),define(V[32],G([0,1,11]),function(j,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class R{constructor(g,h){this._prefixSumIndexOfResultBrand=void 0,this.index=g,this.remainder=h}}t.PrefixSumIndexOfResult=R;class F{constructor(g){this.values=g,this.prefixSum=new Uint32Array(g.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(g,h){g=(0,P.toUint32)(g);const E=this.values,v=this.prefixSum,U=h.length;return U===0?!1:(this.values=new Uint32Array(E.length+U),this.values.set(E.subarray(0,g),0),this.values.set(E.subarray(g),g+U),this.values.set(h,g),g-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=g-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(v.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(g,h){return g=(0,P.toUint32)(g),h=(0,P.toUint32)(h),this.values[g]===h?!1:(this.values[g]=h,g-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=g-1),!0)}removeValues(g,h){g=(0,P.toUint32)(g),h=(0,P.toUint32)(h);const E=this.values,v=this.prefixSum;if(g>=E.length)return!1;let U=E.length-g;return h>=U&&(h=U),h===0?!1:(this.values=new Uint32Array(E.length-h),this.values.set(E.subarray(0,g),0),this.values.set(E.subarray(g+h),g),this.prefixSum=new Uint32Array(this.values.length),g-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=g-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(v.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(g){return g<0?0:(g=(0,P.toUint32)(g),this._getPrefixSum(g))}_getPrefixSum(g){if(g<=this.prefixSumValidIndex[0])return this.prefixSum[g];let h=this.prefixSumValidIndex[0]+1;h===0&&(this.prefixSum[0]=this.values[0],h++),g>=this.values.length&&(g=this.values.length-1);for(let E=h;E<=g;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],g),this.prefixSum[g]}getIndexOf(g){g=Math.floor(g),this.getTotalSum();let h=0,E=this.values.length-1,v=0,U=0,I=0;for(;h<=E;)if(v=h+(E-h)/2|0,U=this.prefixSum[v],I=U-this.values[v],g<I)E=v-1;else if(g>=U)h=v+1;else break;return new R(v,g-I)}}t.PrefixSumComputer=F}),define(V[33],G([0,1,5,2,32]),function(j,t,P,R,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class c{constructor(h,E,v,U){this._uri=h,this._lines=E,this._eol=v,this._versionId=U,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const E=h.changes;for(const v of E)this._acceptDeleteRange(v.range),this._acceptInsertText(new R.Position(v.range.startLineNumber,v.range.startColumn),v.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,E=this._lines.length,v=new Uint32Array(E);for(let U=0;U<E;U++)v[U]=this._lines[U].length+h;this._lineStarts=new F.PrefixSumComputer(v)}}_setLineText(h,E){this._lines[h]=E,this._lineStarts&&this._lineStarts.changeValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,E){if(E.length===0)return;let v=(0,P.splitLines)(E);if(v.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+v[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}v[v.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+v[0]);let U=new Uint32Array(v.length-1);for(let I=1;I<v.length;I++)this._lines.splice(h.lineNumber+I-1,0,v[I]),U[I-1]=v[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,U)}}t.MirrorTextModel=c}),define(V[34],G([0,1,10,3,12,2,6,26,33,27,28,29,31,22,4]),function(j,t,P,R,F,c,g,h,E,v,U,I,L,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class w extends E.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let s=(0,v.getWordAtText)(i.column,(0,v.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return s?new g.Range(i.lineNumber,s.startColumn,i.lineNumber,s.endColumn):null}getWordUntilPosition(i,r){const s=this.getWordAtPosition(i,r);return s?{word:this._lines[i.lineNumber-1].substring(s.startColumn-1,i.column-1),startColumn:s.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,s=this._wordenize.bind(this);let a=0,o="",l=0,u=[];return{*[Symbol.iterator](){for(;;)if(l<u.length){const m=o.substring(u[l].start,u[l].end);l+=1,yield m}else if(a<r.length)o=r[a],u=s(o,i),l=0,a+=1;else break}}}getLineWords(i,r){let s=this._lines[i-1],a=this._wordenize(s,r),o=[];for(const l of a)o.push({word:s.substring(l.start,l.end),startColumn:l.start+1,endColumn:l.end+1});return o}_wordenize(i,r){const s=[];let a;for(r.lastIndex=0;(a=r.exec(i))&&a[0].length!==0;)s.push({start:a.index,end:a.index+a[0].length});return s}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,s=i.startLineNumber-1,a=i.endLineNumber-1,o=[];o.push(this._lines[s].substring(i.startColumn-1));for(let l=s+1;l<a;l++)o.push(this._lines[l]);return o.push(this._lines[a].substring(0,i.endColumn-1)),o.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),s=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||s.lineNumber!==i.endLineNumber||s.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:i}_validatePosition(i){if(!c.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:s}=i,a=!1;if(r<1)r=1,s=1,a=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,a=!0;else{let o=this._lines[r-1].length+1;s<1?(s=1,a=!0):s>o&&(s=o,a=!0)}return a?{lineNumber:r,column:s}:i}}t.MirrorModel=w;class b{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new w(F.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,s,a){const o=this._getModel(i),l=this._getModel(r);if(!o||!l)return null;const u=o.getLinesContent(),m=l.getLinesContent(),_=new h.DiffComputer(u,m,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:a}).computeDiff(),C=_.changes.length>0?!1:this._modelsAreIdentical(o,l);return{quitEarly:_.quitEarly,identical:C,changes:_.changes}}_modelsAreIdentical(i,r){const s=i.getLineCount(),a=r.getLineCount();if(s!==a)return!1;for(let o=1;o<=s;o++){const l=i.getLineContent(o),u=r.getLineContent(o);if(l!==u)return!1}return!0}async computeDirtyDiff(i,r,s){let a=this._getModel(i),o=this._getModel(r);if(!a||!o)return null;let l=a.getLinesContent(),u=o.getLinesContent();return new h.DiffComputer(l,u,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const s=this._getModel(i);if(!s)return r;const a=[];let o;r=r.slice(0).sort((l,u)=>{if(l.range&&u.range)return g.Range.compareRangesUsingStarts(l.range,u.range);let m=l.range?0:1,N=u.range?0:1;return m-N});for(let{range:l,text:u,eol:m}of r){if(typeof m=="number"&&(o=m),g.Range.isEmpty(l)&&!u)continue;const N=s.getValueInRange(l);if(u=u.replace(/\r\n|\n|\r/g,s.eol),N===u)continue;if(Math.max(u.length,N.length)>b._diffLimit){a.push({range:l,text:u});continue}const _=(0,P.stringDiff)(N,u,!1),C=s.offsetAt(g.Range.lift(l).getStartPosition());for(const M of _){const k=s.positionAt(C+M.originalStart),B=s.positionAt(C+M.originalStart+M.originalLength),$={text:u.substr(M.modifiedStart,M.modifiedLength),range:{startLineNumber:k.lineNumber,startColumn:k.column,endLineNumber:B.lineNumber,endColumn:B.column}};s.getValueInRange($.range)!==$.text&&a.push($)}}return typeof o=="number"&&a.push({eol:o,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a}async computeLinks(i){let r=this._getModel(i);return r?(0,U.computeLinks)(r):null}async textualSuggest(i,r,s,a){const o=new S.StopWatch(!0),l=new RegExp(s,a),u=new Set;e:for(let m of i){const N=this._getModel(m);if(!!N){for(let _ of N.words(l))if(!(_===r||!isNaN(Number(_)))&&(u.add(_),u.size>b._suggestionsLimit))break e}}return{words:Array.from(u),duration:o.elapsed()}}async computeWordRanges(i,r,s,a){let o=this._getModel(i);if(!o)return Object.create(null);const l=new RegExp(s,a),u=Object.create(null);for(let m=r.startLineNumber;m<r.endLineNumber;m++){let N=o.getLineWords(m,l);for(const _ of N){if(!isNaN(Number(_.word)))continue;let C=u[_.word];C||(C=[],u[_.word]=C),C.push({startLineNumber:m,startColumn:_.startColumn,endLineNumber:m,endColumn:_.endColumn})}}return u}async navigateValueSet(i,r,s,a,o){let l=this._getModel(i);if(!l)return null;let u=new RegExp(a,o);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let m=l.getValueInRange(r),N=l.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},u);if(!N)return null;let _=l.getValueInRange(N);return I.BasicInplaceReplace.INSTANCE.navigateValueSet(r,m,N,_,s)}loadForeignModule(i,r,s){const a=(u,m)=>this._host.fhr(u,m);let l={host:d.createProxyObject(s,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(l,r),Promise.resolve(d.getAllMethodNames(this._foreignModule))):new Promise((u,m)=>{j([i],N=>{this._foreignModule=N.create(l,r),u(d.getAllMethodNames(this._foreignModule))},m)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}t.EditorSimpleWorker=b,b._diffLimit=1e5,b._suggestionsLimit=1e4;function A(n){return new b(n,null)}t.create=A,typeof importScripts=="function"&&(R.globals.monaco=(0,L.createMonacoBaseAPI)())}),define(V[35],G([0,1,4,34]),function(j,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguageDetectionSimpleWorker=t.create=void 0;function F(g){return new c(g,null)}t.create=F;class c extends R.EditorSimpleWorker{constructor(){super(...arguments);this._loadFailed=!1}async detectLanguage(h){const E=[],v=[],U=new P.StopWatch(!0);for await(const I of this.detectLanguagesImpl(h))E.push(I.languageId),v.push(I.confidence);if(U.stop(),E.length)return this._host.fhr("sendTelemetryEvent",[E,v,U.elapsed()]),E[0]}async getModelOperations(){if(this._modelOperations)return this._modelOperations;const h=await this._host.fhr("getIndexJsUri",[]),{ModelOperations:E}=await new Promise((v,U)=>{j([h],v,U)});return this._modelOperations=new E({modelJsonLoaderFunc:async()=>{const v=await fetch(await this._host.fhr("getModelJsonUri",[]));try{return await v.json()}catch(U){const I="Failed to parse model JSON.";throw new Error(I)}},weightsLoaderFunc:async()=>await(await fetch(await this._host.fhr("getWeightsUri",[]))).arrayBuffer()}),this._modelOperations}async*detectLanguagesImpl(h){if(this._loadFailed)return;let E;try{E=await this.getModelOperations()}catch(L){console.log(L),this._loadFailed=!0;return}const v=this._getModel(h);if(!v)return;const U=await E.runModel(v.getValue());if(!U||U.length===0||U[0].confidence<c.expectedRelativeConfidence)return;const I=[U[0]];for(let L of U){if(L===U[0])continue;if(I[I.length-1].confidence-L.confidence>=c.expectedRelativeConfidence){for(;I.length;)yield I.shift();if(L.confidence>c.expectedRelativeConfidence){I.push(L);continue}return}else{if(L.confidence>c.expectedRelativeConfidence){I.push(L);continue}return}}}}t.LanguageDetectionSimpleWorker=c,c.expectedRelativeConfidence=.2})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9dd4f31a21d63deea5e1fc322cfc802413b31d95/core/vs/workbench/services/languageDetection/browser/languageDetectionSimpleWorker.js.map
